<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Aquotes3 extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct() 
	{
		parent::__construct(); 
					
		// echo "<br>!! aa";
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		
		$check_access = "new";
		if ($check_access == "new") {
			//### THE NEW VERSION CHK ACCESS & LOADS MENU MODULES INTO POST ARRAY - DOUBLES USE IN ONE MODEL 
			$this->load->model('Recheck_access6');
			$var_access_status = $this->Recheck_access6->reset_access6();
		} else {
			$this->load->model('Recheck_access');
			$this->Recheck_access->reset_access();
		}
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // echo "!! must write other functions code for funciton $callfunction";
		}
	}

	public function quote_edit()
	{

		// ### The for post is getting totally cleared when the file field is being loaded.. 
		error_reporting(0); 
		// var_dump($_POST);

		if ($_POST['quote_name'] != "") {
		
			$data_rec = array();
			$data_rec['quote_name'] = $_POST['quote_name'];
			$data_rec['email'] = $_POST['email'];
			$data_rec['mobile'] = $_POST['mobile'];
			$data_rec['quote_reply'] = $_POST['quote_reply'];			
			$data_rec['quote_rooms'] = $_POST['quote_rooms'];			
			$data_rec['quote_surfaces'] = $_POST['quote_surfaces'];		
			$data_rec['quote_status'] = $_POST['quote_status'];		
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update(aaa_quote, $data_rec);
			} else {
				$this->db->insert(aaa_quote, $data_rec);
				$_POST['id'] = $this->db->insert_id();
			}
			
			if ($_POST['add_comm_date'] != "") {
				$data_rec = array();
				$date_parts = explode('/',$data_rec['add_comm_date']);
				$time_parts = explode(' ',$date_parts[2]);
				$var_date_sort = $time_parts[0] . "/" . $date_parts[1] . "/" . $date_parts[0] . " " . $time_parts[1];
				$data_rec['comm_notes'] = $_POST['add_comm_notes'];
				$data_rec['quote_id'] = $_POST['id'];
				$data_rec['comm_date'] = $_POST['add_comm_date'];
				$data_rec['comm_date_sort'] = $var_date_sort;
				// var_dump($data_rec);
				$this->db->insert(aaa_quote_comms_notes, $data_rec);
				$comm_id = $this->db->insert_id();
			}
			if ($comm_id != "") { 
				$sql = "select id from aaa_quote_comms_notes where quote_id = {$_POST['id']} and id not in ($comm_id) order by comm_date_sort";
			} else {
				$sql = "select id from aaa_quote_comms_notes where quote_id = {$_POST['id']} order by comm_date_sort";
			}
			$var_comms_ids = $this->db->query($sql)->result_array();
			foreach ($var_comms_ids as $x) {
				$data_rec = array(); 
				$var_comm_date = $x['id'] . "_comm_date";
				$data_rec['comm_date'] = $_POST[$var_comm_date]; 
				$date_parts = explode('/',$data_rec['comm_date']);
				$time_parts = explode(' ',$date_parts[2]);
				$var_date_sort = $time_parts[0] . "/" . $date_parts[1] . "/" . $date_parts[0] . " " . $time_parts[1];
				$data_rec['comm_date_sort'] = $var_date_sort;
				$var_comm_notes = $x['id'] . "_comm_notes";
				$data_rec['comm_notes'] = $_POST[$var_comm_notes];
				// var_dump($data_rec);
				$this->db->where('id', $x['id']);
				$this->db->update(aaa_quote_comms_notes, $data_rec);
			}
		}
			
		$sql = "select * from ainf_vps3_code_manager where code_group = 'rooms_topaint' order by code_name";
		$data['rooms_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_code_manager where code_group = 'surfaces_topaint' order by code_name";
		$data['surfaces_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_code_manager where code_group = 'quote_status' order by code_name";
		$data['status_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from aaa_quote_comms_notes where quote_id = {$_POST['id']} order by comm_date_sort desc";
		$data['comms_list'] = $this->db->query($sql)->result_array();
		// var_dump($data['comms_list']);
		
		if ($_POST['return_to_list'] == "yes") {
			redirect('/aquotes3/listing/manage_key_lists_4');
		} else {
			$sql = "select * from aaa_quote where id = {$_POST['id']}";
			// // echo "<br>77 !!! sql - $sql ";
			$data['this_quote'] = $this->db->query($sql)->result_array();
			$this->load->view('update_quote_detail', $data);
		}
		
	}

	public function listing($pagename)
	{

		// echo "<br>!! 11 ";
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		$var_last_month = date('Y/m/d', strtotime('-8 days')); 
		//### ATTENDEES - NO FOLLOW-UPS LAST 7 DAYS 
		$sql = "select * from aaa_quote where quote_status = 'New' order by quote_date"; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 

		// echo "<br>!! 22 ";

		$var_last_month = date('Y/m/d', strtotime('-31 days')); 
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from aaa_quote where quote_status = 'Quote Given' or quote_status like '%Call%' order by quote_date"; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 

		$var_last_month = date('Y/m/d', strtotime('-31 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from aaa_quote where quote_status = 'Job Awarded' order by quote_date"; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 

		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select * from aaa_quote where quote_status like '%Other Cont%' order by quote_date"; 
		$data['main_list_array_tab4'] = $this->db->query($sql)->result_array();
		
		//### NOT USED EXCEPT IN REPORT - GOOD FOR PRAYER REQUEST LISTINGS 
		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
	}

	public function attendeestatus($pagename)
	{
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 

		$var_this_yr_month =  date("Y/m"); // Get the users NOT having follow_ups 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  follup_contact_date_sort like '%$var_this_yr_month%') order by first_name, last_name";
		$data['follups_left'] = $this->db->query($sql)->result_array();
		
		//### PRAYER REQUESTS 
		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort like '%$var_this_yr_month%' order by userid, request_date_sort desc"; 
		$data['prayer_req_new'] = $this->db->query($sql)->result_array(); 

		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort not like '%$var_this_yr_month%' and req_status not in ('Answered') order by userid, request_date_sort desc";
		$data['prayer_req_open'] = $this->db->query($sql)->result_array();
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.mobile, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		//### QUERIES FOR GAPS REPORT 
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		
		$var_last_month = date('Y/m/d', strtotime('-31 days')); 
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		$data['no_followups_month'] = $this->db->query($sql)->result_array();

		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 
		
		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where team_regular_church is null or email is null or addr_suburb is null or addr_street is null and compid = $varcompid order by first_name, last_name";
		$data['no_key_dates'] = $this->db->query($sql)->result_array();
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}		
	}

}
	
