<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Biz_quotes_v2 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}

		$this->load->model('Unsett_array'); //### FOR MENUS AND TABS 
		
		$this->load->helper('html');
		$this->load->model('Smscurlapi');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');			
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // // // // // // // // // // // echo  "!! must write other functions code for funciton $callfunction";
		}
	}

	public function process_row_total($date_start, $date_end, $worker_rate) {

		$var_hours_perday = 8; $var_biz_days = 15;
		
		// ### WORKING WAY FOR DAYS DIFF 
		$date_array = explode("/",$date_start);
		$date_start_format = $date_array[2] . "-" . $date_array[1] . "-" . $date_array[0];
		$date_array = explode("/",$date_end);
		$date_end_format = $date_array[2] . "-" . $date_array[1] . "-" . $date_array[0];
		$earlier = new DateTime($date_start_format);
		$later = new DateTime($date_end_format);
		$abs_diff = $later->diff($earlier)->format("%a"); //3
		// ### FIX TO BE ACCURATE 
		$abs_diff_wkdays = round($abs_diff * 5/ 7); // ### QUICK ROUGH WAY FOR WEEK DAYS 
		
		// $abs_diff = $date_end->diff($date_start)->format("%a"); //3 
		// // echo  "<br>!!<b>abs_diff = $abs_diff abs_diff_wkdays - $abs_diff_wkdays </b>"; 
		
		// ### FORMAT ROW TOTAL FOR DATE DIFF  
		$var_rate_array = explode("$", $worker_rate);
		$var_rate_float = $var_rate_array[1];
		$var_round_rate = round($var_rate_float);
		$var_tot_line = $var_round_rate * $var_hours_perday; 
		$var_tot_line = $var_tot_line * $abs_diff_wkdays;
		$var_tot_line_fmt = "$" . number_format($var_tot_line, 2);
		// // echo  "<br>!! TOT total fmt $var_tot_line_fmt";
		
		If (1==2) {
			$var_tot_line = $var_round_rate * $var_hours_perday; 
			$var_tot_line = $var_tot_line * $var_biz_days; 
			$var_tot_line_fmt = "$" . number_format($var_tot_line, 2); 
			$var_row_tot_amt = 100;
			// return($var_row_tot_amt);
		} else {
			$var_row_tot_amt = 100;
		}
		return($var_tot_line_fmt);
	}

	
	public function process_quote_lines() {

			// ### PROCESS ROWS TO DELETE - WORK TO GET A SUBSET OF THE ARRAY.. 
			$quote_lines = explode("==", $_POST['quote_detail_rows']);
			$var_current_quote_rows = ""; 
			$del_rows = 0; 
			if (1==1) { 
				$quote_rows = count($quote_lines); 
				for ($y = 0; $y < $quote_rows; $y++) { //## LOOP AND IF DELETED - REMOVE ROW 
					$var_checkbox = "del_row_" . $y; 
					// // echo "<br><b>TOP checkb is $var_checkbox post value is {$_POST[$var_checkbox]} "; 
					// if (strpos($key,'del_row_') !== false) { 
					if ($_POST[$var_checkbox] != "yes") {
						if (trim($var_current_quote_rows) == "") {
							$var_current_quote_rows .= $quote_lines[$y];
							// // echo " AA chose to add in this case ";
						} else {
							$var_current_quote_rows .= "==" . $quote_lines[$y];
							// // echo " BB chose to add in this case ";
						}
					}
				}
			}
			
			if ($var_current_quote_rows == "" and $del_rows == 0) {
				$var_current_quote_rows = $_POST['quote_detail_rows'];
			}
			
			// ### PROCESS NEWS ROWS TO ADD 
			$var_add_quote_rows = "";
			if ($_POST['add_from_date_1'] !="" and $_POST['add_to_date_1'] !="" and $_POST['add_worker_type_1'] != "") {
				if ($var_add_quote_rows != "") {$varsep = "==";} else {$varsep = "";}
				$var_row_total = $this->process_row_total($_POST['add_from_date_1'], $_POST['add_to_date_1'], $_POST['add_worker_type_1']);
				$var_add_quote_rows .= $varsep . $_POST['add_from_date_1'] . "//" . $_POST['add_to_date_1'] . "//" . $_POST['add_worker_type_1'] . "//" . $var_row_total;
				// // // echo  "<br><b>!!111 add rows is $var_add_quote_rows</b>";
			}
			if ($_POST['add_from_date_2'] !="" and $_POST['add_to_date_2'] !="" and $_POST['add_worker_type_2'] != "") {
				if ($var_add_quote_rows != "") {$varsep = "==";} else {$varsep = "";}
				$var_row_total = $this->process_row_total($_POST['add_from_date_2'], $_POST['add_to_date_2'], $_POST['add_worker_type_2']);
				// $var_add_quote_rows .= $varsep . $_POST['add_from_date_2'] . "//" . $_POST['add_to_date_2'] . "//" . $_POST['add_worker_type_2'];
				$var_add_quote_rows .= $varsep . $_POST['add_from_date_2'] . "//" . $_POST['add_to_date_2'] . "//" . $_POST['add_worker_type_2'] . "//" . $var_row_total;
				// // // echo  "<br><b>!!222 add rows is $var_add_quote_rows</b>";
			}
			
			if ($var_add_quote_rows != "") {
				if ($var_current_quote_rows != "") {
					$var_final_quote_detail_rows = $var_current_quote_rows . "==" . $var_add_quote_rows;
					// // // echo  "<br>AA COMBINE ROWS $var_final_quote_detail_rows";
				} else {
					$var_final_quote_detail_rows = $var_add_quote_rows;
					// // // echo  "<br>BB COMBINE ROWS $var_final_quote_detail_rows";
				}
			} else {
				$var_final_quote_detail_rows = $var_current_quote_rows;
					// // // echo  "<br>CC COMBINE ROWS $var_final_quote_detail_rows";
			}
			
			return($var_final_quote_detail_rows);
	}
	
	public function process_email_request() {

		$key_table = "aaaa_biz2_work_quotes"; 
		if ($_POST['send_email_recipient1'] != "" or $_POST['send_email_recipient2'] != "") { 

			// ######################################## 
			// #### THESE ARE WORKING QUITE OK ######## 
			// ######################################## 
			
			if (1==1) {

				// ### Email FORMAT DOES WORK FOR HTML FORMAT 
				$var_link = base_url() . "Biz_display_proc_doc/display_doc/aaaa_biz2_work_quotes/" . $_POST['id']; 
				$var_quote_link = "<a href='$var_link'><u><b>click here.</u></b></a>"; 

				$var_dark_blue = "#0097b2"; $var_light_blue = "#5ce1e6";
				
				$sql = "select first_name, last_name, userid from ainf_vps3_users where 
				userid in (select biz_client_contact_id from aaaa_biz2_work_quotes where id = {$_POST['id']} )";
				// // echo "<br>!! sql is $sql ";

				$var_client_contact_name = $this->db->query($sql)->result_array(); 
				$var_name = "Team Member";
				foreach ($var_client_contact_name as $x) {
					$var_name = $x['first_name'];
				}
				// // echo "<br>!! First name is $var_name ";
				
				$htmlContent = "
				<html>
				<body>
				  <table style='width: 98%; height: auto; auto; padding: 4px; position: relative;' border='1'>
					<tbody>
					  <tr>
						<td colspan='3' style='text-align:center;'>
								<h2><b>QUOTATION DETAILS<b></h2>
						</td>
						<td colspan='1' style='text-align:center;'>
							<img src='https://jesusonline.live/aa-form-images/logo-emvicta-motto.jpg' hspace=2 vspace=2 width='90' alt=''>
						</td>
					  </tr>
						<tr>
							<td colspan='4' style='text-align:center; background:$var_dark_blue'>
								<b>Please click the link to accept or query this quotation</b>
							</td>
						</tr>
						<tr>
							<td colspan='4' style='text-align:left;'>
								<br>Dear $var_name, 
								<br><br>Thank you for your interest in the workers of the Emvicta Construction Team. Please just click on the quote link to view your quotation details - $var_quote_link
								<br><br>You can approve or send questions by updating the bottom of the quote form. We look forward to working with you.
								<br><br>Best Regards Chrystal,
								<br>The Emvicta Construction Team,
								<br>Mobile:0424371655
							</td>
					  </tr>
				</body>
				</html>";

				$var_from_email = "info@jokesforjesus.com";
				$var_from_email = "sales@ebooksonline.live";
				$to = 'max.emberson@yahoo.com.au'; 
				$subject = $_POST['send_email_subject'];
				$var_reply_email = "chrystals@emvictaconstruction.com.au";
				$headers = "MIME-Version: 1.0" . "\r\n";
				$headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
				$headers .= "From: info<$var_from_email>" . "\r\n";
				if ($_POST['send_email_cc1'] != "") {
					$headers .= "Cc: {$_POST['send_email_cc1']}" . "\r\n";
				}
				$headers .= "Reply-To:$var_reply_email" . "\r\n";
				// $headers .= 'Bcc: welcome2@example.com' . "\r\n";

				// Send email
				if(mail($to,$subject,$htmlContent,$headers)):
					$_POST['update_valid'] = "Your quote email is sent to {$_POST['send_email_recipient1']}. You can view the log in the Comms tab.";
				else:
					$_POST['update_error'] = "Your quote email was NOT sent to {$_POST['send_email_recipient1']}. However, you can view the log in the Comms tab.";
				endif;

				// ### INSERT COMMS RECORD AND SET STATUS MESSAGE
				$data_rec = array();
				$data_rec['biz_table_proc_name'] = "aaaa_biz2_work_quotes";
				$data_rec['biz_table_id'] = $_POST['id'];
				$data_rec['comm_details'] = "Quotation sent to client";
				$data_rec['comm_status'] = "Quote_sent";
				$data_rec['date_comm_sort'] = date('Y/m/d H:i');
				$data_rec['date_comm'] = date('d/m/Y H:i');
				$this->db->insert('aaaa_biz_comms', $data_rec); 

				// ### SET QUOTE STATUS 
				$data_rec = array();
				$data_rec['quote_status'] = "Quote_sent"; 

				$this->db->where('id', $_POST['id']); 
				$this->db->update($key_table, $data_rec); 
				
			}
		} else {
			$_POST['update_error'] = "Please set one recipient and select an email subject.";
		}
	}
	
	public function edit_quote() {

		// #### GET BASIC QUOTE UPDATES WORKING - THEN NOTES ON COMMS - THEN SOME INVOICES AND PAYMENTS 
		// #### DATA FILTER - INCLUDING THE POST CODE ITEMS TO WORK ALSO 
		// // echo  "<br>!! 77 AA post is "; 
				
		// error_reporting(0); 
		//############# NEW PRAYERS CODE ############# 
		$var_userid = $this->session->userdata('userid'); 
		$varcompid = $_POST['sess_compid']; 
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs(); 
		$key_table = "aaaa_biz2_work_quotes"; 

		if ($_POST['add_record'] == "yes") {
			$id = 0; // 
		} elseif ($_POST['id'] > 0) {
			$id = $_POST['id']; // 
		}

		if (isset($_POST['quote_title'])) {

			$data_rec = array();
			$date_array = explode("/",$_POST['date_due']);
			$data_rec['date_due_sort'] = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0];
			$data_rec['date_due'] = $_POST['date_due'];
			$data_rec['quote_title'] = $_POST['quote_title'];
			$data_rec['biz_client_id'] = $_POST['biz_client_id'];
			$data_rec['quote_status'] = htmlentities($_POST['quote_status']); 
			$data_rec['notes_client'] = $_POST['notes_client']; 
			$data_rec['notes_quote'] = $_POST['notes_quote']; 
			$data_rec['biz_client_contact_id'] = $_POST['biz_client_contact_id']; 
			
			$data_rec['qt_com_or_resi'] = htmlentities($_POST['qt_com_or_resi']);
			$data_rec['qt_journey_stage'] = htmlentities($_POST['qt_journey_stage']);
			$data_rec['qt_powerwall_need'] = htmlentities($_POST['qt_powerwall_need']);
			
			if ($_POST['active'] == "Y") {
				$data_rec['active'] = "Y";
			} else {
				$data_rec['active'] = "N";
			}
			
			$data_rec['quote_detail_rows'] = $this->process_quote_lines();
			
			if ($_POST['id'] != 0 and $_POST['id'] != "") { 
				$this->db->where('id', $_POST['id']);
				$this->db->update($key_table, $data_rec);
			} else { 
				// #### SET THIS ONCE 
				if ($_POST['sess_compid'] != "") { 
					$data_rec['compid'] = $_POST['sess_compid'];
				}
				$data_rec['quote_status'] = "Quote_Draft";
				$this->db->insert($key_table, $data_rec);
				$id = $this->db->insert_id();
				// // echo  "<br>!!66bb table is $key_table ID IS $id";
				$_POST['id'] = $id;
			}
			
			if ($_POST['add_item_type'] != "" and $_POST['add_item_title'] != "" and $_POST['add_item_date'] != "") {
				$data_rec = array(); 
				$data_rec['item_type'] = $_POST['add_item_type']; 
				$data_rec['item_title'] = $_POST['add_item_title']; 
				$data_rec['item_date'] = $_POST['add_item_date']; 
				$date_array = explode("/",$data_rec['item_date']); 
				$data_rec['item_date_sort'] = $date_array[2] . "-" . $date_array[1] . "-" . $date_array[0]; 
				$data_rec['biz_quote_id'] = $_POST['id']; 
				// var_dump($data_rec); 
				$this->db->insert('aaaa_biz2_work_items', $data_rec); 
			} 
			if ($_POST['add_item_type2'] != "" and $_POST['add_item_title2'] != "" and $_POST['add_item_date2'] != "") { 
				$data_rec = array(); 
				$data_rec['item_type'] = $_POST['add_item_type2']; 
				$data_rec['item_title'] = $_POST['add_item_title2']; 
				$data_rec['item_date'] = $_POST['add_item_date2']; 
				$date_array = explode("/",$data_rec['item_date']); 
				$data_rec['item_date_sort'] = $date_array[2] . "-" . $date_array[1] . "-" . $date_array[0]; 
				$data_rec['biz_quote_id'] = $_POST['id']; 
				// var_dump($data_rec); 
				$this->db->insert('aaaa_biz2_work_items', $data_rec); 
			} 
			
			$data_rec = array(); 
			$data_rec['first_name'] = $_POST['first_name']; 
			$data_rec['last_name'] = $_POST['last_name']; 
			$data_rec['mobile'] = $_POST['mobile']; 
			$data_rec['email'] = $_POST['email']; 
			// // var_dump($data_rec);
			
			$this->db->where('userid', $_POST['biz_client_id']); 
			$this->db->update('ainf_vps3_users', $data_rec); 

			
			
			// // echo  "<br>yy upd is {$_POST['update_and_email']} confirm is {$_POST['update_and_email_confirm']}";
			if ($_POST['update_and_email'] == "Y" and $_POST['update_and_email_confirm'] == "Y") {
				// // echo  "<br>yy2 upd is {$_POST['update_and_email']} confirm is {$_POST['update_and_email_confirm']}";
				$this->process_email_request();
			} elseif ($_POST['update_and_email'] == "Y" or $_POST['update_and_email_confirm'] == "Y") {
				$_POST['update_error'] = "Please check the confirm checkbox and submit the send email to send your email";
			}
		}

		$sql = "select * from aaaa_biz2_work_items where biz_quote_id = {$_POST['id']} order by item_type, item_date_sort desc "; 
		$data['items_list'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from aaaa_biz_companies where compid = $varcompid and active = 'Y' order by biz_comp_name"; 
		$data['biz_comp_list'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from ainf_vps3_code_manager where code_group = 'site_work_type' order by code_name"; 
		$data['work_types'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'email_quote_subjects' order by code_id";
		$data['email_quote_subjects'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'quote_item_types' order by code_id";
		$data['item_type_list'] = $this->db->query($sql)->result_array();
		
		// // // // // var_dump($data['email_quote_subjects']);
		
		$sql = "select * from aaaa_biz_work_rates where compid = $varcompid and active = 'Y' order by work_type";
		$data['work_rates_list'] = $this->db->query($sql)->result_array();
		
		If ($_POST['return_to_list'] == "yes" and $_POST['update_and_email'] != "Y") {
			redirect('/Biz_quotes/listing/manage_key_lists_4'); 
		} else { 
		
			//############# RUN QUERIES FOR THE SCREEN ############# 
			
			$sql = "select * from ainf_xmodule2 where active = 'D' order by module_order_tot"; 
		
			if (trim($id) != "" and $_POST['id'] != "") { 

				//############# NEW PRAYERS CODE ############# 
				
				$sql = "select * from aaaa_biz_comms where biz_table_id = {$_POST['id']} and biz_table_proc_name = 'aaaa_biz2_work_quotes' order by date_comm_sort desc ";
			// // // echo  "<br>!! 88a 11 ";
				$data['comms_made'] = $this->db->query($sql)->result_array();
			
				$sql = "select * from $key_table where id = {$_POST['id']} "; 
			// // // echo  "<br>!! 88a 22 ";
				$data['edit_rec'] = $this->db->query($sql)->result_array(); 
				
				foreach($data['edit_rec'] as $y) {
					$sql = "select first_name, last_name, mobile, email, userid from ainf_vps3_users where userid = {$y['biz_client_contact_id']} ";
					// // echo  "<br>!! 88a 33 sql $sql";
					$data['quote_contact'] = $this->db->query($sql)->result_array(); 
				}

				foreach ($data['edit_rec'] as $z) {
					$var_biz_client_id = $z['biz_client_id'];
				}
				if ($var_biz_client_id != "") {
					$sql = "select * from ainf_vps3_users where user_type like '%$var_biz_client_id%' ";
					// // echo  "<br>!! 88a 44 ";
					$data['worker_contacts'] = $this->db->query($sql)->result_array(); 
				}
				// // echo  "<br>!! 88 55 {$_POST['update_valid']}"; 

				//############# NEW PRAYERS CODE ############# 
				$_POST['id'] = $id; 
				$this->load->view('biz_update_quote3.php', $data); 

			} else { 
				
				// // echo  "<br>!! 88 77 {$_POST['update_valid']}";
				
				$_POST['id'] = 0;
				$_POST['quote_status'] = "Quote_Draft"; 
				$this->load->view('biz_update_quote3.php', $data); 
			}
		}
	}

	public function listing($pagename)
	{
		
		//############# NEW PRAYERS CODE #############
		// $var_userid = $this->session->userdata('userid');

		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];

		// $varcompid = $_POST['sess_compid'];
		// $data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$key_table = "aaaa_biz_work_rates";
		$key_table = "aaaa_biz2_work_quotes";

		if ($_POST['add_record'] == "yes") {
			$id = 0; // value set from listing
		} elseif ($_POST['id'] > 0) {
			$id = $_POST['id']; // value set from listing
		}
		
		error_reporting(0);
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		$varcompid = 150;

		// PARAM REC 
		// ### THIS MONTH 
		$sql = "select * from $key_table where compid = $varcompid and active = 'Y' order by work_type ";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		// // var_dump($data['main_list_array_tab1']);

		//### DEPOSIT INACTIVE 
		$sql = "select * from $key_table where compid = $varcompid and active = 'N' order by work_type "; 
		// // // // // // // // // echo  "<br><br>!! 88 sql $sql "; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		// // // // // // // var_dump($data['main_list_array_tab2']);
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}

	public function summary($pagename)
	{
		
		// // // // // // // // // // // echo  "<br>!!11 ";
		error_reporting(0);
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];

		// PARAM REC 
		// // // // // // // // // // // echo  "<br>!!22 "; 
		$sql = "select * from aaa_data_params"; 
		$data['drive_loadup'] = $this->db->query($sql)->result_array(); 
		// // // // // // // // // // // echo  "<br>!!33 ";
		// // // // // // // // var_dump($data['drive_loadup']); 

		// MAIN SQLS FOR AUSTRALIA 
		$sql = "select * from aaa_data_logs order by status, date_end_sort limit 0,30 "; // compid_group allows for users going to multiple churches 
		$data['recent_logs'] = $this->db->query($sql)->result_array(); 

		// MAIN SQLS FOR AUSTRALIA 
		$sql = "select count(id) from aaa_oz_v2 where state not in ('State') order by state"; // compid_group allows for users going to multiple churches 
		$data['total_oz'] = $this->db->query($sql)->result_array(); 
		
		// // // // // // // // // // // echo  "<br>!!22";
		if (1==2) {
		$sql = "select state from aaa_oz_v2 where state in ('VIC','vic','Vic') "; // compid_group allows for users going to multiple churches 
		$data['total_state_vic'] = $this->db->query($sql)->result_array(); 
		$sql = "select count(id) from aaa_oz_v2 where state in ('NSW','nsw','Nsw') "; // compid_group allows for users going to multiple churches 
		$data['total_state_nsw'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('QLD','qld','Qld') "; // compid_group allows for users going to multiple churches 
			$data['total_state_qld'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('SA','sa','Sa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_sa'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('WA','wa','Wa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_wa'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('WA','wa','Wa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_wa'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('NT','nt','Nt') "; // compid_group allows for users going to multiple churches 
			$data['total_state_nt'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('ACT','act','Act') "; // compid_group allows for users going to multiple churches 
			$data['total_state_act'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('TAS','tas','Tas') "; // compid_group allows for users going to multiple churches 
			$data['total_state_tas'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state not in ('State','NSW','VIC','QLD','SA','WA','NT','ACT','TAS') "; // compid_group allows for users going to multiple churches 
			$data['total_state_other'] = $this->db->query($sql)->result_array(); 
			$var_full_count = count($data['total_oz']); 
		}
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		// ### VISITORS ATTENDEES IN LAST WEEK 
		$new_visitors_date = date('Y/m/d', strtotime('-7 days')); 
		$var_search_event = "," . $_POST['id'] . ",";
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort > '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_new'] = $this->db->query($sql)->result_array();
		
		// ### REGULARS BEYOND LAST WEEK 
		$var_search_event = "," . $_POST['id'] . ","; 
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort < '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_regular'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}
		
}
	
