<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Campaign_templates5 extends CI_Controller { 
	// Rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Smscurlapi');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');			
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // // // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // echo "!! must write other functions code for funciton $callfunction";
		}
	}

		
	public function load_data() {
		
		$file = fopen("C:\\xampp\\htdocs\\aawebcore-ci311\\bcit-ci-311-dragon-DEMO-b\\audience-segments_files\\aust-postcode-population.csv", "r");
		if ($file) {
			// rec 233859 must be followed by 233860
			$num = 0; $count = 0;
			while(!feof($file)) {

				$line = fgets($file);
				$recarray = explode(',',$line);

				$insarray = array();
				$insarray['num_gen_population'] = $recarray[3];
				$pcode_4digit = $recarray[0];
				$pcode_old_pop = $recarray[2];
				
				// $sqlup = "update aaz_stats_table set num_gen_population where pcode_4digit = '$pcode_4digit'";
				// $rec_upd = $this->db->query($sqlup)->result_array();
				$this->db->where('pcode_4digit', $pcode_4digit);
				$this->db->update('aaz_stats_table', $insarray);
				
			}
		}
		fclose($file);
	}
	
	public function template_view($campaign_id)
	{
		$sql = "select * from campaign_templates_5 where id = $campaign_id"; 
		$data['show_template'] = $this->db->query($sql)->result_array(); 
		$_POST['view'] = 1; 
		$this->load->view('template_display', $data); 
	}
	
	
	public function send_html_email()
	{
		// ### Email FORMAT DOES WORK FOR HTML FORMAT 
		$var_link = base_url() . "Biz_display_proc_doc/display_doc/aaaa_biz_work_quotes/" . $_POST['id']; 
		$var_quote_link = "<a href='$var_link'><u><b>click here.</u></b></a>"; 

		$var_dark_blue = "#0097b2"; $var_light_blue = "#5ce1e6";
		
		echo "<br>!! 11A ";
		if (1==2) {
			$sql = "select first_name, last_name, userid from ainf_vps3_users where 
			userid in (select biz_client_contact_id from aaaa_biz_work_quotes where id = {$_POST['id']} )";

			$var_client_contact_name = $this->db->query($sql)->result_array(); 
			$var_name = "Team Member";
			foreach ($var_client_contact_name as $x) {
				$var_name = $x['first_name'];
			}
			// echo "<br>!! First name is $var_name ";
		}
		$var_name = "Tanya Smith"; 
		$htmlContent = "
		<html>
		<body>
		  <table style='width: 98%; height: auto; auto; padding: 4px; position: relative;' border='1'>
			<tbody>
			  <tr>
				<td colspan='3' style='text-align:center;'>
						<h2><b>QUOTATION DETAILS<b></h2>
				</td>
				<td colspan='1' style='text-align:center;'>
					<img src='https://jesusonline.live/aa-form-images/logo-emvicta-motto.jpg' hspace=2 vspace=2 width='90' alt=''>
				</td>
			  </tr>
				<tr>
					<td colspan='4' style='text-align:center; background:$var_dark_blue'>
						<b>Please click the link to accept or query this quotation</b>
					</td>
				</tr>
				<tr>
					<td colspan='4' style='text-align:left;'>
						<br>Dear $var_name, 
						<br><br>Thank you for your interest in the workers of the Emvicta Construction Team. Please just click on the quote link to view your quotation details - $var_quote_link
						<br><br>You can approve or send questions by updating the bottom of the quote form. We look forward to working with you.
						<br><br>Best Regards Chrystal,
						<br>The Emvicta Construction Team,
						<br>Mobile:0424371655
					</td>
			  </tr>
		</body>
		</html>";

		$var_from_email = "info@jokesforjesus.com";
		$var_from_email = "sales@ebooksonline.live";
		$to = 'max.emberson@yahoo.com.au'; 
		$subject = $_POST['send_email_subject'];
		$var_reply_email = "chrystals@emvictaconstruction.com.au";
		$headers = "MIME-Version: 1.0" . "\r\n";
		$headers .= "Content-type:text/html;charset=UTF-8" . "\r\n";
		$headers .= "From: info<$var_from_email>" . "\r\n";
		if ($_POST['send_email_cc1'] != "") {
			$headers .= "Cc: {$_POST['send_email_cc1']}" . "\r\n";
		}
		$headers .= "Reply-To:$var_reply_email" . "\r\n";
		// $headers .= 'Bcc: welcome2@example.com' . "\r\n";

		// Send email
		if(mail($to,$subject,$htmlContent,$headers)):
		echo "<br>!! 77 ";
			$_POST['update_valid'] = "Your quote email is sent to {$_POST['send_email_recipient1']}. You can view the log in the Comms tab.";
		else:
		echo "<br>!! 88 ";
			$_POST['update_error'] = "Your quote email was NOT sent to {$_POST['send_email_recipient1']}. However, you can view the log in the Comms tab.";
		endif;
		
	}
	
	public function send_test_email($campaign_id)
	{
		$send = "YES"; $sent_num = 0;
		if ($send == "YES") {
			++$sent_num;
			$var_send_v1_test_set = "";
			if ($campaign_id != "") {
				$params = $this->db->query("select * from campaign_templates_5 where id = $campaign_id");
				$var_drive_params = $params->result_array();
				foreach($var_drive_params as $x) {
					$from_email = $x['va_send_email'];
					$_POST['view'] = 1;
					if ($_POST['view'] == 1) { // ### SWITCH ON TEMPLATE CHOICES LATER 1/2/3 FOR A-B TESTING 
						$var_html_template = $x['va_template_design'];
					} elseif ($_POST['view'] == 2) {
						$var_html_template = $x['template_design_v2'];
					}
					// // echo "<br>!!bb from email is $from_email";
					$var_send_v1_test_set = $x['send_v1_test_set'];
					// // echo "<br>!!cc var_send_v1_test_set is $var_send_v1_test_set";
				}
			}
			$from_email = "$var_from_email";
			// // echo "<br>!!22 var_send_v1_test_set is $var_send_v1_test_set";
			
			if (1 == 1) {
				$var_recs[0]['email'] = "newbluelinksysaws@proton.me";
				$var_recs[0]['email'] = "newbluelinksysaws@proton.me";
				$var_recs[1]['email'] = "newbluelinksysaws@proton.me";
				$var_recs[2]['email'] = "newbluelinksysaws@proton.me";
			} elseif ($var_send_v1_test_set != "") {
				// echo "<br>!!22aa sql is $sql ";
				$sql = "select code_name as email from ainf_vps3_code_manager where code_group = '$var_send_v1_test_set' order by code_name"; 
				// echo "<br> sql is $sql ";
				$q = $this->db->query($sql); 
				$var_recs = $q->result_array(); 
				var_dump($var_recs); 
			} elseif (1==1) {
				// echo "<br>!!22bb sql is $sql ";
				$q = $this->db->query("select * from aaa_oz_v2_testing order by id limit 0,7");
				$var_recs = $q->result_array();
			} else {
				// echo "<br>!!22cc sql is $sql ";
				// echo "<br>Loading array.. ";
				$var_recs = array();
				$var_recs[0]['email'] = "seed+64a7a885d33671e3614c1c98@emailconsul.com";
				$var_recs[1]['email'] = "econsul5@hotmail.com";
				$var_recs[2]['email'] = "econsulxx5@hotmail.com";
				$var_recs[3]['email'] = "econsulx9@hotmail.com";
				$var_recs[4]['email'] = "econsulxiii@hotmail.com";
				$var_recs[5]['email'] = "econsulxx8@hotmail.com";
				$var_recs[6]['email'] = "econsulxxi@icloud.com";
				$var_recs[7]['email'] = "econsul6@icloud.com";
				$var_recs[8]['email'] = "econsul4@icloud.com";
				$var_recs[9]['email'] = "econsulxxiv@icloud.com";
				$var_recs[10]['email'] = "econsulxx6@icloud.com";
				$var_recs[11]['email'] = "econsulxxi@aol.com";
				$var_recs[12]['email'] = "econsulxx3@aol.com";
				$var_recs[13]['email'] = "econsul6@aol.com";
				$var_recs[14]['email'] = "econsulx@aol.com";
				$var_recs[15]['email'] = "econsulx8@aol.com";
				$var_recs[16]['email'] = "econsul43@gmail.com";
				$var_recs[17]['email'] = "econsul19@gmail.com";
				$var_recs[18]['email'] = "econsul47@gmail.com";
				$var_recs[19]['email'] = "econsul45@gmail.com";
				$var_recs[20]['email'] = "econsul16@gmail.com";
				$var_recs[21]['email'] = "econsulx@yahoo.com";
				$var_recs[22]['email'] = "econsul9i@yahoo.com";
				$var_recs[23]['email'] = "econsulxi@yahoo.com";
				$var_recs[24]['email'] = "econsulx2@yahoo.com";
				$var_recs[25]['email'] = "econsulxx3@yahoo.com";
				foreach($var_recs as $x) {
					// echo "<br>email is {$x['email']}";
				}
			}
			
			// #### PROCESS TEST DATA HERE .. Get it into var_recs ####
			
			$var_recs = array();
			$var_from_email = "$var_from_email";
			$var_recs[0]['email'] = "newbluelinksysaws@proton.me";
			$var_recs[0]['email'] = "newbluelinksysaws@proton.me";
			$var_recs[1]['email'] = "newbluelinksysaws@proton.me";
			$var_recs[2]['email'] = "newbluelinksysaws@proton.me";
			var_dump($var_recs);
			$email_num = count($var_recs);
			
			// echo "<br>!!cc from email is $from_email email_num $email_num "; 
			// foreach($var_recs as $x) { 


				if (strpos($x['email'], "gmail.com") === false) {
					$to = $x['email'];
				} else {
					$to = "<" . $x['email'] . ">";
				}
				
				$to = "newbluelinksysaws@proton.me"; 
				$to = "newbluelinksysaws@proton.me"; // ## MUCH BETTER FOR TESTING ETC 
				
				$subject = "10 E-Books for $9.99 July Promotion. Read Now. "; 
				$subject = "Enjoy tonights dinner with this totally new recipe.. "; 
				$subject = "Did I leave my phone at your place.. "; 
				$var_type = "html"; 
				$var_type = "plain"; 
				if ($var_type != "html") {
					$headers = "From: <" . $from_email . "> " . "\r\n" . "Reply-To: <" . $from_email . ">" . "\r\n" . "X-Mailer: PHP/" . phpversion();
					$message = "Hi Max, " . "\r\n\r\n" . 
					"Can you check if I left my phone on the coffee table." . "\r\n\r\n" . 
					"Thanks, Michael" . "\r\n"; 
				} else {
					$headers = "From: <" . $from_email . "> " . "\r\n" . "Reply-To: <" . $from_email . ">" . "\r\n";
					// $headers .= "CC: susan@example.com\r\n";
					$headers .= "MIME-Version: 1.0\r\n";
					$headers .= "Content-Type: text/html; charset=UTF-8\r\n";
					$message = $var_html_template;
				}
				
					// #### \n CAN BE NEEDED HERE 
					$sender = $var_from_email;
					$recipient = $var_from_email;
					$recipient = 'newbluelinksysaws@proton.me';
					$recipient = 'newbluelinksysaws@proton.me';

					$subject = "Are you available for our demo tomorrow?";
					$message = "We trust that you are available for our demo tomorrow?";
					$headers = 'From:' . $sender;

					$var_type = "plain"; 
					$var_type = "html"; 
					$this->send_html_email();
					if (1==1 or $var_type == "html") {
						$this->send_html_email();
					} elseif ($var_type == "plain") {
						// ######################################## 
						// #### THESE ARE WORKING QUITE OK ######## 
						// ######################################## 
						$to      = 'newbluelinksysaws@proton.me';
						$subject = 'Did I see you at Town Hall zz';
						$message = 'Hi Max, Did I see you at Town Hall? Please call me.. ';
						$headers = "From:info@jokesforjesus.com"       . "\n" .
									 "Reply-To:$var_from_email" . "\n" .
									 "Content-Type: 
									 text/plain; charset=utf-8" . "\n" . 
									 "X-Mailer: PHP/" . phpversion(); 
						$success = mail($to, $subject, $message, $headers); 
						echo "<br><br>!! <b>### ZZ Sent email with new sample</b>"; 
						
						// #### \n CAN BE NEEDED HERE 
						$to      = "newbluelinksysaws@proton.me";
						$subject = "Did I see you at Town Hall XXB";
						$message = "Hi Max, Did I see you at Town Hall? Please call me.. ";
						$headers = "From:info@jokesforjesus.com"       . "\n" .
									 "Reply-To:$var_from_email" . "\n" .
									 "X-Mailer:PHP/" . phpversion();

						$success = mail($to, $subject, $message, $headers);
						echo "<br><br>!! <b>### XXB Sent email with new sample</b>";
						
					} else {
						if (mail($recipient, $subject, $message, $headers))
						{
							echo "<b>!! GG Message accepted sent to $recipient</b>";
						}
						else
						{
							// echo "Error: Message not accepted"; 
							echo "<b>!! GG Error: Message not accepted sent to $recipient</b>"; 
						}					
						echo "<br><br>!! <b>### GG Sent email with new sample</b>";
						
						// #### \n CAN BE NEEDED HERE 
						$to      = "newbluelinksysaws@proton.me";
						$subject = "Did I see you at Town Hall HH";
						$message = "Hi Max, Did I see you at Town Hall? Please call me.. ";
						$headers = "From:info@jokesforjesus.com"       . "\r\n" .
									 "Reply-To:$var_from_email" . "\r\n" .
									 "Content-Type: text/plain; charset=utf-8" . "\r\n" . 
									 "X-Mailer: PHP/" . phpversion();

						$success = mail($to, $subject, $message, $headers);
						echo "<br><br>!! <b>### HH Sent email with new sample</b>";
					
						// #### \n CAN BE NEEDED HERE 
						$to      = "newbluelinksysaws@proton.me";
						$subject = "Did I see you at Town Hall LL";
						$message = "Hi Max, Did I see you at Town Hall? Please call me.. ";
						$headers = "From:info@jokesforjesus.com"       . "\n" .
									 "Reply-To:$var_from_email" . "\n" .
									 "X-Mailer: PHP/" . phpversion();

						$success = mail($to, $subject, $message, $headers);
						echo "<br><br>!! <b>### LL Sent email with new sample</b>";
						
						// #### \n CAN BE NEEDED HERE 
						$to      = "newbluelinksysaws@proton.me";
						$subject = "Did I see you at Town Hall MM";
						$message = "Hi Max, Did I see you at Town Hall? Please call me.. ";
						$headers = "From:info@jokesforjesus.com"       . "\n" .
									 "Reply-To:$var_from_email" . "\n" .
									 "X-Mailer: PHP/" . phpversion();

						$success = mail($to, $subject, $message, $headers);
						echo "<br><br>!! <b>### MM Sent email with new sample</b>";
					} 
				if (1==2) {
					// #### \n CAN BE NEEDED HERE 
					$to      = "newbluelinksysaws@proton.me";
					$subject = "Did I see you at Town Hall";
					$message = "Hi Max, Did I see you at Town Hall? Please call me.. ";
					$headers = "From: $var_from_email"       . "\n" .
								 "Reply-To: $var_from_email" . "\n" .
								 "X-Mailer: PHP/" . phpversion();

					$success = mail($to, $subject, $message, $headers);
					echo "<br><br>!! <b>### 00 Sent email with new sample</b>";
				} elseif (1==3) {
					$to      = "newbluelinksysaws@proton.me";
					$subject = "Did I see you at Town Hall";
					$message = "Hi Max, Did I see you at Town Hall? Please call me.. ";
					$headers = "From: $var_from_email"       . "\r\n" .
								 "Reply-To: $var_from_email" . "\r\n" .
								 "X-Mailer: PHP/" . phpversion();

					$success = mail($to, $subject, $message, $headers);
					echo "<br><br>!! <b>### 11 Sent email with new sample</b>";
				} else {
					$success = mail($to, $subject, $message, $headers);
				}

				if (!$success) {
					$errorMessage = error_get_last()['message'];
					echo "<br><br>!! <b>00 22 errorMessage $errorMessage</b>";
				} else {
					echo "<br><br>!! <b> 33 Registers email sent with NO errors errorMessage is $errorMessage</b>";
				}
				$var_stats .= "<br>Sent to $to - sent_num = $sent_num "; 
				// echo "<br>!!bb sent email from is $from_email to $to <br>headers are $headers "; 
			// }
		}
		// echo "<br>!!cc sent $sent_num now email is $from_email ";
						
	}
	
	public function template_edit()
	{
		error_reporting(0);
		//############# NEW PRAYERS CODE #############
		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();

		if ($_POST['add_record'] == "yes") {
			$id = 0; // value set from listing
		} elseif ($_POST['id'] > 0) {
			$id = $_POST['id']; // value set from listing
		}
		
		if (isset($_POST['title'])) {
			$data_rec = array();
			$data_rec['title'] = $_POST['title'];
			if ($_POST['active'] == "Y") {
				$data_rec['active'] = "Y";
			} else {
				$data_rec['active'] = "N";
			}
			
			// ##### 
			$data_rec['send_v1_test_set'] = $_POST['send_v1_test_set'];
			$data_rec['rating'] = $_POST['rating'];
			$data_rec['template_send_email'] = $_POST['template_send_email']; $data_rec['template_bcc_email'] = $_POST['template_bcc_email'];
			$data_rec['temp_for_live'] = $_POST['temp_for_live'];
			if ($_POST['temp_active_jspec'] == "Y") { $data_rec['temp_active_jspec'] = "Y"; } else { $data_rec['temp_active_jspec'] = "N"; }
		
			$data_rec['va_send_email'] = $_POST['va_send_email']; $data_rec['va_send_design'] = $_POST['va_send_design'];
			$data_rec['va_send_gmail_rating'] = $_POST['va_send_gmail_rating']; $data_rec['va_send_yahoo_rating'] = $_POST['va_send_yahoo_rating'];
			$data_rec['sales_url'] = $_POST['sales_url']; $data_rec['design_url'] = $_POST['design_url'];
			$data_rec['strategy_notes'] = $_POST['strategy_notes']; 

			$data_rec['va_template_design_rating'] = $_POST['va_template_design_rating'];
			$data_rec['va_greeting'] = $_POST['va_greeting']; 
			$data_rec['va_template_design'] = $_POST['va_template_design'];  $data_rec['va_template_design_html'] = $_POST['va_template_design_html']; 
			if ($_POST['va_opt_out_tested'] == "Y") { $data_rec['va_opt_out_tested'] = "Y"; } else { $data_rec['va_opt_out_tested'] = "N"; } 
			
			$data_rec['vb_send_email'] = $_POST['vb_send_email']; $data_rec['vb_send_design'] = $_POST['vb_send_design'];
			$data_rec['vb_send_gmail_rating'] = $_POST['vb_send_gmail_rating']; $data_rec['vb_send_yahoo_rating'] = $_POST['vb_send_yahoo_rating'];
			$data_rec['vb_template_design_rating'] = $_POST['vb_template_design_rating'];
			$data_rec['vb_greeting'] = $_POST['vb_greeting']; 
			$data_rec['vb_template_design'] = $_POST['vb_template_design']; $data_rec['vb_template_design_html'] = $_POST['vb_template_design_html']; 
			if ($_POST['vb_opt_out_tested'] == "Y") { $data_rec['vb_opt_out_tested'] = "Y"; } else { $data_rec['vb_opt_out_tested'] = "N"; } 
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('campaign_templates_5', $data_rec);
			} else {
				$this->db->insert('campaign_templates_5', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		If ($_POST['submit_test_v1'] == "Y") {
			$this->send_test_email($id);
		}
		
		// echo "<br> BACK IN EDIT FUNCTION ";
		
		If ($_POST['submit_test_sms'] == "yes") {
			// $this->Smscurlapi->sendsms($_POST['sms_test_number'], $_POST['sms_message']); // ### GET AND FILE KEY REPLY DATA 
			// $data_rec['proj_test_count'] = $_POST['proj_test_count']+1;
			// $data_rec['proj_test_date'] = date('d/m/Y H:i:s');
		}
		If ($_POST['submit_campaign'] == "yes") {
			// $this->Smscurlapi->sendsms($_POST['sms_test_number'], $_POST['sms_message']); // ### GET AND FILE KEY REPLY DATA 
		}
		
		If ($_POST['return_to_list'] == "yes" and $_POST['submit_test_v1'] != "Y") {
			redirect('Campaign_templates5/details/manage_key_lists_4');
		} else {
			
			//############# RUN QUERIES FOR THE SCREEN ############# 
			$sql = "select * from ainf_vps3_code_manager where code_group like '%email_test_%' order by code1"; //### New access levels 
			$data['test_email_groups'] = $this->db->query($sql)->result_array(); 
			if ($id != "") {
				$sql = "select * from campaign_templates_5 where id = $id"; // echo "<br>!! cc sql $sql "; 
				$data['this_campaign'] = $this->db->query($sql)->result_array(); 
			}
		
			if (trim($id) != "") {
				//############# NEW PRAYERS CODE ############# 
				$_POST['id'] = $id;
				$this->load->view('update_em_template_v5', $data);
			} else {
				$_POST['id'] = 0;
				$this->load->view('update_em_template_v5', $data);
			}
		}
		
	}
		
	public function sms_edit()
	{
		error_reporting(0);
		//############# NEW PRAYERS CODE #############
		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();

		if ($_POST['add_record'] == "yes") {
			$id = 0; // value set from listing
		} elseif ($_POST['id'] > 0) {
			$id = $_POST['id']; // value set from listing
		}
		
		if (isset($_POST['title'])) {
			$data_rec = array();
			$data_rec['title'] = $_POST['title'];
			$data_rec['sms_test_number'] = $_POST['sms_test_number'];
			$data_rec['sms_group_numbers'] = $_POST['sms_group_numbers'];
			$data_rec['sms_message'] = $_POST['sms_message'];
			$data_rec['sms_campaign_notes'] = $_POST['sms_campaign_notes'];
			if ($_POST['active'] == "Y") {
				$data_rec['active'] = "Y";
			} else {
				$data_rec['active'] = "N";
			}
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('campaign_templates_5', $data_rec);
			} else {
				$this->db->insert('campaign_templates_5', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		If ($_POST['submit_test_sms'] == "yes") {
			$this->Smscurlapi->sendsms($_POST['sms_test_number'], $_POST['sms_message']); // ### GET AND FILE KEY REPLY DATA 
			// $data_rec['proj_test_count'] = $_POST['proj_test_count']+1;
			// $data_rec['proj_test_date'] = date('d/m/Y H:i:s');
		}
		If ($_POST['submit_campaign'] == "yes") {
			$this->Smscurlapi->sendsms($_POST['sms_test_number'], $_POST['sms_message']); // ### GET AND FILE KEY REPLY DATA 
		}
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/Smscampaigns3/details/manage_key_lists_4');
		} else {
			
			//############# RUN QUERIES FOR THE SCREEN ############# 
			$sql = "select * from campaign_templates_5 where id = $id"; 
			// echo "<br>!! fff sql $sql "; 
			$data['this_campaign'] = $this->db->query($sql)->result_array(); 
			// // var_dump($data['this_campaign']); 
		
			if (trim($id) != "") {
				//############# NEW PRAYERS CODE ############# 
				$_POST['userid'] = $id;
				$this->load->view('update_sms', $data);
			} else {
				$_POST['userid'] = 0;
				$this->load->view('update_sms', $data);
			}
		}
		
	}
		
	public function member_edit()
	{

		error_reporting(0);

		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$varcompid2 = $varcompid;
		
		if ($_POST['add_vid_sent_id'] != "") {
			$data_rec = array();
			$data_rec['compid'] = $varcompid;
			$data_rec['mastercompid'] = 113; 
			$data_rec['vid_videoplay_id'] = $_POST['add_vid_sent_id']; 
			$data_rec['vid_sent_notes'] = $_POST['add_vid_sent_notes']; 
			$data_rec['vid_sent_date_sort'] = date('Y/m/d H:m:s'); 
			$data_rec['vid_memberid_to'] = $_POST['userid'];
			$data_rec['vid_memberid_from'] = $var_userid;
			$this->db->insert('ainf_xcloud_vid_sent', $data_rec);
			// $id = $this->db->insert_id(); 
		}
		unset($_POST['add_vid_sent_id']);
		unset($_POST['add_vid_sent_notes']);

		$this->Attendee_mods->update_attendee($varcompid2);
		
		if ($_POST['add_record'] == "yes") {
			$id = 0; // value set from listing
		} elseif ($_POST['id'] > 0) {
			$id = $_POST['id']; // value set from listing
		} elseif ($_POST['userid'] > 0) {
			$id = $_POST['userid']; // value set from edit form
		} elseif ($_POST['userid_new'] > 0 and $_POST['userid_new'] != "") {
			$id = $_POST['userid_new'];
		}
		
		$varcompid = $_POST['sess_compid'];
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'";
		$data['recommend_video'] = $this->db->query($sql)->result_array();
		$varcompid = $_POST['sess_compid'];

		$access_max_level = $this->session->userdata('proteam_access_level') + 1;
		$sql = "select * from ainf_vps3_code_manager where code_group = 'admin_jesus' and code1 < $access_max_level order by code1"; //### New access levels
		// // // // // echo "security sql = $sql";
		$data['access_levels'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group like '%email_test_%' order by code1"; //### New access levels
		$data['test_email_groups'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'family_type' order by code1"; //### New access levels
		$data['family_types'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid and my_family_userids not like '%$id%' order by last_name, first_name";
		$data['poss_family_names'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users, ainf_vps3_code_manager where my_family_role = code_name and code_group = 'family_type' and ainf_vps3_users.compid = $varcompid and my_family_userids like '%,$id,%' order by code1, last_name, first_name";
		$data['my_family_names'] = $this->db->query($sql)->result_array();
		$sql = "SELECT * FROM `ainf_vps3_code_manager` where code_group = 'request_status'";
		$data['list_req_status'] = $this->db->query($sql)->result_array();
		
		//### new attendees today 
		$sql = "select * from campaign_templates_5 where active = 'Y'";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		// // var_dump($data['main_list_array_tab1']);
		
		$sql = "select * from campaign_templates_5 where active not in ('Y') ";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from campaign_templates_5 where active = 'Y'";
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from campaign_templates_5 where active = 'N'";
		$data['main_list_array_tab4'] = $this->db->query($sql)->result_array();
		
		If ($_POST['return_to_list'] == "yes") {
		// // // // // echo "<br>!!yy";
			if ($_POST['return_url'] != "") {
				$varul = "/" . $_POST['return_url'];
				// // // // // // echo "!!! varul is $varul";
				redirect($varul); // back to source page // allows attendee edit from multiple sources 
			} else {
				redirect('/attendees2/details/manage_key_lists'); // back to listing 
			}
		} elseif ($id != 0 and ($id != "" or $_POST['mod_record'] == "yes")) { // the id is always set from default record 
			// back to updates 
			if ($_POST['id'] > 0) {
				$id = $_POST['id']; // value set from listing 
			} elseif ($_POST['userid'] > 0) {
				$id = $_POST['userid']; // value set from edit form 
			}
			$sql = "select * from ainf_vps3_users where userid = $id";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			
			foreach ($data['edit_teampro_groups'] as $x) {
				$var_events_attended =  $x['events_attended']; 
				$var_events_attended = trim($var_events_attended,","); // remove trailing and leading commas 
				// $var_events_attended = "0,12";
				if ($var_events_attended == "") {$var_events_attended = "0,0";}
				$sql = "select * from teampro_events where compid = $varcompid and id in ($var_events_attended) order by date_sort desc limit 5";
				$data['recent_events'] = $this->db->query($sql)->result_array();
			}
			
			$_POST['userid'] = $id;
			$this->load->view('update_attendee', $data);
		} else {
			$_POST['userid'] = 0;
			$this->load->view('update_attendee', $data);
		}
	}

	public function meeting_edit()
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['title'])) {
			$data_rec = array();
			$data_rec = $_POST; 
			unset($data_rec['userid']); 
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_groups', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec['mastercompid'] = 113;
				$this->db->insert('teampro_groups', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			redirect('/teams2/details/index'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select * from teampro_groups where id = $id";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_meetings', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_meetings', $data);
		}
	}	

	public function visitors($pagename)
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid']; 
		$var_this_event_only = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event 
		
		$var_date_sort = date('Y/m/d');
		$var_date_sort = date('d/m/Y');
		$sql = "select id, date_sort, compid from teampro_events where compid = $varcompid and date_sort like ('%$var_date_sort%')";
		$sql = "select id, date, compid from teampro_events where compid = $varcompid and date like ('%$var_date_sort%')";
		$data['current_events'] = $this->db->query($sql)->result_array();
		$var_current_events_sql = ""; $var_ev_num = 0;
		foreach ($data['current_events'] as $x) {
			$var_current_events_sql .=  " and events_attended like '%,{$x['id']},%'";
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid $var_current_events_sql and is_visitor = 'yes'";
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and is_visitor = 'yes'"; // This is all visitors 
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		//// // var_dump($data['visitors_present']);
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_book'] = "";
			$_POST['form_speaker'] = "";
			$_POST['form_keywords'] = "";
		}
		if ($_POST['form_book'] != "") {
			$var_search .= " and book = '{$_POST['form_book']}' ";
		}
		if ($_POST['form_speaker'] != "") {
			$var_search .= " and teacher = '{$_POST['form_speaker']}' ";
		}
		
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_events where compid = $varcompid order by date_sort desc";
		$data['events_list'] = $this->db->query($sql)->result_array();
		// //// // var_dump($data['events_list']);

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // // // // // // echo "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();

		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();

		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_by'] = $this->db->query($sql)->result_array();

		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		// The left join gets the optional leader name 
		$sql = "select a.id, a.event_type, a.compid, a.details, a.leader, a.date, a.date_sort, a.title, a.event_tip, a.address, a.contact_1, a.contact_2, a.duration_note, 
		a.transport_1, a.transport_2, a.image_url, b.first_name as leader_first_name, b.last_name as leader_last_name 
		from teampro_events a 
		left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid = $varcompid order by date_sort desc"; 
		$data['events_list'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}
		
	public function load_sys_menu_tabs()
	{

		$sys_menu_links = explode("/",$_SERVER['REQUEST_URI']);
		// // var_dump($sys_menu_links);
		$end_link = count($sys_menu_links) - 1;
		$var_module_url = $sys_menu_links[$end_link - 2] . "/" . $sys_menu_links[$end_link - 1];
		// $sql = "select * from ainf_xmodule2 where module_url like '%$var_module_url%' ";
		$sql = "select * from ainf_xmodule2_tabs where ainf_xmodule2_tabs.xmodules_id in (select ainf_xmodule2.xmodules_id from ainf_xmodule2 where module_url like '%$var_module_url%') order by tab_label_order";
		$var_sys_menu_tabs = $this->db->query($sql)->result_array();
		return($var_sys_menu_tabs);
	}
	
	public function details($pagename)
	{
	
		// echo "<br>!! aa";
		//############# GET SYSTEM MENUS ############# 
		//############# THEN MAKE THIS A MODEL ############# 
		// $data['sys_menu_tabs'] = $this->load_sys_menu_tabs();
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		
		// $login_message ### find an easy way to pass this parameter.. 
		if ($login_message == "login") {
			$_POST['update_valid'] = "Welcome back to Church of Jesus";
		}
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];

		if ($_POST['add_followup'] == "yes" or $_POST['add_followup2'] == "yes") {
			$this->follow_up_edit();
		}
		
		if ($pagename == "needcontact4") {
			$attendee_type = "needcontact4";
			$pagename = "attendees4";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		//############# NEW PRAYERS CODE ############# 
		$sql = "select * from campaign_templates_5 where active = 'Y'";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		// // var_dump($data['main_list_array_tab1']);
		
		$sql = "select * from campaign_templates_5 where active not in ('Y') ";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from campaign_templates_5 where active = 'Y'";
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from campaign_templates_5 where active = 'N'";
		$data['main_list_array_tab4'] = $this->db->query($sql)->result_array();
		
		// // echo "<br>!!22";
		$sql = "select * from teampro_requests, ainf_vps3_users where  trim(req_update) is not null and trim(req_update) not in ('') and teampro_requests.compid = $varcompid and teampro_requests.request_userid_for = userid order by request_date_sort desc, request_userid_for "; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 
		// // var_dump($data['prayers_testimony']); 
		//############# NEW PRAYERS CODE ############# 

		//#### START FROM SUMMARY - BRINGING ANALYTICS INTO ONE FORM 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		$var_this_year_month = date('Y/m');
		$sql = "select * from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct follup_for from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%'"; 
		$data['followups_distinct_users_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct follup_contact_type from teampro_follow_ups where follup_contact_type is not null and compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month_contact_type'] = $this->db->query($sql)->result_array(); 
		//#### END FROM SUMMARY - BRINGING ANALYTICS INTO ONE FORM 
		
		$varcompid = $_POST['sess_compid']; 

		$var_search = "";
		
		// // echo "<br>!!33";
		// Process the form filter 
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		// // echo "<br>!!44";
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid =  $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$varsql = "";
		if (isset($_POST['form_attendee_type']) and $_POST['form_attendee_type'] != "All" and $_POST['form_attendee_type'] != "") {
			$varsql = " and {$_POST['form_attendee_type']} = 'yes' "; // Allows variable range of items to be selected 
		}
		
		$var_admin = $this->session->userdata('proteam_access');
		if ($var_admin == "Attendee_Admin") { // Just them and their family 
			$sql = "select * from ainf_vps3_users where userid = {$_POST['sess_userid']} order by first_name, last_name";
			$data['team_list'] = $this->db->query($sql)->result_array();
		} elseif ($attendee_type == "needcontact4") {
			$var_this_yr_month =  date("Y/m"); 
			// // // // // // // echo "<br>!! yyy/mm - $var_this_yr_month"; 
			$sql = "select * from ainf_vps3_users where compid = $varcompid $varsql and userid not in (select follup_for from teampro_follow_ups where  follup_contact_date_sort like '%$var_this_yr_month%') order by first_name, last_name"; 
			$data['team_list'] = $this->db->query($sql)->result_array(); 
		} else {
			$sql = "select * from ainf_vps3_users where compid = $varcompid $varsql order by first_name, last_name";
			$data['team_list'] = $this->db->query($sql)->result_array();
		}
		
		$var_shareid = "," . $varcompid . ","; 
		$sql = "select globcompanyname, globcompid, compid_sharing from ainf_xglobalclient where compid_sharing like '%$var_shareid%'"; 
		$sql = "select * from ainf_vps3_users where compid not in ($varcompid,0) and compid in (select globcompid from ainf_xglobalclient where compid_sharing like '%$var_shareid%' and mastercompid = 113) order by first_name, last_name"; 
		$sql = "select user_type, proteam_access, first_name, last_name, mobile, email, userid, compid, globcompid, globcompanyname, ainf_xglobalclient.compid_sharing from ainf_vps3_users, ainf_xglobalclient where compid = globcompid and compid not in ($varcompid,0) and compid in (select globcompid from ainf_xglobalclient where (ainf_xglobalclient.compid_sharing like '%$var_shareid%' or ainf_vps3_users.compid_sharing like '%$var_shareid%') and mastercompid = 113) order by globcompanyname, first_name, last_name"; 
		$data['team_list_shared'] = $this->db->query($sql)->result_array(); 
		// // var_dump($data['team_list_shared_2']);
		
		// // echo "<br>!!66";
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link from ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position"); 
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		
		// // echo "<br>!!77";
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		// // echo "<br>!!88";
		//## KEY LISTS FOR SUB LISTS  
		$var_start_date_sort_today = date('Y/m/d');
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and start_date_sort like '%$var_start_date_sort_today%' ";
		$data['visitors_today'] = $this->db->query($sql)->result_array();
		
		$var_start_date_sort_week = date('Y/m/d', strtotime('-8 days')); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and start_date_sort > 
		'$var_start_date_sort_week' order by start_date_sort desc";
		$data['visitors_week'] = $this->db->query($sql)->result_array();
		
		// // echo "<br>!!99";
		$var_start_date_sort_month = date('Y/m/d', strtotime('-31 days')); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and start_date_sort > 
		'$var_start_date_sort_month' order by start_date_sort desc"; 
		$data['visitors_month'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		//### new attendees today 
		$sql = "select * from campaign_templates_5 where active = 'Y'";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		// // var_dump($data['main_list_array_tab1']);		
		$sql = "select * from campaign_templates_5 where active not in ('Y') ";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from campaign_templates_5 where active = 'Y'";
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array();		
		$sql = "select * from campaign_templates_5 where active = 'N'";
		$data['main_list_array_tab4'] = $this->db->query($sql)->result_array();

		// // echo "<br>!!55 pagename_orig is $pagename_orig";
		if (1==1 or file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
		// // // echo "<br>qqAA orig page is $pagename_orig";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
		// // // echo "<br>qqBB orig page is $pagename_orig";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}
	public function summary($pagename)
	{
		
		error_reporting(0);
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		// ### VISITORS ATTENDEES IN LAST WEEK 
		$new_visitors_date = date('Y/m/d', strtotime('-7 days')); 
		$var_search_event = "," . $_POST['id'] . ",";
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort > '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_new'] = $this->db->query($sql)->result_array();
		
		// ### REGULARS BEYOND LAST WEEK 
		$var_search_event = "," . $_POST['id'] . ","; 
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort < '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_regular'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}

}
	
