<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Certify extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');			
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function certify_list($pagename)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);

		if ($_POST['video_type'] == "") {$_POST['video_type'] = "regular";}
		//*** Get page name for the link 
		
		if ($pagename == "video-player-bsbc-qrcodes") {
			$_POST['qr_code_link'] = "yes";
			$pagename = "video-player-bsbc-base";
		} else {
			$_POST['qr_code_link'] = "no";
		}
		
		if ($pagename == "recommended_videos2" or $pagename == "recommended_videos") {
			$_POST['pagename_mode'] = "recommended_videos";
			$pagename = "video-player-bsbc-v8";
			// // echo "<br>!! set as recommended on v7";
		} elseif ($pagename == "all_videos" or $pagename == "video-player-bsbc-base") {
			$_POST['pagename_mode'] = "all_videos";
			$pagename = "video-player-bsbc-v7";
			$pagename = "video-player-bsbc-base";
			$pagename = "video-player-bsbc-v8";
			// // echo "<br>!! set as all on v7 mode is {$_POST['pagename_mode']}";
		} elseif ($pagename == "tract_videos") {
			$_POST['pagename_mode'] = "tract_videos";
			$pagename = "video-player-bsbc-v8";
			// // echo "<br>!! set as tract on v7";
		} elseif ($pagename == "video-player-bsbc-qrcodes") {
			$_POST['pagename_mode'] = "video-player-bsbc-qrcodes";
			$_POST['qr_code_link'] = "yes";
			$pagename = "video-player-bsbc-base";
		} else {
			$_POST['pagename_mode'] = "regular_videos";
			$pagename = "video-player-bsbc-base";
		}
		
		$pagename = "course-player-v8";
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} 
		// index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid > 0 order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if (1==2) {
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
			$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book "; 
			$data['messages'] = $this->db->query($sql)->result_array(); 
			
			$num_rows1 = count($data['messages']);
			$recsperpage = 4;
			$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
			if ($_POST['page_tot'] < 1) { // reset the form values 
				$_POST['page_tot'] = 1;
			}
			if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
				$_POST['form_page'] = 1;
			}
			
			$_POST['page_curr'] = $_POST['form_page'];
			
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
			if ($_SERVER['REQUEST_METHOD'] == 'POST') {
				$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
			} else {
				$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
			}
		}
				
	
		$var_userid = $this->session->userdata('userid');
		if ($_POST['pagename_mode'] == "recommended_videos") {
			$ainf_fields = "audio_link, teacher_imagebg, book1, book1verse, book2, book2verse, book3, book3verse, book4, book4verse, book5, book5verse, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort ";
			$ainf_fields = "active, first_name, last_name, team_image_link, userid, audio_link, teacher_imagebg, book1, book1verse, book1verse_det, book2, book2verse, book2verse_det, book3, book3verse, book3verse_det, book4, book4verse, book4verse_det, book5, book5verse, book5verse_det, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, ainf_xcloud_videos.id, series, message, message_date_sort, vid_memberid_to, vid_sent_notes, vid_sent_date_sort ";
			// point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, ainf_xcloud_videos.id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort ";

			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select * from ainf_xcloud_videos where id in (select vid_videoplay_id from ainf_xcloud_vid_sent where vid_memberid_to = $var_userid) order by message_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher ";
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_vps3_users, ainf_xcloud_vid_sent where active = 'Y' and teacher_userid = ainf_vps3_users.userid and ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, first_name, last_name ";
			$data['messages'] = $this->db->query($sql)->result_array();
			// // var_dump($data['messages']);
			// echo "<br>!! RECO SQL IS $sql";
			// // // var_dump($data['messages']);
		} elseif ($_POST['pagename_mode'] == "all_videos") {
			$sql = "select * from ainf_xcloud_videos where video_type not in ('tract') and compid = $varcompid and active = 'Y'  order by message_date_sort desc, teacher ";
			$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where teacher_userid = ainf_vps3_users.userid and video_type not in ('tract') and ainf_vps3_users.compid = $varcompid and active = 'Y' order by message_date_sort desc, first_name, last_name ";
			$data['messages'] = $this->db->query($sql)->result_array();
			// echo "<br>!! ALL SQL IS $sql";
			// // // var_dump($data['messages']);
		} elseif ($_POST['pagename_mode'] == "tract_videos") {
			$sql = "select * from ainf_xcloud_videos where video_type = 'tract' and compid = $varcompid and active = 'Y'  order by message_date_sort desc, teacher ";
			$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where teacher_userid = ainf_vps3_users.userid and video_type = 'tract' and active = 'Y' order by message_date_sort desc, first_name, last_name ";
			$data['messages'] = $this->db->query($sql)->result_array();
			// echo "<br>!! TRACT SQL IS $sql";
			// // // var_dump($data['messages']);
		}
				
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// //// // // var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and compid = $varcompid order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array();
		
		// Very basic error handling 
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'";
		$sql = "select * from courses, ainf_xcloud_videos where courses.compid = $varcompid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 
		$sql = "select * from courses, ainf_xcloud_videos, ainf_vps3_users where courses.compid = $varcompid and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 
		
		echo "!! new sql $sql";

		// $data['course_list_active'] = $this->db->query($sql)->result_array(); 
		$data['messages'] = $this->db->query($sql)->result_array(); 
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // echo"!! must write other functions code for funciton $callfunction";
		}
	}

	public function questions($video_page)
	{

		// ### The for post is getting totally cleared when the file field for VIDEO_LINK is being loaded.. 
		// ### The for post is getting totally cleared when the file field is being loaded.. 
		error_reporting(E_ALL);
		error_reporting(0);

		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		// var_dump($data['sys_menu_tabs']);
		
		if (1==2) { //## Can create table if needed 
			// echo "Run sql on courses table<br><br>";
			$sql = "select * from courses2";
			$get_rec_forcopy = $this->db->query($sql)->result_array();
			// echo "Will dump courses table<br><br>";
			// // var_dump($get_rec_forcopy);
			// // echo "This is the dump on courses_questions table<br><br>";
		}

		$varcompid = $_POST['sess_compid'];
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'";
		$data['videos_full'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where compid = $varcompid order by first_name, last_name";
		$data['cse_leaders'] = $this->db->query($sql)->result_array();
		// // var_dump($data['cse_leaders']);

		if ($_POST['id'] != "") {
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid and id in (select vid_group_id from courses where id = {$_POST['id']})";
			$data['videos_course'] = $this->db->query($sql)->result_array();
			$sql = "select ainf_xcloud_videos.title, courses_questions.id, courses_questions.courses_id, courses_questions.question_order, courses_questions.question_text, courses_questions.answer_a, courses_questions.answer_b, courses_questions.answer_c, courses_questions.answer_d, courses_questions.answer_e, courses_questions.correct_answer_abcde 
			from courses_questions, ainf_xcloud_videos where ainf_xcloud_videos.id = question_video_id and 
			courses_questions.compid = $varcompid and courses_id = {$_POST['id']} order by question_order, courses_questions.id";
			// // // echo "<br>!! sql is $sql";
			$data['question_list'] = $this->db->query($sql)->result_array();
			// // // var_dump($data['question_list']);
		}
		
	if ($video_page == "update_course_detail") {
			$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
			$data['vidbooks'] = $this->db->query($sql)->result_array();
			if ($_POST['id'] != "") {
				$sql = "select * from courses where id = {$_POST['id']} limit 0,1";
				$data['videdit'] = $this->db->query($sql)->result_array();
			}
			// // // echo "<br>!! 55 will load update";
			$this->load->view($video_page, $data);
			
		} elseif ($video_page == "manage_key_lists_3") {
			$sql = "select * from courses where compid = $varcompid and active in ('Y') order by id desc "; 
			$data['course_list_active'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from courses where compid = $varcompid  and active not in ('Y') order by id desc "; 
			$data['course_list_inactive'] = $this->db->query($sql)->result_array();
			$sql = "select * from courses_questions where compid = 0 and courses_id = 0 and active in ('Y') order by id desc "; 
			$data['questions_active'] = $this->db->query($sql)->result_array();
			$sql = "select * from courses_questions where compid = 0 and courses_id = 0 and active not in ('Y') order by id desc "; 
			$data['questions_inactive'] = $this->db->query($sql)->result_array();
			$this->load->view($video_page, $data);
		}
	}

	public function course_views($video_page)
	{
		
		if (1==2) { //## Can create table if needed 
			// echo "Run sql on courses table<br><br>";
			$sql = "select * from courses2";
			$get_rec_forcopy = $this->db->query($sql)->result_array();
			// echo "Will dump courses table<br><br>";
			// // var_dump($get_rec_forcopy);
			// // echo "This is the dump on courses_questions table<br><br>";
		}

		$varcompid = $_POST['sess_compid'];
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'";
		$data['videos_full'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where compid = $varcompid order by first_name, last_name";
		$data['cse_leaders'] = $this->db->query($sql)->result_array();
		// // var_dump($data['cse_leaders']);

		if ($_POST['id'] != "") {
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid and id in (select vid_group_id from courses where id = {$_POST['id']})";
			$data['videos_course'] = $this->db->query($sql)->result_array();
			$sql = "select ainf_xcloud_videos.title, courses_questions.id, courses_questions.courses_id, courses_questions.question_order, courses_questions.question_text, courses_questions.answer_a, courses_questions.answer_b, courses_questions.answer_c, courses_questions.answer_d, courses_questions.answer_e, courses_questions.correct_answer_abcde 
			from courses_questions, ainf_xcloud_videos where ainf_xcloud_videos.id = question_video_id and 
			courses_questions.compid = $varcompid and courses_id = {$_POST['id']} order by question_order, courses_questions.id";
			// // // echo "<br>!! sql is $sql";
			$data['question_list'] = $this->db->query($sql)->result_array();
			// // // var_dump($data['question_list']);
		}
		
		if ($video_page == "update_course_detail") {
			$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
			$data['vidbooks'] = $this->db->query($sql)->result_array();
			if ($_POST['id'] != "") {
				$sql = "select * from courses where id = {$_POST['id']} limit 0,1";
				$data['videdit'] = $this->db->query($sql)->result_array();
			}
			// // // echo "<br>!! 55 will load update";
			$this->load->view($video_page, $data);
			
		} elseif ($video_page == "manage_key_lists") {
			$sql = "select * from courses where compid = $varcompid and active in ('Y') order by id desc "; 
			$data['course_list_active'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from courses where compid = $varcompid  and active not in ('Y') order by id desc "; 
			$data['course_list_inactive'] = $this->db->query($sql)->result_array(); 
			// // // echo "<br>!! 55 will load list";
			$this->load->view($video_page, $data);
		}
	}

}
	
