<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Cron_email_attendee_dates extends CI_Controller {

	public $userdata;

	public function __construct()
	{
		parent::__construct();
		
	}

	/*** End Functions ***/ 
	function sendreminders()
	{
	//### EMAIL PARTS 
		$var_name = "Leader";
		$message_start = "<br><br>Dear $var_name ";
		$message_start .= "<br><br>The report accuracy depends closely on the follow-ups by team members to get the correct data such as birthdays and 
		data on the prayer requests. To get a more accurate report, simply get your team to run a round of detailed follow-ups and the data will be 
		much more accurate and useful. 
		";
		$message_end = "<br><br>Best Regards,<br>Church of Jesus Automation Team";
		
	//### DATA COMPONENTS  
		$varcompid = 116;
		$varcompid = 125;
		$var_this_yr_month =  date("Y/m"); // Get the users NOT having follow_ups 
		$sql = "select * from ainf_vps3_users where compid = $varcompid $varsql and userid not in (select follup_for from teampro_follow_ups where  follup_contact_date_sort like '%$var_this_yr_month%') order by first_name, last_name";
		$follups_left = $this->db->query($sql)->result_array();
		//### PRAYER REQUESTS 
		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort like '%$var_this_yr_month%' order by userid, request_date_sort desc";
		$prayer_req_new = $this->db->query($sql)->result_array();
		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort not like '%$var_this_yr_month%' and req_status not in ('Answered') order by userid, request_date_sort desc";
		$prayer_req_open = $this->db->query($sql)->result_array();
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$this_months_key_dates = $this->db->query($sql)->result_array();
		
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		// echo "<br>!!! sql is $sql";
		$next_months_key_dates = $this->db->query($sql)->result_array();

		// SEND ONLY IF DUE BY DATE & FILES ARE OUTSTANDING 
		if (1==1 or $duetosend == "Yes") {
			// Locate the email template and then send the email 
			$to = "max.emberson@yahoo.com.au"; 
			// $to = $j['email']; 
			$email_lists .= "{$j['email']}, "; 

			$headers = "From: noreply@peakwebsystems.com\r\n";
			$headers .= "Return-Path: <".$to.">\r\n";
			$headers .= "MIME-Version: 1.0\r\n";
			if (1==1 or $to == "max@peakwebsystems.com") {
				$headers .= "Bcc:max.emberson@yahoo.com.au\r\n"; // omit paul from test emails
			} else {
				$headers .= "Bcc:paul@lending.sydney, max.emberson@yahoo.com.au\r\n";
			}
			$headers .= "Content-Type: text/HTML; charset=ISO-8859-1\r\n";
	//### FORMAT THE DATA 
			$run_mode = "email_report"; $var_message_body = "";
			include_once('include-birthday-prayer-list.php'); // this file needs to be in views and controllers
			$message = $message_start . $var_message_body . $message_end;

			if (1==1) {
				
				$subject = "Email Report on Key Dates and Prayer Requests for Attendees";
				mail($to, $subject, $message, $headers);
				++$recsentemail;
				
				// echo "<br><br><b>Planning to mail to $to</b> with subject $subject and email message as is here <br>$message ";
				// Insert an email record for the history of the send 
				if (1==2) {
				$insert_data = array();
					$vardate = date("d/m/Y");
					$vardate_sort = date("Y/m/d");
					// Set these fields with temp values
					$insert_data['compid'] = $compid;
					$insert_data['filefinance_id'] = $j['id'];
					$insert_data['template_to'] = $j['email']; //**
					$insert_data['first_name'] = $j['first_name'];
					$insert_data['last_name'] = $j['last_name'];
					$vardate = date("d-m-Y");
					$vardate_sort = date("Y-m-d");
					$insert_data['date_sent'] = $vardate;
					$insert_data['date_sent_sort'] = $vardate_sort;
					$insert_data['email_type'] = 'Sent-Reminder';
					$insert_data['template_subject'] = $var_msg_subject;
					$insert_data['template_from'] = 'noreply@peakwebsystems.com';
					$insert_data['template_name'] = "File Update Reminder";
					// $insert_data['template_cc'] = $j['template_cc'];
					// $insert_data['template_bcc'] = $j['template_bcc'];
					$insert_data['template_body'] = $message;
				$this->db->insert('email_templates', $insert_data);
				}
			}
		} else {
			// echo "<br><br><b>Planning to NOT mail to $to duetosend by date is $duetosend and filetosend = $filetosend</b> with this email message as is here $message ";
		}
		
	}
					    
}

?>