<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Database extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->helper('text');
		$this->load->helper('url');			
		
		$this->load->model('Asys_load_biz_v3'); //### FOR SYS FUNC
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$this->load->model('System_modules'); $this->load->model('Recheck_access');

		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and stripos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}

		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // echo"!! must write other functions code for funciton $callfunction";
		}
	}

	public function edit_tables()
	{

		// ### The for post is getting totally cleared when the file field is being loaded.. 
		error_reporting(0);
		
		$this->course_views();
		
	}

	public function course_views()
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if ($_POST['update_table'] != "") { 
			if (trim($_POST['base_table']) != "" and trim($_POST['new_table']) != "") { 
				// ### MOVE TO OTHER LOCATION SO RENAME CAN BE RUN ALSO 
				$this->Asys_load_biz_v3->sys_code_split('deactivate'); 
				redirect('bible3/bible_display'); 
				
				$sql = "RENAME TABLE `{$_POST['base_table']}` TO `{$_POST['new_table']}`";
				$data['run_table'] = $this->db->query($sql)->result_array();
				// echo "<br>Rename is complete";
			}
		}
		
		if ($_POST['update_sql'] != "") {
			// echo "<br>In sql run vars are sql command {$_POST['sql_command']}";
			$sql = $_POST['sql_command'];
			if (stripos($sql, "select") !== false or stripos($sql, "desc") !== false or stripos($sql, "show") !== false) {
				$data['run_table'] = $this->db->query($sql)->result_array();
			} elseif (stripos($sql, "drop") !== false) {
				// ### CANNOT DROP - BUT ALTER TABLES 
			} else {
				// ### NO RESULT FOR CHANGE // DROP // ALTER 
				$this->db->query($sql);
			}
		}

		$varcompid = $_POST['sess_compid'];
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'";
		$data['videos_full'] = $this->db->query($sql)->result_array();

		if ($_POST['id'] != "") {
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid and id in (select vid_group_id from courses where id = {$_POST['id']})";
			$data['videos_course'] = $this->db->query($sql)->result_array();
			$sql = "select ainf_xcloud_videos.title, courses_questions.id, courses_questions.courses_id, courses_questions.question_order, courses_questions.question_text, courses_questions.answer_a, courses_questions.answer_b, courses_questions.answer_c, courses_questions.answer_d, courses_questions.answer_e, courses_questions.correct_answer_abcde 
			from courses_questions, ainf_xcloud_videos where ainf_xcloud_videos.id = question_video_id and 
			courses_questions.compid = $varcompid and courses_id = {$_POST['id']} order by question_order, courses_questions.id";
			// // echo "<br>!! sql is $sql";
			$data['question_list'] = $this->db->query($sql)->result_array();
			// var_dump($data['question_list']);
		}
		
		$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
		$data['vidbooks'] = $this->db->query($sql)->result_array();
		if ($_POST['id'] != "") {
			$sql = "select * from courses where id = {$_POST['id']} limit 0,1";
			$data['videdit'] = $this->db->query($sql)->result_array();
		}
		// // echo "<br>!! 55 will load update";
		$this->load->view('update_tables_v2', $data);
			
	}

}
	
