<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Dataquery2 extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');			
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function summary_inserts()
	{
		// ### BEST START WORKING CODE BLOCK FOR SEX INSERTION SYDNEY 
		// ### LOAD SEX MATRIX 
		$run_stage_load = "no";
		if ($run_stage_load == "yes") {
			$data_rec = array();
			$var_city = "Melbourne"; $male_limit = 486;
			$var_city = "Sydney"; $male_limit = 531;
			
			$data_rec['country'] = "Australia"; $data_rec['filter'] = "Sex";
			if ($var_city == "Melbourne") {
				$data_rec['state'] = "VIC"; $data_rec['city'] = "Melbourne";
			} else {
				$data_rec['state'] = "NSW"; $data_rec['city'] = "Sydney";
			}
			for ($mils = 1; $mils < 9; $mils++) {
				$var_id_matrix = "";
				if ($var_city == "Melbourne") {
					if ($mils == 8) {$maxrecs = 365958;} else {$maxrecs = 500001;} // slightly less pop than Sydney 
				} else {
					if ($mils == 8) {$maxrecs = 499956;} else {$maxrecs = 500001;} // slightly less pop than Sydney 
				}
				for ($i = 1; $i < $maxrecs; $i++) {
					$var_result = $i % 1000;
					if ($var_result < $male_limit) {
						$var_id_matrix .= "Y,"; // Yes is affirmative for that related ID
					} else {
						$var_id_matrix .= "N,";
					}
				}
				$data_rec['filter_seq'] = $mils;
				$data_rec['matrix'] = rtrim($var_id_matrix, ", "); // remove last record.
				$this->db->insert('adat_nsw_summ_gender', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		// RACE FILTER PROCESSING 
		// English 26.1%, Australian 23.5%, Chinese 10.8%, Irish 7.9%, Scottish 6.2%, Italian 4.3%, Indian 4.3%, Other 16,9% 
		// E 26.1%, A 23.5%, C 10.8%, I 7.9%, S 6.2%, T 4.3%, D 4.3%, O 16,9% 
		// File race records 
		if ($_POST['race_english'] == "yes" and $_POST['race_australian'] == "yes" and $_POST['race_chinese'] == "yes" and $_POST['race_irish'] == "yes" 
		and $_POST['race_scottish'] == "yes" and $_POST['race_italian'] == "yes") {
			// //// echo "<br>All Races Selected";
		} else {
			// //// echo "<br><b>Filtering to Process for Races</b>";
		}
		
		
		// ### BEST START WORKING CODE BLOCK FOR RACE INSERTION SYDNEY 
		// RACE FILTER PROCESSING 
		// English 26.1%, Australian 23.5%, Chinese 10.8%, Irish 7.9%, Scottish 6.2%, Italian 4.3%, Indian 4.3%, Other 16,9% 
		// E 26.1%, A 23.5%, C 10.8%, I 7.9%, S 6.2%, T 4.3%, D 4.3%, O 16,9% 
		// File race records 
		$run_stage_load = "no"; 
 		if ($run_stage_load == "yes") {
			$var_city = "Sydney";
			$var_city = "Melbourne";
			for ($mils = 1; $mils < 9; $mils++) {
				$var_id_matrix = "";
				if ($var_city == "Melbourne") {
					if ($mils == 8) {$maxrecs = 365958;} else {$maxrecs = 500001;} // slightly less pop than Sydney 
				} else {
					if ($mils == 8) {$maxrecs = 499956;} else {$maxrecs = 500001;} // slightly less pop than Sydney 
				}
				for ($i = 1; $i < $maxrecs; $i++) {
					
					// An issue with the nested IF statement // 
					$var_result = $i % 100000; // The larger the number the more even the spread on sex by race 
					if ($var_city == "Sydney") {
						if ($var_result < 26258) {
							$var_id_matrix .= "E,"; // Yes is affirmative for that related ID
							//### this has too many even numbers - gives unrealistic round figures 
						} elseif ($var_result > 26257 and $var_result < 49697) {
							$var_id_matrix .= "A,";
						} elseif ($var_result > 49696 and $var_result < 60489) {
							$var_id_matrix .= "C,";
						} elseif ($var_result > 60488 and $var_result < 68396) {
							$var_id_matrix .= "I,";
						} elseif ($var_result > 68395 and $var_result < 74597) {
							$var_id_matrix .= "S,";
						} elseif ($var_result > 74596 and $var_result < 78898) {
							$var_id_matrix .= "T,";
						} elseif ($var_result > 78897 and $var_result < 83148) {
							$var_id_matrix .= "D,";
						} elseif ($var_result > 83147) {
							$var_id_matrix .= "O,";
						}
					} elseif ($var_city == "Melbourne") {
						if ($var_result < 28213) {
							$var_id_matrix .= "E,"; // Yes is affirmative for that related ID
						} elseif ($var_result > 28212 and $var_result < 54629) {
							$var_id_matrix .= "A,";
						} elseif ($var_result > 54628 and $var_result < 63692) {
							$var_id_matrix .= "I,";
						} elseif ($var_result > 63691 and $var_result < 72268) {
							$var_id_matrix .= "C,";
						} elseif ($var_result > 72267 and $var_result < 80537) {
							$var_id_matrix .= "S,";
						} elseif ($var_result > 80536 and $var_result < 87157) {
							$var_id_matrix .= "T,";
						} elseif ($var_result > 87156 and $var_result < 91849) {
							$var_id_matrix .= "D,";
						} elseif ($var_result > 91848) {
							$var_id_matrix .= "O,";
						}
					}
				}
				
				$data_rec['country'] = "Australia"; $data_rec['filter'] = "Race";
				if ($var_city == "Sydney") {
					$data_rec['state'] = "NSW"; $data_rec['city'] = "Sydney"; 
				} else {
					$data_rec['state'] = "VIC"; $data_rec['city'] = "Melbourne"; 
				}
				$data_rec['filter_seq'] = $mils;
				$data_rec['matrix'] = rtrim($var_id_matrix, ", "); // remove last record. 
				$this->db->insert('adat_nsw_summ_gender', $data_rec);
				$id = $this->db->insert_id();
			}
		}
	}

	public function summary($pagename) 
	// ### NEXT 
	// ### REDUCE CONTROLLER SIZE 
	// EXPAND TO INCLUDE MELBOURNE 
	// OPTIMISE SQLS 
	// OPTIMISE ARRAY PROCESSING 
	// TEST OUT NOSQL 
	// TEST FASTER SERVER 

	{ 

	// error_reporting(E_ALL);

	// echo "<br>!!11 here";

	// echo "<br>!!22 here";

	if ($_POST['form_active'] == "yes") { // Has form been run? 
	
		// CHECK IF TOTAL RECORD SAVED 
		// V2.5 OF TESSERAC 
		$found_result = "no"; 
		// ### PROCESSING BASED ON SEX 
		if ($_POST['sex_male'] != "yes") {$_POST['sex_male'] = "no";}
		if ($_POST['sex_female'] != "yes") {$_POST['sex_female'] = "no";}
		$sql_group_sex = "male=" . $_POST['sex_male'] . ",female=" . $_POST['sex_female'];
		
		// ### PROCESSING BASED ON RACE 
		$sql_group_race = ""; 
		if ($_POST['race_english'] != "yes") {$sql_group_race .= "race_english=no,";} else {$sql_group_race .= "race_english=yes,";} 
		if ($_POST['race_australian'] != "yes") {$sql_group_race .= "race_australian=no,";} else {$sql_group_race .= "race_australian=yes,";} 
		if ($_POST['race_chinese'] != "yes") {$sql_group_race .= "race_chinese=no,";} else {$sql_group_race .= "race_chinese=yes,";} 
		if ($_POST['race_irish'] != "yes") {$sql_group_race .= "race_irish=no,";} else {$sql_group_race .= "race_irish=yes,";} 
		if ($_POST['race_scottish'] != "yes") {$sql_group_race .= "race_scottish=no,";} else {$sql_group_race .= "race_scottish=yes,";} 
		if ($_POST['race_italian'] != "yes") {$sql_group_race .= "race_italian=no,";} else {$sql_group_race .= "race_italian=yes,";} 
		if ($_POST['race_indian'] != "yes") {$sql_group_race .= "race_indian=no,";} else {$sql_group_race .= "race_indian=yes,";} 
		if ($_POST['race_other'] != "yes") {$sql_group_race .= "race_other=no,";} else {$sql_group_race .= "race_other=yes,";} 
		
		$sql_group_city = "";
		if ($_POST['city_melbourne'] != "") {$sql_group_city .= "Melbourne";} 
		if ($_POST['city_sydney'] != "") {$sql_group_city .= "sydney";} 
		
		$sql = "select * from adat_totals_table where group_country = 'Australia' and group_city = '$sql_group_city' and group_sex = '$sql_group_sex' and group_race = '$sql_group_race' limit 0,1";
		
		// //// echo "<br>!! sql is $sql";
		$rec_match = $this->db->query($sql)->result_array();
		// var_dump($rec_match);
		
		foreach ($rec_match as $z) {
			// #### GRAPH PROBLEM IS HERE - RECS ARE NOT CORRECT - OR NOT EXTRACTING CORRECTLY 
			$found_result = "yes";
			$_POST['match_count'] = $z['record_count'];
			$data_rec['sex_count'] = "";
			
			// SEX BREAKDOWN 
			$sex_array = explode(",",$z['sex_count']); // Save each matrix to an array 
			$var_male = $sex_array[0]; $_POST['male_total'] = str_replace('male=','',$var_male);
			$var_female = $sex_array[1]; $_POST['female_total'] = str_replace('female=','',$var_female);
			
			// RACE BREAKDOWN 
			$race_array = explode(",", $z['race_count']); // Save each matrix to an array 
			$var_english = $race_array[0];
			$_POST['english_total'] = str_replace('english=','',$var_english);
			$var_australian = $race_array[1];
			$_POST['australian_total'] = str_replace('australian=','',$var_australian);
			$var_chinese = $race_array[2];
			$_POST['chinese_total'] = str_replace('chinese=','',$var_chinese);
			$var_irish = $race_array[3];
			$_POST['irish_total'] = str_replace('irish=','',$var_irish);
			$var_scottish = $race_array[4];
			$_POST['scottish_total'] = str_replace('scottish=','',$var_scottish);
			$var_italian = $race_array[5];
			$_POST['italian_total'] = str_replace('italian=','',$var_italian);
			$var_indian = $race_array[6];
			$_POST['indian_total'] = str_replace('indian=','',$var_indian);
			$var_other = $race_array[7];
			$_POST['other_total'] = str_replace('other=','',$var_other);
			
			sleep(8);
		}

			// V1.5 TESSERAC 
			// ### BEST END WORKING CODE BLOCK FOR RACE MATCH COUNTING SYDNEY 
			// THE FULL TOTAL IS NOT 4 MILLION SOMEHOW 
			// ### Project Analytics - 3,121,993 (877,999 - THESE RECORDS NOT BEING PICKUP UP - FIND OUT WHY ON ALL CHECKBOXES TICKED) records match. 
			// ISSUES ARE MALES ARE 1,654,653 WOMEN ARE 1,467,340 AND TOTAL IS CORRECT 
			// NEW MATCHING TABLES 
			// 
			
			if ($found_result == "no") {
				$sql_2_group_city = "(";
				if ($_POST['city_sydney'] == "Sydney") {
					$sql_2_group_city .= "city = 'Sydney'";
					if ($_POST['city_melbourne'] == "Melbourne") {
						$sql_2_group_city .= " or city = 'Melbourne'";
					}
				} elseif ($_POST['city_melbourne'] == "Melbourne") {
						$sql_2_group_city .= " city = 'Melbourne'";
				}
				$sql_2_group_city .= ")";
				//// echo "<br>!! sql = $sql_2_group_city";
			
				$sql = "select * from adat_nsw_summ_gender where country = 'Australia' and $sql_2_group_city and (filter = 'Sex' or filter = 'Race') order by city, filter_seq, filter"; 
				// Compid_group 
				$data['matrix_data'] = $this->db->query($sql)->result_array(); 
				// for ($zz = 1; $zz < 3; $zz++) {
				$var_tot_seq = 0; $xtab_1 = array(); $xtab_2 = array(); 
				$var_recs_tot_count = 0; $var_max_seq = 2; 
				$var_male_total = 0; $var_female_total = 0; 
				$var_english_total = 0; $var_australian_total = 0;  $var_irish_total = 0;  $var_chinese_total =0; 
				$var_scottish_total =0; $var_italian_total=0;  $var_indian_total=0;  $var_other_total=0; 
				$match = 0; $match_no = 0; $stage_recs = 0; $recs_per_cycle = 2; 
				foreach ($data['matrix_data'] as $x) {
					++$stage_recs;
					// ### !!! Expand these arrays to be $syd_sex_1 or mel_sex_1 so can do a bigger if inside the array loop 
					if ($x['filter'] == "Sex") {
						$sex_1 = explode(",", $x['matrix']); // save each matrix to an array 
					} elseif ($x['filter'] == "Race") {
						$race_1 = explode(",", $x['matrix']); // save each matrix to an array 
					}
					
					// ## Only process when we have a full cycle of data (sex, race etc 1 of each) to check 
					// ## We pair up record sets & progress then on those 
					if ($stage_recs % $recs_per_cycle == 0) {
						$result_1 = array();
						$array_cnt = count($race_1);
						for ($i = 1; $i < $array_cnt; $i++) {
							// ### !!! Expand checks on sex and race to be in city so can have 2, 1 or 0 matches 
							// RACE FILTER PROCESSING 
							// English 26.1%, Australian 23.5%, Chinese 10.8%, Irish 7.9%, Scottish 6.2%, Italian 4.3%, Indian 4.3%, Other 16,9% 
							// E 26.1%, A 23.5%, C 10.8%, I 7.9%, S 6.2%, T 4.3%, D 4.3%, O 16.9% 
							$race_match = "N"; $sex_match = "N";

							if (($sex_1[$i] == "Y" and $_POST['sex_male'] == "yes") or ($sex_1[$i] == "N" and $_POST['sex_female'] == "yes")) {
								$sex_match = "Y";
							}
							
							if ($sex_match == "Y") { // All criteria must match to go into ANY count 
								if ($race_1[$i] == "E" and $_POST['race_english'] == "yes") {
									$race_match = "Y"; ++$var_english_total; 
								} elseif ($race_1[$i] == "A" and $_POST['race_australian'] == "yes") {
									$race_match = "Y"; ++$var_australian_total; 
								} elseif ($race_1[$i] == "C" and $_POST['race_chinese'] == "yes") {
									$race_match = "Y"; ++$var_chinese_total; 
								} elseif ($race_1[$i] == "I" and $_POST['race_irish'] == "yes") {
									$race_match = "Y"; ++$var_irish_total; 
								} elseif ($race_1[$i] == "S" and $_POST['race_scottish'] == "yes") {
									$race_match = "Y"; ++$var_scottish_total; 
								} elseif ($race_1[$i] == "T" and $_POST['race_italian'] == "yes") {
									$race_match = "Y"; ++$var_italian_total;
								} elseif ($race_1[$i] == "D" and $_POST['race_indian'] == "yes") {
									$race_match = "Y"; ++$var_indian_total;
								} elseif ($race_1[$i] == "O" and $_POST['race_other'] == "yes") {
									$race_match = "Y"; ++$var_other_total;
								}
							}
								
							If ($race_match == "Y") { // All criteria must match to go into ANY count
								if ($sex_1[$i] == "Y" and $_POST['sex_male'] == "yes") {
									++$var_male_total;
									$sex_match = "Y";
								} elseif ($sex_1[$i] == "N" and $_POST['sex_female'] == "yes") {
									++$var_female_total;
									$sex_match = "Y";
								}
							}

							If ($race_match == "Y" and $sex_match == "Y")
							{
								// $array_cnt[$i] = "Y";
								++$match;
							} else {
								// $array_cnt[$i] = "N";
								++$match_no;
							}
						}
					}
				}
			//}
			
			$_POST['match_count'] = $match; $_POST['match_no_count'] = $match_no;
			$_POST['male_total'] = $var_male_total; $_POST['female_total'] = $var_female_total;
			$_POST['english_total'] = $var_english_total; $_POST['australian_total'] = $var_australian_total;
			$_POST['chinese_total'] = $var_chinese_total; $_POST['irish_total'] = $var_irish_total;
			$_POST['scottish_total'] = $var_scottish_total; $_POST['italian_total'] = $var_italian_total;
			$_POST['indian_total'] = $var_indian_total; $_POST['other_total'] = $var_other_total;
			
			$data_rec = array(); // Create a record on the search. A full set can be used instead of checking the database 
			$data_rec['group_country'] = "Australia"; 
			// #### ADJUST HERE 
			 
			if ($_POST['city_melbourne'] != "") {$data_rec['group_city'] = "Melbourne";} 
			if ($_POST['city_sydney'] != "") {$data_rec['group_city'] = "Sydney";} 
			
			$data_rec['group_sex'] = "male=" . $_POST['sex_male'] . ",female=" . $_POST['sex_female']; 

			$var_group_race = "";
			if ($_POST['race_english'] != "yes") {$var_group_race .= "race_english=no,";} else {$var_group_race .= "race_english=yes,";}
			if ($_POST['race_australian'] != "yes") {$var_group_race .= "race_australian=no,";} else {$var_group_race .= "race_australian=yes,";}
			if ($_POST['race_chinese'] != "yes") {$var_group_race .= "race_chinese=no,";} else {$var_group_race .= "race_chinese=yes,";}
			if ($_POST['race_irish'] != "yes") {$var_group_race .= "race_irish=no,";} else {$var_group_race .= "race_irish=yes,";}
			if ($_POST['race_scottish'] != "yes") {$var_group_race .= "race_scottish=no,";} else {$var_group_race .= "race_scottish=yes,";}
			if ($_POST['race_italian'] != "yes") {$var_group_race .= "race_italian=no,";} else {$var_group_race .= "race_italian=yes,";}
			if ($_POST['race_indian'] != "yes") {$var_group_race .= "race_indian=no,";} else {$var_group_race .= "race_indian=yes,";}
			if ($_POST['race_other'] != "yes") {$var_group_race .= "race_other=no,";} else {$var_group_race .= "race_other=yes,";}
			$data_rec['group_race'] = $var_group_race;
			
			$data_rec['record_count'] = $match;
			$data_rec['sex_count'] = "male=" . $var_male_total . ",female=" . $var_female_total;
			$data_rec['race_count'] = "english=" . $var_english_total . ",australian=" . $var_australian_total . ",chinese=" . $var_chinese_total 
			. ",irish=" . $var_irish_total . ",scottish=" . $var_scottish_total . ",italian=" . $var_italian_total . ",indian=" . $var_indian_total . ",other=" . $var_other_total;
			$this->db->insert('adat_totals_table', $data_rec);
			$id = $this->db->insert_id();
		}

	}

	// echo "<br>!!33 here";


		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}

}
	
