<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Es_Quotes_v2 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');
		$this->load->model('Insert_prayer');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW 
		// ################################################################ 

		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout") {
			// #### The userid and/or compid expired or logged out - go to bible app as a public module 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}

	public function foryou($hashnum)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);
		
		//#### From hashnum - extract videoid - then the companyid ####// 
		$var_vid_id_array = explode('4477',$hashnum); 
		$var_vid_id = $var_vid_id_array['1']; 
		// //var_dump($var_vid_id_array);
		
		// ### 956744773934477
		$subqry = ""; $var_search = ""; 
		$varoffset = 0; $recsperpage = 1; 
		
		$compid_string = " compid > 0 ";
		$sql = "select * from ainf_xcloud_videos where id = $var_vid_id"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
		foreach ($data['messages'] as $z) {
			$varcompid = $z['compid'];
			$compid_string = " compid = $varcompid ";
		}
		
		// //var_dump($data['messages']); 
				
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// ////var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where ($compid_string and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and $compid_string order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array();
		
		// very basic error handling
		
		$pagename_orig = "video-player-bsbc-base";
		$pagename_orig = "video-player-bsbc-foryou";
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function display_qr()
	{

		$varcompid = $this->session->userdata('compid');
		$sql = "SELECT * from ainf_xglobalclient where globcompid = $varcompid limit 0,1 ";
		$user_query = $this->db->query($sql);
		$data['mycomp_evangelise'] = $user_query->result_array();
		
		$load_page = "view_qr";
		$this->load->view($load_page, $data);
		
	}

	public function quote_send()
	{
		
		// var_dump($_POST);
		

		$data_rec = array(); 
		$varcompid = 150; 
		$data_rec['compid'] = $varcompid; 
		$name_array = explode(' ',$_POST['quote_full_name']); 
		$data_rec['first_name'] = $name_array[0]; $data_rec['last_name'] = $name_array[1]; 
		$data_rec['mobile'] = $_POST['quote_mobile']; $data_rec['email'] = $_POST['quote_email']; 
		$data_rec['user_type'] = "Quote Lead"; 
		$data_rec['start_date_sort'] = date('Y/m/d'); 
		$data_rec['start_date'] = date('d/m/Y'); 
		// var_dump($data_rec); 
		$this->db->insert('ainf_vps3_users', $data_rec); 
		$var_biz_client_id = $this->db->insert_id(); 
		
		$data_rec = array();
		$data_rec['qt_com_or_resi'] = $_POST['qt_com_or_resi'];
		$data_rec['qt_spec_type'] = $_POST['qt_spec_type'];
		$data_rec['qt_journey_stage'] = $_POST['qt_journey_stage'];
		$data_rec['qt_time_frame'] = $_POST['qt_time_frame'];
		$data_rec['qt_roof_type'] = $_POST['qt_roof_type'];
		$data_rec['qt_powerwall_need'] = $_POST['qt_powerwall_need'];
		var_dump($data_rec);

		$varcompid = 150;
		$data_rec['compid'] = $varcompid;
		$data_rec['quote_status'] = "New";
		$data_rec['biz_client_id'] = $var_biz_client_id;
		$data_rec['biz_client_contact_id'] = $var_biz_client_id;
		// echo "<br>!! Product Name is {$_POST['quote_prod_name']}";
		$data_rec['quote_title'] = "Quote on product " . $_POST['quote_prod_name'] . " for lead " . $name_array[0] . " " . $name_array[1];
		$data_rec['quote_title'] = "Quote on product " . $_POST['quote_prod_name']; // Best to pull name from the client file
		$data_rec['draft_date_sort'] = date('Y/m/d'); 
		$data_rec['draft_date'] = date('d/m/Y'); 
		$data_rec['active'] = "Y"; 
		
		$data_rec['qt_addr_street_1'] = $_POST['qt_addr_street_1'];
		$data_rec['qt_addr_suburb'] = $_POST['qt_addr_suburb'];
		$data_rec['qt_addr_postcode'] = $_POST['qt_addr_postcode'];
		$data_rec['qt_addr_state'] = $_POST['qt_addr_state'];
		$this->db->insert('aaaa_biz2_work_quotes', $data_rec); 
		
		redirect('Es_Quotes_v2/web_pages', 'refresh'); 
	
	}
		
	public function web_pages()
	{

		if ($_POST['sess_compid'] == "" or $_POST['sess_compid'] == "0") {
			// ### Maintain $_POST then not reliant on session 
			$_POST['sess_compid'] = $this->session->userdata('compid');
		}
		$varcompid = $_POST['sess_compid'];
			
		//### NEW SECURITY - DO NOT SHOW VIEW PAGE - PREVENTS MODULE TABLE TO BE UPDATED 
		$load_page = "update_new_friend";
		$load_page = "tesla_powerwall_2_quote_v5";
		$this->load->view($load_page, $data);
			
	}

}
	
