<?php 

if (!defined('BASEPATH'))
  exit('No direct script access allowed');

class Ministry4 extends CI_Controller { 
	// Rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();

		error_reporting(0);
		
		$this->load->model('Unsett_array'); //### FOR MENUS AND TABS 
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');	
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW 
		// ################################################################ 

		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout") {
			// #### The userid and/or compid expired or logged out - go to bible app as a public module 
			redirect('bible3/bible_display', 'refresh');
		}

		$this->load->model('System_modules');
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}

	public function foryou($hashnum)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);
		
		//#### From hashnum - extract videoid - then the companyid ####// 
		$var_vid_id_array = explode('4477',$hashnum); 
		$var_vid_id = $var_vid_id_array['1']; 
		// //// // // // var_dump($var_vid_id_array);
		
		// ### 956744773934477
		$subqry = ""; $var_search = ""; 
		$varoffset = 0; $recsperpage = 1; 
		
		$compid_string = " compid > 0 ";
		$sql = "select * from ainf_xcloud_videos where id = $var_vid_id"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
		foreach ($data['messages'] as $z) {
			$varcompid = $z['compid'];
			$compid_string = " compid = $varcompid ";
		}
		
		// //// // // // var_dump($data['messages']); 
				
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// ////// // // // var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where ($compid_string and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and $compid_string order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array();
		
		// very basic error handling
		
		$pagename_orig = "video-player-bsbc-base";
		$pagename_orig = "video-player-bsbc-foryou";
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function friends($pagename) 
	{
		// // // var_dump($_POST);
		foreach($_POST as $key => $value) {
			// // // // echo "<br>!! CHECK Values !! key is $key value is $value";
			if (strpos($key,'action_taken_') !== false and $value != "") {
				// #### GET ANY ACTION CALLED 
				$var_action = $value;
				$_POST['globcompid'] = str_replace( "action_taken_" , "" , $key);
				$varcompid_str = str_replace( "action_taken_" , "" , $key);
				//#### Format for multi-tabs is now action_taken_TAB_GLOBCOMPID 
				//#### TABS NEEDED IN FORM AS WE HAVE THE SAME RECORD SAME ID (GLOBCOMPID) so TAB MAKES IT UNIQUE 
				//#### SO WE MUST ALSO STRIP OUT THE TAB TO GET COMPID 
				$var_tab = substr($varcompid_str, 0,2);
				$varcompid = substr($varcompid_str, 2);
				// #### GOOD CODE 
				$_POST['globcompid'] = $varcompid;
				// // // // echo "<br>!! 33 tab is $var_tab value = $value, varcompid = $varcompid ";
			}
			// // // // echo "<br>!! END 777 CHECK Values !! key is $key value is $value";
			if ($var_action == "swap") { 
				// #### SWAP TO COMPANY CHOSEN 
				// // // // // echo "<br>The key is $key, value is $value We need to edit for compid {$_POST['globcompid']}"; 
				// Process the swap of session 
				$this->session->set_userdata('compid',$_POST['globcompid']);
				$_POST['sess_compid'] = $_POST['globcompid'];
				$sql = "select globcompanyname from ainf_xglobalclient where globcompid = {$_POST['globcompid']}";
				$varupdate = $this->db->query($sql)->result_array();
				foreach ($varupdate as $i) {
					$this->session->set_userdata('compname',$i['globcompanyname']);
					$var_comp = $this->session->userdata('compname');
				}
				
				// Update current staff record to this compid for any related queries 
				$var_userid = $this->session->userdata('userid'); 
				// // // // // echo "<br>!! userid is $var_userid "; 
				$sql = "update ainf_vps3_users set compid = {$_POST['globcompid']} where userid = $var_userid";
				$varupdate = $this->db->query($sql);
				
			} elseif ($var_action == "add_group" or $var_action == "minus_group") { 
				// #### Get our company record and update sharing 
				$sql = "select * from ainf_xglobalclient where globcompid = {$_POST['sess_compid']}";
				$varupdate = $this->db->query($sql)->result_array();
				foreach ($varupdate as $i) {
					// // // // echo "<br>add circle sharing is {$i['compid_sharing']}"; 
					$var_check_comp = "," . $_POST['globcompid'] . ",";
					if (strpos($i['compid_sharing'],$var_check_comp) === false and $var_action == "add_group") {
						// #### ADD COMP TO SHARING IF NOT THERE 
						$var_new_compid_sharing = str_replace(',0','',$i['compid_sharing']); 
						// // // // echo "<br>22 AA old sharing is $var_new_compid_sharing"; 
						$var_new_compid_sharing = $var_new_compid_sharing . "," . $_POST['globcompid'] . ",0";
						// // // // echo "<br>22 BB new sharing is $var_new_compid_sharing"; 
						$data_rec = array();
						$data_rec['compid_sharing'] = $var_new_compid_sharing;
						$this->db->where('globcompid', $_POST['sess_compid']);
						$this->db->update('ainf_xglobalclient', $data_rec);
					} elseif (strpos($i['compid_sharing'],$var_check_comp) !== false and $var_action == "minus_group") {
						// #### REMOVE COMP FROM SHARING IF THERE 
						$var_check_comp = "," . $_POST['globcompid'] . ","; 
						// // // // echo "<br>!! THE OLD IS THIS {$_POST['globcompid']} "; 
						$var_new_compid_sharing = str_replace($var_check_comp,',',$i['compid_sharing']); 
						// // // // echo "<br>!! THE NEW IS THIS $var_new_compid_sharing "; 
						$data_rec = array(); 
						$data_rec['compid_sharing'] = $var_new_compid_sharing; 
						$this->db->where('globcompid', $_POST['sess_compid']); 
						$this->db->update('ainf_xglobalclient', $data_rec); 
					}
					// $this->session->set_userdata('compname',$i['globcompanyname']);
					// $var_comp = $this->session->userdata('compname');
				}
			} elseif ($var_action == "edit") {

				// #### IN EDIT NOW 
				// #### $_POST['globcompid'] = str_replace("mod_this_record_" , "" , $key); 
				$sql = "select globcompanyname from ainf_xglobalclient where globcompid = {$_POST['globcompid']}"; 
				$varupdate = $this->db->query($sql)->result_array(); 
				// // // // // var_dump($varupdate); 
				// $this->my_organisation_edit(); 
				// #### // 
				$varcompid = "34-87363-77{$_POST['globcompid']}"; 
				redirect("/Ministry4/my_organisation_edit/$varcompid"); // back to listing 
			}			
			
		}
		
		$_POST['video_type'] = "tract";
		$_POST['people_type'] = "friends";
		$this->details($pagename);
		
	}

	public function my_organisation_edit($varcompid) {
		
		// $_POST['globcompid'] = $_POST['sess_compid']; #### SET BY CALLING FUNCTION 
		
		// // // echo "<br>!! aa";
		$_POST['globcompid'] = str_replace('34-87363-77','',$varcompid);
		$_POST['company_driver_purpose'] = "my_ministry";
		// // // echo "<br>!! bb"; 
		$this->organisation_edit();
	}

	public function organisation_edit()
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];
		// echo "<br>!! 66 in org edit ";
		
		// // echo "<br>!! We are in "; 
		// // echo "<br>!! AA name is {$params['savename']} "; 

		// // // echo "<br>!! 11";
		if (isset($_POST['globcompid'])) {
			$var_swap_field = "swap_record_" . $_POST['globcompid'];
			if ($_POST[$var_swap_field] == "yes") { // SWAP ACTIVE COMPANY - ONLY FOR SUPER_ADMIN
				
				// Process the swap of session
				$this->session->set_userdata('compid',$_POST['globcompid']);
				$sql = "select globcompanyname from ainf_xglobalclient where globcompid = {$_POST['globcompid']}";
				$varupdate = $this->db->query($sql)->result_array();
				foreach ($varupdate as $i) {
					$this->session->set_userdata('compname',$i['globcompanyname']);
					$var_comp = $this->session->userdata('compname');
				}
				
				// Update current staff record to this compid for any related queries
				$var_userid = $this->session->userdata('userid');
				$sql = "update ainf_vps3_users set compid = {$_POST['globcompid']} where userid = $var_userid";
				$varupdate = $this->db->query($sql);
				
				redirect('/settings/edit_account/update_account_settings'); // back to listing
			}
		}
		
		// echo "<br>!! 66 will check on company name ";
		if (isset($_POST['globcompanyname'])) { 
			// ### ADD IN THIS COMPANY ### // 
			$sql = "select * from ainf_xglobalclient where mastercompid = 113 order by globcompanyname"; 
			$data['org_list'] = $this->db->query($sql)->result_array(); 
			$var_compid_sharing_value = "0"; 
			foreach ($data['org_list'] as $i) { 
				$var_compid__sharing_fld = "compid__sharing_" . $i['globcompid']; 
				$var_compid__sharing_field = $_POST[$var_compid__sharing_fld]; 
				if ($var_compid__sharing_field == "yes") { 
					$var_compid_sharing_value .= "," . $i['globcompid']; 
 				}
			}
			$var_compid_sharing_value .= ",0";
			// // // // // echo "var_compid_sharing_value = $var_compid_sharing_value";
			
			$data_rec = array(); 
			$data_rec['compid_sharing'] = $var_compid_sharing_value;
			// $data_rec['glob_qr_signup_url'] = $_POST['glob_qr_signup_url'];
			$data_rec['globcompanyname'] = $_POST['globcompanyname']; $data_rec['globcompanysite'] = $_POST['globcompanysite'];
			$data_rec['globcomp_city'] = $_POST['globcomp_city']; $data_rec['globcompanyaddress'] = $_POST['globcompanyaddress'];
			$data_rec['min_transport_buses'] = $_POST['min_transport_buses']; $data_rec['min_transport_train_station'] = $_POST['min_transport_train_station'];
			$data_rec['address_map'] = $_POST['address_map'];

			$data_rec['globcomp_postcode'] = $_POST['globcomp_postcode']; $data_rec['globcomp_postcode_group'] = $_POST['globcomp_postcode_group'];
			$data_rec['globcomp_country'] = $_POST['globcomp_country']; $data_rec['date_create'] = $_POST['date_create'];
			$data_rec['cpanel_url'] = $_POST['cpanel_url']; $data_rec['webmail_url'] = $_POST['webmail_url'];
			if ($_POST['active'] == "Y") {$data_rec['active'] = "Y";} else {$data_rec['active'] = "N";}
			
			$data_rec['profile_leader_userid'] = $_POST['profile_leader_userid'];
			$data_rec['profile_leader_profile'] = $_POST['profile_leader_profile'];
			$data_rec['profile_about_us'] = $_POST['profile_about_us'];
			$data_rec['profile_our_mission'] = $_POST['profile_our_mission'];
			$data_rec['profile_about_us_video'] = $_POST['profile_about_us_video'];
			
			$data_rec['mastercompid'] = 113;
			$data_rec = $this->Unsett_array->clear_sess_array($data_rec); // ### MODEL CLEARS POST/DATA ARRAY OF SESS DATA 
			if ($_POST['globcompid'] != 0) { 
				// // // echo "<br>!! 66a compid {$_POST['globcompid']} <br>";
				// // var_dump($data_rec);
				$this->db->where('globcompid', $_POST['globcompid']); 
				$this->db->update('ainf_xglobalclient', $data_rec); 

			} else { 

				$this->db->insert('ainf_xglobalclient', $data_rec); 
				$_POST['globcompid'] = $this->db->insert_id(); 
			} 

			// #### QR GENERATOR 
			// #### THIS QR ALLOWS FRIEND ACCESS FOR BIBLE / MEETINGS / ADD FRIENDS 
			$this->load->library('ciqrcode');
			$params['data'] = "https://churchofjesus.live/Registerpublic/load/93467234987112677"; 
			// ### BELOW THIS IS A URL PUT INTO THE QR - IT ALLOWS THAT MINISTRY TEAM TO GET NEW FRIENDS LOGGED INTO THEIR PUBLIC CONTENT 
			$params['data'] = "https://churchofjesus.live/Registerpublic/load/934672349871" . $_POST['globcompid'] . "77";
			$params['level'] = 'H';
			$params['size'] = 10;
			$var_qr_name =  $_POST['globcompid'] . "_new_friend_access.png";
			$params['savename'] = FCPATH . "images_qr_new/" . $var_qr_name;
			$this->ciqrcode->generate($params);

			$data_rec = array();
			$data_rec['glob_qr_signup_url'] = "https://churchofjesus.live/images_qr_new/" . $var_qr_name;
			// echo "<br>!! 77 qr name is {$data_rec['glob_qr_signup_url']}";
			$this->db->where('globcompid', $_POST['globcompid']);
			$this->db->update('ainf_xglobalclient', $data_rec);

		}
		
		if ($_POST['add_record'] != "yes" and $_POST['globcompid'] != "") {
			$sql = "select * from ainf_xglobalclient where globcompid = {$_POST['globcompid']}";
			$data['organisation'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid order by title";
		$data['video_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_xglobalclient where mastercompid = 113 order by globcompanyname";
		$data['org_list'] = $this->db->query($sql)->result_array();

		$sql = "select * from ainf_vps3_code_manager where code_group = 'country' order by code_name";
		$data['country_list'] = $this->db->query($sql)->result_array();
		if ($_POST['globcompid'] != "") {
			$sql = "select * from ainf_vps3_users where compid = {$_POST['globcompid']} and team_image_link is not null order by first_name, last_name";
			$data['leaders'] = $this->db->query($sql)->result_array();
		}
			
		// // // // // var_dump($data['organisation']);
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/Ministry4/friends/people_home_list_v3'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			$this->load->view('update_organisation_v2', $data);
		} else {
			$this->load->view('update_organisation_v2', $data);
		}
	}
	
	public function details($pagename)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);

		if ($_POST['video_type'] == "") {$_POST['video_type'] = "regular";}
		//*** Get page name for the link 
		// // // // // echo "<br>!!22";
		
		if ($pagename == "video-player-bsbc-qrcodes") {
			$_POST['qr_code_link'] = "yes";
			$pagename = "video-player-bsbc-base";
		} else {
			$_POST['qr_code_link'] = "no";
		}
				
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} 
		// index.php is multi-purpose but same core data - message list or service list 
		
		// // // // // echo "<br>!!33 pagename_orig $pagename_orig";
		
		$varcompid = 110; 
		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid > 0 order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book ";
		$data['messages'] = $this->db->query($sql)->result_array();
		
		// // // // // echo "<br>!!44";
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		$var_compid = $this->session->userdata('compid');
		if ($var_compid != $_POST['sess_compid']) {
			$_POST['sess_compid'] = $varcompid;
		}
		$var_userid = $this->session->userdata('userid'); 
				
		// #### Must DO JOIN IN CASE LEADER NOT YET CHOSEN FOR MINISTRY 
		$sql = "select * from ainf_xglobalclient a left join ainf_vps3_users b on a.profile_leader_userid = b.userid where a.globcompid = {$_POST['sess_compid']}"; 
		$data['ministry_my'] = $this->db->query($sql)->result_array(); 
		// // // // var_dump($data['ministry_my']); 
		
		$var_compid_sharing = "0,0";
		$sql = "select globcompid, compid_sharing from ainf_xglobalclient where globcompid = {$_POST['sess_compid']}";
		$list_ministry_circle_compid = $this->db->query($sql)->result_array(); 
		foreach ($list_ministry_circle_compid as $z) {
			$var_compid_sharing = $z['compid_sharing'];
		}
		$_POST['compid_sharing'] = $var_compid_sharing;

		$sql = "select * from ainf_xglobalclient a left join ainf_vps3_users b on a.profile_leader_userid = b.userid where globcompid in ($var_compid_sharing) and active in ('Y')"; 
		$data['ministry_circle'] = $this->db->query($sql)->result_array(); 
		// // // // var_dump($data['ministry_circle']); 

		$sql = "select * from ainf_vps3_users, ainf_xglobalclient where userid = profile_leader_userid"; 
		// #### Must DO JOIN IN CASE LEADER NOT YET CHOSEN FOR MINISTRY 
		$sql = "select * from ainf_xglobalclient a left join ainf_vps3_users b on a.profile_leader_userid = b.userid where active in ('Y')"; 
		$data['messages'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_xglobalclient a left join ainf_vps3_users b on a.profile_leader_userid = b.userid where active not in ('Y')"; 
		$data['inactive_messages'] = $this->db->query($sql)->result_array();
	
		$sql = "select * from ainf_vps3_users where aboutme_aboutme is not null and compid = $varcompid"; 
		$data['friends_home'] = $this->db->query($sql)->result_array(); 
		// // // // // var_dump($data['friends_home']);
		
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// ////// // // // var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 
		// // // // // echo "<br>!!55";

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_xcloud_videos where id in (select profile_about_us_video from ainf_xglobalclient where globcompid = $varcompid)"; 
		$data['about_videos'] = $this->db->query($sql)->result_array(); 
		
		// // // // echo "<br>!!66";
		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
		// // // // // echo "<br>!!yy11 pagename_orig - $pagename_orig ";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
		// // // // // echo "<br>!!yy22 pagename_orig - $pagename_orig ";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}
	
	public function index()
	{
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // echo"!! must write other functions code for funciton $callfunction";
		}
	}

	public function video_edit()
	{

		// ### !!! The for post is getting totally cleared when the file field for VIDEO_LINK is being loaded.. 
		// ### The for post is getting totally cleared when the file field is being loaded.. 
		// //// // // // var_dump($_POST);
		error_reporting(0);
		
		$varcompid = $_POST['sess_compid'];
		// //// // // // // echo "<br>!!11 vid id is {$_POST['id']} actual is 395";

		////// // // // // echo "<br>!! vid 11 - this is post";
		// //// // // // var_dump($_POST);
		
		////// // // // // echo "<br>!!aa OUT OF POST vid 11 - this is post";
		
		if ($_POST['title'] != "") {
			////// // // // // echo "<br>!! vid 22";
			$var_video_link = "";
		//////// // // // // echo "<br>!!22 vid id is {$_POST['id']} actual is 395";
			if ($_FILES['video_link']['name']) {

				$targetPath = "/home/bizadmin/churchofjesus.live/client_videos/"; // correct path for infinity
				$varurlpath = "https://churchofjesus.live/client_videos/";
				
				$upload=$_FILES['video_link']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('m4a','mp4', 'mov', 'mp3');
				if(1==1 or in_array($ext,$config['allowed_types'])) {
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = $varcompid . "_service_video_" . $vardate . "." . $ext;
					////// // // // // echo "<br>!! vid aa";
					if (is_dir($targetPath)and is_writable($targetPath)) {
					////// // // // // echo "<br>!! vid bb";
						if (move_uploaded_file($_FILES['video_link']['tmp_name'], $targetPath . $targetFile)) {
					////// // // // // echo "<br>!! vid cc";
							$var_video_link = $varurlpath . $targetFile;
						}
					} else {
					////// // // // // echo "<br>!! vid dd";
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}
				} else {
					////// // // // // echo "<br>!! vid ee";
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
				}
		//////// // // // // echo "<br>!!33 vid id is {$_POST['id']} actual is 395";
			} else {
		////// // // // // echo "<br>!! vid 44";
			}

			$var_teacher_image = "";
			if($_FILES['user_image']['name']) {
				$targetPath = "/home/bizadmin/churchofjesus.live/client_files/"; // correct path for infinity 
				$targetPath = "/home/bizadmin/churchofjesus.live/client_files/"; // correct path for infinity 
				$varurlpath = "https://churchofjesus.live/client_files/"; 
			
				$upload=$_FILES['user_image']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('png','jpg', 'jpeg', 'gif', 'tif');
				if(1==1 or in_array($ext,$config['allowed_types'])) {
				// // // // // echo"<br>XX22 vid 2 id {$_POST['id']}";
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = $varcompid . "_preacher_image_" . $vardate . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						if (move_uploaded_file($_FILES['user_image']['tmp_name'], $targetPath . $targetFile)) {
							$var_teacher_image = $varurlpath . $targetFile;
							if ($_POST['teacher_image_all'] == "y" and $_POST['teacher'] != "") {
								$image_rec = array();
								$image_rec['teacher_image'] = $var_teacher_image; 
								$this->db->where('teacher', $_POST['teacher']);
								$this->db->where('compid', $varcompid);
								$this->db->update(ainf_xcloud_videos, $image_rec);
							}
						}
					} else {
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}
				} else {
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
				}
			}
			
		//////// // // // // echo "<br>!!55 vid id is {$_POST['id']} actual is 395";
		
			$data_rec = array();
			$data_rec['teacher'] = $_POST['teacher']; $data_rec['title'] = $_POST['title'];
			$data_rec['book'] = $_POST['book']; 
			
			if (trim($_POST['series_add']) != "") {
				$data_rec['series'] = $_POST['series_add'];
			} else {
				$data_rec['series'] = $_POST['series'];
			}

			if(trim($_POST['video_link_youtube']) != "") {
				// ### GET LISTING TO RUN ON VIDEOS 
				// $data_rec['video_link'] = trim($_POST['video_link_youtube']); $data_rec['audio_link'] = trim($_POST['video_link_youtube']); 
			}
			if ($var_video_link != "") {
				$data_rec['video_link'] = $var_video_link; $data_rec['audio_link'] = $var_video_link;
			}
			if ($var_teacher_image != "") {
				$data_rec['teacher_image'] = $var_teacher_image; 
			} else {
				$data_rec['teacher_image'] = $_POST['teacher_image']; //## This is a hidden field and fine to use for copy or no changes made 
			}
			$data_rec['video_link_youtube'] = trim($_POST['video_link_youtube']); 
			$data_rec['message'] = $_POST['message']; 
			$data_rec['message_date'] = $_POST['message_date'];
			$date_time = explode(" ",$_POST['message_date']);
			$date_time_parts = explode("/",$date_time[0]);
			$data_rec['message_date_sort'] = $date_time_parts[2] . "/" . $date_time_parts[1] . "/" . $date_time_parts[0] . " " . $date_time[1];
			$data_rec['teacher_title'] = $_POST['teacher_title']; $data_rec['teacher'] = $_POST['teacher'];
			if ($_POST['active']=="Y") {$data_rec['active']="Y";} else {$data_rec['active']="N";}
			
			$data_rec = $this->Unsett_array->clear_sess_array($data_rec); // ### MODEL CLEARS POST/DATA ARRAY OF SESS DATA 
			if ($_POST['id'] != 0 and $_POST['update_video'] == "y") {
				// // // // // echo"<br>!!x1 in update is {$_POST['id']}";
				$this->db->where('id', $_POST['id']);
				$this->db->update(ainf_xcloud_videos, $data_rec);
			} else {
				// // // // // echo"<br>!! y22 in update is {$_POST['id']}";
				if ($_POST['copy_video'] == "y") {
					$_POST['return_to_list'] = ""; //## COPY MAKE THEM CHECK THIS 
					$data_rec['title'] = "This is a copy - plese set now"; 
				}
				$data_rec['compid'] = $varcompid;
				$this->db->insert(ainf_xcloud_videos, $data_rec);
				$_POST['id'] = $this->db->insert_id();
			}
			
			if ($_POST['return_to_list'] == "y") {
				$this->video_views('manage_key_lists');
			} else {
				////////// // // // // echo "<br>!!aa detail here";
				$this->video_views('update_video_detail');
			}
		} else {
				////////// // // // // echo "<br>!!bb detail here";
			$this->video_views('update_video_detail');
		}
		
	}

	public function video_views($video_page)
	{
		
		//////// // // // // echo "<br>!!AA IN video_views to load record vid id is {$_POST['id']} actual is 395";
		$varcompid = $_POST['sess_compid'];
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		if ($var_copy_value == "yes") {
			//////// // // // // echo "<br>!!BB IN copy video {$_POST['id']} actual is 395 ";
			$sql = "select * from ainf_xcloud_videos where id = {$_POST['id']} limit 0,1";
			$get_rec_forcopy = $this->db->query($sql)->result_array();
			$copy_rec = array();
			foreach ($get_rec_forcopy as $z) {

				$copy_rec['title'] = "Just Copied - Please Update";
				$copy_rec['teaser'] = "Just Copied - Please Update";
				$copy_rec['message'] = "Just Copied - Please Update";
				 	
				$copy_rec['video_type'] = $z['video_type'];
				$copy_rec['video_series'] = $z['video_series'];
				$copy_rec['video_writeup'] = $z['video_writeup'];
				$copy_rec['active'] = "Y";
				$copy_rec['video_order'] = $z['video_order'];
				$copy_rec['book'] = $z['book'];
				$copy_rec['compid'] = $z['compid'];
				$copy_rec['mastercompid'] = $z['mastercompid'];
				$copy_rec['public_viewing'] = $z['public_viewing'];
				$copy_rec['video_trainerid'] = $z['video_trainerid'];
				$copy_rec['pageid'] = $z['pageid'];
				$copy_rec['video_name'] = $z['video_name'];
				$copy_rec['ecourse_id'] = $z['ecourse_id'];
				$copy_rec['eunit_id'] = $z['eunit_id'];
				$copy_rec['date_create'] = date("Y/m/d H:i:s");
				
				$this->db->insert(ainf_xcloud_videos, $copy_rec); 
				$_POST['id'] = $this->db->insert_id(); 
			}
			
		}
		
		////////// // // // // echo "<br>!! copy action POST value - $var_copy_value ";
		////////// // // // // echo "<br>!! edit action POST value - $var_edit_value ";
		
		if ($video_page == "update_video_detail") {
			//////// // // // // echo "<br>!!CC IN copy video {$_POST['id']} actual is 395 ";
			$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
			$data['vidbooks'] = $this->db->query($sql)->result_array();
			if ($_POST['id'] != "") {
				$sql = "select * from ainf_xcloud_videos where id = {$_POST['id']} limit 0,1";
				$data['videdit'] = $this->db->query($sql)->result_array();
			}
			$sql = "select distinct series from ainf_xcloud_videos where compid = $varcompid order by series "; 
			$data['vidseries'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from `ainf_vps3_code_manager` where code_group like 'preacher_title'";
			$data['titles'] = $this->db->query($sql)->result_array();
			$sql = "select title, full_name from speakers where compid = $varcompid";
			$data['speakers'] = $this->db->query($sql)->result_array();
			$sql = "select distinct teacher from ainf_xcloud_videos where compid = $varcompid order by teacher"; 
			$data['speakers'] = $this->db->query($sql)->result_array(); 
			
			$this->load->view($video_page, $data); 
			
		} elseif ($video_page == "manage_key_lists") {
			//////// // // // // echo "<br>!!DD IN copy video {$_POST['id']} actual is 395 ";
			$sql = "select * from ainf_xcloud_videos order by message_date_sort desc "; 
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid order by message_date_sort desc "; 
			$data['vidlist'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active in ('Y') order by message_date_sort desc "; 
			$data['vidlist_active'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid  and active not in ('Y') order by message_date_sort desc "; 
			$data['vidlist_inactive'] = $this->db->query($sql)->result_array(); 
			
			$this->load->view($video_page, $data);
		}
	}

}
	
