<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Module_profiles3 extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // // echo  "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // echo  "!! must write other functions code for funciton $callfunction";
		}
	}
	
	public function profile_edit()
	{
		// Get page name for the link
		error_reporting(0);

				// echo  "<br>!!11 to add";
		//############# NEW PRAYERS CODE #############
		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$key_table = "ainf_xmodule2_profiles";

		if ($_POST['add_record'] == "yes") {
			$id = 0; // value set from listing
		} elseif ($_POST['id'] > 0) {
			$id = $_POST['id']; // value set from listing
		}
		
		$sql = "select * from ainf_xmodule2 where active = 'Y' order by module_order_tot";
		$data['modules_active'] = $this->db->query($sql)->result_array();
		if (isset($_POST['profile_name'])) {
			$data_rec = array();
			$data_rec['profile_name'] = $_POST['profile_name'];
			$data_rec['profile_description'] = $_POST['profile_description'];
			
			//### Modules update 
			$data_rec['profile_modules'] = "0";
			foreach ($data['modules_active'] as $x) {
				$var_field = "xmodules_id_" . $x['xmodules_id'];
				if ($_POST[$var_field] != "") {
					$data_rec['profile_modules'] .= "," . $_POST[$var_field];
					// // // echo  "<br>!! mod fields tot is " . $data_rec['profile_modules'];
				}
			}
			$data_rec['profile_modules'] .= ",0";
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($key_table, $data_rec);
			} else {
				$this->db->insert($key_table, $data_rec);
				$id = $this->db->insert_id();
				$_POST['id'] = $id;
			}
		}
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/Module_profiles3/listing/manage_key_lists_4');
		} else {
			//############# RUN QUERIES FOR THE SCREEN ############# 
			$sql = "select * from ainf_xmodule2 where active = 'N' order by module_order_tot"; 
			$data['modules_inactive'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from ainf_xmodule2 where active = 'D' order by module_order_tot"; 
			$data['modules_dev'] = $this->db->query($sql)->result_array(); 
		
			if (trim($id) != "" and $_POST['id'] != "") {
				//############# NEW PRAYERS CODE ############# 
				$sql = "select * from $key_table where id = {$_POST['id']} order by profile_name";
				$data['edit_rec'] = $this->db->query($sql)->result_array();
				// var_dump($data['edit_rec']);
				//############# NEW PRAYERS CODE ############# 
				$_POST['userid'] = $id;
				$this->load->view('update_profile.php', $data);
			} else {
				$_POST['userid'] = 0;
				$this->load->view('update_profile.php', $data);
			}
		}
		
	}

	public function listing($pagename)
	{
		// Get page name for the link
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		//### PROFILE LIST
		$sql = "select * from ainf_xmodule2_profiles order by profile_name"; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 

		$var_last_month = date('Y/m/d', strtotime('-31 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();

		$var_last_month = date('Y/m/d', strtotime('-31 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month and follup_contact_type in ('Successful Phone Call','Meeting','Group Event')) order by first_name, last_name";
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array();

		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select userid, mobile, email, userid, first_name, last_name from ainf_vps3_users where compid = $varcompid and (team_regular_church is null or email is null or addr_suburb is null or addr_street is null) order by first_name, last_name";
		$data['main_list_array_tab4'] = $this->db->query($sql)->result_array();
		
		//### NOT USED EXCEPT IN REPORT - GOOD FOR PRAYER REQUEST LISTINGS 
		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
	}

	public function attendeestatus($pagename)
	{
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 

		$var_this_yr_month =  date("Y/m"); // Get the users NOT having follow_ups 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  follup_contact_date_sort like '%$var_this_yr_month%') order by first_name, last_name";
		$data['follups_left'] = $this->db->query($sql)->result_array();
		
		//### PRAYER REQUESTS 
		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort like '%$var_this_yr_month%' order by userid, request_date_sort desc";
		$data['prayer_req_new'] = $this->db->query($sql)->result_array();

		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort not like '%$var_this_yr_month%' and req_status not in ('Answered') order by userid, request_date_sort desc";
		$data['prayer_req_open'] = $this->db->query($sql)->result_array();
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.mobile, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		//### QUERIES FOR GAPS REPORT 
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		
		$var_last_month = date('Y/m/d', strtotime('-31 days')); 
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		$data['no_followups_month'] = $this->db->query($sql)->result_array();

		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 
		
		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where team_regular_church is null or email is null or addr_suburb is null or addr_street is null and compid = $varcompid order by first_name, last_name";
		$data['no_key_dates'] = $this->db->query($sql)->result_array();
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}		
	}

}
	
