<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');

class Notes extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html'); 
		//$this->load->model('mArticle'); 
		//$this->load->model('mArtist'); 
		$this->load->helper('text'); 
		// $this->load->library('cart'); 
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS 
		$this->load->model('System_modules'); $this->load->model('Recheck_access'); 
		$this->Recheck_access->reset_access(); 
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// echo "!! must write other functions code for funciton $callfunction";
		}
		//var_dump($_POST);
	}	

	public function files_manager($var_file_name)
	{
			$err = ""; 
			$var_file_name_key = $var_file_name . "_key";
			$var_file_name_key = $var_file_name;
			$targetPath = "/home/lifecrew/public_html/churchofjesus.live/songfiles/"; // correct path for infinity
			$varurlpath = "https://churchofjesus.live/songfiles/";
			$targetPath = "/home/lifecrew/public_html/churchofjesus.live/files_notes/"; // correct path for infinity
			$varurlpath = "https://churchofjesus.live/files_notes/";
			
			if($_FILES[$var_file_name]['name']) {
				$upload=$_FILES[$var_file_name]['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('gif','jpg','png','jpeg','pdf','doc');
				if(in_array($ext,$config['allowed_types'])) {
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					
					$var_song_title = str_replace( " " , "_"  , $_POST['note_title']); $var_rand = rand(00000,99999);
					$targetFile = $vardate . "_note_" . $var_song_title . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						if (move_uploaded_file($_FILES[$var_file_name]['tmp_name'], $targetPath . $targetFile)) {
							$varuploadurl = $varurlpath . $targetFile;
							$_POST[$var_file_name] = $varuploadurl;
							return $varuploadurl;
							// SUCCESS ";
						} else {
							$err = "ERROR !!04 file name is $var_file_name move not working target path $targetPath target file $targetFile ERROR IS {$_FILES[$var_file_name]['error']}";
							return $err;
						}
					} else {
						$err = "ERROR The path target or dir $targetPath or NOT WRITABLE";
						return $err;
					}
				} else {
					$err = "ERROR <br>!!02 The err is $err";
					return $err;
				}
			} else {
				$err = "ERROR !!01 No image loaded";
				return $err;
			}
	}
	
	public function note_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
					
		if (isset($_POST['note_title'])) {
			
			$data_rec = array();
			unset($data_rec['userid']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['delete_record']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
			
			unset($data_rec['note_pic_1']); unset($data_rec['note_pic_2']);
			unset($data_rec['note_pic_3']); unset($data_rec['note_pic_4']);
			$data_rec['note_title'] = $_POST['note_title']; $data_rec['note_location'] = $_POST['note_location'];
			$data_rec['note_date'] = $_POST['note_date'];
			if (isset($_POST['active']) and $_POST['active'] = "yes") {$data_rec['active'] = "yes";} else {$data_rec['active'] = "no";}

			$date_vars = explode(" ",$data_rec['note_date']); //## BREAK UP DATE INTO REVERSE WITHOUT TIME
			$date_part_vars = explode('/',$date_vars[0]);
			$data_rec['note_date_sort'] = $date_part_vars[2] . "/" . $date_part_vars[1] . "/" . $date_part_vars[0] . " " . $date_vars[1];

			$data_rec['note_friends'] = $_POST['note_friends'];

			//### 
			$varscript = substr($_SERVER['SCRIPT_FILENAME'], 0 , 15);
			if ($varscript != "C:/xampp/htdocs") { // check local or live 
				if($_FILES['note_pic_1']['name']) {
					$file_name = "note_pic_1"; 
					$var_file_result = $this->files_manager($file_name);
					if (strpos($var_file_result,"ERROR") === false) {
						$data_rec['note_pic_1'] = $var_file_result;
					} else {
						// // echo "<br>!!!aa error is {$data_rec['song_chords_url']}";
					}
				}
				if($_FILES['note_pic_2']['name']) {
					$file_name = "note_pic_2"; // 
					$var_file_result = $this->files_manager($file_name);
					if (strpos($var_file_result,"ERROR") === false) {
						$data_rec['note_pic_2'] = $var_file_result;
					} else {
						// // echo "<br>!!!aa error is {$data_rec['song_chords_url']}";
					}
				}
				if($_FILES['note_pic_3']['name']) {
					$file_name = "note_pic_3"; // 
					$var_file_result = $this->files_manager($file_name);
					if (strpos($var_file_result,"ERROR") === false) {
						$data_rec['note_pic_3'] = $var_file_result;
					} else {
						// // echo "<br>!!!aa error is {$data_rec['song_chords_url']}";
					}
				}
				if($_FILES['note_pic_4']['name']) {
					$file_name = "note_pic_4"; // 
					$var_file_result = $this->files_manager($file_name);
					if (strpos($var_file_result,"ERROR") === false) {
						$data_rec['note_pic_4'] = $var_file_result;
					} else {
						// // echo "<br>!!!aa error is {$data_rec['song_chords_url']}";
					}
				}
			}
			
			// SPEAKER REC 
			if ($_POST['id'] != 0) {
				$data_rec['date_updated'] = date("d/m/Y H:i:s");
				$this->db->where('id', $_POST['id']);
				$this->db->update('notes', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec['date_created_sort'] = date("Y/m/d H:i:s");
				$data_rec['date_created'] = date("d/m/Y H:i:s");
				$this->db->insert('notes', $data_rec);
				$id = $this->db->insert_id();
				$_POST['id'] = $id;
				$var_add_user = "yes";
			}
			
		}
		
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'request_status' order by code_name";
		$data['req_types'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			redirect('/notes/details/notes_list'); // back to listing
		} elseif (($_POST['id'] != 0 and $_POST['id'] != "") or ($id != 0 and $id != "")) { // the id is always set from default record 
			// Back to updates 
			$sql = "select * from notes where id = {$_POST['id']}";
			$data['edit_note'] = $this->db->query($sql)->result_array();
			$this->load->view('update_notes', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_notes', $data);
		}
	}

	public function details($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];

		// ## ALL NOTES 
		$sql = "select * from notes where active = 'yes' order by note_date_sort desc"; // Notes are beyond any company - for director only 
		$data['notes_list'] = $this->db->query($sql)->result_array(); 
		
		// ## NOTES TODAY 
		$var_today_end = date('Y/m/d') . " 99:99"; $var_today_start = date('Y/m/d') . " 00:00"; 
		$sql = "select * from notes where active = 'yes' and note_date_sort > '$var_today_start' and note_date_sort < '$var_today_end' order by note_date_sort desc"; 
		$data['notes_list_today'] = $this->db->query($sql)->result_array(); 
		// // echo "<br>!! today start $var_today_start";
		
		// ## NOTES FOR WEEK 
		$date = date('Y/m/d'); $date1 = strtotime($date); $date2 = strtotime("-7 day", $date1);
		$var_week_start = date('Y/m/d', $date2) . " 00:00"; $var_week_end = date('Y/m/d') . " 99:99";
		$sql = "select * from notes where active = 'yes' and note_date_sort > '$var_week_start' and note_date_sort < '$var_week_end' order by note_date_sort desc";
		$data['notes_list_week'] = $this->db->query($sql)->result_array();
		
		if (file_exists(base_url("views/manage_key_lists")))
		{
			$_POST['error'] = "";
			$this->load->view("manage_key_lists", $data);
		} else {
			$this->load->view("manage_key_lists", $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	
