<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Praise4 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // echo "!! must write other functions code for funciton $callfunction";
		}
		// //// // var_dump($_POST);
	}	

	public function follow_up_edit()
	{

		$varcompid = $_POST['sess_compid']; 
		
		if ($_POST['follup_contact_type'] != "")  {
			$data_rec = array();
			$data_rec = $_POST;
			$date_array = explode('/',$_POST['follup_contact_date_time']);
			$var_follup_contact_date_sort = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0];
			$data_rec['follup_contact_date_sort'] = $var_follup_contact_date_sort;
			
			unset($data_rec['userid']); unset($data_rec['compid']); 
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_follow_ups', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert('teampro_follow_ups', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$varcompid = $_POST['sess_compid']; 
		$_POST['follup_for'] = $_POST['userid'];
					
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		// //// // var_dump($data['host_names']);
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'follup_contact_types' order by code_name";
		$data['follup_contact_types'] = $this->db->query($sql)->result_array();		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['team_visitor_list'] = $this->db->query($sql)->result_array();
		
		// // // // echo "<br>!! The post add rec is {$_POST['add_record']} !! mod rec is  {$_POST['mod_record']} ";
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/follow_ups/details/follow_ups'); // back to listing 
		} elseif ($_POST['add_record'] == "yes") {
			$_POST['id'] = 0;
			$this->load->view('update_followups', $data);
		} elseif ($_POST['mod_record'] == "yes" or $_POST['id'] > 0) { // the id is always set from default record 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from teampro_follow_ups where id = $id";			
			$data['edit_teampro_follow_ups'] = $this->db->query($sql)->result_array();
			$_POST['userid'] = $id;
			$this->load->view('update_followups', $data);
		}
	}

	public function event_edit()
	{

		$varcompid = $_POST['sess_compid'];

		if ($_POST['register_image_x'] != "" and isset($_POST['register_image_x'])) {
			$_POST['redirect-from-event-edit'] = "yes";
			$this->attendance();
			// redirect('/events/attendance/update_attendance'); // back to listing 
		} else {

			if ($_POST['add_followup'] == "yes") {
				$this->follow_up_edit();
			} else {
				if (isset($_POST['title'])) {
					$data_rec = array();
					$data_rec = $_POST;
					unset($data_rec['userid']);
					unset($data_rec['id']); unset($data_rec['return_to_list']); unset($data_rec['MAX_FILE_SIZE']); 
					unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
					unset($data_rec['team_userid']); unset($data_rec['team_type']);
					unset($data_rec['main_action']);

					$date_array = explode('/',$_POST['date']);
					$var_date_time_array = explode(' ',$date_array[2]);
					$data_rec['date_sort'] = $var_date_time_array[0] . "/" . $date_array[1] . "/" . $date_array[0] . " " . $var_date_time_array[1];
					//// // var_dump($data_rec);
					
					if ($_POST['id'] != 0) {
						$this->db->where('id', $_POST['id']);
						$this->db->update('teampro_events', $data_rec);
						$id = $_POST['id'];
					} else {
						$data_rec['compid'] = $varcompid;
						$this->db->insert('teampro_events', $data_rec);
						$id = $this->db->insert_id();
					}
					
					if ($_POST['team_type'] != "" and $_POST['team_userid'] != "") {
						$data_rec = array();
						$data_rec['team_type'] = $_POST['team_type'];
						$data_rec['team_userid'] = $_POST['team_userid'];
						$data_rec['event_id'] = $id;
						$data_rec['compid'] = $varcompid;
						$this->db->insert('teampro_event_teams', $data_rec);
					}
				}
				
				if ($_POST['mod_view_image_x'] != "") {
					$_POST['main_action'] = "view";
				} else {
					$_POST['main_action'] = "edit";
				}

				$varcompid = $_POST['sess_compid'];
				$sql = "select * from ainf_vps3_users where compid = $varcompid";
				$data['event_leaders'] = $this->db->query($sql)->result_array();
				$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid and is_visitor not in ('yes')";
				$data['event_follow_ups'] = $this->db->query($sql)->result_array();
				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name";
				$data['sex_list'] = $this->db->query($sql)->result_array();
				$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
				$data['connect_list'] = $this->db->query($sql)->result_array();
				$sql = "select * from teampro_events where compid = $varcompid";
				$data['host_names'] = $this->db->query($sql)->result_array();
				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'next_steps' order by code_name";
				$data['next_steps_list'] = $this->db->query($sql)->result_array();
				
				$sql = "select * from ainf_vps3_code_manager where code_group = 'follow_frequency'";
				$data['follow_freq'] = $this->db->query($sql)->result_array();			
				$sql = "select * from ainf_vps3_code_manager where code_group = 'event_type'";
				$data['event_types'] = $this->db->query($sql)->result_array();
				$varsql = "";
				$sql = "select * from ainf_vps3_code_manager where code_group = 'proteam-access' $varsql order by code_id desc";
				$data['access_levels'] = $this->db->query($sql)->result_array();

				$sql = "select code_name from ainf_vps3_code_manager where code_group = 'event_team_type' order by code_name";
				$data['event_team_types'] = $this->db->query($sql)->result_array();
				$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid or compid_group like '%,$varcompid,%'";
				$data['potential_team_members'] = $this->db->query($sql)->result_array();
				
				if ($_POST['id'] > 0 and $_POST['id'] != "") {
					$id = $_POST['id'];
					$sql = "select first_name, last_name, compid from ainf_vps3_users where userid in (select leader from teampro_events where id = $id)";
					$data['leader_name'] = $this->db->query($sql)->result_array();
				}
				
				if ($_POST['id'] > 0 and $_POST['id'] != "") {
					$id = $_POST['id'];
					$sql = "select a.id, a.event_id, a.compid, a.event_id, a.team_userid, a.team_type, b.first_name, b.last_name, b.mobile, b.email from teampro_event_teams a 
					left join ainf_vps3_users b on a.team_userid = b.userid where event_id = $id order by team_type";
					$data['event_teams'] = $this->db->query($sql)->result_array();
				}
				
				If ($_POST['return_to_list'] == "yes") {
					redirect('/events/details/praiselist2'); // back to listing 
				} elseif ($_POST['mod_record'] == "yes" OR $_POST['id'] > 0) { // the id is always set from default record 
					// back to updates 
					if ($_POST['id'] > 0) {$id = $_POST['id'];}
					$sql = "select * from teampro_events where id = $id";
					$data['edit_teampro_event'] = $this->db->query($sql)->result_array();
					$_POST['userid'] = $id;
					$this->load->view('update_event', $data);
				} else {
					$_POST['userid'] = 0;
					$this->load->view('update_event', $data);
				}
			}
		}
	}

	public function files_manager($var_file_name)
	{
			$err = "";
			$var_file_name_key = $var_file_name . "_key";
			$targetPath = "/home/lifecrew/public_html/churchofjesus.live/songfiles/"; // correct path for infinity 
			$varurlpath = "https://churchofjesus.live/songfiles/";
			if($_FILES[$var_file_name]['name']) {
				$upload=$_FILES[$var_file_name]['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('gif','jpg','png','jpeg','pdf','doc');
				if(in_array($ext,$config['allowed_types'])) {
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					
					$var_song_title = str_replace( " " , "_"  , $_POST['song_title']); $var_rand = rand(00000,99999);
					$targetFile = "song_" . $var_song_title . "_key_" . $_POST[$var_file_name_key] . "_" . $vardate . "_" . $var_rand . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						// // // echo "";
						if (move_uploaded_file($_FILES[$var_file_name]['tmp_name'], $targetPath . $targetFile)) {
							$varuploadurl = $varurlpath . $targetFile;
							$_POST[$var_file_name] = $varuploadurl;
							return $varuploadurl;
							// SUCCESS ";
						} else {
							$err = "ERROR !!04 file name is $var_file_name move not working target path $targetPath target file $targetFile ERROR IS {$_FILES[$var_file_name]['error']}";
							return $err;
						}
					} else {
						$err = "ERROR The path target or dir $targetPath or NOT WRITABLE";
						return $err;
					}
				} else {
					$err = "ERROR <br>!!02 The err is $err";
					return $err;
				}
			} else {
				$err = "ERROR !!01 No image loaded";
				return $err;
			}
	}
	
	public function play_manage($pagename)
	{

		$pagename_orig = $pagename; 
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs(); 

		$sql = "select * from teampro_song_list where list_type = 'header' and list_priority = '1' order by list_title "; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from teampro_song_list where list_type = 'header' and list_priority = '2' order by list_title "; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from teampro_song_list where list_type = 'header' and list_priority = '3' order by list_title "; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 
		
		if (file_exists(base_url("application/views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
		}
		
	}

	public function play_list_sing()
	{
		$_POST['perform_mode'] = "public_singer"; 
		echo "<br>!! 11 "; 
		$this->play_list_perform(); 
	}

	public function play_list_perform()
	{

		// echo "<br>!! 33 in perform !! ";
		if ($_POST['perform_mode'] == "") {
			$_POST['perform_mode'] = "public_singer";
			$_POST['perform_mode'] = "worship_leader";
		}

		$pagename_orig = "list_dragdrop_v1"; 
		$pagename_orig = "song-playlist-run-v1"; 
		$pagename_orig = "song-playlist-singer-v1"; // ### SINGER VERSION LYRICS 
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs(); 

		$sql = "select * from teampro_song_list where id = {$_POST['id']} and list_type = 'header'"; 
		$data['song_list_header'] = $this->db->query($sql)->result_array(); 
		// echo "<br>!! header sql is $sql";
		// var_dump($data['song_list_header']);
		
		$sql = "select list_song_id from teampro_song_list where list_group_id = {$_POST['id']} and list_type = 'song' order by list_song_position "; 
		$sql = "select * from teampro_songs where id in (select list_song_id from teampro_song_list where list_group_id = {$_POST['id']} and list_type = 'song' order by list_song_position )"; 
		// echo "<br>!! sql is $sql ";

		$data['song_listing'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("application/views/list_dragdrop_v1")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
		}
		
	}
	
		
	public function play_lists($pagename)
	{

		$pagename_orig = $pagename; 
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs(); 

		$sql = "select * from teampro_song_list where list_type = 'header' and active = 'Y' order by list_title "; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from teampro_song_list where list_type = 'header' and active = 'N' order by list_title "; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 
		
		if (file_exists(base_url("application/views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
		}
		
	}
	
	public function listing($pagename)
	{

		$pagename_orig = $pagename;
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();

		$sql = "select * from teampro_songs order by song_title"; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from teampro_songs order by song_best_key"; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from teampro_songs where song_capo_fret = 0 order by song_title"; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 
		
		if (file_exists(base_url("application/views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
		}
		
	}
	
	public function play_list_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		if (isset($_POST['list_title'])) {

			$data_rec = array();
			$data_rec['list_title'] = $_POST['list_title']; $data_rec['list_theme'] = $_POST['list_theme'];
			$data_rec['list_type'] = "header"; $data_rec['list_notes'] = $_POST['list_notes']; 
			$data_rec['list_priority'] = $_POST['list_priority']; 
			if ($_POST['active'] == "Y") { $data_rec['active'] = "Y"; } else { $data_rec['active'] = "N"; } 
			if ($_POST['id'] != 0) {
				$data_rec['list_last_mod_user'] = $_POST['sess_userid']; 
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_song_list', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec['mastercompid'] = 113;
				$data_rec['list_create_user'] = $_POST['sess_userid']; 
				$this->db->insert('teampro_song_list', $data_rec);
				$_POST['id'] = $this->db->insert_id();
				$data_rec['list_group_id'] = $id;

				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_song_list', $data_rec);
			}
			
			if ($_POST['list_song_id_add1'] != "") { 
				$data_rec['list_type'] = "song"; 
				$data_rec['list_song_id'] = $_POST['list_song_id_add1']; 
				$data_rec['list_group_id'] = $_POST['id']; 
				$data_rec['list_create_user'] = $_POST['sess_userid']; 
				// var_dump($data_rec); 
				$this->db->insert('teampro_song_list', $data_rec); 
 			} 
			
			$sql = "select * from teampro_song_list where list_group_id = {$_POST['id']} and list_type = 'song' order by list_song_position "; 
			$var_all_song_list = $this->db->query($sql)->result_array(); 
			$rows = 0; 
			foreach ($var_all_song_list as $z) { 
				++$rows; 
				
				$var_mod_id = "list_song_id_" . $rows;
				$var_mod_id_val = $_POST[$var_mod_id];
				// echo "<br>!! song id value is $var_mod_id_val";
				$var_mod_name = "list_song_id_mod_" . $rows;
				$var_mod_name_val = $_POST[$var_mod_name];
				
				$var_mod_position = "list_song_position_" . $rows;
				$var_mod_position_val = $_POST[$var_mod_position];
				if ($_POST[$var_mod_id] == $z['id']) {
					
					// echo "<br>Match on ID of {$z['id']}"; 
					// echo " Position is $var_mod_position_val SONGID is $var_mod_name_val "; 

					$song_rec = array();
					$song_rec['list_song_position'] = $var_mod_position_val;
					$song_rec['list_song_id'] = $var_mod_id_val;
					$data_rec['list_last_mod_user'] = $_POST['sess_userid']; 
					$this->db->where('id', $z['id']);
					$this->db->update('teampro_song_list', $song_rec);
					
				}
			}
			
			// ####	USEFUL TO KNOW THE SONG COUNT ####
			$data_rec = array();
			$data_rec['list_song_count'] = count($var_all_song_list);
			$this->db->where('id', $_POST['id']);
			$this->db->update('teampro_song_list', $data_rec);
			
		}
		
		// #### // echo "<br>#### "; 
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'song_type' order by code_name";
		$data['song_type_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_songs where compid = $varcompid order by song_title"; 
		$sql = "select * from teampro_songs order by song_title"; 
		$data['songs_by_title'] = $this->db->query($sql)->result_array(); 
		
		If ($_POST['return_to_list'] == "yes") {
			// redirect('/praise4/details/praiselist2'); // back to listing
			redirect('/Praise4/play_lists/manage_key_lists_4'); // back to listing
		} elseif ($_POST['id'] != 0 or $id != "") { // BEST SETTING - WORKS IF NOT RETURNING TO LIST 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select * from teampro_song_list where id = $id"; 
			$data['edit_teampro_song_list'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from teampro_song_list where list_group_id = $id and list_type = 'song' order by list_song_position"; 
			$data['edit_teampro_all_song_list'] = $this->db->query($sql)->result_array(); 
			$_POST['id'] = $id;
			$this->load->view('update_play_list', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_play_list', $data);
		}
	}
		
	public function song_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		// // echo "<br>!! 11";
		if (isset($_POST['song_title'])) {
			$data_rec = array();
			$data_rec = $_POST;
		// // echo "<br>!! 22";
			unset($data_rec['userid']); unset($data_rec['MAX_FILE_SIZE']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']);
			unset($data_rec['sess_userid']); unset($data_rec['main_action']);

			// FILE UPLOADS IF UPLOADED
			unset($data_rec['song_chords_url']); unset($data_rec['song_lead_url']); unset($data_rec['song_vocal_url']);
			if($_FILES['song_chords_url']['name']) {
				$file_name = "song_chords_url"; $file_name_key = "song_chords_url_key";
				$var_file_result = $this->files_manager($file_name);
				if (strpos($var_file_result,"ERROR") === false) {
					$data_rec['song_chords_url'] = $var_file_result;
					// // // echo "<br>!!!aa song_chords_url valid {$data_rec['song_chords_url']}";
				} else {
					// // // echo "<br>!!!aa error is {$data_rec['song_chords_url']}";
				}
			}

			if($_FILES['song_lead_url']['name']) {
				$file_name = "song_lead_url"; $file_name_key = "song_lead_url_key";
				$var_file_result = $this->files_manager($file_name);
				if (strpos($var_file_result,"ERROR") === false) {
					$data_rec['song_lead_url'] = $var_file_result;
					// // // echo "<br>!!!bb song_lead_url {$data_rec['song_lead_url']}";
				} else {
					// // // echo "<br>!!!bb error is $var_file_result";
				}
			}

			if($_FILES['song_vocal_url']['name']) {
				$file_name = "song_vocal_url"; $file_name_key = "song_vocal_url_key";
				$var_file_result = $this->files_manager($file_name);
				if (strpos($var_file_result,"ERROR") === false) {
					$data_rec['song_vocal_url'] = $var_file_result;
					// // // echo "<br>!!!cc song_vocal_url {$data_rec['song_vocal_url']}";
				} else {
					// // // echo "<br>!!!cc error is {$data_rec['song_vocal_url']}";
				}
			}
			
			$data_rec = array(); 
			$data_rec['song_title'] = $_POST['song_title']; $data_rec['song_year'] = $_POST['song_year']; 
			$data_rec['song_writer'] = $_POST['song_writer']; $data_rec['song_artist'] = $_POST['song_artist']; 
			$data_rec['song_best_key'] = $_POST['song_best_key']; $data_rec['song_capo_fret'] = $_POST['song_capo_fret']; 
			// ### My settings allow key and capo to match each team 
			if ($_POST['song_my_best_key'] != "") {
				$data_rec['song_my_best_key'] = $_POST['song_my_best_key'];
			} else {
				$data_rec['song_my_best_key'] = $_POST['song_best_key'];
			}
			if ($_POST['song_my_capo_fret'] != "") {
				$data_rec['song_my_capo_fret'] = $_POST['song_my_capo_fret'];
			} else {
				$data_rec['song_capo_fret'] = $_POST['song_my_capo_fret'];
			}
			$data_rec['song_link_youtube'] = $_POST['song_link_youtube']; $data_rec['song_link_spotify'] = $_POST['song_link_spotify'];
			$data_rec['song_type'] = $_POST['song_type'];
			
			$data_rec['song_notes'] = $_POST['song_notes'];
			$data_rec['song_notes'] = str_replace('<pre>','<html>',$data_rec['song_notes']);
			$data_rec['song_notes'] = str_replace('</pre>','</html>',$data_rec['song_notes']);
			$data_rec['song_notes'] = preg_replace( "/\r|\n/", "<br>", $data_rec['song_notes']);
			$data_rec['song_notes'] = str_replace('<br />','',$data_rec['song_notes']);
			$data_rec['song_notes'] = str_replace('<br />','',$data_rec['song_notes']);
			$data_rec['song_notes'] = str_replace('<br><br>','<br>',$data_rec['song_notes']);
			$data_rec['song_notes'] = str_replace('<br><br>','<br>',$data_rec['song_notes']);

			$data_rec['song_lyrics_only'] = $_POST['song_lyrics_only'];
			$data_rec['song_lyrics_only'] = str_replace('<br />
<br />','<br />',$data_rec['song_lyrics_only']);
			$data_rec['song_lyrics_only'] = str_replace('<br />','<br>',$data_rec['song_lyrics_only']);
			$data_rec['song_lyrics_only'] = str_replace('<br />','<br>',$data_rec['song_lyrics_only']);
			$data_rec['song_lyrics_only'] = str_replace('<br />&nbsp;<br />','<br>',$data_rec['song_lyrics_only']);
			
			$data_rec['song_lyrics_only'] = str_replace('<p>','<br>',$data_rec['song_lyrics_only']);
			$data_rec['song_lyrics_only'] = str_replace('<p>','<br>',$data_rec['song_lyrics_only']);
			$data_rec['song_lyrics_only'] = str_replace('</p>','',$data_rec['song_lyrics_only']);
			$data_rec['song_lyrics_only'] = str_replace('</p>','',$data_rec['song_lyrics_only']);
			$data_rec['song_lyrics_only'] = str_replace('<br><br>','<br>',$data_rec['song_lyrics_only']);
			
			// ### //
			// ### //
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_songs', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec['mastercompid'] = 113;
				$this->db->insert('teampro_songs', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'song_type' order by code_name";
		$data['song_type_list'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'key_type' order by code_name";
		$data['song_key_list'] = $this->db->query($sql)->result_array();
		// $sql = "select code_name from ainf_vps3_code_manager where code_group = 'chord_chart_type' order by code_name";
		// $data['chord_chart_type'] = $this->db->query($sql)->result_array();		
		
		If ($_POST['return_to_list'] == "yes") {
			// redirect('/praise4/details/praiselist2'); // back to listing
			redirect('/praise4/listing/manage_key_lists_4'); // back to listing
		} elseif ($_POST['id'] != 0 or $id != "") { // BEST SETTING - WORKS IF NOT RETURNING TO LIST 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select * from teampro_songs where id = $id";
			$data['edit_teampro_songs'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_song', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_song', $data);
		}
	}
	
	public function attendance()
	{
		
		// Set the sub-querys 
		$var_at_this_event = "%," . $_POST['id'] .  ",%"; // Sub-query locating that event 
				
		$varcompid = $_POST['sess_compid'];
		if (isset($_POST['first_name'])) {

			// Find user from mobile 
			$var_mobile = trim($_POST['mobile']);
			if (trim($var_mobile) != "") {
				$sql = "select * from ainf_vps3_users where mobile = $var_mobile";
				$data['new_attendee'] = $this->db->query($sql)->result_array();
			}
			
			if (count($data['new_attendee']) > 0 and $var_mobile != "") { // this attendee has registered before - we can add them in 
				foreach ($data['new_attendee'] as $rec) {
					$var_events_attended = $rec['events_attended'];
					$var_userid = $rec['userid'];
					$var_this_event_string = "," . $_POST['id'] .  ","; // to check if they are registered they would have this substr
					// // // // echo "<br>!! cc var_events_attended $var_events_attended";
						} if (strpos($var_events_attended, $var_this_event_string) !== false) {
							// Already registered for this event
						} else {
							if (trim($var_events_attended) == "") { // On record but not attended
								$var_events_attended = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event
								// // // // echo "<br>!!dda NEW var_events_attended $var_events_attended, ";
							} else {  // On record and attended already
								$var_str_replace = "0," . $_POST['id'] .  ",";
								$var_events_attended_new = str_replace( "0," , $var_str_replace  , $var_events_attended);
								// // // // echo "<br>!!XX After replace str_replace $var_str_replace, var_events_attended= $var_events_attended, var_events_attended_new= $var_events_attended_new";
								$var_events_attended = $var_events_attended_new;
							}
							// $var_events_attended = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event
							// // // // echo "<br>!!ddB UPDATE var_events_attended $var_events_attended, ";
							$data_rec = array();
							$data_rec['events_attended'] = $var_events_attended;
							$this->db->where('userid', $var_userid);
							$this->db->update('ainf_vps3_users', $data_rec);
						}
			} else {
				// NEW VISITOR NOT ON RECORD AT ANY CHURCH 
				$var_events_attended = "0," . $_POST['id'] .  ",0"; // Make present for this church 
				$data_rec = array();
				$data_rec['events_attended'] = $var_events_attended;
				$data_rec['first_name'] = $_POST['first_name'];
				$data_rec['last_name'] = $_POST['last_name'];
				$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email']; $data_rec['compid'] = $varcompid;
				$data_rec['sex'] = $_POST['sex']; $data_rec['followup_person'] = $_POST['followup_person']; 
				$data_rec['is_visitor'] = "yes";
				$this->db->insert('ainf_vps3_users', $data_rec);
			}
			
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid and is_leader = 'yes'";
		$data['event_follow_ups'] = $this->db->query($sql)->result_array();
		$sql = "select userid, first_name, last_name, compid from ainf_vps3_users where compid = $varcompid and is_visitor not in ('yes')";
		$data['event_follow_ups'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name";
		$data['sex_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select userid from ainf_vps3_users where events_attended like '$var_at_this_event')";
		$data['attendees_not_present'] = $this->db->query($sql)->result_array();
		
		// ANALYTICS FOR EVENT 
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event'";
		$data['attendees_present'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and sex = 'Male'";
		$data['attendees_present_male'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and (mobile is not null and mobile <> '' and (email is null or email = ''))";
		$data['attendees_present_left_phone'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and ((mobile is null or email = '') and (email is not null and email <> ''))";
		$data['attendees_present_left_email'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where events_attended like '$var_at_this_event' and (mobile is not null and mobile <> '' and email is not null and email <> '')";
		$data['attendees_present_left_phoneandemail'] = $this->db->query($sql)->result_array();

		$var_this_event_only = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event
		$sql = "select * from ainf_vps3_users where compid = $varcompid and events_attended = '$var_this_event_only' and is_visitor = 'yes'";
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		
		if ($_POST['id'] > 0) {
			$id = $_POST['id'];
			$sql = "select * from teampro_events where id = $id";
			$data['this_event'] = $this->db->query($sql)->result_array();
		}
		$sql = "select * from teampro_events where compid = $varcompid";
		$data['edit_teampro_events'] = $this->db->query($sql)->result_array();
		$_POST['id'] = $id;
		$this->load->view('update_attendance', $data);
	}
	
	public function details($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];
		if ($_POST['add_followup'] == "yes" or $_POST['add_followup2'] == "yes") {
			$this->follow_up_edit();
		}
		

		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // // // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_book'] = "";
			$_POST['form_speaker'] = "";
			$_POST['form_keywords'] = "";
		}
		if ($_POST['form_book'] != "") {
			$var_search .= " and book = '{$_POST['form_book']}' ";
		}
		if ($_POST['form_speaker'] != "") {
			$var_search .= " and teacher = '{$_POST['form_speaker']}' ";
		}

		$var_sql_range = ""; // Get filters into the sql 
		
		
		
		if (isset($_POST['form_event_group']) or strpos($_SERVER['REQUEST_URI'], "events_next") !== false or strpos($_SERVER['REQUEST_URI'], "events_today") !== false) {
			if ($_POST['form_event_group'] == "Past Events") {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort < '$var_date_from'";
			} elseif ($_POST['form_event_group'] == "Events Today" or strpos($_SERVER['REQUEST_URI'], "events_today")) {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort > '$var_date_from' ";
				$var_date_today = date("Y-m-d");
				$var_date_to = date('Y/m/d', strtotime($var_date_today. ' + 1 days')) . " 00:00";
				$var_sql_range .= " and date_sort < '$var_date_to' ";
				$_POST['form_event_group'] = "Events Today";
			} elseif ($_POST['form_event_group'] == "Events This Week" or strpos($_SERVER['REQUEST_URI'], "events_next_7_days") !== false) {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort > '$var_date_from' ";
				$var_date_today = date("Y-m-d");
				$var_date_to = date('Y/m/d', strtotime($var_date_today. ' + 8 days')) . " 00:00";
				$var_sql_range .= " and date_sort < '$var_date_to' ";
				$_POST['form_event_group'] = "Events This Week";
			} elseif ($_POST['form_event_group'] == "Events next 30 Days" or strpos($_SERVER['REQUEST_URI'], "events_next_30_days") !== false) {
				$var_date_from = date("Y/m/d") . " 00:00";
				$var_sql_range = " and date_sort > '$var_date_from' ";
				$var_date_today = date("Y-m-d");
				$var_date_to = date('Y/m/d', strtotime($var_date_today. ' + 31 days')) . " 00:00";
				$var_sql_range .= " and date_sort < '$var_date_to' ";
				$_POST['form_event_group'] = "Events next 30 Days";
			} elseif ($_POST['form_event_group'] == "All Events") {
				$var_sql_range = "";
			}
		}

		// Set form filters into main sql 
		$sql = "select * from teampro_events where compid = $varcompid $var_sql_range order by date_sort desc";
		$data['events'] = $this->db->query($sql)->result_array();
		$var_sql_range = "";
		if (isset($_POST['form_song_type']) and trim($_POST['form_song_type']) != "" and trim($_POST['form_song_type']) != "All Song Types" and trim($_POST['form_song_type']) != "All Types") {
			$var_sql_range .= " and song_type = '{$_POST['form_song_type']}' ";
		}
		if (isset($_POST['song_date_range']) and trim($_POST['song_date_range']) != "" and trim($_POST['song_date_range']) != "All Dates") {
			$var_sql_range .= " and {$_POST['song_date_range']} ";
		}
		$sql = "select * from teampro_songs where compid = $varcompid $var_sql_range order by song_title";
		$sql = "select * from teampro_songs order by song_title";
		$data['song_list'] = $this->db->query($sql)->result_array();
				
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // // // echo "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid order by first_name, last_name";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'song_type' order by code_name";
		$data['song_type_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_code_manager where code_group = 'songs_date_range' order by code2";
		$data['song_date_range'] = $this->db->query($sql)->result_array();

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		//// // // echo $pagename_orig;exit;
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function visitors($pagename)
	{
		
		$varcompid = $_POST['sess_compid']; 
		$var_this_event_only = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event 
		
		$var_date_sort = date('Y/m/d');
		$var_date_sort = date('d/m/Y');
		$sql = "select id, date_sort, compid from teampro_events where compid = $varcompid and date_sort like ('%$var_date_sort%')";
		$sql = "select id, date, compid from teampro_events where compid = $varcompid and date like ('%$var_date_sort%')";
		$data['current_events'] = $this->db->query($sql)->result_array();
		$var_current_events_sql = ""; $var_ev_num = 0;
		foreach ($data['current_events'] as $x) {
			$var_current_events_sql .=  " and events_attended like '%,{$x['id']},%'";
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid $var_current_events_sql and is_visitor = 'yes'";
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_book'] = "";
			$_POST['form_speaker'] = "";
			$_POST['form_keywords'] = "";
		}
		if ($_POST['form_book'] != "") {
			$var_search .= " and book = '{$_POST['form_book']}' ";
		}
		if ($_POST['form_speaker'] != "") {
			$var_search .= " and teacher = '{$_POST['form_speaker']}' ";
		}
		
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_events where compid = $varcompid order by date_sort desc";
		$data['events_list'] = $this->db->query($sql)->result_array();
		// //// // var_dump($data['events_list']);

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // // // echo "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid order by first_name, last_name";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		// The left join gets the optional leader name 
		$sql = "select a.id, a.event_type, a.compid, a.details, a.leader, a.date, a.date_sort, a.title, a.event_tip, a.address, a.contact_1, a.contact_2, a.duration_note, 
		a.transport_1, a.transport_2, a.image_url, b.first_name as leader_first_name, b.last_name as leader_last_name 
		from teampro_events a 
		left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid = $varcompid order by date_sort desc"; 
		$data['events_list'] = $this->db->query($sql)->result_array();

		// // // echo "";
		// $pagename_orig = "visitors-list.php";
		// $pagename_orig = "visitors-list";
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	
