<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Prayer_requests extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		// We are using POST as then we can clear the session data that can be a security hole - so every click is a POST 
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['userid']) == "" and $var_userid != "") {
			$_POST['userid'] = $var_userid;
		}
		if (trim($_POST['sess_userid']) == "" and $var_userid != "") {
			$_POST['sess_userid'] = $var_userid;
		}
						
		$sql = "select first_name, last_name, compid, globcompanyname from ainf_xglobalclient, ainf_vps3_users where (compid = globcompid and userid = {$_POST['sess_userid']})";
		$var_comp_user = $this->db->query($sql)->result_array();
		foreach ($var_comp_user as $i) {
			$_POST['sess_first_name'] = $i['first_name'];
			$_POST['sess_last_name'] = $i['last_name'];
			$_POST['sess_compid'] = $i['compid'];
			$_POST['sess_globcompanyname'] = $i['globcompanyname'];
		}

		$var_compname = $this->session->userdata('compname'); 
		$var_first_name = $this->session->userdata('first_name'); 
		$var_last_name = $this->session->userdata('last_name'); 
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
	}
	
	public function index()
	{
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// echo "!! must write other functions code for funciton $callfunction";
		}
		var_dump($_POST);
	}	

	public function request_edit()
	{
		
		$varcompid = $_POST['sess_compid']; 
		
		
		if (isset($_POST['req_status'])) {
		// echo "!! BB in req";
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['delete_record']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']); 
			
			if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_requests', $data_rec);
			} else {
				// // echo "<br>!! delete record is !!{$_POST['delete_record']}!! ";
				if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
				$data_rec['compid'] = $varcompid;
				$this->db->insert('teampro_requests', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'request_status' order by code_name";
		$data['req_types'] = $this->db->query($sql)->result_array();
		// echo "!! CC in req";
		If ($_POST['return_to_list'] == "yes") { 
			redirect('/teams2/details/index'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default record
			// back to updates
			$sql = "select * from teampro_requests where id = {$_POST['id']}";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
		// echo "!! DD in req";
			$this->load->view('update_request', $data);
		} else {
			$_POST['id'] = 0;
		// echo "!! EE in req";
			$this->load->view('update_request', $data);
		}
	}

	public function member_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['first_name'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
			if ($data_rec['team_visitor_followups'] != "yes") {$data_rec['team_visitor_followups'] = "no";}
			if ($data_rec['team_team_member'] != "yes") {$data_rec['team_team_member'] = "no";}
			
			// Make sure one of visit or team is chosen and team_visitor_followups and team_team_member
			if ($data_rec['team_visitor_followups'] != "yes" and $data_rec['team_team_member'] != "yes") {
				$data_rec['team_visitor_followups'] = "yes"; // Put in visitors if not selected so is in one list
			}
			
			if ($_POST['userid'] != 0) {
				$this->db->where('userid', $_POST['userid']);
				$this->db->update('ainf_vps3_users', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert('ainf_vps3_users', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$varcompid = $_POST['sess_compid'];
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'next_steps' order by code_name";
		$data['next_steps_list'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			redirect('/teams2/details/index'); // back to listing 
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default record
			// back to updates 
			if ($_POST['userid'] > 0) {$id = $_POST['userid'];} 
			$sql = "select * from ainf_vps3_users where userid = $id";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();									
			$_POST['userid'] = $id;
			$this->load->view('update_teams', $data);
		} else {
			$_POST['userid'] = 0;
			$this->load->view('update_teams', $data);
		}
	}

	public function meeting_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['title'])) {
			$data_rec = array();
			$data_rec = $_POST; 
			unset($data_rec['userid']); 
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_groups', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec['mastercompid'] = 113;
				$this->db->insert('teampro_groups', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			redirect('/teams2/details/index'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select * from teampro_groups where id = $id";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_meetings', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_meetings', $data);
		}
	}
	
	public function details($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];		
		// // echo "<br>!!11 teams2/detail - sess_compid = {$_POST['sess_compid']} ";
		
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid']; 

		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array();
				
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$sql = "select * from ainf_vps3_users where compid = $varcompid order by first_name, last_name"; 
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// var_dump($data['services']); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	