<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Services2 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// echo "!! must write other functions code for funciton $callfunction";
		}
		//var_dump($_POST);
	}	

	public function speaker_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['last_name'])) {
			
			$data_rec = array();
			unset($data_rec['userid']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['delete_record']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
			
			$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name'];
			$data_rec['writeup'] = $_POST['writeup']; $data_rec['title'] = $_POST['title'];
			$data_rec['full_name'] = $_POST['first_name'] . " " . $_POST['last_name'];
			$var_add_user = "no";
			
			// SPEAKER REC 
			if ($_POST['active'] == "yes") {$data_rec['active'] = "yes";} else {$data_rec['active'] = "no";}
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('speakers', $data_rec);
			} else {
				if ($_POST['delete_record'] == "yes") {$data_rec['active'] = "yes";} else {$data_rec['active'] = "no";}
				$data_rec['compid'] = $varcompid;
				$this->db->insert('speakers', $data_rec);
				$id = $this->db->insert_id();
				$_POST['id'] = $id;
				$var_add_user = "yes";
			}
			
			// USER RECORD HOLDS OTHER DATA  
			$data_rec2 = array();
			$data_rec2['first_name'] = $_POST['first_name']; $data_rec2['last_name'] = $_POST['last_name'];
			$data_rec2['mobile'] = $_POST['mobile']; $data_rec2['phone'] = $_POST['phone']; $data_rec2['email'] = $_POST['email'];
			$data_rec['is_speaker'] = "yes"; $data_rec2['sex'] = $_POST['sex'];
			if ($var_add_user == "yes" or $_POST['speaker_userid'] == "" or $_POST['speaker_userid'] == 0) {
				$data_rec2['compid'] = $varcompid;
				$this->db->insert('ainf_vps3_users', $data_rec2);
				$speaker_userid = $this->db->insert_id();			
				$data_rec3 = array(); $data_rec3['speaker_userid'] = $speaker_userid;
				$this->db->where('id', $_POST['id']);
				$this->db->update('speakers', $data_rec3);
			} else {
				$this->db->where('userid', $_POST['speaker_userid']);
				$this->db->update('ainf_vps3_users', $data_rec2);
			}
		}
		
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name";
		$data['sex_types'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'request_status' order by code_name";
		$data['req_types'] = $this->db->query($sql)->result_array();
		$sql = "select * from `ainf_vps3_code_manager` where code_group = 'title' order by code_id";
		$data['titles'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			redirect('/services2/speakers/service_manager'); // back to listing
		} elseif (($_POST['id'] != 0 and $_POST['id'] != "") or ($id != 0 and $id != "")) { // the id is always set from default record

			// back to updates 
			$sql = "select a.id, a.speaker_userid, a.first_name, a.last_name, a.full_name, a.title, a.teaser, a.compid, a.writeup, a.active, a.regular_church, b.sex, b.userid, b.email, b.phone, b.mobile   
			from speakers a 
			left join ainf_vps3_users b on a.speaker_userid = b.userid 
			where a.id = {$_POST['id']}";
			$data['edit_speaker'] = $this->db->query($sql)->result_array();
			$this->load->view('speaker_edit', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('speaker_edit', $data);
		}
	}

	public function request_edit()
	{
		
		$varcompid = $_POST['sess_compid']; 
		
		if (isset($_POST['req_status'])) {
		// // echo "!! BB in req";
			$data_rec = array();
			// $data_rec = $_POST;
			unset($data_rec['userid']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['delete_record']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']); 
			
			$data_rec['first_name'] = $_POST['first_name'];
			$data_rec['last_name'] = $_POST['last_name'];
			$data_rec['writeup'] = $_POST['writeup'];
			
			if ($_POST['active'] == "yes") {$data_rec['active'] = "yes";} else {$data_rec['active'] = "no";}
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_requests', $data_rec);
			} else {
				if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
				$data_rec['compid'] = $varcompid;
				$this->db->insert('teampro_requests', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'request_status' order by code_name";
		$data['req_types'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") { 
			redirect('/teams2/details/index'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default record
			// back to updates
			$sql = "select * from teampro_requests where id = {$_POST['id']}";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			$this->load->view('update_request', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_request', $data);
		}
	}

	public function member_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
				
		if (1==2 and isset($_POST['first_name'])) { // WORKS BUT NO RESIZE 
			
			$varuploadimage = "";
			$targetPath = "/home/lifecrew/public_html/teampro.live/files_users_$varcompid/"; // correct path for infinity 
			$varurlpath = "https://teampro.live/files_users_$varcompid/";
			
			//var_dump($_FILES);
			
			if($_FILES['user_image']['name']) {
				$upload=$_FILES['user_image']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('gif','jpg', 'png', 'jpeg');
				if(in_array($ext,$config['allowed_types'])) {
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = "user_image_" . $_POST['first_name'] . "_" . $_POST['last_name'] . "_" . $vardate . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						// echo "";
						if (move_uploaded_file($_FILES['user_image']['tmp_name'], $targetPath . $targetFile)) {
							$varuploadurl = $varurlpath . $targetFile;
							$_POST['team_image_link'] = $varuploadurl;
							// echo "<br>!!03 GOOD We will file team_image_link as {$_POST['team_image_link']}";
							// SUCCESS ";
						} else {
							// echo "<br>!!04 move not working target path $targetPath target file $targetFile ERROR IS {$_FILES['user_image']['error']}";
						}
					} else {
						// echo "<br>!!03 The path target or dir $targetPath or NOT WRITABLE";
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}				
				} else {
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
					// echo "<br>!!02 The err is $err";
				}
			} else {
				// echo "<br>!!01 no image loaded - can be fine!!";
				// // echo "<br>!! The user_image is NOT set";
			}
		}
			
		if($_FILES['user_image']['name']) {
		// NOTE THIS RESIZES AND MOVES TO THE CORRECT DIR 
		// NOW RESIZE TO PNG LOOP 4 TIMES FOR EACH OF THE SIZES 
		// SEE IF USING BEFORE MOVE HELPS 
		
			$filename = $_FILES['user_image']['tmp_name'];
			list($width, $height) = getimagesize($filename);
			$smallwidth = 110; $filemid = $fileid . "-s.png";

			$resizer = array();
			$resizer[1]['width'] = 115; $resizer[1]['ext-mime'] = "-s.png"; 
			
			for ($i = 1; $i < 2; $i++) { // Only 1 cycle 
				$maxDim = $resizer[$i]['width'];
				// list($width, $height, $type, $attr) = getimagesize($_FILES['user_image']['tmp_name']);
				// //// echo "<br><br>!! RESIZE width $width height $height type = $type, attr = $attr maxDim $maxDim";
				// // echo "!!eee MUST BE > MAXDIM TO NEED RESIZE wid $width, height $height maxdim $maxDim";
				if ($width >= $maxDim || $height >= $maxDim ) {
					$ratio = $width/$height;
					if($ratio > 1) {
						$new_width = $maxDim;
						$new_height = $maxDim/$ratio;
					} else {
						$new_width = $maxDim*$ratio;
						$new_height = $maxDim;
					}
					
					$targetPath = "/home/lifecrew/public_html/teampro.live/files_users_$varcompid/"; // correct path for infinity 
					$varurlpath = "https://teampro.live/files_users_$varcompid/";

					$vardate = date("Y-m-d-H-m-s");
					$targetFile = "user_image_" . $_POST['first_name'] . "_" . $_POST['last_name'] . "_" . $vardate . "." . $ext;
					$varfilename = "user_image_" . $_POST['first_name'] . "_" . $_POST['last_name'] . "_" . $vardate . $resizer[$i]['ext-mime'];
					// OLD $varfilename = $fileid . $resizer[$i]['ext-mime'];
					
					$resizefile = $uploaddir . $globimagedir . $varfilename; // OLD 
					$resizefile = $targetPath . $varfilename; // new KEEP 
					$src = imagecreatefromstring( file_get_contents( $_FILES['user_image']['tmp_name'] ) );
					$dst = imagecreatetruecolor( $new_width, $new_height );
					imagecopyresampled( $dst, $src, 0, 0, 0, 0, $new_width, $new_height, $width, $height );
					imagedestroy( $src );
					imagepng( $dst, $resizefile); // the png file is moved to $resizefile in wpdata/
					imagedestroy( $dst );
					
					$varuploadurl = $varurlpath . $varfilename;
					$_POST['team_image_link'] = $varuploadurl;
					// // echo "!!!fff GOOD post rec is {$_POST['team_image_link']}";
				}
			}
		}
		// exit;
		
		// NO NEED TO MOVE THE TEMP FILE - WE ONLY USING RESIZED FILES 
		
		$data_rec = array();
		$data_rec = $_POST;
		
		if ($_POST['team_image_link'] != "") {$data_rec['team_image_link'] = $_POST['team_image_link'];} // set if they uploaded an image record
		
		unset($data_rec['userid']);
		unset($data_rec['MAX_FILE_SIZE']);
		unset($data_rec['user_image']);			
		unset($data_rec['id']); unset($data_rec['return_to_list']);
		unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
		if ($data_rec['team_visitor_followups'] != "yes") {$data_rec['team_visitor_followups'] = "no";}
		if ($data_rec['team_team_member'] != "yes") {$data_rec['team_team_member'] = "no";}
		
		// Make sure one of visit or team is chosen and team_visitor_followups and team_team_member
		if ($data_rec['team_visitor_followups'] != "yes" and $data_rec['team_team_member'] != "yes") {
			$data_rec['team_visitor_followups'] = "yes"; // Put in visitors if not selected so is in one list
		}
		if ($this->session->userdata('proteam_access') ==  "Super_Admin" or $this->session->userdata('proteam_access') == "Admin") { 
			if ($data_rec['trainer_access'] != "yes") {$data_rec['trainer_access'] = "no";}
		}
		
		if ($data_rec['team_visitor_followups'] != "yes") {
			$data_rec['follow_up_frequency'] = "Not Applicable";
		}
			
		if ($_POST['first_name'] != "") {
			if ($_POST['userid'] != 0) {
				$this->db->where('userid', $_POST['userid']);
				$this->db->update('ainf_vps3_users', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert('ainf_vps3_users', $data_rec);
				$id = $this->db->insert_id();
				if ($data_rec['team_connect_group'] != 0 and $data_rec['team_connect_group'] != "") { // only inc if they in a group
					$sql = "update teampro_groups set num_members = num_members + 1 where id = {$data_rec['team_connect_group']}";
					$inc_connect = $this->db->query($sql);
				}
				
			}
		}
		
		// Now update the members per company.. 
		$sql = "select userid from ainf_vps3_users where compid = $varcompid";
		$sql = "select userid from ainf_vps3_users where compid = {$_POST['sess_compid']}";
		$num_users = $this->db->query($sql)->result_array(); $var_num_users = count($num_users);
		
		// Now update the members per company.. 
		$sql = "select id from teampro_groups where compid = {$_POST['sess_compid']}";
		$num_home = $this->db->query($sql)->result_array(); $var_num_home = count($num_home);
		$sql = "update ainf_xglobalclient set num_members = $var_num_users, num_connects = $var_num_home where globcompid = {$_POST['sess_compid']}";
		$mod_members = $this->db->query($sql);
		
		if ($this->session->userdata('proteam_access') != "Super_Admin" and $this->session->userdata('proteam_access') != "Admin") {
			$varsql = " and code_name not in ('Super_Admin', 'Admin') ";
		} elseif ($this->session->userdata('proteam_access') == "Admin") {
			$varsql = " and code_name not in ('Super_Admin') ";
		}
		$sql = "select * from ainf_vps3_code_manager where code_group = 'proteam-access' $varsql order by code_id desc";
		$data['access_levels'] = $this->db->query($sql)->result_array();
		
		$varcompid = $_POST['sess_compid'];
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_code_manager where code_group = 'follow_frequency'";
		$data['follow_freq'] = $this->db->query($sql)->result_array();
		// //var_dump($data['follow_freq']); // TBA

		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'next_steps' order by code_name";
		$data['next_steps_list'] = $this->db->query($sql)->result_array();
		
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/teams2/details/index'); // back to listing
		} elseif (($_POST['mod_record'] == "yes" or $_POST['add_record'] != "yes") or (1==2 and $_POST['userid'] != "" and $_POST['userid'] != 0)) { 
		// Add is main indicator to add a record in this case.. 
			// back to updates
			$_POST['mod_record'] = "yes";
			if ($_POST['userid'] > 0) {$id = $_POST['userid'];}
			$sql = "select * from ainf_vps3_users where userid = {$_POST['userid']}";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			$_POST['userid'] = $id;
			$this->load->view('update_teams', $data);
		} else {
			$_POST['userid'] = 0;
			$this->load->view('update_teams', $data);
		}
	}

	public function meet_details_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$var_maintable = "group_meeting";
		
		if (isset($_POST['date_time_start'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']);
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";} else {$data_rec['archive'] = "no";}
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($var_maintable, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($var_maintable, $data_rec);
				$id = $this->db->insert_id();
			}
						
			//### BEST AS A CENTRAL FUNCTION TO CALL IF CALLING SETTINGS OR CONNECTS.. ###
			
			// $sql = "select userid from ainf_vps3_users where compid = $varcompid";
			$sql = "select userid from ainf_vps3_users where compid = {$_POST['sess_compid']}";
			$num_users = $this->db->query($sql)->result_array(); $var_num_users = count($num_users);		
			// Now update the members per company.. 
			$sql = "select id from teampro_groups where compid = {$_POST['sess_compid']}";
			$num_home = $this->db->query($sql)->result_array(); $var_num_home = count($num_home);
			$sql = "update ainf_xglobalclient set num_members = $var_num_users, num_connects = $var_num_home where globcompid = {$_POST['sess_compid']}";			
			$mod_members = $this->db->query($sql);
			
			//### BEST AS A FUNCTION TO CALL IF CALLING SETTINGS OR CONNECTS.. ###			
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql_message = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid $subqry $var_search and delete_record = 'no' order by id";
		$data['home_groups'] = $this->db->query($sql_message)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name"; 
		$data['sex_types'] = $this->db->query($sql)->result_array(); 
		// //var_dump($data['home_groups']);
		
		If ($_POST['return_to_list'] == "yes") {
			if ($_POST['return_url'] != "") {
				redirect("{$_POST['return_url']}"); // back to listing
			} else {
				redirect('/teams2/details/index'); // back to listing
			}
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select * from $var_maintable where id = $id";
			$data['edit_group_meeting'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_meet_details', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_meet_details', $data);
		}
	}

	public function update_service_profile()
	{
		
		$var_maintable = "ainf_xcloud_videos";
		$var_main_controller = "services2";
		$var_main_view = "update_service_profile";
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['title'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']); unset($data_rec['MAX_FILE_SIZE']); unset($data_rec['return_url']); 
			unset($data_rec['mod_record']); unset($data_rec['id']); unset($data_rec['return_to_list']); 
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']); 
			unset($data_rec['MAX_FILE_SIZE']); unset($data_rec['follup_contact_date_time']); 
			unset($data_rec['follup_contact_date_time']); unset($data_rec['follup_by']); 
			
			// ### BEST CODE - USE PREFIX KEYS TO GROUP & UNSET OTHER FIELDS 
			foreach($data_rec as $key => $value) { // unset the order form 
				if (strpos($key, "order_") === false) {
				} else {
					unset($data_rec[$key]);
				}
			}
			
			$data_rec['message_date_1'] = $data_rec['message_date1']; unset($data_rec['message_date1']); //date picker doesnt work message_date_1 field name 
			if ($_POST['archive'] == "Y") {$data_rec['archive'] = "Y";} else {$data_rec['archive'] = "N";}
			if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}

			if ($_POST['id'] != 0) {
				// echo "<br>!! id is {$_POST['id']}";
				$this->db->where('id', $_POST['id']);
				$this->db->update($var_maintable, $data_rec);
			} else {
				$data_rec['mastercompid'] = 113;
				$data_rec['compid'] = $varcompid;
				$this->db->insert($var_maintable, $data_rec);
				$id = $this->db->insert_id();
				$_POST['mod_record'] = "Update"; // if they stay in form must update it now
			}

			// ### BEST CODE - USE PREFIX KEYS TO SET THE TABLE 
			if (trim($_POST['order_details']) != "") { // Any new order record 
				$data_rec2 = array();
				$data_rec2['compid'] = $varcompid;
				$data_rec2['video_service_id'] = $_POST['id'];
				$data_rec2['service_date_time'] = $_POST['message_date1'];
				foreach($_POST as $key => $value) { // Set up Order Record
					if (strpos($key, "order_") === false) {
					} else {
						$data_rec2[$key] = $_POST[$key];
					}
				}
				$this->db->insert('service_order', $data_rec2);
				$id = $this->db->insert_id();
			}

		}
		
		if ($_POST['id'] != 0 and $_POST['id'] != "") {
			$id = $_POST['id'];
		}
		$sql = "select order_seq, order_seq_sub, order_details, first_name, last_name 
		from service_order a 
		left join ainf_vps3_users b on a.order_member_1 = b.userid 
		where video_service_id = $id order by order_seq, order_seq_sub"; 
		// $data['order_recs'] = $this->db->query($sql)->result_array();
		//var_dump($data['order_recs']);

		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from `ainf_vps3_code_manager` where code_group = 'bible_books' order by code_id";
		$data['bible_books'] = $this->db->query($sql)->result_array();
		
		If ($_POST['return_to_list'] == "yes") {
			if ($_POST['return_url'] != "") {
				redirect("{$_POST['return_url']}"); // back to listing
			} else {
				$var_redirect_url = "/" . $var_main_controller . "/details/service_main";
				redirect($var_redirect_url); // back to listing
			}
		} elseif ($_POST['id'] > 0 or $id = $_POST['id']) { // The id is always set 
			// back to updates 	
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $var_maintable where id = $id";
			$data['edit_main_table'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$_POST['main_controller'] = $var_main_controller;
			$_POST['main_function'] = $var_main_view;
			//$this->load->view($var_main_view, $data);
			$this->load->view('update_service_full', $data);
		} else {
			$_POST['id'] = 0;
			$_POST['main_controller'] = $var_main_controller;
			$_POST['main_function'] = $var_main_view;
			//$this->load->view($var_main_view, $data);
			$this->load->view('update_service_full', $data);
		}
	}
	
	public function speakers($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter 
		if (isset($_POST['form_reset'])) {
			$_POST['form_connect'] = "";
		}
		if ($_POST['form_connect'] != "") {
			$var_search .= " and teampro_groups.id = {$_POST['form_connect']} ";
			$var_search_user .= " and team_connect_group = {$_POST['form_connect']} ";
		}

		$sql = "select * from speakers where compid = $varcompid or compid = 110 order by full_name, first_name, last_name desc"; 
		$data['speakers'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		$subqry = "";
		$sql_message = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid $subqry $var_search and delete_record = 'no' order by id";
		$data['home_groups'] = $this->db->query($sql_message)->result_array();

		$sql = "select * from ainf_vps3_users where compid = $varcompid $var_search_user order by userid";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from `ainf_vps3_code_manager` where code_group = 'bible_books' order by code_id";
		$data['bible_books'] = $this->db->query($sql)->result_array();
		
		$sql_message = "select group_meeting.id as id, attend_percentage, attend_id_array, date_time_start, date_time_end, online_url, online_login, online_password, title from group_meeting, teampro_groups where groupid = teampro_groups.id and teampro_groups.compid = $varcompid $var_search order by group_meeting.date_time_start desc";
		$data['meetings'] = $this->db->query($sql_message)->result_array();
														
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();
				
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		// $sql = "select * from teampro_services where compid = $varcompid order by serv_date_time";
		

		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and delete_record not in ('yes') order by message_date_time";

		$pre_sql = "select a.id, a.title, a.series, a.delete_record, a.service_word_speaker, a.compid, a.message_date_time, a.book, a.teaser, 
		b.userid, b.first_name as speaker_first_name, b.last_name as speaker_last_name, 
		c.userid, c.first_name as worship_first_name, c.last_name as worship_last_name, 
		d.userid, d.first_name as mc_first_name, d.last_name as mc_last_name, 
		e.userid, e.first_name as host_first_name, e.last_name as host_last_name 
		
		from ainf_xcloud_videos a 
		left join ainf_vps3_users b on a.service_word_speaker = b.userid 
		left join ainf_vps3_users c on a.service_worship_team = c.userid 
		left join ainf_vps3_users d on a.service_mc = d.userid 
		left join ainf_vps3_users e on a.service_host_team = e.userid 
		where a.compid = $varcompid and a.delete_record not in ('yes') "; 
		$order_sql = " order by a.message_date_time"; 
		
		$varyear = date("Y");
		$varmonth = date("m");
		$date_sql = " and a.message_date like '%$varmonth/$varyear%' ";
		
		$sql = $pre_sql . $date_sql . $order_sql;	
		
		// !! temp old sql - switch to other sql later on.. 
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and delete_record not in ('yes') order by message_date_time";
		
		$data['service_list'] = $this->db->query($sql)->result_array();
		
		$varyear = date("Y");
		$varmonth = date("m");
		$date_sql = " and a.message_date like '%$varmonth/$varyear%' ";
		$sql = $pre_sql . $date_sql . $order_sql;	
		$data['service_list_month'] = $this->db->query($sql)->result_array();
		
		//// echo $pagename_orig;exit;
		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function details($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney';
			//$to      = 'max.emb@gmail.com';
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid']; 

		$var_search = "";
		
		// Process the form filter 
		if (isset($_POST['form_reset'])) {
			$_POST['form_connect'] = "";
		}
		if ($_POST['form_connect'] != "") {
			$var_search .= " and teampro_groups.id = {$_POST['form_connect']} ";
			$var_search_user .= " and team_connect_group = {$_POST['form_connect']} ";
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		$subqry = "";
		$sql_message = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid $subqry $var_search and delete_record = 'no' order by id";
		$data['home_groups'] = $this->db->query($sql_message)->result_array();

		$sql = "select * from ainf_vps3_users where compid = $varcompid $var_search_user order by userid";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from `ainf_vps3_code_manager` where code_group = 'bible_books' order by code_id";
		$data['bible_books'] = $this->db->query($sql)->result_array();
		
		$sql_message = "select group_meeting.id as id, attend_percentage, attend_id_array, date_time_start, date_time_end, online_url, online_login, online_password, title from group_meeting, teampro_groups where groupid = teampro_groups.id and teampro_groups.compid = $varcompid $var_search order by group_meeting.date_time_start desc";
		$data['meetings'] = $this->db->query($sql_message)->result_array();
														
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();
				
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		// $sql = "select * from teampro_services where compid = $varcompid order by serv_date_time";
		

		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and delete_record not in ('yes') order by message_date_time";

		$pre_sql = "select a.id, a.title, a.series, a.delete_record, a.service_word_speaker, a.compid, a.message_date_time, a.book, a.teaser, 
		b.userid, b.first_name as speaker_first_name, b.last_name as speaker_last_name, 
		c.userid, c.first_name as worship_first_name, c.last_name as worship_last_name, 
		d.userid, d.first_name as mc_first_name, d.last_name as mc_last_name, 
		e.userid, e.first_name as host_first_name, e.last_name as host_last_name 
		
		from ainf_xcloud_videos a 
		left join ainf_vps3_users b on a.service_word_speaker = b.userid 
		left join ainf_vps3_users c on a.service_worship_team = c.userid 
		left join ainf_vps3_users d on a.service_mc = d.userid 
		left join ainf_vps3_users e on a.service_host_team = e.userid 
		where a.compid = $varcompid and a.delete_record not in ('yes') "; 
		$order_sql = " order by a.message_date_time"; 
		
		$varyear = date("Y");
		$varmonth = date("m");
		$date_sql = " and a.message_date like '%$varmonth/$varyear%' ";
		
		$sql = $pre_sql . $date_sql . $order_sql;	
		
		// !! temp old sql - switch to other sql later on.. 
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and delete_record not in ('yes') order by message_date_time";
		
		$data['service_list'] = $this->db->query($sql)->result_array();
		
		$varyear = date("Y");
		$varmonth = date("m");
		$date_sql = " and a.message_date like '%$varmonth/$varyear%' ";
		$sql = $pre_sql . $date_sql . $order_sql;
		$data['service_list_month'] = $this->db->query($sql)->result_array();
		
		//// echo $pagename_orig;exit;
		// very basic error handling
		
		if (file_exists(base_url("views/service_main")))
		// if (file_exists(base_url("views/service_manager")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function services($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney';
			//$to      = 'max.emb@gmail.com';
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid']; 

		$var_search = "";
		
		// Process the form filter 
		if (isset($_POST['form_reset'])) {
			$_POST['form_connect'] = "";
		}
		if ($_POST['form_connect'] != "") {
			$var_search .= " and teampro_groups.id = {$_POST['form_connect']} ";
			$var_search_user .= " and team_connect_group = {$_POST['form_connect']} ";
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		$subqry = "";
		$sql_message = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid $subqry $var_search and delete_record = 'no' order by id";
		$data['home_groups'] = $this->db->query($sql_message)->result_array();

		$sql = "select * from ainf_vps3_users where compid = $varcompid $var_search_user order by userid";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from `ainf_vps3_code_manager` where code_group = 'bible_books' order by code_id";
		$data['bible_books'] = $this->db->query($sql)->result_array();
		
		$sql_message = "select group_meeting.id as id, attend_percentage, attend_id_array, date_time_start, date_time_end, online_url, online_login, online_password, title from group_meeting, teampro_groups where groupid = teampro_groups.id and teampro_groups.compid = $varcompid $var_search order by group_meeting.date_time_start desc";
		$data['meetings'] = $this->db->query($sql_message)->result_array();
														
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();
				
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		// $sql = "select * from teampro_services where compid = $varcompid order by serv_date_time";
		

		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and delete_record not in ('yes') order by message_date_time";

		$pre_sql = "select a.id, a.title, a.series, a.delete_record, a.service_word_speaker, a.compid, a.message_date_time, a.book, a.teaser, 
		b.userid, b.first_name as speaker_first_name, b.last_name as speaker_last_name, 
		c.userid, c.first_name as worship_first_name, c.last_name as worship_last_name, 
		d.userid, d.first_name as mc_first_name, d.last_name as mc_last_name, 
		e.userid, e.first_name as host_first_name, e.last_name as host_last_name 
		
		from ainf_xcloud_videos a 
		left join ainf_vps3_users b on a.service_word_speaker = b.userid 
		left join ainf_vps3_users c on a.service_worship_team = c.userid 
		left join ainf_vps3_users d on a.service_mc = d.userid 
		left join ainf_vps3_users e on a.service_host_team = e.userid 
		where a.compid = $varcompid and a.delete_record not in ('yes') "; 
		$order_sql = " order by a.message_date_time"; 
		
		$varyear = date("Y");
		$varmonth = date("m");
		$date_sql = " and a.message_date like '%$varmonth/$varyear%' ";
		
		$sql = $pre_sql . $date_sql . $order_sql;	
		
		// !! temp old sql - switch to other sql later on.. 
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and delete_record not in ('yes') order by message_date_time";
		
		$data['service_list'] = $this->db->query($sql)->result_array();
		
		$varyear = date("Y");
		$varmonth = date("m");
		$date_sql = " and a.message_date like '%$varmonth/$varyear%' ";
		$sql = $pre_sql . $date_sql . $order_sql;
		$data['service_list_month'] = $this->db->query($sql)->result_array();
		
		//// echo $pagename_orig;exit;
		// very basic error handling
		
		if (file_exists(base_url("views/service_main")))
		// if (file_exists(base_url("views/service_manager")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	
