<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Settings extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();

		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS
		$this->load->model('System_modules'); 

		$check_access = "new";
		if ($check_access == "new") {
			$this->load->model('Recheck_access6');
			$var_access_status = $this->Recheck_access6->reset_access6();
			// echo "<br><br>Settings Controller ";
		} else {
			$this->load->model('Recheck_access');
			$this->Recheck_access->reset_access();
		}

		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		$var_webmail_url = $this->session->userdata('webmail_url');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
	}

	public function check_function()
	{	
		error_reporting(0);
		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		$this->load->helper('url'); 
		$callfunction = trim($_POST['function_type']); 
		if ($callfunction == "details") { 
			$this->details('index'); 
		} 
	}

	public function my_organisation_edit() {
		$_POST['globcompid'] = $_POST['sess_compid'];
		$_POST['company_driver_purpose'] = "my_ministry";
		$this->organisation_edit();
	}

	public function organisation_edit()
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];

		// // // echo "<br>!! globcompid = {$_POST['globcompid']} comp name {$_POST['globcompanyname']} "; 


		if (isset($_POST['globcompid'])) {
			$var_swap_field = "swap_record_" . $_POST['globcompid'];
			if ($_POST[$var_swap_field] == "yes") { // SWAP ACTIVE COMPANY - ONLY FOR SUPER_ADMIN
				
				// Process the swap of session
				$this->session->set_userdata('compid',$_POST['globcompid']);
				$sql = "select globcompanyname from ainf_xglobalclient where globcompid = {$_POST['globcompid']}";
				$varupdate = $this->db->query($sql)->result_array();
				foreach ($varupdate as $i) {
					$this->session->set_userdata('compname',$i['globcompanyname']);
					$var_comp = $this->session->userdata('compname');
				}
				
				// Update current staff record to this compid for any related queries
				$var_userid = $this->session->userdata('userid');
				$sql = "update ainf_vps3_users set compid = {$_POST['globcompid']} where userid = $var_userid";
				$varupdate = $this->db->query($sql);
				
				redirect('/settings/edit_account/update_account_settings'); // back to listing
			}
		}
		
		if (isset($_POST['globcompanyname'])) {
			$sql = "select * from ainf_xglobalclient where mastercompid = 113 order by globcompanyname";
			$data['org_list'] = $this->db->query($sql)->result_array();
			$var_compid_sharing_value = "0";
			foreach ($data['org_list'] as $i) {
				$var_compid__sharing_fld = "compid__sharing_" . $i['globcompid'];
				$var_compid__sharing_field = $_POST[$var_compid__sharing_fld];
				if ($var_compid__sharing_field == "yes") {
					$var_compid_sharing_value .= "," . $i['globcompid'];
				}
			}
			$var_compid_sharing_value .= ",0";
			// // echo "var_compid_sharing_value = $var_compid_sharing_value";
			
			$data_rec = array();
			$data_rec['compid_sharing'] = $var_compid_sharing_value;
			$data_rec['glob_qr_signup_url'] = $_POST['glob_qr_signup_url'];
			$data_rec['globcompanyname'] = $_POST['globcompanyname']; $data_rec['globcompanysite'] = $_POST['globcompanysite'];
			$data_rec['globcomp_city'] = $_POST['globcomp_city']; $data_rec['globcomp_postcode'] = $_POST['globcomp_postcode'];
			$data_rec['globcomp_country'] = $_POST['globcomp_country']; $data_rec['date_create'] = $_POST['date_create'];
			$data_rec['cpanel_url'] = $_POST['cpanel_url']; $data_rec['webmail_url'] = $_POST['webmail_url'];
			
			$data_rec['profile_leader_userid'] = $_POST['profile_leader_userid'];
			$data_rec['profile_leader_profile'] = $_POST['profile_leader_profile'];
			$data_rec['profile_about_us'] = $_POST['profile_about_us'];
			$data_rec['profile_our_mission'] = $_POST['profile_our_mission'];
			$data_rec['profile_about_us_video'] = $_POST['profile_about_us_video'];

			$data_rec['mastercompid'] = 113;

			if ($_POST['globcompid'] != 0) {
				$this->db->where('globcompid', $_POST['globcompid']);
				$this->db->update('ainf_xglobalclient', $data_rec);
			} else {
				$this->db->insert('ainf_xglobalclient', $data_rec);
				$_POST['globcompid'] = $this->db->insert_id();				
			}
		}
		
		if ($_POST['add_record'] != "yes" and $_POST['globcompid'] != "") {
			$sql = "select * from ainf_xglobalclient where globcompid = {$_POST['globcompid']}";
			$data['organisation'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid order by title";
		$data['video_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_xglobalclient where mastercompid = 113 order by globcompanyname";
		$data['org_list'] = $this->db->query($sql)->result_array();

		$sql = "select * from ainf_vps3_code_manager where compid = 113 and code_group = 'country' order by code_name";
		$data['country_list'] = $this->db->query($sql)->result_array();
		if ($_POST['globcompid'] != "") {
			$sql = "select * from ainf_vps3_users where compid = {$_POST['globcompid']} and team_image_link is not null order by first_name, last_name";
			$data['leaders'] = $this->db->query($sql)->result_array();
		}
			
		If ($_POST['return_to_list'] == "yes") {
			redirect('/settings/edit_account/update_account_settings'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			$this->load->view('update_organisation_v2', $data);
		} else {
			$this->load->view('update_organisation_v2', $data);
		}
	}
	
	public function recalc_totals() {

		error_reporting(0);
		//## PROCESS NUM OF CONNECTS 
		$sql = "select title, compid, id from teampro_groups where compid in (select globcompid from ainf_xglobalclient where mastercompid = 113) order by compid";
		$member_total = $this->db->query($sql)->result_array();
		$groups_total_percomp = 0;
		$num_recs = 0;
		
		foreach ($member_total as $i) {
			++$num_recs;
			
			
			if ($num_recs == 1) {
				$groups_total_percomp = 1;
			}
			
			if ($num_recs > 1 and ($var_current_comp != $i['compid'])) {
				
				// RESET the connect count for the $var_current_comp
				// ++$users_total_percomp;
				
				$sqlmod = "update ainf_xglobalclient set num_connects = $groups_total_percomp where globcompid = $var_current_comp";
				$this->db->query($sqlmod);
				$groups_total_percomp = 1;
			} elseif ($num_recs > 1) {
				++$groups_total_percomp;
			}
			
			$var_current_comp = $i['compid'];
			
		}
		
		// We must do a final update for the last 
		// // // echo "<br>Name {$i['title']} {$i['compid']} Total is $groups_total_percomp";
		$sqlmod = "update ainf_xglobalclient set num_connects = $groups_total_percomp where globcompid = $var_current_comp";
		$this->db->query($sqlmod);
		
		//## PROCESS NUM OF USERS BY COMP AND GROUP 
		$sql = "select first_name, compid, team_connect_group from ainf_vps3_users where team_connect_group not in (0) and compid in (select globcompid from ainf_xglobalclient where mastercompid = 113) order by compid, team_connect_group";
		$member_total = $this->db->query($sql)->result_array();

		$users_total_percomp = 0; $users_total_pergroup = 0;
		$var_current_group = 0; $var_current_comp = 0;
		$num_recs = 0;
		
		foreach ($member_total as $i) {
			++$num_recs;		
			
			if ($num_recs == 1) {
				++$users_total_pergroup;
				++$users_total_percomp;
			}
				
			if ($num_recs > 1 and ($var_current_group != $i['team_connect_group'])) {
				// RESET the connect count for the $var_current_group
				// ++$users_total_pergroup;
				$sqlmod = "update teampro_groups set num_members = $users_total_pergroup where id = $var_current_group";
				$this->db->query($sqlmod);
				
				$users_total_pergroup = 1;
			} else {
				++$users_total_pergroup;
			}
			
			if ($num_recs > 1 and ($var_current_comp != $i['compid'])) {
				// RESET the connect count and member count for the $var_current_comp
				// ++$users_total_percomp;
				$sqlmod = "update ainf_xglobalclient set num_members = $users_total_percomp where globcompid = $var_current_comp";
				$this->db->query($sqlmod);

				$users_total_percomp = 1;
			} elseif ($num_recs > 1) {
				++$users_total_percomp;
			}
			$var_current_group = $i['team_connect_group'];
			$var_current_comp = $i['compid'];
			
		}
		// We must do final update for the last company and group 
		$sqlmod = "update teampro_groups set num_members = $users_total_pergroup where id = $var_current_group";
		$this->db->query($sqlmod);
		$sqlmod = "update ainf_xglobalclient set num_members = $users_total_percomp where globcompid = $var_current_comp";
		$this->db->query($sqlmod);
		
		$this->edit_account();
		
	}
	
	public function edit_account() // GOOD KEEP 
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];	
		
		if (isset($_POST['first_name'])) {
			$data_rec = array();
			$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name'];
			$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email'];
			$data_rec['team_connect_group'] = $_POST['team_connect_group'];
			$this->db->where('userid', $_POST['sess_userid']);
			$this->db->update('ainf_vps3_users', $data_rec);
		}
		
		$varsql = "";
		if (isset($_POST['form_group_city']) and $_POST['form_group_city'] != "") {
			$varsql .= " and city = '{$_POST['form_group_city']}' ";
		} else { // set the filter to default values
			$_POST['form_group_city'] = "All Cities";
		}
		
		$sql = "select * from ainf_vps3_users where proteam_access like '%Admin%' order by first_name, last_name";
		$sql = "select * from ainf_vps3_users,  ainf_xglobalclient where compid = $varcompid and compid = globcompid order by first_name, last_name";
		$data['team_list'] = $this->db->query($sql)->result_array();

		$sql = "select title, id from teampro_groups where compid = $varcompid $varsql order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();

		$sql = "select * from ainf_vps3_users where userid = {$_POST['userid']}";
		$data['user_profile'] = $this->db->query($sql)->result_array();
		
		// data for filter form 
		$sql = "select distinct globcomp_country from ainf_xglobalclient where mastercompid = 113 order by globcomp_country";
		$data['country_list'] = $this->db->query($sql)->result_array();
			
		$sql = "select distinct globcomp_city, globcomp_country from ainf_xglobalclient where mastercompid = 113 order by globcomp_country";
		$data['city_org_list'] = $this->db->query($sql)->result_array();
			
		$sql = "select distinct city from teampro_groups where compid = $varcompid order by city";
		$data['home_city_list'] = $this->db->query($sql)->result_array();
		
		// data for the main listing 
		
		$varsql = "";
		if (isset($_POST['form_country']) and $_POST['form_country'] != "") {
			$varsql .= " and globcomp_country = '{$_POST['form_country']}' ";
		} else { // set the filter to default values 
			$_POST['form_country'] = "All Countries";
		}
		if (isset($_POST['form_city']) and $_POST['form_city'] != "") {
			$varsql .= " and globcomp_city = '{$_POST['form_city']}' ";
		} else { // set the filter to default values 
			$_POST['form_city'] = "All Cities";
		}		
		
		$sql = "select * from ainf_xglobalclient where mastercompid = 113 $varsql order by globcompanyname";
		$data['organisation_list'] = $this->db->query($sql)->result_array();
		
		//$this->load->view('update_account', $data);
		$this->load->view('update_account_settings', $data);
	}
	
	public function update_my_account()
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['first_name']) and $_POST['first_name'] != "") {
			$data_rec = array();
			if (trim($_POST['password'] != "")) { $data_rec['password'] = sha1($_POST['password']); } // Password is optional 
			$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name'];
			$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email'];
			$data_rec['team_connect_group'] = $_POST['team_connect_group'];
			$data_rec['code_group_api'] = $_POST['code_group_api'];
			
			$this->db->where('userid', $_POST['sess_userid']);
			$this->db->update('ainf_vps3_users', $data_rec);
		}

		if ($_POST['userid'] != "" and $_POST['userid'] != "0") {
			$sql = "select first_name, last_name, code_group_api, mobile, email, team_connect_group, proteam_access from ainf_vps3_users where userid = {$_POST['userid']}"; 
		} else {
			// ### THIS IS THE USER PROFILE LINK PAGE SO sess_userid is USED 
			$sql = "select first_name, last_name, code_group_api, mobile, email, team_connect_group, proteam_access from ainf_vps3_users where userid = {$_POST['sess_userid']}"; 
		}
		$data['user_profile'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_xglobalclient where mastercompid = 113 order by globcompanyname"; 
		$data['org_list'] = $this->db->query($sql)->result_array(); 

		If ($_POST['return_to_list'] == "yes") {
			redirect('/settings/edit_account/update_account_settings'); // back to listing
		} else {
			$this->load->view('update_my_account', $data);
		}
		
	}
	
}
	