<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Settings extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		// We are using POST as then we can clear the session data that can be a security hole - so every click is a POST 
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['userid']) == "" and $var_userid != "") {
			$_POST['userid'] = $var_userid;
		}
		if (trim($_POST['sess_userid']) == "" and $var_userid != "") {
			$_POST['sess_userid'] = $var_userid;
		}
						
		$sql = "select first_name, last_name, compid, globcompanyname from ainf_xglobalclient, ainf_vps3_users where (compid = globcompid and userid = {$_POST['sess_userid']})";
		$var_comp_user = $this->db->query($sql)->result_array();
		foreach ($var_comp_user as $i) {
			$_POST['sess_first_name'] = $i['first_name'];
			$_POST['sess_last_name'] = $i['last_name'];
			$_POST['sess_compid'] = $i['compid'];
			$_POST['sess_globcompanyname'] = $i['globcompanyname'];
		}

		$var_compname = $this->session->userdata('compname'); 
		$var_first_name = $this->session->userdata('first_name'); 
		$var_last_name = $this->session->userdata('last_name'); 
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // echo "!! must write other functions code for funciton $callfunction";
		}
		// var_dump($_POST);
	}	

	public function follow_up_edit()
	{

		$varcompid = $_POST['sess_compid']; 
		
		if ($_POST['follup_contact_type'] != "")  {
			$data_rec = array();
			$data_rec = $_POST;
			$date_array = explode('/',$_POST['follup_contact_date_time']);
			$var_follup_contact_date_sort = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0];
			$data_rec['follup_contact_date_sort'] = $var_follup_contact_date_sort;
			
			unset($data_rec['userid']); unset($data_rec['compid']); 
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
						
			var_dump($data_rec);
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_follow_ups', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert('teampro_follow_ups', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$varcompid = $_POST['sess_compid']; 
		$_POST['follup_for'] = $_POST['userid'];
					
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		// var_dump($data['host_names']);
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'follup_contact_types' order by code_name";
		$data['follup_contact_types'] = $this->db->query($sql)->result_array();		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['team_visitor_list'] = $this->db->query($sql)->result_array();
		
		// // echo "<br>!! The post add rec is {$_POST['add_record']} !! mod rec is  {$_POST['mod_record']} ";
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/follow_ups/details/follow_ups'); // back to listing 
		} elseif ($_POST['add_record'] == "yes") {
			$_POST['id'] = 0;
			$this->load->view('update_followups', $data);
		} elseif ($_POST['mod_record'] == "yes" or $_POST['id'] > 0) { // the id is always set from default record 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from teampro_follow_ups where id = $id";			
			$data['edit_teampro_follow_ups'] = $this->db->query($sql)->result_array();
			$_POST['userid'] = $id;
			$this->load->view('update_followups', $data);
		}
	}

	public function member_edit()
	{

		$varcompid = $_POST['sess_compid'];
		
		if ($_POST['add_followup'] == "yes") {
			$this->follow_up_edit();
		} else {
			if (isset($_POST['first_name'])) {
				$data_rec = array();
				$data_rec = $_POST;
				unset($data_rec['userid']);
				unset($data_rec['id']); unset($data_rec['return_to_list']);
				unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
				if ($data_rec['team_visitor_followups'] != "yes") {$data_rec['team_visitor_followups'] = "no";}
				if ($data_rec['team_team_member'] != "yes") {$data_rec['team_team_member'] = "no";}
				
				// Make sure one of visit or team is chosen and team_visitor_followups and team_team_member
				if ($data_rec['team_visitor_followups'] != "yes" and $data_rec['team_team_member'] != "yes") {
					$data_rec['team_visitor_followups'] = "yes"; // Put in visitors if not selected so is in one list
				}
				
				if ($_POST['userid'] != 0) {
					$this->db->where('userid', $_POST['userid']);
					$this->db->update('ainf_vps3_users', $data_rec);
				} else {
					$data_rec['compid'] = $varcompid;
					$this->db->insert('ainf_vps3_users', $data_rec);
					$id = $this->db->insert_id();
				}
			}
			
			$varcompid = $_POST['sess_compid'];
			$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
			$data['connect_list'] = $this->db->query($sql)->result_array();
			$sql = "select * from ainf_vps3_users where compid = $varcompid";
			$data['host_names'] = $this->db->query($sql)->result_array();
			$sql = "select code_name from ainf_vps3_code_manager where code_group = 'next_steps' order by code_name";
			$data['next_steps_list'] = $this->db->query($sql)->result_array();
			$sql = "select * from ainf_vps3_code_manager where code_group = 'follow_frequency'";
			$data['follow_freq'] = $this->db->query($sql)->result_array();
			
			If ($_POST['return_to_list'] == "yes") {
				redirect('/teams2/details/index'); // back to listing 
			} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default record
				// back to updates 
				if ($_POST['userid'] > 0) {$id = $_POST['userid'];} 
				$sql = "select * from ainf_vps3_users where userid = $id";
				$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();									
				$_POST['userid'] = $id;
				$this->load->view('update_teams', $data);
			} else {
				$_POST['userid'] = 0;
				$this->load->view('update_teams', $data);
			}
		}
	}

	public function organisation_edit()
	{
		
		$varcompid = $_POST['sess_compid'];

		// // echo "<br>!! globcompid = {$_POST['globcompid']} comp name {$_POST['globcompanyname']} "; 
		
		if (isset($_POST['globcompanyname'])) {
			$data_rec = array();
			$data_rec['globcompanyname'] = $_POST['globcompanyname']; $data_rec['globcompanysite'] = $_POST['globcompanysite'];
			$data_rec['globcomp_city'] = $_POST['globcomp_city']; $data_rec['globcomp_postcode'] = $_POST['globcomp_postcode'];
			$data_rec['globcomp_country'] = $_POST['globcomp_country']; $data_rec['date_create'] = $_POST['date_create'];
			$data_rec['mastercompid'] = 113;

			if ($_POST['globcompid'] != 0) {
				$this->db->where('globcompid', $_POST['globcompid']);
				$this->db->update('ainf_xglobalclient', $data_rec);
			} else {
				$this->db->insert('ainf_xglobalclient', $data_rec);
				$_POST['globcompid'] = $this->db->insert_id();				
			}
		}
		
		if ($_POST['add_record'] != "yes" and $_POST['globcompid'] != "") {
			$sql = "select * from ainf_xglobalclient where globcompid = {$_POST['globcompid']}";
			$data['organisation'] = $this->db->query($sql)->result_array();
			
			$sql = "select * from ainf_vps3_code_manager where compid = 113 and code_group = 'country' order by code_name";
			$data['country_list'] = $this->db->query($sql)->result_array();
			
		}
		// var_dump($data['organisation']);
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/settings/edit_account/update_account_settings'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			$this->load->view('update_organisation', $data);
		} else {
			$this->load->view('update_organisation', $data);
		}
	}

	public function edit_home() // GOOD KEEP 
	{
		
		$varcompid = $_POST['sess_compid']; 
		
		
		if (isset($_POST['first_name'])) {
			$data_rec = array();
			$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name'];
			$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email'];
			$data_rec['team_connect_group'] = $_POST['team_connect_group']; 
			$this->db->where('userid', $_POST['sess_userid']);
			$this->db->update('ainf_vps3_users', $data_rec);
		}
		
		$sql = "select * from ainf_vps3_users where userid = {$_POST['userid']}";
		$data['user_profile'] = $this->db->query($sql)->result_array();
		
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		
		// data for filter form 
		$sql = "select distinct globcomp_country from ainf_xglobalclient where mastercompid = 113 order by globcomp_country";
		$data['country_list'] = $this->db->query($sql)->result_array();		
			
		// data for the main listing 
		
		$varsql = "";
		if (isset($_POST['form_country']) and $_POST['form_country'] != "") {
			$varsql .= " and globcomp_country = '{$_POST['form_country']}' ";
		} else { // set the filter to default values 
			$_POST['form_country'] = "All Countries";
		}
		
		$sql = "select * from ainf_xglobalclient where mastercompid = 113 $varsql order by globcompanyname";
		$data['organisation_list'] = $this->db->query($sql)->result_array();
		
		//$this->load->view('update_account', $data);
		$this->load->view('update_account_settings', $data);		
	}
		
	public function edit_account() // GOOD KEEP 
	{
		
		$varcompid = $_POST['sess_compid']; 
		
		
		if (isset($_POST['first_name'])) {
			$data_rec = array();
			$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name'];
			$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email'];
			$data_rec['team_connect_group'] = $_POST['team_connect_group'];
			$data_rec['proteam_access'] = $_POST['proteam_access'];
			$this->db->where('userid', $_POST['sess_userid']);
			$this->db->update('ainf_vps3_users', $data_rec);
		}
		
		$sql = "select * from ainf_vps3_users where userid = {$_POST['userid']}";
		$data['user_profile'] = $this->db->query($sql)->result_array();
		
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		
		// data for filter form
		$sql = "select distinct globcomp_country from ainf_xglobalclient where mastercompid = 113 order by globcomp_country";
		$data['country_list'] = $this->db->query($sql)->result_array();
			
		$sql = "select distinct globcomp_city from ainf_xglobalclient where mastercompid = 113 order by globcomp_country";
		$data['city_org_list'] = $this->db->query($sql)->result_array();
			
		$sql = "select distinct city from teampro_groups where compid = $varcompid order by city";
		$data['home_city_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'proteam-access' order by code_id desc";
		$data['access_levels'] = $this->db->query($sql)->result_array();
		
		// data for the main listing 		
		$varsql = "";
		$sql = "select * from teampro_groups where compid = $varcompid $varsql order by title";
		$data['home_list'] = $this->db->query($sql)->result_array();
		
		$varsql = "";
		if (isset($_POST['form_country']) and $_POST['form_country'] != "") {
			$varsql .= " and globcomp_country = '{$_POST['form_country']}' ";
		} else { // set the filter to default values 
			$_POST['form_country'] = "All Countries";
		}
		if (isset($_POST['form_city']) and $_POST['form_city'] != "") {
			$varsql .= " and globcomp_city = '{$_POST['form_city']}' ";
		} else { // set the filter to default values 
			$_POST['form_city'] = "All Cities";
		}		
		
		$sql = "select * from ainf_xglobalclient where mastercompid = 113 $varsql order by globcompanyname";
		$data['organisation_list'] = $this->db->query($sql)->result_array();
		
		//$this->load->view('update_account', $data);
		$this->load->view('update_account_settings', $data);		
	}
	
	public function update_my_account()
	{
		
		$varcompid = $_POST['sess_compid']; 
		
		// echo "<br>!!aa We are here !!.";
		
		if (isset($_POST['first_name'])) {
			$data_rec = array();
			$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name'];
			$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email'];
			$data_rec['team_connect_group'] = $_POST['team_connect_group'];
			// $data_rec['proteam_access'] = $_POST['proteam_access'];
			// var_dump($data_rec);
			// exit; 
			
			$this->db->where('userid', $_POST['sess_userid']);
			$this->db->update('ainf_vps3_users', $data_rec);
		}
		
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'proteam-access' order by code_id desc";
		$data['access_levels'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where userid = {$_POST['userid']}";
		$data['user_profile'] = $this->db->query($sql)->result_array();
		
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/settings/edit_account/update_account_settings'); // back to listing 
		} else {
			$this->load->view('update_my_account', $data);
		}
		
	}
	
	public function details($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];

		if ($_POST['add_followup'] == "yes" or $_POST['add_followup2'] == "yes") {
			$this->follow_up_edit();
		}
		
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid']; 

		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array();
				
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // echo "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid order by first_name, last_name"; 
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	