<?php

if (!defined('BASEPATH')) 
  exit('No direct script access allowed'); 
  
class Sys_Jobs_v4 extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		error_reporting(0);
		// error_reporting(E_ALL & ~E_NOTICE & ~E_STRICT & ~E_USER_NOTICE);
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		// $this->load->model('Generic_updates_v2'); //### GENERIC TABLE UPDATES 
		$this->load->helper('text');
		$this->load->model('Asys_load7_new');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // echo "!! must write other functions code for funciton $callfunction";
		}
	}

	public function job_edit() 
	{
		error_reporting(0); 
		error_reporting(E_ALL & ~E_NOTICE & ~E_STRICT & ~E_USER_NOTICE);

		//############# NEW PRAYERS CODE ############# 
		// echo "<br>!! 11 ";
		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$varcompid2 = $varcompid;
		
		if ($_POST['id'] == "") { $_POST['id'] = 0; }
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();

		if ($_POST['add_record'] == "yes") {
			$id = 0; // value set from listing
		} elseif ($_POST['id'] > 0) {
			$id = $_POST['id']; // value set from listing
		}

		if (isset($_POST['data_title'])) { 
			// ##### NOW SEND THE TABLE NAME, TABLE KEY AND KEY ID AND MODEL DOES UPDATE USING FORM FIELDS TO ID THE FIELDS 
			// // echo "<br>!! ### A bug in generic code MODEL - IN LIVE- so change this model to local code {$_POST['id']} ### ";

			$varmain_table = "jspec"; 
			$data_rec = array(); 
			$data_rec['title'] = $_POST['data_title']; 
			$data_rec['job_description'] = $_POST['data_job_description']; 
			$data_rec['job_sql_dat'] = $_POST['data_job_sql_dat']; 
			$data_rec['job_email_subject'] = $_POST['data_job_email_subject']; 
			$data_rec['job_email_send'] = $_POST['data_job_email_send']; 
			$data_rec['job_email_bcc'] = $_POST['data_job_email_bcc']; 
			$data_rec['job_buy_link_sell'] = $_POST['data_job_buy_link_sell']; 
			$data_rec['job_optout_link'] = $_POST['data_job_optout_link']; 
			
			$data_rec['job_run_minute_freq'] = $_POST['data_job_run_minute_freq']; 
			$data_rec['job_run_day_freq'] = $_POST['data_job_run_day_freq']; 
			$data_rec['job_email_template'] = $_POST['data_job_email_template']; 
			$data_rec['job_email_mode'] = $_POST['data_job_email_mode']; 
			$data_rec['controller_func'] = $_POST['data_controller_func']; 
			if ($_POST['data_active'] == "Y") {$data_rec['active'] = "Y";} else {$data_rec['active'] = "N";} 
			// $data_rec['func_params'] = $_POST['data_func_params']; // NOT SET ON FORM YET 

			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
				// echo "<br>!! update done ";
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
				// echo "<br>!! insert done ";
				$_POST['id'] = $id; 
			}			
		} 
		
		If ($_POST['update_run_test'] == "Y") {
			// ## RUN THE EMAIL TEST 
			$this->Asys_load7_new->sendemailv2_test($_POST['id']);
			// echo "<br>!! 33 HAVE CALL TEST ";
		}
	
		If ($_POST['update_record_go_list'] == "Y") {
			// echo "<br>!! ### will redirect now - FAILS IF TOO MANY PARAMS ";
			redirect('/Sys_Jobs_v4/listing/manage_key_lists_4');
		} else {

			$sql = "select * from `ainf_vps3_code_manager` where code_group = 'email_run_status' order by code_id"; 
			$data['list_email_run_status'] = $this->db->query($sql)->result_array(); 

			$sql = "select * from `ainf_vps3_code_manager` where code_group = 'peakdata_email_template' order by code_id"; 
			$data['list_data_job_email_template'] = $this->db->query($sql)->result_array(); 
			
			$sql = "select * from `ainf_vps3_code_manager` where code_group = 'job_run_mins' order by code_id"; 
			$data['list_run_min_freq'] = $this->db->query($sql)->result_array(); 
			
			$sql = "select * from `ainf_vps3_code_manager` where code_group = 'job_run_days' order by code_id"; 
			$data['list_run_day_freq'] = $this->db->query($sql)->result_array(); 

			$sql = "select * from `campaign_templates_5` where temp_active_jspec = 'Y' order by title"; 
			$data['list_data_job_email_template'] = $this->db->query($sql)->result_array();
			// var_dump($data['list_data_job_email_template']);
		
			//############# RUN QUERIES FOR THE SCREEN ############# 
			$sql = "select * from `aaa_data_logs` where jspec_id = {$_POST['id']} order by date_end_sort limit 0,3 "; 
			
			if (trim($id) != "") {
				//############# NEW PRAYERS CODE ############# 
				$sql = "select * from jspec where id = $id"; 
				$data['edit_record'] = $this->db->query($sql)->result_array(); 
				//############# NEW PRAYERS CODE ############# 
				$_POST['userid'] = $id; 
			// echo "<br>!! 99a sql is $sql <br>";
				$this->load->view('update_job_manager_5', $data); 
			} else {
				//#### NOTE SYSTEM MODULES HAVE NO COMPANY - ARE FOR ENTIRE SYSTEM 
				$_POST['userid'] = 0; 
				// $this->load->view('update_sprint_5', $data); 
				// echo "<br>!! 99b sql is $sql <br>"; 
				$this->load->view('update_job_manager_5', $data); 
			}
		}
		
	}

	public function listing($pagename)
	{
	
		error_reporting(0);
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		
		// $login_message ### find an easy way to pass this parameter.. 
		if ($login_message == "login") {
			$_POST['update_valid'] = "Welcome back to Church of Jesus";
		}
		// echo "<br>!! 22";
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];
		
		if ($pagename == "needcontact4") {
			$attendee_type = "needcontact4";
			$pagename = "attendees4";
		}

		// echo "<br>!! 33";
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		// echo "<br>!! 33bb";
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		//############# NEW PRAYERS CODE ############# 

		$var_this_month = date('m'); $var_this_year = date('Y'); 
		$var_this_month_year = $var_this_year . "/" . $var_this_month; 
				
		$sql = "select * from jspec where active = 'Y' order by title";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from jspec where active = 'N' order by title";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		
		// $sql = "select * from jspec where sprint_type = 'Strategic' and sprint_status = 'Incomplete' order by priority";
		// $data['main_list_array_tab3'] = $this->db->query($sql)->result_array();

		$varcompid = $_POST['sess_compid']; 
				
		// // echo "<br>!!55 pagename_orig is $pagename_orig";
		if (1==1 or file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
		// // // echo "<br>qqAA orig page is $pagename_orig";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
	
	}

	public function listing_fups_old($pagename)
	{
		// Get page name for the link
		
		error_reporting(0);
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		$var_last_month = date('Y/m/d', strtotime('-8 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 7 DAYS 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();

		$var_last_month = date('Y/m/d', strtotime('-31 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();

		$var_last_month = date('Y/m/d', strtotime('-31 days'));
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month and follup_contact_type in ('Successful Phone Call','Meeting','Group Event')) order by first_name, last_name";
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array();

		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select userid, mobile, email, userid, first_name, last_name from ainf_vps3_users where compid = $varcompid and (team_regular_church is null or email is null or addr_suburb is null or addr_street is null) order by first_name, last_name";
		$data['main_list_array_tab4'] = $this->db->query($sql)->result_array();
		
		//### NOT USED EXCEPT IN REPORT - GOOD FOR PRAYER REQUEST LISTINGS 
		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
	}

	public function attendeestatus($pagename)
	{
		error_reporting(0);
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 

		$var_this_yr_month =  date("Y/m"); // Get the users NOT having follow_ups 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  follup_contact_date_sort like '%$var_this_yr_month%') order by first_name, last_name"; 
		$data['follups_left'] = $this->db->query($sql)->result_array(); 
		
		//### PRAYER REQUESTS 
		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort like '%$var_this_yr_month%' order by userid, request_date_sort desc";
		$data['prayer_req_new'] = $this->db->query($sql)->result_array();

		$sql = "select a.title, a.request_date, a.request_date_sort, a.request_userid_for, a.compid, b.mobile, b.userid, b.first_name, b.last_name from teampro_requests a 
		left join ainf_vps3_users b on a.request_userid_for = b.userid 
		where a.compid = $varcompid and request_date_sort not like '%$var_this_yr_month%' and req_status not in ('Answered') order by userid, request_date_sort desc";
		$data['prayer_req_open'] = $this->db->query($sql)->result_array();
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.mobile, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name, b.mobile  
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		//### QUERIES FOR GAPS REPORT 
		//### ATTENDEES - NO FOLLOW-UPS LAST 30 DAYS 
		
		$var_last_month = date('Y/m/d', strtotime('-31 days')); 
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and userid not in (select follup_for from teampro_follow_ups where  
		follup_contact_date_sort > $var_last_month) order by first_name, last_name";
		$data['no_followups_month'] = $this->db->query($sql)->result_array();

		//### ATTENDEES - NO PRAYER REQUESTS LAST 30 DAYS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where userid not in (select request_userid_for from teampro_requests where  request_date_sort > $var_last_month) and compid = $varcompid order by first_name, last_name"; 
		$data['no_prayer_req_month'] = $this->db->query($sql)->result_array(); 
		
		//### ATTENDEES - GAPS IN EMAIL, REG CHURCH OR ADDRESS 
		$sql = "select mobile, email, userid, first_name, last_name from ainf_vps3_users where team_regular_church is null or email is null or addr_suburb is null or addr_street is null and compid = $varcompid order by first_name, last_name";
		$data['no_key_dates'] = $this->db->query($sql)->result_array();
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}		
	}

}
	
