<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');

class Video_trainer4 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');
	
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START 
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	function process_get_checklist()
	{
		if (1==1) {
			// Add any new checklists 
			if (isset($_POST['checklist_item_add1']) and trim($_POST['checklist_item_add1']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add1']);
				$this->db->insert('edu_checklist', $inscheck);
			}
			if (isset($_POST['checklist_item_add2']) and trim($_POST['checklist_item_add2']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add2']);
				$this->db->insert('edu_checklist', $inscheck);
			}
		}
		$q = $this->db->query("select * FROM edu_checklist");
		$data = $q->result_array();
		return($data);
	} 

	public function index() 
	{
		error_reporting(0); 
		$this->load->helper('url'); 
		// redirect('ministry/messages/sermons-list', 'refresh'); 
	} 

	public function check_function() 
	{ 
		error_reporting(0); 
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type'] 
		$this->load->helper('url'); 
		$callfunction = trim($_POST['function_type']); 
		if ($callfunction == "details") { 
			$this->details('index'); 
		} else { 
			// // // // // // // // // // // echo"!! must write other functions code for funciton $callfunction"; 
		} 
	} 

	public function save_answers()
	{
	
		$varcompid = $_POST['sess_compid'];

		$sql = "select id, correct_answer_abcde, question_video_id, courses_id from courses_questions where courses_id = {$_POST['cse_id']} and question_video_id = {$_POST['answers_video_id']} ";
		$this_question_set = $this->db->query($sql)->result_array();
		
		$num_ans = 0; $answer_string = "";
		$var_answers_total = 0; $var_answers_right = 0;
		$var_answers_needed = 0; $var_answers_wrong = 0;
		foreach($_POST as $key => $value) {
			if ((strpos($key,'questid_') !== false)) {
				++$num_ans;
				// // // // echo "<br>!!! key is $key, value is $value";
				if ($num_ans > 1) {$answer_string .= ",";}
				//#### - SAVE user answers in a string for all answers for current video 
				$answer_string .= $key . "==" . $value;
				$var_user_answer = $value;
				
				//#### - match user answers with correct answer for STATS 
				$var_quest_id = str_replace('questid_','',$key);
				foreach($this_question_set as $z) {
					if ($z['id'] == $var_quest_id) {
						if ($z['correct_answer_abcde'] == $var_user_answer) {
							++$var_answers_right;
						} elseif ($var_user_answer == "") {
							++$var_answers_needed;
						} else {
							++$var_answers_wrong;
						}
					}
				}
				++$var_answers_total;
			}
		}
		
		$data_rec = array();
		$data_rec['answers_right'] = $var_answers_right;
		$var_right = count($data_rec['answers_right']);
		$data_rec['answers_needed'] = $var_answers_needed;
		$data_rec['answers_needed'] = $var_answers_needed;
		$var_needed = count($this_question_set);
		$data_rec['answers_wrong'] = $var_answers_wrong;
		$data_rec['answers_total'] = $var_answers_total;
		$var_total = count($data_rec['answers_total']); 
		
		$data_rec['answer_group_ids'] = $answer_string; 
		$data_rec['answers_userid'] = $_POST['sess_userid']; 
		$data_rec['compid'] = $varcompid; 
		$data_rec['cse_id'] = $_POST['cse_id']; 
		$data_rec['answers_video_id'] = $_POST['answers_video_id'];
		
		// // // // var_dump($data_rec);
		$sql = "select * from course_answers where answers_userid = {$_POST['sess_userid']} and cse_id = {$_POST['cse_id']} and answers_video_id = {$_POST['answers_video_id']} ";
		$this_answer_set = $this->db->query($sql)->result_array();
		
		if (count($this_answer_set) > 0) {
			foreach ($this_answer_set as $z) {
				$this->db->where('id', $z['id']);
				$this->db->update(course_answers, $data_rec);
			}
			// // // // // echo "<br>UPDATE save_answers";
		} else {
			$this->db->insert(course_answers, $data_rec);
			// // // // // echo "<br>INS save_answers";
		}

		//#### NOW SAVE A SUMMARY RECORD FOR ENTIRE COURSE - VID=0, QUESTIONS TOTAL, TOTAL RIGHT, TOTAL WRONG
		$sql = "select id, correct_answer_abcde, courses_id from courses_questions where question_video_id > 0 and courses_id = {$_POST['cse_id']} and active = 'Y'";
		$total_questions_course = $this->db->query($sql)->result_array();
		$total_questions = count($total_questions_course);
		$sql = "select sum(answers_total) from course_answers where cse_id = {$_POST['cse_id']}";
		$total_answers = $this->db->query($sql)->result_array();
		$total_answers = $total_answers[0]['sum(answers_total)'];
		// echo "<br>11 answers=$total_answers, TOTAL QUESTS=$total_questions "; 
		if ($total_answers == $total_questions) {
			$sql = "select my_courses_started, my_courses_done, userid from ainf_vps3_users where userid = {$_POST['sess_userid']} limit 0,1"; 
			$check_course_started = $this->db->query($sql)->result_array(); 
			foreach ($check_course_started as $z) 
			{
				// echo "<br>!!22 IN loop - checking user rec"; 
				$data_rec = array();
				// #### ADD THIS COURSE TO my_courses_done FIELD
				$this_course_string = ",{$_POST['sess_userid']},";
				if (strpos($this_course_string, $z['my_courses_done']) === false)
				{
					// echo "<br>!! 22aa Will try for done";
					if ($z['my_courses_done'] == "") {
						$data_rec['my_courses_done'] = "0,{$_POST['cse_id']},0"; 
					} else {
					// echo "<br>!! 22a2 try as done";
						$var_new_done_course_string = ",{$_POST['cse_id']},0";
						$var_find_string = ",0";
						$var_my_courses_done = $z['my_courses_done']; 
						$var_my_courses_done = str_replace($var_find_string, $var_new_done_course_string, $var_my_courses_done); 
						$data_rec['my_courses_done'] = $var_my_courses_done; 
						// // // // echo "<br>!!! TTT var_my_courses_done $var_my_courses_done TTT ";
					} 
				}
				// #### REMOVE THIS COURSE FROM my_courses_started FIELD 
				if ($z['my_courses_started'] == "") { 
					$data_rec['my_courses_started'] = "0,0"; 
				} else { 
					// echo "<br>!! 33aa Will loop for started";
					$var_find_string = ",{$_POST['cse_id']},"; 
					$var_my_courses_started = $z['my_courses_started']; 
					for ($i=1; $i <= 8; ++$i) {
						//### Just in case course is repeated clear it out, but keep other courses
						$var_my_courses_started = str_replace($var_find_string,",",$var_my_courses_started); 
						// echo "<br>!! 33 started is $var_my_courses_started";
					} 
					$data_rec['my_courses_started'] = $var_my_courses_started; 
				} 
				
				// ### Remove the course from the users my_courses_started list 
				// echo "<br>!!CC will update $data_rec is <br>"; // // var_dump($data_rec); 
				$this->db->where('userid', $_POST['sess_userid']); 
				$this->db->update(ainf_vps3_users, $data_rec); 

			}
		}

		if ($total_answers == $total_questions) {
			// #### SHOW THEM THE RESULTS - ADD NICE MESSAGE 
			redirect('/video_trainer4/my_list_done/course-player-v8');
		} else { 
			// #### CONTINUE WITH THE ANSWERING 
			$this->run_course(course-run-v8); 
		}

	}

	public function details($pagename)
	{
	
		$varcompid = $_POST['sess_compid'];
		// // // // // // echo "<br>!!11 - details $varcompid varcompid";
		
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // // // // // // // echo "!! email not sent ";
		}

		// // // // // // echo "<br>!!22 - details ";
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$var_search = "";
		
		// // // // // // echo "<br>!!33 - details ";
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		// // // // // // echo "<br>!!44 - details ";
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		
		// // // // // // echo "<br>!!44aa - sql - $sql";
		$data['events'] = $this->db->query($sql)->result_array();
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$sql = "select * from ainf_xcloud_videos, mentor_series where video_series = mentor_series.id order by video_order";
		// // // // // // echo "<br>!!44bb - sql - $sql ";
		$data['messages'] = $this->db->query($sql)->result_array();
		// //// // // // // // var_dump($data['messages']);
		
		// // // // // // echo "<br>!!55 - details ";
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		// // // // // // echo "<br>!!66 - details ";
		// !!! THIS IS THE NEW CODE TO BEGIN USING THE ainf_xcloud_videos TABLE AS IT HAS ALL THE DATA 
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$varfixed_comp = 114;
		$sql = "select * from ainf_xcloud_videos, speakers where  ainf_xcloud_videos.compid = $varfixed_comp and video_trainerid = speakers.id order by video_order";
												
		$var_search = "";
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_series'] = "";
		}
		if ($_POST['form_series'] != "") {
			$var_search .= " and video_series = '{$_POST['form_series']}' ";
		}
		
		if ($_POST['form_archive'] != "" and $_POST['form_archive'] != "all") {
			$var_search .= " and v.archive = '{$_POST['form_archive']}' ";
		}

		//### LEFT JOIN SQL 
		// // // // // // echo "<br>!!77 - details "; 
		$sql = "SELECT v.compid, v.id as id, v.public_viewing, v.archive as archive, video_name, v.video_link, teaser, video_writeup, series_title FROM ainf_xcloud_videos v LEFT JOIN mentor_series m ON v.video_series = m.id where v.compid = $varcompid $var_search";
		$data['messages'] = $this->db->query($sql)->result_array();

		if (!isset($_POST['form_archive']) or $_POST['form_archive'] == "") { // Starting value to all
			$_POST['form_archive'] = "all";
		}

		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'archive_values' order by code_id desc";
		$data['archive_list'] = $this->db->query($sql)->result_array();

		if ($_POST['form_series'] != "" and $_POST['form_series'] != 0) {
			$sql = "select * from mentor_series where id = {$_POST['form_series']}";
			$data['series_header'] = $this->db->query($sql)->result_array();
		}

		$sql = "select distinct teacher from ainf_xcloud_videos where compid = $varcompid $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();

		// // // // // // echo "<br>!!88 - details ";
		$sql = "select distinct book from ainf_xcloud_videos where compid = $varcompid order by book";
		$data['books'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid = $varcompid order by code_id";
		$data['services'] = $this->db->query($sql)->result_array();

		$sql = "select * from mentor_series where compid = $varcompid order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 
				
		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason

		// // // // // // echo "<br>!!99 - details page is $pagename_orig"; 
		$data['eunit_checklist'] = $this->process_get_checklist(); // load the checklist items
		// //// // // // // // var_dump($data['eunit_checklist']);
		
		//### list qrys
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid and id  in (select video_series from ainf_xcloud_videos) order by series_title";
		// // // // // // echo "<br>!!99bb - details page is $pagename_orig <br>sql $sql"; 
		$data['list_series'] = $this->db->query($sql)->result_array();

		// very basic error handling
		// // // // // // echo "<br>!!99 - details page is $pagename_orig"; 
		$this->load->view($pagename_orig, $data);
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
		// // // // // // echo "<br>!!AA - details "; 
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
		// // // // // // echo "<br>!!BB - details "; 
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function my_list($pagename)
	{
		$_POST['course_type'] = "My_Courses";
		$this->certify_list($pagename);
	}	

	public function my_list_done($pagename)
	{
		$_POST['course_type'] = "My_Completed_Courses";
		$pagename = "course-player-v9";
		$this->certify_list($pagename);
	}	

	public function exit_course()
	{
		if ($_POST['cse_id'] != "" and $_POST['exit_course'] != "") { 
			$sql = "select my_courses_started, userid from ainf_vps3_users where userid = {$_POST['sess_userid']} limit 0,1"; 
			$check_course_started = $this->db->query($sql)->result_array(); 
			foreach ($check_course_started as $z) 
			{ 
				$data_rec = array(); 
				if ($z['my_courses_started'] == "") { 
					$data_rec['my_courses_started'] = "0,0"; 
				} else { 
					$var_find_string = ",{$_POST['cse_id']},"; 
					$var_my_courses_started = $z['my_courses_started']; 
					for ($i=1; $i <= 8; ++$i) { 
						//### Just in case course is repeated here 
						$var_my_courses_started = str_replace($var_find_string,",",$var_my_courses_started); 
					} 
					$data_rec['my_courses_started'] = $var_my_courses_started; 
				} 
				// ### Remove the course from the users my_courses_started list 
				$this->db->where('userid', $_POST['sess_userid']); 
				$this->db->update(ainf_vps3_users, $data_rec); 
			}
		}
		redirect('/video_trainer4/certify_list/course-player-v8');

	}

	public function global_list($pagename)
	{
		$_POST['course_type'] = "Global_Courses";
		$this->certify_list($pagename);
	}
	
	public function run_course()
	{
		//### NOW RUN THE COURSE AND ACCEPT AND SAVE ANSWERS 
		$pagename = "course-run-v8"; 
		$pagename_orig = $pagename;
		
		error_reporting(E_ALL); 
		error_reporting(0); 
		
		//### ADD TO THE COURSES STARTED 
		if ($_POST['cse_id'] != "" and $_POST['start_course'] != "") {
			$sql = "select my_courses_started, userid from ainf_vps3_users where userid = {$_POST['sess_userid']} limit 0,1"; 
			$check_course_started = $this->db->query($sql)->result_array(); 
			// // // // // // var_dump($check_course_started); 
			// // // // // echo "<br>!! 22 checking on start_course";
			foreach ($check_course_started as $z) 
			{
				$data_rec = array();
				if ($z['my_courses_started'] == "") {
					$data_rec['my_courses_started'] = "0," . $_POST['cse_id'] . ",0";
				} else {
					$var_my_courses_started = str_replace(",0","",$z['my_courses_started']);
					$data_rec['my_courses_started'] = $var_my_courses_started . "," . $_POST['cse_id'] . ",0";
				}
				$this->db->where('userid', $_POST['sess_userid']);
				$this->db->update(ainf_vps3_users, $data_rec);
			} 
		}

		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();	
		if ($_POST['video_type'] == "") {$_POST['video_type'] = "regular";}
		//*** Get page name for the link 
		
		// // // // // echo "<br>!! BB in courses "; 
		if ($pagename == "video-player-bsbc-qrcodes") {
			$_POST['qr_code_link'] = "yes";
			$pagename = "video-player-bsbc-base";
		} else {
			$_POST['qr_code_link'] = "no";
		}
				
		$varcompid = $_POST['sess_compid'];
		// // // // // // echo "<br>!!bb compid $varcompid ";
		
		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid > 0 order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if (1==2) {
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
			$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book "; 
			$data['messages'] = $this->db->query($sql)->result_array(); 
			
			$num_rows1 = count($data['messages']);
			$recsperpage = 4;
			$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
			if ($_POST['page_tot'] < 1) { // reset the form values 
				$_POST['page_tot'] = 1;
			}
			if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
				$_POST['form_page'] = 1;
			}
			
			$_POST['page_curr'] = $_POST['form_page'];
			
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
			if ($_SERVER['REQUEST_METHOD'] == 'POST') {
				$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
			} else {
				$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
			}
		}
				
	
		$var_userid = $this->session->userdata('userid');
		if ($_POST['pagename_mode'] == "recommended_videos") { 
			$ainf_fields = "audio_link, teacher_imagebg, book1, book1verse, book2, book2verse, book3, book3verse, book4, book4verse, book5, book5verse, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort "; 
			$ainf_fields = "active, first_name, last_name, team_image_link, userid, audio_link, teacher_imagebg, book1, book1verse, book1verse_det, book2, book2verse, book2verse_det, book3, book3verse, book3verse_det, book4, book4verse, book4verse_det, book5, book5verse, book5verse_det, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, ainf_xcloud_videos.id, series, message, message_date_sort, vid_memberid_to, vid_sent_notes, vid_sent_date_sort "; 
			// point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, ainf_xcloud_videos.id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort "; 

			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select * from ainf_xcloud_videos where id in (select vid_videoplay_id from ainf_xcloud_vid_sent where vid_memberid_to = $var_userid) order by message_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher ";
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_vps3_users, ainf_xcloud_vid_sent where active = 'Y' and teacher_userid = ainf_vps3_users.userid and ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, first_name, last_name ";

		// // // // // // echo "<br>!!DD compid $varcompid sql $sql ";
			$data['messages'] = $this->db->query($sql)->result_array();
			// // // // // // // // // echo"<br>!! RECO SQL IS $sql";
			// // // // // // // // // // // // var_dump($data['messages']);
		} elseif ($_POST['pagename_mode'] == "all_videos") {
			$sql = "select * from ainf_xcloud_videos where video_type not in ('tract') and compid = $varcompid and active = 'Y'  order by message_date_sort desc, teacher ";
			$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where teacher_userid = ainf_vps3_users.userid and video_type not in ('tract') and ainf_vps3_users.compid = $varcompid and active = 'Y' order by message_date_sort desc, first_name, last_name ";

		// // // // // // echo "<br>!!EE compid $varcompid sql $sql ";
			$data['messages'] = $this->db->query($sql)->result_array();
			// // // // // // // // // // // // var_dump($data['messages']);
		} elseif ($_POST['pagename_mode'] == "tract_videos") {
			$sql = "select * from ainf_xcloud_videos where video_type = 'tract' and compid = $varcompid and active = 'Y'  order by message_date_sort desc, teacher ";
			$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where teacher_userid = ainf_vps3_users.userid and video_type = 'tract' and active = 'Y' order by message_date_sort desc, first_name, last_name ";
		// // // // // // echo "<br>!!FF compid $varcompid sql $sql ";
			$data['messages'] = $this->db->query($sql)->result_array(); 
			// // // // // // // // // echo"<br>!! TRACT SQL IS $sql"; 
			
		} else {
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
			$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book "; 
			$data['messages'] = $this->db->query($sql)->result_array(); 
			// // // // // // echo "<br>!!GG compid $varcompid sql $sql "; 
		}
				
		$sql = "select * from course_answers where answers_userid = {$_POST['sess_userid']} order by answers_userid, cse_id, answers_video_id "; 
		$data['user_answers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position"); 
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and compid = $varcompid order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array(); 

		// Very basic error handling 
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'"; 
		$sql = "select * from courses, ainf_xcloud_videos where courses.compid = $varcompid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 
		$sql = "select * from courses, ainf_xcloud_videos, ainf_vps3_users where courses.compid = $varcompid and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 

		$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where ainf_vps3_users.userid = ainf_xcloud_videos.teacher_userid and id in 
		(select vid_group_id from courses where courses.compid = $varcompid and courses.active in ('Y')) order by ainf_xcloud_videos.id desc "; 
		$data['course_videos'] = $this->db->query($sql)->result_array(); 
		
		$var_count = count($data['course_videos']); 
		// echo "<br><br>11 sql is $sql - RECS = $var_count"; 

		$sql = "select courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
		video_type, video_series, public_viewing, video_trainerid, video_name, date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, 
		first_name, last_name, userid from courses, ainf_xcloud_videos, ainf_vps3_users where courses.compid = $varcompid and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 
		$data['messages'] = $this->db->query($sql)->result_array(); 

		$var_field_list = "courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
		ainf_xcloud_videos.id as vid_id, audio_link, video_type, video_series, public_viewing, video_trainerid, video_name, 
		date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, team_image_link, user_img_link, first_name, last_name, userid "; 
		
		if ($_POST['cse_id'] != "") {
			//### Can possibly join better later on 
			$var_sql_min = "select my_courses_started from ainf_vps3_users where userid = {$_POST['sess_userid']} limit 0,1 "; 
			$array_my_courses = $this->db->query($var_sql_min)->result_array(); 
			$var_my_courses = $array_my_courses[0]['my_courses_started'];
			if ($var_my_courses == "") {$var_my_courses = "0";}
			$sql = "select $var_field_list 
			from courses, ainf_xcloud_videos, ainf_vps3_users 
			where courses.compid = $varcompid and (courses.local_or_global = 'Local' or courses.local_or_global = 'Global') 
			and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
			and courses.id = {$_POST['cse_id']}
			and courses.vid_intro_id = ainf_xcloud_videos.id order by courses.id desc "; 
			$intro_course_video = $this->db->query($sql)->result_array(); 

			$var_sql_min = "select vid_group_id, id from courses where id = {$_POST['cse_id']} limit 0,1 "; 
			$array_course_videso = $this->db->query($var_sql_min)->result_array(); 
			$var_vid_group_id = $array_course_videso[0]['vid_group_id']; 
			if ($var_vid_group_id == "") {$var_vid_group_id = "0";} 
			$sql = "select $var_field_list 
			from courses, ainf_xcloud_videos, ainf_vps3_users 
			where courses.compid = $varcompid and (courses.local_or_global = 'Local' or courses.local_or_global = 'Global') 
			and ainf_xcloud_videos.teacher_userid = ainf_vps3_users.userid and courses.active in ('Y') 
			and courses.id = {$_POST['cse_id']} 
			and ainf_xcloud_videos.id in ($var_vid_group_id) order by courses.id desc "; 
			$list_course_videos = $this->db->query($sql)->result_array(); 
			$var_count = count($list_course_videos); 
			// // // // var_dump($list_course_videos);
			// echo "<br><br>!!! - sql 22 is $sql array VIDEO count {$var_count} "; 

			//#### MERGE THE DATABASES 
			$data['messages'] = array_merge($intro_course_video, $list_course_videos); 
			$var_count = count($data['messages']); 
			
			$sql = "select * from courses_questions where courses_id = {$_POST['cse_id']} order by question_video_id, question_order ";
			$data['quest_lists'] = $this->db->query($sql)->result_array();
			// // // // echo "<br>!!aa";
			// // // // var_dump($data['quest_lists']);
			// // // // echo "<br>!!bb";
			
		}
		

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = ""; 
			$this->load->view($pagename_orig, $data); 
		} else { 
			$this->load->view($pagename_orig, $data);
		}

	}
	
	public function certify_list($pagename)
	{
	
		// echo "<br>!!00 sql = sql ";
	
		if ($_POST['course_type'] == "") {
			$_POST['course_type'] = "Local_Courses";
		}

		error_reporting(E_ALL); 
		error_reporting(0); 

		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		
		if ($_POST['video_type'] == "") {$_POST['video_type'] = "regular";}
		
		if ($pagename == "video-player-bsbc-qrcodes") {
			$_POST['qr_code_link'] = "yes";
			$pagename = "video-player-bsbc-base";
		} else {
			$_POST['qr_code_link'] = "no";
		}
		
		if ($pagename == "recommended_videos2" or $pagename == "recommended_videos") {
			$_POST['pagename_mode'] = "recommended_videos";
			$pagename = "video-player-bsbc-v8";
		} elseif ($pagename == "all_videos" or $pagename == "video-player-bsbc-base") {
			$_POST['pagename_mode'] = "all_videos";
			$pagename = "video-player-bsbc-v7";
			$pagename = "video-player-bsbc-base";
			$pagename = "video-player-bsbc-v8";
			// // // // // // // // // // echo"<br>!! set as all on v7 mode is {$_POST['pagename_mode']}";
		} elseif ($pagename == "tract_videos") {
			$_POST['pagename_mode'] = "tract_videos";
			$pagename = "video-player-bsbc-v8";
			// // // // // // // // // // echo"<br>!! set as tract on v7";
		} elseif ($pagename == "video-player-bsbc-qrcodes") {
			$_POST['pagename_mode'] = "video-player-bsbc-qrcodes";
			$_POST['qr_code_link'] = "yes";
			$pagename = "video-player-bsbc-base";
		} else {
			$_POST['pagename_mode'] = "regular_videos";
			$pagename = "video-player-bsbc-base";
		}
		
		$pagename = "course-player-v8";
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// // // // // // // // echo"<br>!!bb";
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} 
		// index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];
		// // // // // // echo "<br>!!bb compid $varcompid ";
		
		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid > 0 order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if (1==2) {
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
			$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book "; 
			$data['messages'] = $this->db->query($sql)->result_array(); 
			
			$num_rows1 = count($data['messages']);
			$recsperpage = 4;
			$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
			if ($_POST['page_tot'] < 1) { // reset the form values 
				$_POST['page_tot'] = 1;
			}
			if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
				$_POST['form_page'] = 1;
			}
			
			$_POST['page_curr'] = $_POST['form_page'];
			
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
			if ($_SERVER['REQUEST_METHOD'] == 'POST') {
				$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
			} else {
				$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
			}
		}
				
	
		$var_userid = $this->session->userdata('userid');
		if ($_POST['pagename_mode'] == "recommended_videos") { 
			$ainf_fields = "audio_link, teacher_imagebg, book1, book1verse, book2, book2verse, book3, book3verse, book4, book4verse, book5, book5verse, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort "; 
			$ainf_fields = "active, first_name, last_name, team_image_link, userid, audio_link, teacher_imagebg, book1, book1verse, book1verse_det, book2, book2verse, book2verse_det, book3, book3verse, book3verse_det, book4, book4verse, book4verse_det, book5, book5verse, book5verse_det, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, ainf_xcloud_videos.id, series, message, message_date_sort, vid_memberid_to, vid_sent_notes, vid_sent_date_sort "; 
			// point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, ainf_xcloud_videos.id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort "; 

			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select * from ainf_xcloud_videos where id in (select vid_videoplay_id from ainf_xcloud_vid_sent where vid_memberid_to = $var_userid) order by message_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher ";
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_vps3_users, ainf_xcloud_vid_sent where active = 'Y' and teacher_userid = ainf_vps3_users.userid and ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, first_name, last_name ";

		// // // // // // echo "<br>!!DD compid $varcompid sql $sql ";
			$data['messages'] = $this->db->query($sql)->result_array();
			// // // // // // // // // echo"<br>!! RECO SQL IS $sql";
			// // // // // // // // // // // // var_dump($data['messages']);
		} elseif ($_POST['pagename_mode'] == "all_videos") {
			$sql = "select * from ainf_xcloud_videos where video_type not in ('tract') and compid = $varcompid and active = 'Y'  order by message_date_sort desc, teacher ";
			$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where teacher_userid = ainf_vps3_users.userid and video_type not in ('tract') and ainf_vps3_users.compid = $varcompid and active = 'Y' order by message_date_sort desc, first_name, last_name ";

		// // // // // // echo "<br>!!EE compid $varcompid sql $sql ";
			$data['messages'] = $this->db->query($sql)->result_array();
			// // // // // // // // // // // // var_dump($data['messages']);
		} elseif ($_POST['pagename_mode'] == "tract_videos") {
			$sql = "select * from ainf_xcloud_videos where video_type = 'tract' and compid = $varcompid and active = 'Y'  order by message_date_sort desc, teacher ";
			$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where teacher_userid = ainf_vps3_users.userid and video_type = 'tract' and active = 'Y' order by message_date_sort desc, first_name, last_name ";
		// // // // // // echo "<br>!!FF compid $varcompid sql $sql ";
			$data['messages'] = $this->db->query($sql)->result_array(); 
			// // // // // // // // // echo"<br>!! TRACT SQL IS $sql"; 
			
		} else {
			if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
			$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book "; 
			$data['messages'] = $this->db->query($sql)->result_array(); 
			// // // // // // echo "<br>!!GG compid $varcompid sql $sql "; 
		}
				
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position"); 
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and compid = $varcompid order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from course_answers where answers_userid = {$_POST['sess_userid']} order by answers_userid, cse_id, answers_video_id ";
		$data['user_answers'] = $this->db->query($sql)->result_array();
		
		// Very basic error handling 
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'"; 
		$sql = "select * from courses, ainf_xcloud_videos where courses.compid = $varcompid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 
		$sql = "select * from courses, ainf_xcloud_videos, ainf_vps3_users where courses.compid = $varcompid and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 

		$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where ainf_vps3_users.userid = ainf_xcloud_videos.teacher_userid and id in 
		(select vid_group_id from courses where courses.compid = $varcompid and courses.active in ('Y') ) order by ainf_xcloud_videos.id desc "; 
		$data['course_videos'] = $this->db->query($sql)->result_array(); 

		$var_count = count($data['course_videos']); 
		// echo "<br><br>11 sql is $sql - RECS = $var_count "; 
		// // var_dump($data['course_videos']); 

		$sql = "select courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
		video_type, video_series, public_viewing, video_trainerid, video_name, date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, 
		first_name, last_name, userid from courses, ainf_xcloud_videos, ainf_vps3_users where courses.compid = $varcompid and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
		and ainf_xcloud_videos.id in (select question_video_id from courses_questions where courses_id = courses.id) order by courses.id desc "; 
		$data['messages'] = $this->db->query($sql)->result_array(); 

		// ##############################################################################################################
		// VIP TO GET THESE VARIABLES 
		$var_sql_min = "select my_courses_done, my_courses_started from ainf_vps3_users where userid = {$_POST['sess_userid']} limit 0,1 "; 
		$array_my_courses = $this->db->query($var_sql_min)->result_array(); 
		$var_my_courses_done = $array_my_courses[0]['my_courses_done'];
		if (trim($var_my_courses_done) == "") {$var_my_courses_done = "0";}
		$var_my_courses_started = $array_my_courses[0]['my_courses_started'];
		if (trim($var_my_courses_done) == "") {$var_my_courses_started = "0";}
		
		if (1==2 and $_POST['course_type'] == "Local_Courses") {
			$sql = "select courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
			audio_link, video_type, video_series, public_viewing, video_trainerid, video_name, date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, 
			team_image_link, user_img_link, first_name, last_name, userid 
			from courses, ainf_xcloud_videos 
			where courses.compid = $varcompid and courses.active in ('Y') 
			and courses.vid_intro_id = ainf_xcloud_videos.id order by courses.id desc "; 

		} elseif ($_POST['course_type'] == "Local_Courses") {
			$sql = "select courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
			audio_link, video_type, video_series, public_viewing, video_trainerid, video_name, date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, 
			team_image_link, user_img_link, first_name, last_name, userid from courses, ainf_xcloud_videos, ainf_vps3_users 
			where (courses.local_or_global = 'Local' or courses.local_or_global = 'Global') and courses.compid = $varcompid 
			and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
			and courses.vid_intro_id = ainf_xcloud_videos.id order by courses.id desc "; 
			
		} elseif ($_POST['course_type'] == "My_Completed_Courses") {
			//### Can possibly join better later on 
			// // // echo "<br>!!! my courses is $var_my_courses";
			if ($var_my_courses == "") {$var_my_courses = "0";}
			$sql = "select courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
			audio_link, video_type, video_series, public_viewing, video_trainerid, video_name, date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, 
			team_image_link, user_img_link, first_name, last_name, userid from courses, ainf_xcloud_videos, ainf_vps3_users 
			where courses.compid = $varcompid and (courses.local_or_global = 'Local' or courses.local_or_global = 'Global') 
			and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
			and courses.id in ($var_my_courses_done)
			and courses.vid_intro_id = ainf_xcloud_videos.id order by courses.id desc "; 
			// // // echo "<br>!!!33 type is My_Completed_Courses <br>sql is $sql"; 
		} elseif ($_POST['course_type'] == "My_Courses") {
			//### Can possibly join better later on 
			if ($var_my_courses_started == "") {$var_my_courses_started = "0";} 
			$sql = "select courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
			audio_link, video_type, video_series, public_viewing, video_trainerid, video_name, date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, 
			team_image_link, user_img_link, first_name, last_name, userid from courses, ainf_xcloud_videos, ainf_vps3_users 
			where courses.compid = $varcompid and (courses.local_or_global = 'Local' or courses.local_or_global = 'Global') 
			and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
			and courses.id in ($var_my_courses_started) 
			and courses.vid_intro_id = ainf_xcloud_videos.id order by courses.id desc "; 

		} elseif ($_POST['course_type'] == "Global_Courses") {
			// #### Global is across ministries and ONLY for the best and approved content 
			$sql = "select courses.id, cse_name, cse_writeup, cse_benefits,  courses.active, vid_group_id, local_or_global, courses.compid, cse_cost, 
			audio_link, video_type, video_series, public_viewing, video_trainerid, video_name, date_create, video_link, video_writeup, video_order, series, ainf_xcloud_videos.title, ainf_xcloud_videos.teaser, ainf_xcloud_videos.message, 
			team_image_link, user_img_link, first_name, last_name, userid from courses, ainf_xcloud_videos, ainf_vps3_users 
			where courses.local_or_global = 'Global' 
			and courses.cse_leader = ainf_vps3_users.userid and courses.active in ('Y') 
			and courses.vid_intro_id = ainf_xcloud_videos.id order by courses.id desc "; 
		}
		
		// echo "<br>!! sql = $sql ";
		
		$data['messages'] = $this->db->query($sql)->result_array(); 

		// #### NOW USE THE CURRENT MESSAGE ORDER TO BUILD VIDEO ARRAY GROUPED BY COURSE 
		$data['course_videos'] = array();
		foreach ($data['messages'] as $z_cse) {
			// ########################### 
			// MAKE A DISTINCT GROUP OF VIDEOS - NO REPEAT - EVEN AFTER MERGE 
			// ########################### 
			$var_vid_group_id = $z_cse['vid_group_id'];
			// #### must RE-SORT to this order $var_vid_group_id
			$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where id in ($var_vid_group_id) and teacher_userid = userid ";
			$course_videos_part = $this->db->query($sql)->result_array();
			$maxrows = count($course_videos_part);
			for ($y_vid = 0; $y_vid <= $maxrows; $y_vid++) {
				$course_videos_part[$y_vid]['cse_id'] = $z_cse['id']; // #### Need to append cse_id for matching videos to course 
			}
			// // // var_dump($course_videos_part);
			$data['course_videos'] = array_merge($data['course_videos'], $course_videos_part);
			// echo "<br><br>11 BB  sql is $sql - RECS = $var_count "; 
		}

		$sql = "SELECT v.compid, v.id as id, v.public_viewing, v.archive as archive, video_name, v.video_link, teaser, video_writeup, series_title 
		FROM ainf_xcloud_videos v LEFT JOIN mentor_series m ON v.video_series = m.id where v.compid = $varcompid $var_search";
		$sql = "select * from courses_questions q left join ainf_xcloud_videos v on q.question_video_id = v.id where courses_id in ($var_my_courses_done) and question_video_id > 0 order by courses_id, question_video_id";
		// echo "<br>12 BB sql $sql";
		$data['question_list_new'] = $this->db->query($sql)->result_array();
		foreach ($data['question_list_new'] as $q) {
			// // echo "<br><b>Cse:{$q['courses_id']}</B> qid:{$q['questoin_video_id']} ";
		}
		
		$sql = "select * from course_answers where cse_id in ($var_my_courses_done) 
		and answers_video_id > 0 order by cse_id, answers_video_id";
		$sql = "select * from course_answers a left join ainf_xcloud_videos v on a.answers_video_id = v.id where cse_id in ($var_my_courses_done) 
		and answers_video_id > 0 order by cse_id, answers_video_id";
		// echo "<br>12 BB sql $sql";
		$data['answers_list_new'] = $this->db->query($sql)->result_array();
		foreach ($data['answers_list_new'] as $q) { 
			// echo "<br><b>Cse_id:{$q['cse_id']}</B> VID:{$q['answer_video_id']} total questions:{$q['answers_total']} ";
		} 

		$var_count = count($data['course_videos']); 
		
		if ($_POST['course_type'] == "My_Completed_Courses") {
			$pagename_orig = "course-player-v9";
		}
		
		// echo "<br><br>12 BB  sql is $sql - RECS = $var_count ORIG is $pagename_orig"; 
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = ""; 
			$this->load->view($pagename_orig, $data); 
		} else { 
			$this->load->view($pagename_orig, $data);
		}
		
	}

	public function course_edit()
	{

		// ### !!! The for post is getting totally cleared when the file field for VIDEO_LINK is being loaded.. 
		// ### The for post is getting totally cleared when the file field is being loaded.. 
		// // // // // // // // // // // // // var_dump($_POST);
		error_reporting(0);
		
		$varcompid = $_POST['sess_compid'];
		
		if ($_POST['cse_name'] != "") {
		
			$data_rec = array();
			$data_rec['cse_name'] = $_POST['cse_name'];
			$data_rec['cse_cost'] = $_POST['cse_cost'];
			$data_rec['cse_writeup'] = $_POST['cse_writeup'];
			$data_rec['local_or_global'] = $_POST['local_or_global'];
			
			$maxrows = $_POST['maxrows'];
			$var_vid_group_id = "";
			for ($z = 1; $z <= $maxrows; $z++) { //## This for loop works for BOTH add and mod 
				// Post & Table Fields 
				$var_vid_id = "vid_" . $z . "_id";
				$var_lesson_title = "vid_" . $z . "_lesson_title";
				$var_vid_order = "vid_" . $z . "_order";
				
				// BUILD THE GROUP IDS - it holds video ids in order with comma delimiter 
				if ($_POST[$var_vid_id] != "" and $_POST[$var_vid_id] != "0") {
					if ($var_vid_group_id == "") {
						$var_vid_group_id .= $_POST[$var_vid_id];
					} else {
						$var_vid_group_id .= "," . $_POST[$var_vid_id];
					}
				}
				
			}
			
			$data_rec[vid_group_id] = $var_vid_group_id;
			
			if ($_POST['active']=="Y") {$data_rec['active']="Y";} else {$data_rec['active']="N";}
			if ($_POST['id'] != 0 and $_POST['update_course'] == "y") {
				// // // // // // // // // // // var_dump($data_rec);
				$this->db->where('id', $_POST['id']);
				$this->db->update(courses, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert(courses, $data_rec);
				$_POST['id'] = $this->db->insert_id();
			}
			
			// // // // // // // // // // echo"<br>!! Video ID {$_POST['question_video_id']} answer {$_POST['correct_answer_abcde']} ";
			// ###################################################################################################### 
			// QUESTION INSERT 
			if ($_POST['question_video_id'] != "" and $_POST['question_video_id'] != "0" and $_POST['correct_answer_abcde'] != "0") {
				$data_rec = array();
				$data_rec['compid'] = $varcompid;
				$data_rec['courses_id'] = $_POST['id']; $data_rec['question_video_id'] = $_POST['question_video_id'];
				$data_rec['question_text'] = $_POST['question_text']; $data_rec['answer_a'] = $_POST['answer_a'];
				$data_rec['answer_b'] = $_POST['answer_b']; $data_rec['answer_c'] = $_POST['answer_c'];
				$data_rec['answer_d'] = $_POST['answer_d']; $data_rec['answer_e'] = $_POST['answer_e'];
				$data_rec['correct_answer_abcde'] = $_POST['correct_answer_abcde'];
				// // // // // // // // // // var_dump($data_rec);
				$this->db->insert(courses_questions, $data_rec);
			}
			// ###################################################################################################### 
			
			// ###################################################################################################### 
			// QUESTION UPDATES 
			$var_question_group = explode(',',$_POST['question_group']);
			// // // // // // // // // // var_dump($var_question_group); 
			
			$var_sum = 0; 
			$var_question_count = count($var_question_group);
			$var_question_group = explode(',',$_POST['question_group']);
			// // // // // // // // // // var_dump($var_question_group); 
			// ## CHECK ALL THE VARIABLES 
			$data_rec = array();
			for ($x = 0; $x <= $var_question_count; $x++) { //## This for loop works for BOTH add and mod 
				$quest_id = $var_question_group[$x]; 
				$var_question_text = $quest_id . "_question_text"; 
				$data_rec['question_text'] = $_POST[$var_question_text];
				$var_correct_answer_abcde = $quest_id . "_correct_answer_abcde"; 
				$data_rec['correct_answer_abcde'] = $_POST[$var_correct_answer_abcde];
				
				$var_answer_a = $quest_id . "_answer_a";
				$data_rec['answer_a'] = $_POST[$var_answer_a];
				$var_answer_b = $quest_id . "_answer_b";
				$data_rec['answer_b'] = $_POST[$var_answer_b];
				$var_answer_c = $quest_id . "_answer_c";
				$data_rec['answer_c'] = $_POST[$var_answer_c];
				$var_answer_d = $quest_id . "_answer_d";
				$data_rec['answer_d'] = $_POST[$var_answer_d];
				$var_answer_e = $quest_id . "_answer_e";
				$data_rec['answer_e'] = $_POST[$var_answer_e];
				
				$this->db->where('id', $quest_id);
				$this->db->update(courses_questions, $data_rec);
				// // // // // // // // // // echo"<br>## x is $x field name is $var_question_text field value is {$_POST[$var_question_text]} "; 
				
			}
			// ###################################################################################################### 
			
			if ($_POST['return_to_list'] == "y") {
				redirect('/certify4/course_views/manage_key_lists_4');
			} else {
				$sql = "select * from ainf_vps3_code_manager where code_group = 'course_type' ";
				$data['course_types'] = $this->db->query($sql)->result_array();
				$this->course_views('update_course_detail');
			}
		} else {
				$sql = "select * from ainf_vps3_code_manager where code_group = 'course_type' ";
				$data['course_types'] = $this->db->query($sql)->result_array();
				$this->course_views('update_course_detail');
		}
		
	}

	public function question_edit()
	{
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		// // // // // // // // // // var_dump($data['sys_menu_tabs']);
		
		// ### !!! The for post is getting totally cleared when the file field for VIDEO_LINK is being loaded.. 
		// ### The for post is getting totally cleared when the file field is being loaded.. 
		// // // // // // // // // // // // // var_dump($_POST);
		error_reporting(0);
		
		$varcompid = $_POST['sess_compid'];
		
		
		if ($_POST['question_text'] != "") {
			// // // // // // // echo"<br>!!aa question IN ID IS {$_POST['id']}";
		
			$data_rec = array();
			$data_rec['question_text'] = $_POST['question_text'];
			$data_rec['answer_a'] = $_POST['answer_a'];
			$data_rec['answer_b'] = $_POST['answer_b'];
			$data_rec['answer_c'] = $_POST['answer_c'];
			$data_rec['answer_d'] = $_POST['answer_d'];
			$data_rec['answer_e'] = $_POST['answer_e'];
			
			//### IF ITS A KEYWORD FLAG - then load it into the keyword field 
			//### This keeps keywords standard and easier to load them 
			$data_rec['keywords'] = "";
			$key_count = 0;
			foreach ($_POST as $mKey => $mValue)
			{
				if (strpos($mKey, 'keyword_') !== false)
				{
					++$key_count;
					if ($key_count > 1) {$varcomma = ", ";} else {$varcomma = "";};
					$var_keyword = str_replace('keyword_','',$mKey);
					$var_keyword = str_replace('_',' ',$var_keyword);
					$data_rec['keywords'] .= $varcomma . $var_keyword;
				}
			}
			//### IF ITS A KEYWORD FLAG END
			
			if ($_POST['active']=="Y") {$data_rec['active']="Y";} else {$data_rec['active']="N";}
			if ($_POST['id'] != 0 and $_POST['update_question'] == "y") {
				// // // // // // echo"<br>!! aa at update";
				// // // // // // // // // // // var_dump($data_rec);
				$this->db->where('id', $_POST['id']);
				$this->db->update(courses_questions, $data_rec);
			} else {
				// // // // // // echo"<br>!! aa at insert";
				$this->db->insert(courses_questions, $data_rec);
				$_POST['id'] = $this->db->insert_id();
				// // // // // // echo"<br>!! aa from insert is id {$_POST['id']}";
				// // // // // // // var_dump($data_rec);
			}
			
			if ($_POST['id'] != "") {
				$sql = "select * from courses_questions where id = {$_POST['id']}";
				$data['question_edit'] = $this->db->query($sql)->result_array();
				// // // // // // // echo"<br>!!dd sql - $sql ";				$data['question_edit'] = $this->db->query($sql)->result_array();
			}
			// // // // // // // // var_dump($data['question_edit']);
			// ###################################################################################################### 
			
			if ($_POST['return_to_list'] == "y") {
				//### NEW SYSTEM MUST REDIRECT TO GET LOAD SYS TABLE AND TABS CORRECT
				redirect('/certify4/question_views/manage_key_lists_4');
				//### NEW SYSTEM MUST REDIRECT TO GET LOAD SYS TABLE AND TABS CORRECT
			} else {
				$this->load->view('update_question_detail', $data);
			}
		} else {
			if ($_POST['id'] != "") {
				$sql = "select * from courses_questions where id = {$_POST['id']}";
				$data['question_edit'] = $this->db->query($sql)->result_array();
			}
			// // // // // // // // var_dump($data['question_edit']);
			$this->load->view('update_question_detail', $data);
		}
		
	}
		
	public function question_views($video_page)
	{
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		// // // // // // // // // // var_dump($data['sys_menu_tabs']);
		
		// // // // // // // echo"<br>!! 111 BACK IN QUESTION VIEWS page is $video_page";
		
		$varcompid = $_POST['sess_compid'];
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		// // // // // // // echo"<br>!! 222 page is $video_page compid is $varcompid";
		
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'";
		$data['videos_full'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from courses_questions where compid = 0 and active = 'Y' and courses_id = 0";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		$sql = "select * from courses_questions where compid = 0 and active not in ('Y') and courses_id = 0";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		// // // // // // // // // var_dump($data['main_list_array']);

		if ($_POST['id'] != "") {
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid and id in (select vid_group_id from courses where id = {$_POST['id']})";
			$data['videos_course'] = $this->db->query($sql)->result_array();
			$sql = "select ainf_xcloud_videos.title, courses_questions.id, courses_questions.courses_id, courses_questions.question_order, courses_questions.question_text, courses_questions.answer_a, courses_questions.answer_b, courses_questions.answer_c, courses_questions.answer_d, courses_questions.answer_e, courses_questions.correct_answer_abcde 
			from courses_questions, ainf_xcloud_videos where ainf_xcloud_videos.id = question_video_id and 
			courses_questions.compid = $varcompid and courses_id = {$_POST['id']} order by question_order, courses_questions.id";
			// // // // // // // // // // echo"<br>!! sql is $sql";
			$data['question_list'] = $this->db->query($sql)->result_array();
			// // // // // // // // // // var_dump($data['question_list']);
		}
		
		if ($video_page == "update_course_detail") {
			// // // // // // // echo"<br>!!aa ";
			$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
			$data['vidbooks'] = $this->db->query($sql)->result_array();
			if ($_POST['id'] != "") {
				$sql = "select * from courses where id = {$_POST['id']} limit 0,1";
				$data['videdit'] = $this->db->query($sql)->result_array();
			}
			$this->load->view($video_page, $data);
			
		} elseif ($video_page == "manage_key_lists") {
			$sql = "select * from courses where compid = $varcompid and active in ('Y') order by id desc ";
			$data['course_list_active'] = $this->db->query($sql)->result_array();
			$sql = "select * from courses where compid = $varcompid  and active not in ('Y') order by id desc ";
			$data['course_list_inactive'] = $this->db->query($sql)->result_array();
			// // // // // // // echo"<br>!!bb ";
			$this->load->view($video_page, $data);
		} else { // ## $video_page == "manage_key_lists_3
			$sql = "select * from courses where compid = $varcompid and active in ('Y') order by id desc "; 
			$data['course_list_active'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from courses where compid = $varcompid  and active not in ('Y') order by id desc "; 
			$data['course_list_inactive'] = $this->db->query($sql)->result_array(); 
			$this->load->view($video_page, $data);
		}
	}

	public function course_views($video_page)
	{
				
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		
		$varcompid = $_POST['sess_compid'];
		// // // // // // echo "!!tt varcompid $varcompid";
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		if ($_POST['id'] != "") {
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid and id in (select vid_group_id from courses where id = {$_POST['id']})";
			$data['videos_course'] = $this->db->query($sql)->result_array();
			$sql = "select ainf_xcloud_videos.title, courses_questions.id, courses_questions.courses_id, courses_questions.question_order, courses_questions.question_text, courses_questions.answer_a, courses_questions.answer_b, courses_questions.answer_c, courses_questions.answer_d, courses_questions.answer_e, courses_questions.correct_answer_abcde 
			from courses_questions, ainf_xcloud_videos where ainf_xcloud_videos.id = question_video_id and 
			courses_questions.compid = $varcompid and courses_id = {$_POST['id']} order by question_order, courses_questions.id";
			// // // // // // // // // // echo"<br>!! sql is $sql";
			$data['question_list'] = $this->db->query($sql)->result_array();
			// // // // // // // // // // var_dump($data['question_list']);
		}
		
		if ($video_page == "update_course_detail") {
			$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
			$data['vidbooks'] = $this->db->query($sql)->result_array();
			$sql = "select * from ainf_vps3_code_manager where code_group = 'course_type' ";
			$data['course_types'] = $this->db->query($sql)->result_array();
			// // // // // // // var_dump($data['course_types']);
			
			if ($_POST['id'] != "") {
				$sql = "select * from courses where id = {$_POST['id']} limit 0,1";
				$data['videdit'] = $this->db->query($sql)->result_array();
			}
			$this->load->view($video_page, $data);
			
		} else {
			$video_page = "manage_key_lists_4";
			$sql = "select * from courses where compid = $varcompid and active in ('Y') order by id desc "; 
			$data['course_list_active'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from courses where compid = $varcompid  and active not in ('Y') order by id desc "; 
			$data['course_list_inactive'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from courses where compid = $varcompid and active in ('Y') order by id desc "; 
			$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from courses where compid = $varcompid and active in ('Y') and local_or_global = 'Global' order by id desc "; 
			$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from courses where compid = $varcompid  and active not in ('Y') order by id desc "; 
			$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 
			$this->load->view($video_page, $data);
		}
	}

}
	
