<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Website extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');			
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // //echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // //echo "!! must write other functions code for funciton $callfunction";
		}
	}

	public function webevent_edit()
	{

		// error_reporting(E_ALL);
		
		$varcompid = $_POST['sess_compid'];
		// //echo "<br>!!!000 We are here compid - $varcompid id is {$_POST['id']}";

		$varuploadimage = "";
		$targetPath = "/home/ebooksonline/public_html/churchofjesus.live/client_files/"; // correct path for infinity 
		$varurlpath = "https://churchofjesus.live/client_files/";
		

		if ($_POST['title'] != "") {
			
			$var_image_url = "";
			if($_FILES['image_url']['name']) {
				$upload=$_FILES['image_url']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('gif','jpg', 'png', 'jpeg');
				if(in_array($ext,$config['allowed_types'])) {
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = $varcompid . "_event_image_event_filed_on_" . $vardate . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						if (move_uploaded_file($_FILES['image_url']['tmp_name'], $targetPath . $targetFile)) {
							$varuploadurl = $varurlpath . $targetFile;
							$var_image_url = $varuploadurl;
						}
					} else {
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}
				} else {
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
				}
			} else {
				// // //echo "<br>!! The image_url is NOT set";
			}
			
			$data_rec = array();
			if ($var_image_url != "") {$data_rec['image_url'] = $var_image_url;}
			$data_rec['title'] = $_POST['title']; 
			$data_rec['date'] = $_POST['date'];
			$date_time = explode(" ",$_POST['date']);
			$date_time_parts = explode("/",$date_time[0]);
			$data_rec['date_sort'] = $date_time_parts[2] . "/" . $date_time_parts[1] . "/" . $date_time_parts[0] . " " . $date_time[1];
			$data_rec['leader'] = $_POST['leader']; $data_rec['event_tip'] = $_POST['event_tip'];
			$data_rec['details'] = $_POST['details'];
			$data_rec['event_tip'] = $_POST['event_tip']; $data_rec['leader'] = $_POST['leader'];
			$data_rec['duration_note'] = $_POST['duration_note']; $data_rec['address'] = $_POST['address'];
			$data_rec['contact_1'] = $_POST['contact_1']; $data_rec['contact_2'] = $_POST['contact_2'];
			if ($_POST['active']=="Y") {$data_rec['active']="Y";} else {$data_rec['active']="N";}
			
			if ($_POST['submit_delete'] == "y" and $_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->delete('events');
				$_POST['return_to_list'] = "y";
			} elseif ($_POST['submit_copy'] == "y" or $_POST['id'] == "" or $_POST['id'] == 0) {
				//echo "<br>!!!! doing copy here ";
				$data_rec['compid'] = $varcompid;
				if ($_POST['submit_copy'] == "y") {
					$data_rec['title'] = "This is a new copy - please edit it";
				}
				$this->db->insert('events', $data_rec);
				$_POST['id'] = $this->db->insert_id();
				if ($_POST['submit_copy'] == "y") {
					$_POST['return_to_list'] = "";
				}
			} elseif ($_POST['submit_update'] = "y" and $_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('events', $data_rec);
			}
			if ($_POST['submit_copy'] == "y") {
				$_POST['have_submit_copy'] = "y"; // ### ONLY ONE COPY OF RECORD - OR THEYLL GET LOST COPYING 
			}
			
			$sql = "select * from events where id = {$_POST['id']}"; 
			$data['eventedit'] = $this->db->query($sql)->result_array(); 
			// //echo "<br>!!44 In update sql - $sql ";
			
			If (isset($_POST['return_to_list']) and $_POST['return_to_list'] == "y") {
			// //echo "<br>!!551 ";
				$sql = "select * from events where compid = $varcompid ";
				$data['eventedit'] = $this->db->query($sql)->result_array();
			// //echo "<br>!!55b ";
				$this->events('manage_key_lists');
			} else {
			// //echo "<br>!!return to edit ";
				$sql = "select * from events where id = {$_POST['id']}";
				$data['eventedit'] = $this->db->query($sql)->result_array();
				// //echo "<br>!!55c ";
				$this->load->view('update_web_event', $data);
			}
		} else {
			$sql = "select * from events where id = {$_POST['id']}";
			$data['eventedit'] = $this->db->query($sql)->result_array();
			// //echo "<br>!!55c ";
			$this->load->view('update_web_event', $data);
		}

		
	}
	
	public function events($pagename)
	{
		
		error_reporting(0);
		$varcompid = $_POST['sess_compid'];

		if ($_POST['add_followup'] == "yes" or $_POST['add_followup2'] == "yes") {
			$this->follow_up_edit();
		}
		
		if ($pagename == "needcontact4") {
			$attendee_type = "needcontact4";
			$pagename = "attendees4";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		//#### AAA DDD #### !!! 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 

		//#### START FROM SUMMARY - BRINGING ANALYTICS INTO ONE FORM 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		// ### VISITORS ATTENDEES IN LAST WEEK 
		$new_visitors_date = date('Y/m/d', strtotime('-7 days')); 
		$var_search_event = "," . $_POST['id'] . ",";
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort > '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_new'] = $this->db->query($sql)->result_array();
		
		// ### REGULARS BEYOND LAST WEEK 
		$var_search_event = "," . $_POST['id'] . ","; 
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort < '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_regular'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		$var_this_year_month = date('Y/m');
		$sql = "select * from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct follup_for from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%'"; 
		$data['followups_distinct_users_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct follup_contact_type from teampro_follow_ups where follup_contact_type is not null and compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month_contact_type'] = $this->db->query($sql)->result_array(); 
		//#### END FROM SUMMARY - BRINGING ANALYTICS INTO ONE FORM 
		
		$varcompid = $_POST['sess_compid']; 

		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		//### KEY LISTING HERE 
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		$data['event_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from events where compid = $varcompid and active in ('N') order by date_sort desc";
		$data['event_list_inactive'] = $this->db->query($sql)->result_array();
		$sql = "select * from events where compid = $varcompid and active in ('Y') order by date_sort desc";
		$data['event_list_active'] = $this->db->query($sql)->result_array();
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid =  $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$varsql = "";
		if (isset($_POST['form_attendee_type']) and $_POST['form_attendee_type'] != "All" and $_POST['form_attendee_type'] != "") {
			$varsql = " and {$_POST['form_attendee_type']} = 'yes' "; // Allows variable range of items to be selected 
		}
		
		if ($attendee_type == "needcontact4") {
			$var_this_yr_month =  date("Y/m"); 
			// // // //echo "<br>!! yyy/mm - $var_this_yr_month"; 
			$sql = "select * from ainf_vps3_users where compid = $varcompid $varsql and userid not in (select follup_for from teampro_follow_ups where  follup_contact_date_sort like '%$var_this_yr_month%') order by first_name, last_name"; 
			$data['team_list'] = $this->db->query($sql)->result_array(); 
		} else {
			$sql = "select * from ainf_vps3_users where compid = $varcompid $varsql order by first_name, last_name";
			$data['team_list'] = $this->db->query($sql)->result_array();
		}

		$sql = "select * from ainf_xcloud_videos where compid = $varcompid order by message_date_sort desc "; 
		$sql = "select * from ainf_xcloud_videos order by message_date_sort desc "; 
		$data['vidlist'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		//## KEY LISTS FOR SUB LISTS  
		$var_start_date_sort_today = date('Y/m/d');
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and start_date_sort like '%$var_start_date_sort_today%' ";
		$data['visitors_today'] = $this->db->query($sql)->result_array();
		
		$var_start_date_sort_week = date('Y/m/d', strtotime('-8 days')); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and start_date_sort > 
		'$var_start_date_sort_week' order by start_date_sort desc";
		$data['visitors_week'] = $this->db->query($sql)->result_array();
		
		$var_start_date_sort_month = date('Y/m/d', strtotime('-31 days')); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and start_date_sort > 
		'$var_start_date_sort_month' order by start_date_sort desc"; 
		$data['visitors_month'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	
