<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
	class Appreciation4 extends CI_Controller { 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again.
			redirect('Ad_user_login_v4');
			// break;
		}

		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 

		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		error_reporting(0);
		$this->load->helper('url');
	}

	public function check_function()
	{
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // // // // // // // // // // // // echo  "!! must write other functions code for funciton $callfunction";
		}
	}

	public function edit_items()
	{
		
		error_reporting(0);
		$data_rec = array(); 
		// echo "<br>!! 00 id is {$_POST['id']} title is {$_POST['title']} ";
		if ($_POST['title'] != "") { 
			// echo "<br>!! 11 processing the edit"; 

			$data_rec['title'] = $_POST['title'];
			$data_rec['date'] = $_POST['date'];
			$data_recarray = explode('/',$_POST['date']);
			$data_rec['date_sort'] = $data_recarray[2] . "/" . $data_recarray[1] . "/" . $data_recarray[0];
			$data_rec['who_we_appreciate'] = $_POST['who_we_appreciate'];
			$data_rec['what_we_appreciate'] = $_POST['what_we_appreciate'];
			if ($_POST['id'] != "" and $_POST['id'] != "0") {
				$data_rec['title'] = $_POST['title'];
				$this->db->where('id', $_POST['id']); 
				$this->db->update('appreciation', $data_rec); 

			} else {

				$data_rec['compid'] = $_POST['sess_compid'];
				$this->db->insert('appreciation', $data_rec);
				$id = $this->db->insert_id();
				$_POST['id'] = $id;
			}
		}
			
		If ($_POST['return_to_list'] == "yes") { 
			redirect('/Appreciation4/listing/manage_key_lists_4'); // back to listing 
		} elseif ($_POST['mod_record'] == "yes" OR $_POST['id'] > 0) { // the id is always set from default record 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select b.first_name, b.last_name, b.mobile, b.email, b.userid, a.id, a.title, a.date_sort, a.date, a.who_we_appreciate, a.what_we_appreciate from appreciation a left join ainf_vps3_users b on a.who_we_appreciate = b.userid 
			where a.id = {$_POST['id']} "; 
			$data['edit_record'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from ainf_vps3_users where compid = {$_POST['sess_compid']} "; 
			$data['list_members'] = $this->db->query($sql)->result_array(); 
			// var_dump($data['edit_record']); 
			$this->load->view('update_appreciate', $data); 
		} else {
			// // echo "<br>!! 55 sql $sql id is {$_POST['id']} "; 
			$this->load->view('update_appreciate', $data); 
		}
		
	}

	public function listing($pagename)
	{
		
		// // echo "<br>!! 11 orig is $pagename_orig";
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;

		if ($login_message == "login") {
			$_POST['update_valid'] = "Welcome back to Church of Jesus";
		}
		error_reporting(0);
		// // echo "<br>!! 22 orig is $pagename_orig";
		$varcompid = $_POST['sess_compid'];
		
		if ($pagename == "needcontact4") {
			$attendee_type = "needcontact4";
			$pagename = "attendees4";
		}
		
		$var_this_year = date('Y');
		$var_start_jan = $var_this_year . "/01/01";
		$var_this_year_month = date('Y/m');

		$sql = "select b.first_name, b.last_name, b.userid, a.id, a.title, a.date_sort, a.who_we_appreciate from appreciation a left join ainf_vps3_users b on a.who_we_appreciate = b.userid 
		where a.date_sort like '%$var_this_year_month%' and a.compid = $varcompid "; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 
		foreach ($data['main_list_array_tab1'] as $z) {
			if ($z['first_name'] == "" and $z['who_we_appreciate'] == 0) {
				$z['first_name'] = "God";
			}
		}
		
		$sql = "select b.first_name, b.last_name, b.userid, a.id, a.title, a.date_sort, a.who_we_appreciate from appreciation a left join ainf_vps3_users b on a.who_we_appreciate = b.userid 
		where a.date_sort like '%$var_this_year%' and a.compid = $varcompid "; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 

		$sql = "select b.first_name, b.last_name, b.userid, a.id, a.title, a.date_sort, a.who_we_appreciate from appreciation a left join ainf_vps3_users b on a.who_we_appreciate = b.userid 
		where a.date_sort < '$var_start_jan' and a.compid = $varcompid "; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}
	public function summary($pagename)
	{
		
		error_reporting(0);
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		// NEW SECTION WITH VIDEOS 
		$var_this_yr_month =  date("Y/m"); // date ranges 
		$var_this_yr_start =  date("Y") . "/01/00"; // date ranges 
		$var_this_yr_month_end =  date("Y/m") . "/01"; // date ranges 

		$var_this_month = date('m');
		$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where message_date_sort like '%$var_this_yr_month%' and teacher_userid = ainf_vps3_users.userid and ainf_xcloud_videos.compid = $varcompid and video_type not in ('tract') and ainf_vps3_users.compid = $varcompid and ainf_xcloud_videos.active = 'Y' order by message_date_sort desc, first_name, last_name ";
		$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where message_date_sort like '%$var_this_yr_month%' and teacher_userid = ainf_vps3_users.userid and ainf_xcloud_videos.compid = $varcompid and video_type not in ('tract') and ainf_vps3_users.compid = $varcompid and ainf_xcloud_videos.active = 'Y' order by message_date_sort desc, first_name, last_name ";

		$data['videos_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from ainf_xcloud_videos, ainf_vps3_users where 
		message_date_sort > '$var_this_yr_start' and message_date_sort < '$var_this_yr_month_end' and teacher_userid = ainf_vps3_users.userid and ainf_xcloud_videos.compid = $varcompid and video_type not in ('tract') and ainf_vps3_users.compid = $varcompid and ainf_xcloud_videos.active = 'Y' order by message_date_sort desc, first_name, last_name ";
		$data['videos_rest_year'] = $this->db->query($sql)->result_array(); 

		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		// ### VISITORS ATTENDEES IN LAST WEEK 
		$new_visitors_date = date('Y/m/');
		$var_search_event = "," . $_POST['id'] . ",";
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%') and start_date_sort like '%$new_visitors_date%' order by start_date_sort desc";
		$data['event_attendees_new'] = $this->db->query($sql)->result_array();
		
		// ### REGULARS BEYOND LAST WEEK 
		$var_search_event = "," . $_POST['id'] . ","; 
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort < '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_regular'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		$var_this_year_month = date('Y/m');
		$sql = "select * from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct follup_for from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%'"; 
		// $sql = "select distinct follup_for from teampro_follow_ups where compid = $varcompid "; 
		$data['followups_distinct_users_month'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select distinct follup_contact_type from teampro_follow_ups where follup_contact_type is not null and compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month_contact_type'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}

}
	
