<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
 
class Biz_staff4 extends CI_Controller {
	// Rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();

		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START 
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // // // // // // // // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		}
	}
		
	public function generate_report_body()
	{

		// echo "<br>The report is {$_POST['report_name']} "; 
		// echo "<br>The timeframe is {$_POST['report_timing']} ";
		
		$var_sql_compid = " compid = {$_POST['sess_compid']} ";
		$var_year_sql = date('Y'); $var_month = date('m'); 
		$var_this_month_year_sql = "%" . $var_year_sql . "/" . $var_month . "/%"; 
		$var_this_year_sql = "%" . $var_year_sql . "/%"; 

		if ($_POST['report_name'] == "Tithe Report") {
		// echo "<br>11 aa ";
			if ($_POST['report_timing'] == "This Month") {
				$var_sql_date = " date_sort like '$var_this_month_year_sql' ";
			} elseif ($_POST['report_timing'] == "YTD") {
				$var_sql_date = " date_sort like '$var_this_year_sql' ";
			}
			$sql = "select * from aa_time_items where $var_sql_compid and active = 'Y' and $var_sql_date order by date_sort desc, dep_or_pay, title"; 
			// // echo "<br>!!77 sql $sql"; 
			$var_tithe_data = $this->db->query($sql)->result_array(); 
			// var_dump($var_tithe_data); 
		// echo "<br>11 bb ";
			
			// #### PROCESS THE SQL INTO EMAIL BODY FORMAT 
			$var_html_result = $var_tithe_data;
		} else {
			if ($_POST['report_timing'] == "This Month") {
				$var_sql_date = " start_date_sort like '$var_this_month_year_sql' ";
			} elseif ($_POST['report_timing'] == "YTD") {
				$var_sql_date = " start_date_sort like '$var_this_year_sql' ";
			}
			
			// echo "<br>11 cc "; 
			$sql = "select * from inf_vps3_users where $var_sql_compid and active = 'Y' and $var_sql_date order by start_date_sort desc "; 
			// echo "<br> 22 dd sql $sql "; 
			
			// $var_user_data = $this->db->query($sql)->result_array(); 
			// var_dump($var_user_data);
			
			// #### PROCESS THE SQL INTO EMAIL BODY FORMAT 
			$var_html_result = $var_user_data;
		}
		// echo "<br>11 dd ";

		return $var_html_result;
		
	}

	public function send_email($action_type) 
	{ 

		// ############# NEW PRAYERS CODE ############# 
		$var_userid = $this->session->userdata('userid'); 
		$varcompid = $_POST['sess_compid']; 
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs(); 
		$key_table = "ainf_xmodule2_profiles"; 
		$key_table = "aa_time_items"; 
		
		$var_year_sql = date('Y'); $var_month = date('m'); 
		$var_this_month_year_sql = "%" . $var_year_sql . "/" . $var_month . "/%"; 
		$var_this_year_sql = "%" . $var_year_sql . "/%"; 

		if ($_POST['report_name'] != "" or $_POST['report_name'] != "") {
				$var_email_body = $this->generate_report_body(); 
				// // echo "<br>!! 11 Sent email to $var_toemail "; 
				if ($_POST['email_default'] != "" or $_POST['email_other'] != "") {
				$var_toemail = $_POST['email_default']; 
				// echo "<br>!! 22 Sent email to $var_toemail "; 

				$to      = $_POST['email_default'];
				$to      = 'max.emberson@yahoo.com.au';
				
				if (1==1) {  
					
					$to = $x['email'];
					$to = 'max.emb@gmail.com'; 
					$to = 'max.emberson@yahoo.com.au'; 
					
					// echo "<br>To email is $to";
					$subject = '10 E-Books for $9.99 July Promotion. Read Now.'; 
					$message = "Hi Friend, " . "\r\n\r\n" . 
					"Do click for our latest range of ebooks at incredible promotional prices." . "\r\n\r\n" . 
					"We have bundled ebook packages of 8 Cooking & Nutrition books for $9.99" . "\r\n\r\n" . 
					"We have bundled ebook packages of 8 Healthy Workout books for $9.99" . "\r\n\r\n" . 
					"Best Regards, Shop ebooks" . "\r\n";
					$headers = 'From: sales@ebooksonline.live' . "\r\n" .
						'Reply-To: max.emb@gmail.com' . "\r\n" .
						'X-Mailer: PHP/' . phpversion();
					if (strpos($_SERVER['SERVER_NAME'], "localhost") === false) { 
						// echo "<br>!! 777 Sent email to $to "; 
						mail($to, $subject, $message, $headers);
					}
					$var_stats .= "<br>Sent to $to - sent_num = $sent_num";
				} else {
					//$to      = 'max.emb@gmail.com';
					
					$subject = "Church of Jesus {$_POST['report_name']} Report, With a Time Period of {$_POST['report_timing']} ";
					$message = "Hello, " . "\r\n" . "\r\n" . "The report details are listed below." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team."; 
					$headers = 'From: sales@ebooksonline.live' . "\r\n" .
				
						'Reply-To: max.emb@gmail.com' . "\r\n" .
						'Cc: max.emb@gmail.com' . "\r\n" .
						'X-Mailer: PHP/' . phpversion();
						
						if (strpos($_SERVER['SERVER_NAME'], "localhost") === false) { 
							mail($to, $subject, $message, $headers); 
							// echo "Email sent to hard coded yahoo to = $to"; 
						}
					
						$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
						// echo "<br>!! 33 URI IS {$_SERVER['SERVER_NAME']} sent email to $var_toemail "; 
				}
			} else {
				// echo "No submit as email NOT SET"; 
			}
		} else {
			// echo "No submit of form";
		}

		// ### THIS YEAR 
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Email Reports' order by code_name"; 
		$data['report_list'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Report Time Period' order by code_name"; 
		$data['report_timing'] = $this->db->query($sql)->result_array(); 
		
		// var_dump($data['main_list_array_tab2']); 
		$this->load->view('send_email_form.php', $data); 

	}
	
	public function reports($reportpage)
	{

		// error_reporting(0);
		//############# NEW PRAYERS CODE #############
		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$key_table = "ainf_xmodule2_profiles";
		$key_table = "aa_time_items";
		
		$var_year_sql = date('Y');
		$var_month = date('m');
		$var_this_month_year_sql = "%" . $var_year_sql . "/" . $var_month . "/%";
		$var_this_year_sql = "%" . $var_year_sql . "/%";
		
		// ### THIS MONTH 
		$sql = "select * from aa_time_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_month_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();
		// var_dump($data['main_list_array_tab1']);

		// ### THIS YEAR 
		$sql = "select * from aa_time_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_sort desc, dep_or_pay, title"; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		// var_dump($data['main_list_array_tab2']);
		$this->load->view('reports-fin-dep-lon.php', $data);

	}

	public function biz_file_upload() {
		
		if ($_FILES['skill_1_cert_url-front_load']['name']) {
			$targetPath = "/home/bizadmin/churchofjesus.live/files_biz_skills/"; // correct path for infinity
			$varurlpath = "https://jesusonline.live/files_biz_skills/";
			$upload=$_FILES['skill_1_cert_url-front_load']['name'];
			$ext=end(explode('.',$upload));
			$config['allowed_types'] = array('jpg','jpeg', 'png', 'wmf', 'emf', 'webp');
			if(1==1 or in_array($ext,$config['allowed_types'])) {
				// $upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
				$vardate = date("Y-m-d-H-m-s");
				$targetFile = $varcompid . "_receipts_" . $vardate . "." . $ext;
				if (1==1 or is_dir($targetPath)and is_writable($targetPath)) {
					if (move_uploaded_file($_FILES['skill_1_cert_url-front_load']['tmp_name'], $targetPath . $targetFile)) {
						$data_rec['pay_receipt_url'] = $varurlpath . $targetFile; 
						// // // // echo"<br>!! <b>file is {$data_rec['pay_receipt_url']} </b>"; 
					}
				} else {
					$err = "The path target or dir $targetPath or NOT WRITABLE";
				}
			}
		}
	}

	public function biz_staff_item_edit()
	{

		//############# NEW PRAYERS CODE #############
		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$key_table = "ainf_vps3_users";

		if ($_POST['add_record'] == "yes") {
			$_POST['userid'] = 0; // value set from listing 
		} elseif ($_POST['userid'] > 0) {
			$_POST['userid'] = $_POST['userid']; // value set from listing 
		}
		
		if (isset($_POST['first_name'])) {
			$data_rec = array();

			$data_rec['first_name'] = $_POST['first_name'];
			$data_rec['last_name'] = $_POST['last_name'];
			$data_rec['email'] = $_POST['email'];
			$data_rec['mobile'] = $_POST['mobile'];
			$data_rec['soc_fb'] = $_POST['soc_fb'];
			$data_rec['soc_tw'] = $_POST['soc_tw'];
			$data_rec['user_type'] = $_POST['user_type'];
			// ## Skills for workers 
			if ($data_rec['user_type'] == "Worker") {
				$data_rec['skill_1_work_id'] = $_POST['skill_1_work_id'];
				$data_rec['skill_1_cert_name'] = $_POST['skill_1_cert_name'];
				$data_rec['skill_1_cert_id'] = $_POST['skill_1_cert_id'];
				$data_rec['skill_1_cert_expiry_date'] = $_POST['skill_1_cert_expiry_date'];
				if ($data_rec['skill_1_cert_expiry_date'] != "") {
					$date_array = explode("/",$data_rec['skill_1_cert_expiry_date']);
					$data_rec['skill_1_cert_expiry_date_sort'] = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0];
				}
				$data_rec['skill_1_cert_url-front'] = $_POST['skill_1_cert_url-front'];
				$data_rec['skill_1_cert_url-back'] = $_POST['skill_1_cert_url-back'];
				if ($_FILES['skill_1_cert_url-front_load']['name']) { $data_rec['skill_1_cert_url-front'] = $this->biz_file_upload(); }
				if ($_FILES['skill_1_cert_url-back_load']['name']) { $data_rec['skill_1_cert_url-back'] = $this->biz_file_upload(); }

				$data_rec['skill_2_work_id'] = $_POST['skill_2_work_id'];
				$data_rec['skill_2_cert_name'] = $_POST['skill_2_cert_name'];
				$data_rec['skill_2_cert_id'] = $_POST['skill_2_cert_id'];
				$data_rec['skill_2_cert_expiry_date'] = $_POST['skill_2_cert_expiry_date']; 
				if ($data_rec['skill_2_cert_expiry_date'] != "") {
					$date_array = explode("/",$data_rec['skill_2_cert_expiry_date']);
					$data_rec['skill_2_cert_expiry_date_sort'] = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0];
				}
				$data_rec['skill_2_cert_url-front'] = $_POST['skill_2_cert_url-front'];
				$data_rec['skill_2_cert_url-back'] = $_POST['skill_2_cert_url-back'];

				$data_rec['skill_3_work_id'] = $_POST['skill_3_work_id'];
				$data_rec['skill_3_cert_name'] = $_POST['skill_3_cert_name'];
				$data_rec['skill_3_cert_id'] = $_POST['skill_3_cert_id'];
				$data_rec['skill_3_cert_expiry_date'] = $_POST['skill_3_cert_expiry_date'];
				if ($data_rec['skill_3_cert_expiry_date'] != "") {
					$date_array = explode("/",$data_rec['skill_3_cert_expiry_date']);
					$data_rec['skill_3_cert_expiry_date_sort'] = $date_array[2] . "/" . $date_array[1] . "/" . $date_array[0];
				}
				$data_rec['skill_3_cert_url-front'] = $_POST['skill_3_cert_url-front'];
				$data_rec['skill_3_cert_url-back'] = $_POST['skill_3_cert_url-back'];
			}
			
			if ($_POST['password_confirm'] != "" and $_POST['password_confirm'] == $_POST['password']) {
				$data_rec['password'] = sha1(trim($_POST['password']));
			}
			
			// var_dump($data_rec);
			
			if ($_POST['userid'] != 0 and $_POST['userid'] != "") {
				$this->db->where('userid', $_POST['userid']); 
				$this->db->update($key_table, $data_rec); 
				
			} else {

				If ($POST['userid'] == 819) {
					// echo "<br>!!! This is Maximum";
				} elseif ($data_rec['user_type'] == "Biz_Staff") {
					$data_rec['user_access_new'] = "Biz_System_Admin";
					$data_rec['proteam_access'] = "Biz_System_Admin";
				} elseif ($data_rec['user_type'] == "Worker") {
					$data_rec['user_access_new'] = "Biz_System_User";
					$data_rec['proteam_access'] = "Biz_System_User";
				}
					
				if ($_POST['sess_compid'] != "") { //#### SET THIS ONCE 
					$data_rec['compid'] = $_POST['sess_compid'];
				}
				$this->db->insert($key_table, $data_rec);
				$userid = $this->db->insert_id();
				$_POST['userid'] = $userid;
			}
		}
		
		if ($_POST['return_to_list'] == "yes") {
			redirect('/Biz_staff4/listing/manage_key_lists_4'); 
		} else {
			//############# RUN QUERIES FOR THE SCREEN ############# 
			$sql = "select * from ainf_xmodule2 where active = 'D' order by module_order_tot"; 
			$data['modules_dev'] = $this->db->query($sql)->result_array(); 

			$sql = "select * from aaaa_biz_work_rates where compid = $varcompid and active = 'Y' order by work_type";
			$data['work_rates_list'] = $this->db->query($sql)->result_array();
		
			if (trim($_POST['userid']) != "0" and $_POST['userid'] != "") {
				$sql = "select * from $key_table where userid = {$_POST['userid']} "; 
				$data['edit_rec'] = $this->db->query($sql)->result_array(); 
				//############# NEW PRAYERS CODE ############# 
				$this->load->view('biz_staff_my_account.php', $data); 
			} else {
				$_POST['userid'] = 0;
				// $this->load->view('update_profile.php', $data);
				$this->load->view('biz_staff_my_account.php', $data);
			}
		}
	}
	
	public function listing($pagename)
	{
		// Get page name for the link
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		//### DEPOSIT ACTIVE 
		$var_year_sql = date('Y');
		$var_month = date('m');
		$var_this_month_year_sql = "%" . $var_year_sql . "/" . $var_month . "/%";
		$var_this_year_sql = "%" . $var_year_sql . "/%";
		$var_prev_year_sql = $var_year_sql . "/01/01";
		
		// ### THIS MONTH 
		$sql = "select * from aaaa_biz_companies where compid = $varcompid and active = 'Y' and date_sort like '$var_this_month_year_sql' order by date_sort desc, dep_or_pay, title"; 
		$sql = "select * from aaaa_biz_companies where active = 'Y' order by biz_comp_name "; 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and user_type = 'Biz_Staff' order by first_name, last_name "; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 

		// ### THIS YEAR 
		$sql = "select * from aaaa_biz_companies where active = 'N' order by biz_comp_name "; 
		$sql = "select * from ainf_vps3_users where compid = $varcompid and user_type = 'Worker' order by first_name, last_name "; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();
		
		//### DEPOSIT INACTIVE 
		$sql = "select * from ainf_xmodule2_profiles order by profile_name"; 
		$sql = "select * from aa_time_items where compid = $varcompid and active = 'Y' and date_sort < '$var_prev_year_sql' order by date_sort desc, dep_or_pay, title"; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			// // echo"<br>!! list ff 44 ";
			$this->load->view($pagename_orig, $data);
		} else {
			// // echo"<br>!! list ff 55 ";
			$this->load->view($pagename_orig, $data);
		}
	}
	
	public function summary($pagename)
	{
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		//### DEPOSIT ACTIVE 
		$var_year_sql = date('Y');
		$var_month = date('m');
		$var_this_month_year_sql = "%" . $var_year_sql . "/" . $var_month . "/%";
		$var_this_year_sql = "%" . $var_year_sql . "/%";
		
		// ### THIS MONTH 
		$sql = "select * from aa_time_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_month_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();

		// ### THIS YEAR 
		$sql = "select * from aa_time_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();

		$sql = "select * from aa_time_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['ytd_dep_pay_list_by_date'] = $this->db->query($sql)->result_array();

		// ### MONTHS LIST ### 
		$sql = "select distinct date_month, date_year from aa_time_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_year desc, date_month desc "; 
		$data['months_list'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			// // echo"<br>!! list ff 44 ";
			$this->load->view($pagename_orig, $data);
		} else {
			// // echo"<br>!! list ff 55 ";
			$this->load->view($pagename_orig, $data);
		}
	}

}
