<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Checklists extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // echo "!! must write other functions code for funciton $callfunction";
		}
		////var_dump($_POST);
	}	

	function process_get_checklist()
	{
		// $compid = $this->session->userdata('compid');
		if (1==1) {
			// Add any new checklists 
			if (isset($_POST['checklist_item_add1']) and trim($_POST['checklist_item_add1']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add1']);
				$this->db->insert('edu_checklist', $inscheck);
			}
			if (isset($_POST['checklist_item_add2']) and trim($_POST['checklist_item_add2']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add2']);
				$this->db->insert('edu_checklist', $inscheck);
			}
		}

		$q = $this->db->query("select * FROM edu_checklist");
		$data = $q->result_array();
		return($data);
	} 

	public function edit_account() // GOOD KEEP 
	{

		// ### DECIDE WHAT TYPE OF RECORD TO RELOAD BEST TABS 
		if ($_POST['list_tab'] == "") {
			$_POST['list_tab'] = "allp";
		}

		$varcompid = $_POST['sess_compid'];

		if (isset($_POST['first_name'])) {
			$data_rec = array();
			$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name'];
			$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email'];
			$data_rec['team_connect_group'] = $_POST['team_connect_group'];
			$this->db->where('userid', $_POST['sess_userid']);
			$this->db->update('ainf_vps3_users', $data_rec);
		}

		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'active_filters' order by code_id";
		$data['active_filters'] = $this->db->query($sql)->result_array();

		$sql = "select * from ainf_vps3_users where userid = {$_POST['userid']}";
		$data['user_profile'] = $this->db->query($sql)->result_array();
		
		$varsql = "";
		if (isset($_POST['form_active']) and $_POST['form_active'] != "") {
			if ($_POST['form_active'] == "Active") {
				$varsql = " active = 'yes' and ";
			} elseif ($_POST['form_active'] == "Active & Incomplete") {
				$varsql = " active = 'yes' and pri_comp_level < 100 and ";
			} elseif ($_POST['form_active'] == "Inactive") {
				$varsql = " active = 'no' and ";
			}
		} else { // set the filter to default values 
			$varsql = " active = 'yes' and "; 
		}
		
		if ($_POST['form_code_group'] != "") { $var_sql = " and code_group = '{$_POST['form_code_group']}' "; } else  { $var_sql = " "; }
		$sql = "select * from priority_list where $varsql pri_userid = {$_POST['sess_userid']} and pri_group not in ('NA') order by pri_group, pri_seq, pri_title";
		$data['pri_list'] = $this->db->query($sql)->result_array();
		
		if ($_POST['form_code_group'] != "") { $var_sql = " and code_group = '{$_POST['form_code_group']}' "; } else  { $var_sql = " "; }
		$sql = "select * from priority_list where $varsql pri_userid = {$_POST['sess_userid']} and pri_group not in ('NA') and pri_seq in (1,2) order by pri_group, pri_seq, pri_title";
		$data['pri_p1_p2_list'] = $this->db->query($sql)->result_array();
		
		if ($_POST['form_code_group'] != "") { $var_sql = " and code_group = '{$_POST['form_code_group']}' "; } else  { $var_sql = " "; }
		$sql = "select * from priority_list where $varsql pri_userid = {$_POST['sess_userid']} and check_group not in ('NA') order by check_group, pri_seq, pri_title";
		$data['check_list'] = $this->db->query($sql)->result_array();
		$this->load->view('manage_key_lists', $data);
	}

	public function priority_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "priority_list";
		
		if (isset($_POST['pri_title'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']);
			unset($data_rec['MAX_FILE_SIZE']);
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if($data_rec['pri_group_add'] != "") {$data_rec['pri_group'] = $data_rec['pri_group_add'];}
			
			if($data_rec['check_group_add'] != "") {$data_rec['check_group'] = $data_rec['check_group_add'];}

			$data_rec['pri_userid'] = $_POST['sess_userid'];
			
			if ($data_rec['pri_group'] != "NA") {
				$data_rec['check_group'] = "NA";
			} else {
				$data_rec['pri_group'] = "NA";
			}

			unset($data_rec['pri_group_add']);
			unset($data_rec['check_group_add']);
			$data_rec['pri_userid'] = $_POST['sess_userid'];
			if (isset($_POST['active']) and $_POST['active'] == "yes") {$data_rec['active'] = "yes";} else {$data_rec['active'] = "no";}
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
				$id = $_POST['id'];
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}
			
			// ### WHAT TYPE OF REC TO RELOAD BEST TABS 
			if ($_POST['pri_group_add'] != "" or $_POST['pri_group'] != "NA") {
				if ($_POST['pri_seq'] != "1" and $_POST['pri_seq'] != "2") {
						$_POST['list_tab'] = "allp";
					} else {
						$_POST['list_tab'] = "p1p2";
					}
			} else {
				$_POST['list_tab'] = "checklist";
			}
		}
		
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'repeat_rate' order by code_id";
		$data['repeat_list'] = $this->db->query($sql)->result_array();
		$sql = "select distinct pri_group from $varmain_table where pri_userid = {$_POST['sess_userid']} order by pri_group";
		$data['priority_groups'] = $this->db->query($sql)->result_array();
		$sql = "select distinct check_group from $varmain_table where pri_userid = {$_POST['sess_userid']} order by check_group"; 
		$data['checklist_groups'] = $this->db->query($sql)->result_array(); 

		if ($_POST['id'] > 0 or $_POST['id'] != "") { // the id is always set from default meeting
			$id = $_POST['id'];
		}

		If ($_POST['return_to_list'] == "yes") {
			$this->edit_account(manage_key_lists);
		} elseif ($id > 0 or $id > 0) { // the id is always set from default meeting 
			$sql = "select * from $varmain_table where id = $id";
			$data['edit_priority'] = $this->db->query($sql)->result_array();
			$this->load->view('update_priority', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_priority', $data);
		}
	}
		
	public function personal($pagename)
	{
	
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - 		
		$varcompid = $_POST['sess_compid'];		
		$var_search = "";
		
		// Process the form filter 
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		$data['events'] = $this->db->query($sql)->result_array();
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$sql = "select * from ainf_xcloud_videos, mentor_series where video_series = mentor_series.id order by video_order";
		$data['messages'] = $this->db->query($sql)->result_array();
		
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		// !!! THIS IS THE NEW CODE TO BEGIN USING THE ainf_xcloud_videos TABLE AS IT HAS ALL THE DATA 
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$varfixed_comp = 114;
		$sql = "select * from ainf_xcloud_videos, speakers where  ainf_xcloud_videos.compid = $varfixed_comp and video_trainerid = speakers.id order by video_order";
		
		// exit;
										
		$var_search = "";
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_series'] = "";
		}
		if ($_POST['form_series'] != "") {
			$var_search .= " and video_series = '{$_POST['form_series']}' ";
		}
		
		if ($_POST['form_archive'] != "" and $_POST['form_archive'] != "all") {
			$var_search .= " and v.archive = '{$_POST['form_archive']}' ";
		}

		//### LEFT JOIN SQL
		$sql = "SELECT v.compid, v.id as id, v.archive as archive, video_name, v.video_link, teaser, video_writeup, series_title FROM ainf_xcloud_videos v LEFT JOIN mentor_series m ON v.video_series = m.id where v.compid = $varcompid $var_search";
		$data['messages'] = $this->db->query($sql)->result_array();

		if (!isset($_POST['form_archive']) or $_POST['form_archive'] == "") { // Starting value to all
			$_POST['form_archive'] = "all";
		}

		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'archive_values' order by code_id desc";
		$data['archive_list'] = $this->db->query($sql)->result_array();

		if ($_POST['form_series'] != "" and $_POST['form_series'] != 0) {
			$sql = "select * from mentor_series where id = {$_POST['form_series']}";
			$data['series_header'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select distinct teacher from ainf_xcloud_videos where compid = $varcompid $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid = $varcompid order by book";
		$data['books'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid = $varcompid order by code_id";
		$data['services'] = $this->db->query($sql)->result_array();

		$sql = "select * from mentor_series where compid = $varcompid order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 
				
		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason

		$data['eunit_checklist'] = $this->process_get_checklist(); // load the checklist items
		// //var_dump($data['eunit_checklist']);
		
		//### list qrys
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid and id  in (select video_series from ainf_xcloud_videos) order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();

		$var_mastercompid = 113;
		$sql = "select distinct code_group from ainf_vps3_code_manager where mastercompid = $var_mastercompid order by code_group, code_name";
		$data['code_group_list'] = $this->db->query($sql)->result_array();

		$var_mastercompid = 113;
		if ($_POST['form_code_group'] != "") { $var_sql = " and code_group = '{$_POST['form_code_group']}' "; } else  { $var_sql = " "; }
		$sql = "select * from ainf_vps3_code_manager where mastercompid = $var_mastercompid $var_sql order by code_group, code_name";
		$data['codes_list'] = $this->db->query($sql)->result_array();

		$var_mastercompid = 113;
		if ($_POST['form_code_group'] != "") { $var_sql = " and code_group = '{$_POST['form_code_group']}' "; } else  { $var_sql = " "; }
		$sql = "select * from priority_list where compid = $varcompid order by pri_group, pri_seq, pri_title";
		$data['priority_list'] = $this->db->query($sql)->result_array();

		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	