<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Codes extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}

		$this->load->model('Unsett_array'); //### FOR MENUS AND TABS 
		
		$this->load->helper('html');
		$this->load->model('Smscurlapi');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');			
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // // // // // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // // // echo "!! must write other functions code for funciton $callfunction";
		}
	}

	public function edit_driver() {

		if ($_POST['cron_rec_num'] != "" and $_POST['update_params'] == "yes") { 
			$data_rec = array(); 
			// // // echo "<br>!!! UPDATE PARAMS "; 
			$data_rec['cron_rec_num'] = $_POST['cron_rec_num']; 
			$data_rec['cron_time_start'] = $_POST['cron_time_start']; 
			$data_rec['cron_time_end'] = $_POST['cron_time_end']; 
			if ($_POST['id'] != 0) { 
				$this->db->where('id', $_POST['id']);
				$this->db->update('aaa_data_params', $data_rec);
			}
		}
		
		// if ($_POST['confirm_delete_logs'] == "yes" and $_POST['confirm_delete_logs'] == "yes") {
		if ($_POST['confirm_delete_logs'] == "yes") {
			$this->db->empty_table('aaa_data_logs');
		}
		
		redirect('codes/summary/data-analytics-v8');
		
	}
	
	public function summary($pagename)
	{
		
		// // // echo "<br>!!11 ";
		error_reporting(0);
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];

		// PARAM REC 
		// // // echo "<br>!!22 "; 
		$sql = "select * from aaa_data_params"; 
		$data['drive_loadup'] = $this->db->query($sql)->result_array(); 
		// // // echo "<br>!!33 ";
		// var_dump($data['drive_loadup']); 

		// MAIN SQLS FOR AUSTRALIA 
		$sql = "select * from aaa_data_logs order by status, date_end_sort limit 0,30 "; // compid_group allows for users going to multiple churches 
		$data['recent_logs'] = $this->db->query($sql)->result_array(); 

		// MAIN SQLS FOR AUSTRALIA 
		$sql = "select count(id) from aaa_oz_v2 where state not in ('State') order by state"; // compid_group allows for users going to multiple churches 
		$data['total_oz'] = $this->db->query($sql)->result_array(); 
		
		// // // echo "<br>!!22";
		if (1==2) {
		$sql = "select state from aaa_oz_v2 where state in ('VIC','vic','Vic') "; // compid_group allows for users going to multiple churches 
		$data['total_state_vic'] = $this->db->query($sql)->result_array(); 
		$sql = "select count(id) from aaa_oz_v2 where state in ('NSW','nsw','Nsw') "; // compid_group allows for users going to multiple churches 
		$data['total_state_nsw'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('QLD','qld','Qld') "; // compid_group allows for users going to multiple churches 
			$data['total_state_qld'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('SA','sa','Sa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_sa'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('WA','wa','Wa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_wa'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('WA','wa','Wa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_wa'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('NT','nt','Nt') "; // compid_group allows for users going to multiple churches 
			$data['total_state_nt'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('ACT','act','Act') "; // compid_group allows for users going to multiple churches 
			$data['total_state_act'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state in ('TAS','tas','Tas') "; // compid_group allows for users going to multiple churches 
			$data['total_state_tas'] = $this->db->query($sql)->result_array(); 
			$sql = "select select count(id) from aaa_oz_v2 where state not in ('State','NSW','VIC','QLD','SA','WA','NT','ACT','TAS') "; // compid_group allows for users going to multiple churches 
			$data['total_state_other'] = $this->db->query($sql)->result_array(); 
			$var_full_count = count($data['total_oz']); 
		}
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		// ### VISITORS ATTENDEES IN LAST WEEK 
		$new_visitors_date = date('Y/m/d', strtotime('-7 days')); 
		$var_search_event = "," . $_POST['id'] . ",";
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort > '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_new'] = $this->db->query($sql)->result_array();
		
		// ### REGULARS BEYOND LAST WEEK 
		$var_search_event = "," . $_POST['id'] . ","; 
		$sql = "select userid, first_name, last_name, compid, events_attended, start_date, start_date_sort from ainf_vps3_users where (compid = $varcompid or compid_group  like '%,$varcompid,%') and start_date_sort < '$new_visitors_date' order by start_date_sort desc"; 
		$data['event_attendees_regular'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}

	public function details($pagename)
	{
	
		// // echo "<br>!! 11";
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // // // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];		
		$var_search = "";
		
		// Process the form filter 
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		// // echo "<br>!! 22";
		
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		$data['events'] = $this->db->query($sql)->result_array();
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$sql = "select * from ainf_xcloud_videos, mentor_series where video_series = mentor_series.id order by video_order";
		$data['messages'] = $this->db->query($sql)->result_array();
		// //var_dump($data['messages']);
		
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		// !!! THIS IS THE NEW CODE TO BEGIN USING THE ainf_xcloud_videos TABLE AS IT HAS ALL THE DATA 
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$varfixed_comp = 114;
		$sql = "select * from ainf_xcloud_videos, speakers where  ainf_xcloud_videos.compid = $varfixed_comp and video_trainerid = speakers.id order by video_order";
		
		// // echo "<br>!! 33";
		
		$var_search = "";
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_series'] = "";
		}
		if ($_POST['form_series'] != "") {
			$var_search .= " and video_series = '{$_POST['form_series']}' ";
		}
		
		if ($_POST['form_archive'] != "" and $_POST['form_archive'] != "all") {
			$var_search .= " and v.archive = '{$_POST['form_archive']}' ";
		}

		//### LEFT JOIN SQL
		$sql = "SELECT v.compid, v.id as id, v.archive as archive, video_name, v.video_link, teaser, video_writeup, series_title FROM ainf_xcloud_videos v LEFT JOIN mentor_series m ON v.video_series = m.id where v.compid = $varcompid $var_search";
		$data['messages'] = $this->db->query($sql)->result_array();

		if (!isset($_POST['form_archive']) or $_POST['form_archive'] == "") { // Starting value to all
			$_POST['form_archive'] = "all";
		}

 		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'archive_values' order by code_id desc";
		$data['archive_list'] = $this->db->query($sql)->result_array();

		if ($_POST['form_series'] != "" and $_POST['form_series'] != 0) {
			$sql = "select * from mentor_series where id = {$_POST['form_series']}";
			$data['series_header'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select distinct teacher from ainf_xcloud_videos where compid = $varcompid $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid = $varcompid order by book";
		$data['books'] = $this->db->query($sql)->result_array();
		
		// // echo "<br>!! 44";
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid = $varcompid order by code_id";
		$data['services'] = $this->db->query($sql)->result_array();

		// // echo "<br>!! 44 b";
		$sql = "select * from mentor_series where compid = $varcompid order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array();
		
		// // echo "<br>!! 44 c";
		
		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		// // echo "<br>!! 44 d";
		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 
				
		// // echo "<br>!! 44 e";
		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason

		// // echo "<br>!! 44 f";
		// $data['eunit_checklist'] = $this->process_get_checklist(); // load the checklist items
		// //var_dump($data['eunit_checklist']);
		
		//### list qrys
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid and id  in (select video_series from ainf_xcloud_videos) order by series_title";
		// // echo "<br>!!aa sql $sql";
		
		$data['list_series'] = $this->db->query($sql)->result_array();

		// // echo "<br>!! 44 g";
		$var_mastercompid = 113;
		$sql = "select distinct code_group from ainf_vps3_code_manager where mastercompid = $var_mastercompid order by code_group";
		$data['code_group_list'] = $this->db->query($sql)->result_array();

		$var_mastercompid = 113;
		if ($_POST['form_code_group'] != "")
			{$var_sql = " and code_group = '{$_POST['form_code_group']}' ";}
		elseif ($_POST['code_group'] != "")
			{$var_sql = " and code_group = '{$_POST['code_group']}' ";
			$_POST['form_code_group'] = $_POST['code_group'];
			}
		else  
			{$var_sql = " ";}
		
		// ### this old code line is very buggy $sql = "select * from ainf_vps3_code_manager where mastercompid = $var_mastercompid $var_sql order by code_group, code_name";
		$sql = "select * from ainf_vps3_code_manager where code_group is not null $var_sql order by code_group, code_name";
		$data['codes_list'] = $this->db->query($sql)->result_array();

		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
	}

	public function codes_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_vps3_code_manager";
		
		if (isset($_POST['code_group'])) {
			$data_rec = array();

			// $data_rec = $_POST; 
			// $data_rec = $this->Unsett_array->clear_sess_array($data_rec); // ### MODEL CLEARS POST/DATA ARRAY OF SESS DATA
			
			$data_rec['code_group'] = $_POST['code_group'];
			$data_rec['code_name'] = $_POST['code_name'];
			$data_rec['code1'] = $_POST['code1'];
			$data_rec['code2'] = $_POST['code2'];
			
			if ($_POST['code_id'] != 0) {
				$this->db->where('code_id', $_POST['code_id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$var_mastercompid = 113;
				$data_rec['mastercompid'] = $var_mastercompid;
				// var_dump($data_rec);
				$this->db->insert($varmain_table, $data_rec);
				$code_id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
				
		If ($_POST['return_to_list'] == "yes") {
			$this->details(codes_manager);
		} elseif ($_POST['code_id'] > 0 or $code_id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['code_id'] > 0) {$code_id = $_POST['code_id'];}
			$sql = "select * from $varmain_table where code_id = $code_id";
			$data['edit_code'] = $this->db->query($sql)->result_array();

			$_POST['code_id'] = $code_id;
			$this->load->view('update_code', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_code', $data);
		}
	}
		
}
	
