<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Counsellor2 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // echo "!! must write other functions code for funciton $callfunction";
		}
	}	

	public function member_edit()
	{

		$varcompid = $_POST['sess_compid'];
		$varcompid2 = $varcompid;

		$var_new_compid = $this->Attendee_mods->update_attendee($varcompid2);
		
		if ($_POST['id'] > 0) { 
			$id = $_POST['id']; // value set from listing 
		} elseif ($_POST['userid'] > 0) { 
			$id = $_POST['userid']; // value set from edit form 
		}
		
		$varcompid = $_POST['sess_compid'];
		$sql = "select * from teampro_follow_ups where compid = $varcompid and follup_type = 'Follow-Up' and follup_for = $id order by follup_contact_date_sort desc limit 8";
		$data['follow_ups_recent'] = $this->db->query($sql)->result_array();
		$varcompid = $_POST['sess_compid'];
		$sql = "select * from teampro_follow_ups where compid = $varcompid and follup_type = 'Medical' and follup_for = $id order by follup_contact_date_sort desc limit 8";
		$data['follow_ups_medical'] = $this->db->query($sql)->result_array();
		$sql = "select * from teampro_follow_ups where compid = $varcompid and follup_type = 'Counselling' and follup_for = $id order by follup_contact_date_sort desc limit 8";
		$data['follow_ups_counselling'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from teampro_requests where compid = $varcompid and (request_userid_for = $id) order by request_date_sort desc limit 4";
		$data['prayers_for'] = $this->db->query($sql)->result_array();
		$sql = "select * from teampro_requests where compid = $varcompid and request_userid = $id and request_userid_for not in ($id) order by request_date_sort desc limit 4";
		$data['prayers_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select title, id from teampro_groups where compid = $varcompid order by title";
		$data['connect_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'next_steps' order by code_name";
		$data['next_steps_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_code_manager where code_group = 'follow_frequency'";
		$data['follow_freq'] = $this->db->query($sql)->result_array();

		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'user_date_types' order by code_name"; 
		$data['user_date_types'] = $this->db->query($sql)->result_array(); 
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'follup_contact_types' order by code_name"; 
		$data['follup_contact_types'] = $this->db->query($sql)->result_array(); 
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'follup_urgency' order by code_name"; 
		$data['follup_urgency'] = $this->db->query($sql)->result_array(); 
		$sql = "select date_userid, date, date_type from teampro_user_dates where date_userid = '$id' order by id";
		$data['list_user_dates'] = $this->db->query($sql)->result_array();
		
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name"; 
		$data['sex_types'] = $this->db->query($sql)->result_array(); 
		$varsql = "";
		$sql = "select * from ainf_vps3_code_manager where code_group = 'proteam-access' $varsql order by code_id desc";
		$data['access_levels'] = $this->db->query($sql)->result_array();
		
		// //var_dump($data['access_levels']);
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/counsellor2/details/attendees4'); // back to listing 
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default record

			// back to updates 
			if ($_POST['id'] > 0) {
				$id = $_POST['id']; // value set from listing 
			} elseif ($_POST['userid'] > 0) {
				$id = $_POST['userid']; // value set from edit form  
			}
			$sql = "select * from ainf_vps3_users where userid = $id";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			
			foreach ($data['edit_teampro_groups'] as $x) {
				$var_events_attended =  $x['events_attended'];
				if ($var_events_attended == "") {$var_events_attended = "0,0";}
				$sql = "select * from teampro_events where compid = $varcompid and id in ($var_events_attended) order by date_sort desc limit 5";
				$data['recent_events'] = $this->db->query($sql)->result_array();
			}	
			//print_R($data['edit_teampro_groups']);exit;
			$_POST['userid'] = $id;
			$this->load->view('update_attendee', $data);
		} else {
			$_POST['userid'] = 0;
			$this->load->view('update_attendee', $data);
		}
		
	}

	public function meeting_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['title'])) {
			$data_rec = array();
			$data_rec = $_POST; 
			unset($data_rec['userid']); 
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update('teampro_groups', $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$data_rec['mastercompid'] = 113;
				$this->db->insert('teampro_groups', $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			redirect('/teams2/details/index'); // back to listing
		} elseif ($_POST['mod_record'] == "yes") { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];} 
			$sql = "select * from teampro_groups where id = $id";
			$data['edit_teampro_groups'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_meetings', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_meetings', $data);
		}
	}
	

	public function visitors($pagename)
	{
		
		$varcompid = $_POST['sess_compid']; 
		$var_this_event_only = "0," . $_POST['id'] .  ",0"; // Sub-query locating that event 
		
		$var_date_sort = date('Y/m/d');
		$var_date_sort = date('d/m/Y');
		$sql = "select id, date_sort, compid from teampro_events where compid = $varcompid and date_sort like ('%$var_date_sort%')";
		$sql = "select id, date, compid from teampro_events where compid = $varcompid and date like ('%$var_date_sort%')";
		$data['current_events'] = $this->db->query($sql)->result_array();
		$var_current_events_sql = ""; $var_ev_num = 0;
		foreach ($data['current_events'] as $x) {
			$var_current_events_sql .=  " and events_attended like '%,{$x['id']},%'";
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid $var_current_events_sql and is_visitor = 'yes'";
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and is_visitor = 'yes'"; // This is all visitors 
		$data['visitors_present'] = $this->db->query($sql)->result_array();
		//var_dump($data['visitors_present']);
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list		
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_book'] = "";
			$_POST['form_speaker'] = "";
			$_POST['form_keywords'] = "";
		}
		if ($_POST['form_book'] != "") {
			$var_search .= " and book = '{$_POST['form_book']}' ";
		}
		if ($_POST['form_speaker'] != "") {
			$var_search .= " and teacher = '{$_POST['form_speaker']}' ";
		}
		
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_events where compid = $varcompid order by date_sort desc";
		$data['events_list'] = $this->db->query($sql)->result_array();
		// //var_dump($data['events_list']);

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // echo "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid order by first_name, last_name";
		$data['team_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		// The left join gets the optional leader name 
		$sql = "select a.id, a.event_type, a.compid, a.details, a.leader, a.date, a.date_sort, a.title, a.event_tip, a.address, a.contact_1, a.contact_2, a.duration_note, 
		a.transport_1, a.transport_2, a.image_url, b.first_name as leader_first_name, b.last_name as leader_last_name 
		from teampro_events a 
		left join ainf_vps3_users b on a.leader = b.userid 
		where a.compid = $varcompid order by date_sort desc"; 
		$data['events_list'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}
	
	public function details($pagename)
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid']; 

		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$sql = "select id from teampro_groups where compid = $varcompid $subqry $var_search order by message_date_sort desc";
		$data['messages'] = $this->db->query($sql)->result_array();

		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
			
		$sql = "select * from teampro_groups where compid = $varcompid order by message_date_sort desc"; 
		$sql = "select * from teampro_groups, ainf_vps3_users where teampro_groups.compid = $varcompid and meeting_host = userid order by message_date_sort desc"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
								
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid order by request_date desc"; 
		$data['prayer_requests'] = $this->db->query($sql)->result_array();

		$varqry = ""; // Apply the filter 
		if ($_POST['form_follup_for'] != "") {$varqry .= " and follup_for = {$_POST['form_follup_for']} ";} 
		if ($_POST['form_follup_by'] != "") {$varqry .= " and follup_by = {$_POST['form_follup_by']} ";} 
		if ($_POST['form_sort_by'] != "") {$varsort = " order by {$_POST['form_sort_by']} ";} else {$varsort = " order by follup_for, follup_contact_date_sort desc ";} 

		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by $varsort"; 
		$data['follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where ainf_vps3_users.compid = $varcompid $varqry and userid = follup_by and 
		(follup_by = {$_POST['sess_userid']} or follup_for = {$_POST['sess_userid']}) $varsort"; 
		$data['my_follow_ups'] = $this->db->query($sql)->result_array(); // show followups per owner 
		
		$var_follup_contact_date_time = date('Y/m/d',strtotime("-1 days"));
		$sql = "select * from teampro_follow_ups, ainf_vps3_users where follup_contact_date_sort > '$var_follup_contact_date_time' and ainf_vps3_users.compid = $varcompid and userid = follup_by $varsort"; 
		$data['follow_ups_planned'] = $this->db->query($sql)->result_array(); // show followups per owner 
		// // echo "<br>varsql is $sql";
		
		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'follup_sort_types' order by code_name";
		$data['follup_sort_types_list'] = $this->db->query($sql)->result_array();
		
		
		$varsql = "";
		if (isset($_POST['form_attendee_type']) and $_POST['form_attendee_type'] != "All" and $_POST['form_attendee_type'] != "") {
			$varsql = " and {$_POST['form_attendee_type']} = 'yes' "; // Allows variable range of items to be selected 
		}
		$sql = "select * from ainf_vps3_users where compid = $varcompid $varsql order by first_name, last_name";
		$data['team_list'] = $this->db->query($sql)->result_array();
		// var_dump($data['team_list']);
		
		$sql = "select distinct meeting_host from teampro_groups where compid = $varcompid $subqry order by meeting_host";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_by from  teampro_follow_ups) order by first_name, last_name"; 
		$data['list_follup_by'] = $this->db->query($sql)->result_array();
		
		$sql = "select first_name, last_name, userid from ainf_vps3_users where ainf_vps3_users.compid = $varcompid and userid in (select distinct follup_for from  teampro_follow_ups) order by first_name, last_name";
		$data['list_follup_for'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Open' order by request_date desc";
		$data['prayer_requests_open'] = $this->db->query($sql)->result_array();

		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}
	public function summary($pagename)
	{
		
		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		// MAIN SQLS FOR ANALYTICS 
		$sql = "select * from ainf_vps3_users where (compid = $varcompid or compid_group like '%,$varcompid,%')"; // compid_group allows for users going to multiple churches 
		$data['total_users'] = $this->db->query($sql)->result_array(); 
		$sql = "select * from `ainf_vps3_users` where (compid = $varcompid or compid_group like '%,$varcompid,%') and team_connect_group not in (0)"; 
		$data['total_users_in_connect'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct date_userid from teampro_user_dates where (compid = $varcompid or compid_group like '%,$varcompid,%')"; 
		$data['unique_users_special_days'] = $this->db->query($sql)->result_array(); 
		
		// KEY DATES THIS MONTH WITH JOIN TO GET USER NAME 
		$var_this_month = date('m');
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_this_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['this_months_key_dates'] = $this->db->query($sql)->result_array();
		// KEY DATES NEXT MONTH WITH JOIN TO GET USER NAME 
		$var_next_month = date('m',strtotime('first day of +1 month'));
		$sql = "select a.id, a.compid, a.date_userid, a.date, a.date_type, b.userid, b.first_name, b.last_name 
		from teampro_user_dates a 
		left join ainf_vps3_users b on a.date_userid = b.userid 
		where a.date like '%/$var_next_month/%' and (a.compid = $varcompid or a.compid_group like '%,$varcompid,%') order by a.date_userid";
		$data['next_months_key_dates'] = $this->db->query($sql)->result_array();

		// KEY DATES THIS MONTH ON FOLLOW-UPS & PRAYER REQUESTS 
		$var_this_year_month = date('Y/m');
		$sql = "select * from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct follup_for from teampro_follow_ups where compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%'"; 
		$data['followups_distinct_users_month'] = $this->db->query($sql)->result_array(); 
		$sql = "select distinct follup_contact_type from teampro_follow_ups where follup_contact_type is not null and compid = $varcompid and follup_contact_date_sort like '%$var_this_year_month%' order by follup_contact_type"; 
		$data['followups_month_contact_type'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}

}
	
