<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Database4 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->helper('text');
		$this->load->helper('url');			
		
		$this->load->model('Asys_load_biz_v3'); //### FOR SYS FUNC
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$this->load->model('System_modules'); $this->load->model('Recheck_access');

		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and stripos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}

		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // echo"!! must write other functions code for funciton $callfunction";
		}
	}

	public function gen_tab_profiles()
	{

		// ### Empty table 
		$sql = "delete from tables_profile";
		$this->db->query($sql);
	
		$sql = "show tables"; $rows = 0;
		$table_list = $this->db->query($sql)->result_array();
		// var_dump($table_list);
		// ### CAN GET ONE TABLE 
		
		$varscript = substr($_SERVER['SCRIPT_FILENAME'], 0 , 15); 
		if ($varscript != "C:/xampp/htdocs") { // check local or live 
			$var_db = "Tables_in_conquer2_churchdb"; 
		} else {
			$var_db = "Tables_in_church_db"; 
		}
		foreach ($table_list as $z) {
			// ### Rebuild table 
			++$rows; 

			$data_rec = array(); 
			$data_rec['table_name'] = $z[$var_db];
			// // echo "<br>Table: {$data_rec['table_name']} ";

			if (strpos($z[$var_db], "back") !== false or strpos($z[$var_db], "2023") !== false or strpos($z[$var_db], "2024") !== false ) {
				$data_rec['table_status'] = "backup"; 
			} elseif (strpos($z[$var_db], "user") !== false or strpos($z[$var_db], "video") !== false or strpos($z[$var_db], "ministry") !== false  or strpos($z[$var_db], "module") !== false ) { 
				$data_rec['table_status'] = "priority"; 
			} else { 
				$data_rec['table_status'] = "general"; 
			}
			$this->db->insert('tables_profile', $data_rec);
			
		}
		
	}
	
	public function edit_tables()
	{

		// ### The for post is getting totally cleared when the file field is being loaded.. 
		error_reporting(0);
		
		$this->course_views();
		
	}

	public function course_views()
	{
		
		$varcompid = $_POST['sess_compid'];
		
		if ($_POST['backup_table'] != "") { 
			if (trim($_POST['base_table']) != "") { 
				
				$var_new_table = $_POST['base_table'] . "_" . date("Ymd") . "_bck"; 
				$sql = "CREATE TABLE `$var_new_table` AS SELECT * FROM `{$_POST['base_table']}` "; 
				// echo "<br>!!! sql = $sql"; 
				
				// ### CHECK IT MUST ONLY BE ONCE PER DAY NOW - OR MAKE IT PER MINUTE 
				// ### CHECK IT MUST ONLY BE ONCE PER DAY NOW 
				$this->db->query($sql);

			} 
		} elseif ($_POST['tune_table'] != "") { 
			
			// echo "<br>AA In tune will call split ";
			$this->Asys_load_biz_v3->sys_code_split('deactivate'); 
			redirect('bible3/bible_display'); 
			
		} elseif (1==2 and $_POST['update_table'] != "") { 
			// ### Rename is dangerous and will not be done 
			if (trim($_POST['base_table']) != "" and trim($_POST['new_table']) != "") { 
				
				$sql = "RENAME TABLE `{$_POST['base_table']}` TO `{$_POST['new_table']}`";
				$data['run_table'] = $this->db->query($sql)->result_array();

			} 
		}
		
		$this->gen_tab_profiles();

		
		if ($_POST['update_sql'] != "") {
			$sql = $_POST['sql_command'];
			if (stripos($sql, "select") !== false or stripos($sql, "desc") !== false or stripos($sql, "show") !== false) { 
				$data['run_table'] = $this->db->query($sql)->result_array(); 
			} elseif (stripos($sql, "drop") !== false and stripos($sql, "ALTER TABLE") === false) { // CANNOT DROP TABLE OR COLUMN - TO PLAY IT SAFER - JUST ADD 
				// ### CANNOT DROP - BUT ALTER TABLES 
			} else { 
				// ### NO RESULT FOR CHANGE // DROP // ALTER 
				$this->db->query($sql); 
			}
		}

		$varcompid = $_POST['sess_compid'];
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active = 'Y'";
		$data['videos_full'] = $this->db->query($sql)->result_array();

		$sql = "select * from `tables_profile` where table_status = 'priority' order by table_name ";
		$data['tables_priority'] = $this->db->query($sql)->result_array();
		$sql = "select * from `tables_profile` where table_status = 'general' order by table_name ";
		$data['tables_general'] = $this->db->query($sql)->result_array();
		$sql = "select * from `tables_profile` order by table_name ";
		$data['tables_all'] = $this->db->query($sql)->result_array();
		
		if ($_POST['table_priority'] != "") {
			$sql = "describe {$_POST['table_priority']} ";
			$data['fields_table_priority'] = $this->db->query($sql)->result_array();
		} elseif ($_POST['table_general'] != "") { 
			$sql = "describe {$_POST['table_general']} "; 
			$data['fields_table_general'] = $this->db->query($sql)->result_array();
		} 
		
		$this->load->view('update_tables_v4', $data); 

	}

}
	
