<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Datacronjob2 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS 
		$this->load->model('System_modules'); $this->load->model('Recheck_access'); 
		$this->Recheck_access->reset_access(); 
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // echo "!! must write other functions code for funciton $callfunction";
		}
		////// // var_dump($_POST);
	}	

	public function load_data_5() {
		
		// #### CURRENT VERSION SHOULD LOAD 500K PER DAY 
		// echo "<br>!!22 ";
		// echo "<br>!!33 ";
		// echo "<br>!!44 ";

		$var_run = "no";
		$var_recs_to_run = 10000;
		$time_run_check_start = "17:01:00";
		$time_run_check_end = "04:10:00";
		$sql = "select * from aaa_data_params where system = 'DIG_BIZ'";
		$drive_rec = $this->db->query($sql)->result_array();
		foreach ($drive_rec as $x) {
			$var_recs_to_run = $x['cron_rec_num']; //### WE KNOW THE COUNT AND CONTINUE FROM THERE
			// echo "<br><br>RECS RESET TO $var_recs_to_run<br>";
			$time_run_check_start = $x['cron_time_start'];
			$time_run_check_end = $x['cron_time_end'];
		}

		$time_run_check_full = date('Y/m/d H:m:s');
		$time_run_check = substr($time_run_check_full, -8);
		// echo "<BR>TIME CHECK TIME NOW IS - $time_run_check start time is $time_run_check_start end time is $time_run_check_end";
		// #### ONLY RUN EARLY IN MORNING AT THIS POINT - LIMIT IMPACT TO LIVE WEB SITES 
		if ($time_run_check > $time_run_check_start and $time_run_check < $time_run_check_end) {
			// echo "<br><br>WE ARE RUNNING - INSIDE TIME WINDOW time check is $time_run_check<br>";
			$var_start_id = 0;
			$sql = "SELECT COUNT(id) from aaa_oz_v2 where id > 0";
			$listid = $this->db->query($sql)->result_array();
			foreach ($listid as $x) {
				$var_start_id = $x['COUNT(id)']; //### WE KNOW THE COUNT AND CONTINUE FROM THERE 
			}

			// #### FILE LOG RECORD 
			$dat_ins = array();
			$dat_ins['runjob_type'] = "Data Loaing AUS"; 
			$dat_ins['date_start'] = date('d/m/Y H:m:s'); 
			$dat_ins['date_start_sort'] = date('Y/m/d H:m:s'); 
			$dat_ins['rec_num_start'] = $var_start_id; 
			$dat_ins['status'] = "STARTING RUN"; 
			$dat_ins['runjob_script'] = "load_data_5";
			
			$this->db->insert('aaa_data_logs',$dat_ins); 
			$var_log_id_key = $this->db->insert_id(); 

			$handle = fopen("aaa-dat/8DD_25M_Australian_db_with_new_fields.csv","r"); 
			
			// $handle = fopen("/home/rasmus/file.txt", "r");
			// ##############################################################
			
			$var_recs_to_run = 10000; //#### TEMP NOTES ####
			$count = 0; $var_recs_total = $var_recs_to_run + $var_start_id;
			// echo "<br>!!aa var_recs_total = $var_recs_total, var_recs_to_run = $var_recs_to_run, var_start_id = $var_start_id";
			// $var_recs_to_run = 1000; // #### THIS IS NOW TAKEN FROM DRIVER FILE
			// // // var_dump .= "<br>The total recs is $var_recs_total. We will process $var_recs_to_run after the last mysql record at id= $var_start_id";
			// ##############################################################

			$insnum = 0;
			while($count <= $var_recs_total and !feof($handle))
			{

				++$count;
				$thisline = fgets($handle); 
				$x = explode('|',$thisline); 

				if ($count < $var_start_id and $var_start_id > 0) {
					// ### DATA IS HUGE SO THE CRON RUNS AND DOES BATCHES AT INTERVALS TO COMPLETE THE WORK OVER SOME DAYS 
					// ### WE ARE MOVING THE POINTER UP TO RESTART WHERE WE LEFT OFF 
					// // // echo "<br>!!11 Count is $count READ THROUGH RECORDS TO GET TO NEW PART OF CSV ";
				} else { 
					++$insnum;
					$dat_ins = array(); 
					$dat_ins['title'] = $x[1]; 
					$dat_ins['firstname'] = $x[2]; 
					$dat_ins['lastname'] = $x[3]; 
					$dat_ins['dob'] = $x[4]; 
					$dat_ins['age'] = $x[5]; 
					$dat_ins['address1'] = $x[6]; 
					$dat_ins['address2'] = $x[7]; 
					$dat_ins['suburb'] = $x[8];
					$dat_ins['state'] = $x[9];
					$dat_ins['postcode'] = $x[10];
					$dat_ins['email'] = $x[11];
					$dat_ins['mobile'] = $x[12];
					$dat_ins['landline'] = $x[13];
					$dat_ins['property_type'] = $x[14];
					$dat_ins['house_income_code'] = $x[15];
					$dat_ins['Beauty'] = $x[16];
					$dat_ins['Fashion'] = $x[17];
					$dat_ins['Music'] = $x[18];
					$dat_ins['Festivals'] = $x[19];
					$dat_ins['Facebook_Beauty'] = $x[20];
					$dat_ins['Facebook_Fashion'] = $x[21];
					$dat_ins['Facebook_Hair'] = $x[22];
					$dat_ins['Facebook_Music'] = $x[23];
					$dat_ins['Facebook_Music_Fantastic'] = $x[24];
					$dat_ins['Credit_card_holder'] = $x[25];
					$dat_ins['Travel_Domestic'] = $x[26];
					$dat_ins['Travel_International'] = $x[27];
					$dat_ins['Pay_Tv_Subscription'] = $x[28];
					$dat_ins['Womans_Fashion_Online'] = $x[29];
					$dat_ins['Womans_Fashion_Instore'] = $x[30];
					$dat_ins['Mens_Fashion_online'] = $x[31];
					$dat_ins['Mens_Fashion_Instore'] = $x[32];
					$dat_ins['Travel_Domestic_Air'] = $x[33];
					$dat_ins['Travel_Domestic_Rail'] = $x[34];
					$dat_ins['Social_FB'] = $x[35];
					$dat_ins['Social_WA'] = $x[36];
					$dat_ins['Social_Insta'] = $x[37];
					$dat_ins['football_spectator'] = $x[38];
					$dat_ins['tennis_spectator'] = $x[39];
					$dat_ins['rugby_spectator'] = $x[40];
					$dat_ins['Debit_Card'] = $x[41];
					$dat_ins['Credit_Card'] = $x[42];
					$dat_ins['Auto'] = $x[43];
					$dat_ins['Health_Insurance'] = $x[44];
					$dat_ins['Superannuation'] = $x[45];
					$dat_ins['BNPL'] = $x[46];
					$dat_ins['Invest_Crypto'] = $x[47];
					$dat_ins['Invest_Shares'] = $x[48];
					$dat_ins['charity_donor_online'] = $x[49];
					$dat_ins['charity_donor_facetoface'] = $x[50];

					$this->db->insert('aaa_oz_v2',$dat_ins); 
					// echo "<br>!!22 Will insert"; 
					
					// // // echo "<br>!!11 Count is $count INSERT NOW FOR {$x[2]} {$x[3]} Email {$x[11]} Phone {$x[13]} Mobile {$x[12]} ";
					// // // // // echo "<br>1 {$x[1]} 2 {$x[2]} 3 {$x[3]} 4 {$x[4]} 5 {$x[5]} 6 {$x[6]} 7 {$x[7]} 8 {$x[8]} 9 {$x[9]} 10 {$x[10]} ";
					// // // // // echo "<br>11 {$x[11]} 12 {$x[12]} 13 {$x[13]} 14 {$x[14]} 15 {$x[15]} 16 {$x[16]} 17 {$x[17]} 18 {$x[18]} 19 {$x[19]} 20 {$x[20]} ";
					// // // // // echo "<br>21 {$x[21]} 22 {$x[22]} 23 {$x[23]} 24 {$x[24]} 25 {$x[25]} 26 {$x[26]} 27 {$x[27]} 28 {$x[28]} 29 {$x[29]} 30 {$x[30]}
					// 31 {$x[31]} 32 {$x[32]} 33 {$x[33]} 34 {$x[34]} 35 {$x[35]} 36 {$x[36]} 37 {$x[37]} 38 {$x[38]} 39 {$x[39]} 40 {$x[40]} ";

				}
			}

			fclose($handle);

			// echo "<br>!! 11 update key is $var_log_id_key";
			$dat_ins = array();
			$dat_ins['date_end'] = date('d/m/Y H:m:s');
			$dat_ins['date_end_sort'] = date('Y/m/d H:m:s');
			$dat_ins['rec_num_loaded'] = $insnum;
			$dat_ins['rec_num_end'] = $var_recs_total;
			$dat_ins['status'] = "FINISHED RUN";
			$this->db->where('id', $var_log_id_key);
			$this->db->update('aaa_data_logs', $dat_ins);
			// echo "<br>!! 22 update key is $var_log_id_key";
			
		} else {
			// #### LOG NO RUN 
			// echo "<br><br>DID NOT RUN OUT OF THE RUN TIME WINDOW time check is $time_run_check<br>";
			$dat_ins = array(); 
			$dat_ins['date_start'] = date('d/m/Y'); 
			$dat_ins['date_start_sort'] = date('Y/m/d H:m:s'); 
			$dat_ins['rec_num_start'] = $var_start_id; 
			$dat_ins['status'] = "NO RUN (TIMING)";
			$this->db->insert('aaa_data_logs',$dat_ins); 
			$var_log_id_key = $this->db->insert_id(); 
		}
		// echo "<br><br><b>CRON IS COMPLETE</b><br>"; 
	}

	function process_get_checklist()
	{
		// $compid = $this->session->userdata('compid');
		if (1==1) {
			// Add any new checklists 
			if (isset($_POST['checklist_item_add1']) and trim($_POST['checklist_item_add1']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add1']);
				$this->db->insert('edu_checklist', $inscheck);
			}
			if (isset($_POST['checklist_item_add2']) and trim($_POST['checklist_item_add2']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add2']);
				$this->db->insert('edu_checklist', $inscheck);
			}
		}

		$q = $this->db->query("select * FROM edu_checklist");		
		$data = $q->result_array();
		return($data);
	} 

	public function video_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_xcloud_videos";
		
		if (isset($_POST['teaser'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']); 
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";	} else {$data_rec['archive'] = "no";}
			//// // var_dump($data_rec);
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}			
		}
		
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();
		////// // var_dump($data['list_series']);
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			$this->details(trainer3_manager);
		} elseif ($_POST['id'] > 0 or $id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $varmain_table where id = $id";
			$data['edit_videos'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_videos', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_videos', $data);
		}
	}
		
	public function codes_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_vps3_code_manager";
		
		if (isset($_POST['code_group'])) {
			$data_rec = array();

			unset($_POST['sess_proteam_access']);
			unset($_POST['sess_proteam_access_level']);
			$data_rec = $_POST;
			
			unset($data_rec['userid']);
			unset($data_rec['MAX_FILE_SIZE']);
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['code_id'] != 0) {
				$this->db->where('code_id', $_POST['code_id']);
				// $this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$var_mastercompid = 113;
				$data_rec['mastercompid'] = $var_mastercompid;
				$this->db->insert($varmain_table, $data_rec);
				$code_id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
				
		If ($_POST['return_to_list'] == "yes") {
			$this->details(codes_manager);
		} elseif ($_POST['code_id'] > 0 or $code_id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['code_id'] > 0) {$code_id = $_POST['code_id'];}
			$sql = "select * from $varmain_table where code_id = $code_id";
			$data['edit_code'] = $this->db->query($sql)->result_array();

			$_POST['code_id'] = $code_id;
			$this->load->view('update_code', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_code', $data);
		}
	}
		
	public function details($pagename)
	{
	
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // // // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];		
		$var_search = "";
		
		// Process the form filter 
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		$data['events'] = $this->db->query($sql)->result_array();
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$sql = "select * from ainf_xcloud_videos, mentor_series where video_series = mentor_series.id order by video_order";
		$data['messages'] = $this->db->query($sql)->result_array();
		// //// // var_dump($data['messages']);
		
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		// !!! THIS IS THE NEW CODE TO BEGIN USING THE ainf_xcloud_videos TABLE AS IT HAS ALL THE DATA 
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$varfixed_comp = 114;
		$sql = "select * from ainf_xcloud_videos, speakers where  ainf_xcloud_videos.compid = $varfixed_comp and video_trainerid = speakers.id order by video_order";
		
		$var_search = "";
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_series'] = "";
		}
		if ($_POST['form_series'] != "") {
			$var_search .= " and video_series = '{$_POST['form_series']}' ";
		}
		
		if ($_POST['form_archive'] != "" and $_POST['form_archive'] != "all") {
			$var_search .= " and v.archive = '{$_POST['form_archive']}' ";
		}

		//### LEFT JOIN SQL
		$sql = "SELECT v.compid, v.id as id, v.archive as archive, video_name, v.video_link, teaser, video_writeup, series_title FROM ainf_xcloud_videos v LEFT JOIN mentor_series m ON v.video_series = m.id where v.compid = $varcompid $var_search";
		$data['messages'] = $this->db->query($sql)->result_array();

		if (!isset($_POST['form_archive']) or $_POST['form_archive'] == "") { // Starting value to all
			$_POST['form_archive'] = "all";
		}

 		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'archive_values' order by code_id desc";
		$data['archive_list'] = $this->db->query($sql)->result_array();

		if ($_POST['form_series'] != "" and $_POST['form_series'] != 0) {
			$sql = "select * from mentor_series where id = {$_POST['form_series']}";
			$data['series_header'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select distinct teacher from ainf_xcloud_videos where compid = $varcompid $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid = $varcompid order by book";
		$data['books'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid = $varcompid order by code_id";
		$data['services'] = $this->db->query($sql)->result_array();

		$sql = "select * from mentor_series where compid = $varcompid order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 
				
		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason

		$data['eunit_checklist'] = $this->process_get_checklist(); // load the checklist items
		// //// // var_dump($data['eunit_checklist']);
		
		//### list qrys
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid and id  in (select video_series from ainf_xcloud_videos) order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();

		$var_mastercompid = 113;
		$sql = "select distinct code_group from ainf_vps3_code_manager where mastercompid = $var_mastercompid order by code_group";
		$data['code_group_list'] = $this->db->query($sql)->result_array();

		$var_mastercompid = 113;
		if ($_POST['form_code_group'] != "")
			{$var_sql = " and code_group = '{$_POST['form_code_group']}' ";}
		elseif ($_POST['code_group'] != "")
			{$var_sql = " and code_group = '{$_POST['code_group']}' ";
			$_POST['form_code_group'] = $_POST['code_group'];
			}
		else  
			{$var_sql = " ";}
		
		// ### this old code line is very buggy $sql = "select * from ainf_vps3_code_manager where mastercompid = $var_mastercompid $var_sql order by code_group, code_name";
		$sql = "select * from ainf_vps3_code_manager where code_group is not null $var_sql order by code_group, code_name";
		$data['codes_list'] = $this->db->query($sql)->result_array();

		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	
	public function summary($pagename)
	{
		
		// echo "<br>!!11 ";
		error_reporting(0);

		// echo "<br>!!22 ";

		// Get page name for the link 
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];

		// PARAM REC 
		// echo "<br>!!22 "; 
		$sql = "select * from aaa_data_params"; 
		$data['drive_loadup'] = $this->db->query($sql)->result_array(); 
		// echo "<br>!!33 ";
		// var_dump($data['drive_loadup']); 

		// MAIN SQLS FOR AUSTRALIA 
		$sql = "select * from aaa_data_logs order by date_end_sort limit 0,10 "; // compid_group allows for users going to multiple churches 
		$data['recent_logs'] = $this->db->query($sql)->result_array(); 

		// MAIN SQLS FOR AUSTRALIA 
		// echo "<br>!!44 "; 
		$sql = "select id from aaa_oz_v2 where state not in ('State') "; // compid_group allows for users going to multiple churches 
		// echo "<br>!!44 11 sql - $sql "; 
		if (1==2) {
			$data['total_oz'] = $this->db->query($sql)->result_array(); 
			// echo "<br>!!44 22"; 
			$sql = "select state from aaa_oz_v2 where state in ('VIC','vic','Vic') "; // compid_group allows for users going to multiple churches 

			$data['total_state_vic'] = $this->db->query($sql)->result_array(); 
			$sql = "select state from aaa_oz_v2 where state in ('NSW','nsw','Nsw') "; // compid_group allows for users going to multiple churches 
			$data['total_state_nsw'] = $this->db->query($sql)->result_array(); 
			$sql = "select state from aaa_oz_v2 where state in ('QLD','qld','Qld') "; // compid_group allows for users going to multiple churches 
			$data['total_state_qld'] = $this->db->query($sql)->result_array(); 
			$sql = "select state from aaa_oz_v2 where state in ('SA','sa','Sa') "; // compid_group allows for users going to multiple churches 
			// echo "<br>!!44aa ";


			$data['total_state_sa'] = $this->db->query($sql)->result_array(); 
			$sql = "select state from aaa_oz_v2 where state in ('WA','wa','Wa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_wa'] = $this->db->query($sql)->result_array(); 
			$sql = "select state from aaa_oz_v2 where state in ('WA','wa','Wa') "; // compid_group allows for users going to multiple churches 
			$data['total_state_wa'] = $this->db->query($sql)->result_array(); 
			// echo "<br>!!44bb ";
			$sql = "select state from aaa_oz_v2 where state in ('NT','nt','Nt') "; // compid_group allows for users going to multiple churches 
			$data['total_state_nt'] = $this->db->query($sql)->result_array(); 

			$sql = "select state from aaa_oz_v2 where state in ('ACT','act','Act') "; // compid_group allows for users going to multiple churches 
			$data['total_state_act'] = $this->db->query($sql)->result_array(); 
			// echo "<br>!!44cc "; 

			$sql = "select state from aaa_oz_v2 where state in ('TAS','tas','Tas') "; // compid_group allows for users going to multiple churches 
			$data['total_state_tas'] = $this->db->query($sql)->result_array(); 


		$sql = "select count( DISTINCT(email) ) FROM aaa_oz_v2 "; // compid_group allows for users going to multiple churches 
		$data['total_state_other'] = $this->db->query($sql)->result_array(); 
		$var_full_count = count($data['total_oz']); 


		$sql = "select * from teampro_requests, ainf_vps3_users where teampro_requests.compid = $varcompid and request_userid_for = userid and req_status = 'Answered' order by request_date desc";
		$data['prayer_requests_anwered'] = $this->db->query($sql)->result_array();


		// echo "<br>!!55 page is $pagename_orig ";

		}
	
		$sql = "select state, email FROM aaa_oz_v2 where email is not null order by state desc;"; // compid_group allows for users going to multiple churches 
		$test_total = $this->db->query($sql)->result_array(); 
		$var_count_tot = count($test_total); 

		// echo "<br>!!77ee total recs - $var_count_tot";


		// exit;

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			$this->load->view($pagename_orig, $data);
		}
		
	}

}
