<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Es_Quotes_v1 extends CI_Controller { 
	// Rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');
		$this->load->model('Insert_prayer');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW 
		// ################################################################ 

		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout") {
			// #### The userid and/or compid expired or logged out - go to bible app as a public module 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}

	public function foryou($hashnum)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);
		
		//#### From hashnum - extract videoid - then the companyid ####// 
		$var_vid_id_array = explode('4477',$hashnum); 
		$var_vid_id = $var_vid_id_array['1']; 
		// //var_dump($var_vid_id_array);
		
		// ### 956744773934477
		$subqry = ""; $var_search = ""; 
		$varoffset = 0; $recsperpage = 1; 
		
		$compid_string = " compid > 0 ";
		$sql = "select * from ainf_xcloud_videos where id = $var_vid_id"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
		foreach ($data['messages'] as $z) {
			$varcompid = $z['compid'];
			$compid_string = " compid = $varcompid ";
		}
		
		// //var_dump($data['messages']); 
				
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// ////var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where ($compid_string and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and $compid_string order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array();
		
		// very basic error handling
		
		$pagename_orig = "video-player-bsbc-base";
		$pagename_orig = "video-player-bsbc-foryou";
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function display_qr()
	{

		$varcompid = $this->session->userdata('compid');
		$sql = "SELECT * from ainf_xglobalclient where globcompid = $varcompid limit 0,1 ";
		$user_query = $this->db->query($sql);
		$data['mycomp_evangelise'] = $user_query->result_array();
		
		$load_page = "view_qr";
		$this->load->view($load_page, $data);
		
	}
	
	public function friend_signup()
	{

		if ($_POST['sess_compid'] == "" or $_POST['sess_compid'] == "0") {
			// ### Maintain $_POST then not reliant on session 
			$_POST['sess_compid'] = $this->session->userdata('compid');
		}
		$varcompid = $_POST['sess_compid'];
		
		$_POST['form_url'] = "evangelism/friend_signup"; //### MULTI-PURPOSE FORM 
		$_POST['form_url'] = "evangelism/friend_signup"; //### MULTI-PURPOSE FORM 

		//### THIS IS FOR THE QR CODE TABS 
		$varcompid = $this->session->userdata('compid'); 
		$sql = "SELECT * from ainf_xglobalclient where globcompid = $varcompid limit 0,1 "; 
		$user_query = $this->db->query($sql); 
		$data['mycomp_evangelise'] = $user_query->result_array(); 
		
		//### MANAGING THE SIGNUP FORM 
		if ($_POST['first_name'] != "" and $_POST['last_name'] != "") { 
			$sql = "SELECT * from ainf_vps3_users where mobile = '{$_POST['mobile']}' order by userid limit 0,1 "; 
			$user_query = $this->db->query($sql); 
			$user_exists = $user_query->result_array(); 
			if (!$user_exists) {
					$data_rec = array();
					if (trim($_POST['password'] != "")) { $data_rec['password'] = sha1($_POST['password']); } // Password is optional 
					$data_rec['compid'] = $varcompid; $data_rec['compid_sharing'] = "0," . $varcompid . ",0"; 
					$data_rec['first_name'] = $_POST['first_name']; $data_rec['last_name'] = $_POST['last_name']; 
					$data_rec['mobile'] = $_POST['mobile']; $data_rec['email'] = $_POST['email']; 
					$data_rec['proteam_access'] = "Visitor";
					$data_rec['soc_fb'] = $_POST['soc_fb']; $data_rec['soc_tw'] = $_POST['soc_tw'];
					$data_rec['soc_insta'] = $_POST['soc_insta'];
					$data_rec['referred_by'] = $_POST['sess_userid'];
					$data_rec['start_date_sort'] = date('Y/m/d');
					$data_rec['start_date'] = date('d/m/Y');
					if ($_POST['sess_userid'] != "" and $_POST['sess_userid'] != "0") {
						$data_rec['my_friends'] = "0," . $_POST['sess_userid'] . ",0";
					}
		
					$this->db->insert('ainf_vps3_users', $data_rec);
					$new_friend_id = $this->db->insert_id();

					if ($_POST['prayer_title'] != "" or $_POST['request_detail'] != "") {
						// ### PRAYER REQUEST IS OPTIONAL WHEN THEY SIGN IN 
						$this->Insert_prayer->add_teampro_events($new_friend_id);
					}
					
					if ($_POST['sess_userid'] != "" and $_POST['sess_userid'] != "0") {
						//### Now update new friend to my friend 
						$sql = "select my_friends, userid from ainf_vps3_users where userid = {$_POST['sess_userid']}"; 
						$myrec = $this->db->query($sql)->result_array(); 
						// echo "<br>!!aa my friends list";
						foreach ($myrec as $z) {
							$data_rec = array();
							if ($z['my_friends'] != "") {
								//### tac onto end for existing friends string in format 0,123,124,126,129,0 
								$var_my_friends = str_replace(",0","", $z['my_friends']);
								$var_my_friends = $var_my_friends . ",$new_friend_id,0";
							} else {
								//### tac onto end for existing friends string in format 0,123,0 
								$var_my_friends = "0,$new_friend_id,0";
							}
							$data_rec['my_friends'] = $var_my_friends; 
							$this->db->where('userid', $_POST['sess_userid']);
							$this->db->update('ainf_vps3_users', $data_rec);
						}
					}
					
			} else {
				
				$var_compid_sharing = $user_exists[0]['compid_sharing'];
				$varcompid_search = "," . $varcompid . ",";
				if (strpos($var_compid_sharing, $varcompid_search) === false) { 
					//### User exists - but not for this ministry - just get them into the group 
					$var_LEFT_compid_sharing = substr($var_compid_sharing, 0, -1);
					$var_NEW_compid_sharing = $var_LEFT_compid_sharing . $varcompid . ",0";
					// echo "<br>!!33AA LEFT IS $var_LEFT_compid_sharing NEW IS $var_NEW_compid_sharing the userid - {$user_exists[0]['userid']}"; 
					$data_rec = array();
					$data_rec['compid_sharing'] = $var_NEW_compid_sharing;
					$this->db->where('userid', $user_exists[0]['userid']);
					$this->db->update('ainf_vps3_users', $data_rec);
				} else {
					//### User exists - AND ARE IN THIS Ministry - NO UPDATE NEEDED 
				}
			}
		}
			
		//### NEW SECURITY - DO NOT SHOW VIEW PAGE - PREVENTS MODULE TABLE TO BE UPDATED 
		$load_page = "update_new_friend";
		$load_page = "tesla_powerwall_2_quote_v3";
		$this->load->view($load_page, $data);
			
	}

}
	
