<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Financegraph4 extends CI_Controller {
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START 
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		$this->load->helper('url');
	}	

	public function summary2($pagename)
	{
		
		// echo "<br>!! 11 ";
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		// echo "<br>!! 22 ";
		
		//### DEPOSIT ACTIVE 
		$var_year_sql = date('Y');
		$var_month = date('m');
		// echo "<br>!! 33 ";
		$var_this_month_year_sql = "%" . $var_year_sql . "/" . $var_month . "/%";
		$var_this_year_sql = "%" . $var_year_sql . "/%";		
		
		// ### THIS MONTH 
		$sql = "select * from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_month_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();

		// ### THIS YEAR 
		$sql = "select * from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();

		$sql = "select * from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['ytd_dep_pay_list_by_date'] = $this->db->query($sql)->result_array();

		// ### MONTHS LIST ### 
		$sql = "select distinct date_month, date_year from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_year desc, date_month desc "; 
		$data['months_list'] = $this->db->query($sql)->result_array(); 

		// echo"<br>!! list ff 88 ORIG $pagename_orig "; 
		$this->load->view($pagename_orig, $data);
		
	}

	public function summary($pagename)
	{
		
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$varcompid = $_POST['sess_compid'];
		
		//### DEPOSIT ACTIVE 
		$var_year_sql = date('Y');
		$var_month = date('m');
		$var_this_month_year_sql = "%" . $var_year_sql . "/" . $var_month . "/%";
		$var_this_year_sql = "%" . $var_year_sql . "/%";
		
		// ### THIS MONTH 
		$sql = "select * from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_month_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array();

		// ### THIS YEAR 
		$sql = "select * from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array();

		$sql = "select * from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_sort desc, dep_or_pay, title";
		$data['ytd_dep_pay_list_by_date'] = $this->db->query($sql)->result_array();

		// ### MONTHS LIST ### 
		$sql = "select distinct date_month, date_year from aa_dep_pay_items where compid = $varcompid and active = 'Y' and date_sort like '$var_this_year_sql' order by date_month desc, date_sort desc, dep_or_pay, title"; 
		$data['months_list'] = $this->db->query($sql)->result_array(); 

		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			// echo"<br>!! list ff 44 ";
			$this->load->view($pagename_orig, $data);
		} else {
			// echo"<br>!! list ff 55 ";
			$this->load->view($pagename_orig, $data);
		}
	}

}
