<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Modules2 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		error_reporting(0);
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // // // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // echo "!! must write other functions code for funciton $callfunction";
		}
		////// // var_dump($_POST);
	}	

	function process_get_checklist()
	{
		// $compid = $this->session->userdata('compid');
		if (1==1) {
			// Add any new checklists 
			if (isset($_POST['checklist_item_add1']) and trim($_POST['checklist_item_add1']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add1']);
				$this->db->insert('edu_checklist', $inscheck);
			}
			if (isset($_POST['checklist_item_add2']) and trim($_POST['checklist_item_add2']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add2']);
				$this->db->insert('edu_checklist', $inscheck);
			}
		}

		$q = $this->db->query("select * FROM edu_checklist");		
		$data = $q->result_array();
		return($data);
	} 

	public function video_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_xcloud_videos";
		
		if (isset($_POST['teaser'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']); 
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";	} else {$data_rec['archive'] = "no";}
			//// // var_dump($data_rec);
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}			
		}
		
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();
		////// // var_dump($data['list_series']);
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			$this->details(trainer3_manager);
		} elseif ($_POST['id'] > 0 or $id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $varmain_table where id = $id";
			$data['edit_videos'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_videos', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_videos', $data);
		}
	}
		
	public function current_stock()
	{
		
		$data_rec = array();
		$data_rec['parent_has_children'] = "N";
		$this->db->where('xmodules_id > 0');
		$this->db->update('ainf_xmodule2', $data_rec);
		
		$sql = "select * from ainf_xmodule2 where parent_module = 0 and xmodules_id in (select parent_module from `ainf_xmodule2` where active not in ('N')) ";
		$set_parent_modules = $this->db->query($sql)->result_array();
		$data_rec = array(); $data_rec['parent_has_children'] = "Y";
		foreach ($set_parent_modules as $x) {
			$this->db->where('xmodules_id', $x['xmodules_id']);
			$this->db->update('ainf_xmodule2', $data_rec);
		}
		
	}

	public function module_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_xmodule2";
		if (isset($_POST['module_name'])) {
			
			// ### IF INACTIVE THEN CAN DELETE - LEAVE A WHILE TO ENSURE NOT NEEDED 
			// // echo "<br>!!! Module active status = {$_POST['active']} xmodules_id = {$_POST['xmodules_id']}"; 
			if ($_POST['delete_module'] == "Y" and $_POST['active'] != "Y") { 
				// Delete the Module 
				$this->db->where('xmodules_id', $_POST['xmodules_id']);
				$this->db->delete($varmain_table);
				$this->current_stock();
				redirect('modules/details/codes_manager');
			}

			$data_rec = array();
			$data_rec['module_name'] = $_POST['module_name']; $data_rec['module_order'] = $_POST['module_order'];
			$data_rec['active'] = $_POST['active'];
			if ($_POST['parent_module'] == 0) {
				$data_rec['module_order_tot'] = $_POST['module_order'] * 100;
			} else {
				$data_rec['module_order_tot'] = $_POST['module_order'] * 100;
				$sql = "select module_order_tot, module_url from ainf_xmodule2 where xmodules_id = {$_POST['parent_module']}";
				$parent_module_order = $this->db->query($sql)->result_array();
				foreach ($parent_module_order as $x) {
					// ### This is to set links in header if active
					$data_rec['module_url_parent'] = $x['module_url'];
					// ### This gives a single field to order modules and sub_modules together (using module_order_tot) and within group using module_order
					$data_rec['module_order_tot'] = $x['module_order_tot'] + $_POST['module_order'];
				}
			}
			
			$data_rec['module_url'] = $_POST['module_url']; $data_rec['system'] = $_POST['system']; $data_rec['module_page'] = $_POST['module_page']; 
			$data_rec['parent_module'] = $_POST['parent_module']; $data_rec['module_notes'] = $_POST['module_notes']; 
			$data_rec['module_tips'] = $_POST['module_tips']; 
			// echo "<br>!!! 88 tips is {$data_rec['module_tips']} "; 

			// // // var_dump($data_rec); 

			if ($_POST['xmodules_id'] != 0) {
				$this->db->where('xmodules_id', $_POST['xmodules_id']);
				$this->db->update($varmain_table, $data_rec);
				$xmodules_id = $_POST['xmodules_id'];
			} else {
				$this->db->insert($varmain_table, $data_rec);
				$xmodules_id = $this->db->insert_id();
			}
			
			// // // // echo "<br>!!aa add is {$_POST['add_tab_label_name']} ";
			//#############################################################################
			//#####	TABS ADD 
			if (trim($_POST['add_tab_label_name']) != "") {
				// // // // // echo "<br>!!bb add is {$_POST['add_tab_label_name']} ";
				$data_rec = array();
				$data_rec['xmodules_id'] = $xmodules_id;
				
				$id_list_array = explode(',',$_POST['id_list']);
				$var_tabs_count = count($id_list_array);
				$data_rec['tab_label_order'] = $var_tabs_count + 1; // Put the new tab at the end - can reorder in edit tab 
				$data_rec['tab_label_name'] = $_POST['add_tab_label_name'];
				if (trim($_POST['add_tab_title_name']) == "") {
					$data_rec['tab_title_name'] = $_POST['add_tab_label_name'];
				} else {
					$data_rec['tab_title_name'] = $_POST['add_tab_title_name'];
				}
				$data_rec['tab_main_table'] = $_POST['add_tab_main_table'];
				$data_rec['tab_table_key'] = $_POST['add_tab_table_key'];
				$data_rec['tab_list_sql'] = $_POST['add_tab_list_sql'];
				$data_rec['tab_list_display_string'] = $_POST['add_tab_list_display_string'];
				$data_rec['tab_edit_link'] = $_POST['add_tab_edit_link'];
				$data_rec['tab_include_file'] = $_POST['add_tab_include_file'];
				$data_rec['tab_add_link'] = $_POST['add_tab_add_link'];
				$this->db->insert('ainf_xmodule2_tabs', $data_rec);
				// // // // echo "<br>!!cc add is {$_POST['add_tab_label_name']} ";
			}
			
			//############################################################################# 
			//#####	TABS MOD 
			$id_list_array = explode(',',$_POST['id_list']);
			$var_tabs_count = count($id_list_array);
			// // // // echo "<br>!!11 mod array ids";
			// // var_dump($var_tabs_count);
			for ($x = 0; $x < $var_tabs_count; $x++) { //## Loop works for Update
				$data_rec = array();
				$var_id = $id_list_array[$x];
				$var_tab_label_name = $var_id . "_tab_label_name";
				//### the label is short for mobile, BUT the title is long to describe the list/record
				$data_rec['tab_label_name'] = $_POST[$var_tab_label_name];
				$var_tab_title_name = $var_id . "_tab_title_name";
				$data_rec['tab_title_name'] = $_POST[$var_tab_title_name];
				$var_tab_main_table = $var_id . "_tab_main_table";
				$data_rec['tab_main_table'] = $_POST[$var_tab_main_table];
				$var_tab_table_key = $var_id . "_tab_table_key";
				$data_rec['tab_table_key'] = $_POST[$var_tab_table_key];
				$var_tab_edit_link = $var_id . "_tab_edit_link";
				$data_rec['tab_edit_link'] = $_POST[$var_tab_edit_link];
				$var_tab_add_link = $var_id . "_tab_add_link";
				$data_rec['tab_add_link'] = $_POST[$var_tab_add_link];
				$var_tab_include_file = $var_id . "_tab_include_file";
				$data_rec['tab_include_file'] = $_POST[$var_tab_include_file];
				$var_tab_label_order = $var_id . "_tab_label_order";
				$data_rec['tab_label_order'] = $_POST[$var_tab_label_order];

				$var_tab_list_sql = $var_id . "_tab_list_sql";
				$data_rec['tab_list_sql'] = $_POST[$var_tab_list_sql];
				// // // // echo "<br><br>Field is $var_tab_list_sql post is {$_POST[$var_tab_list_sql]} ";
				
				$var_tab_list_display_string = $var_id . "_tab_list_display_string";
				$data_rec['tab_list_display_string'] = $_POST[$var_tab_list_display_string];
				// // // // echo "<br><br>Field is $var_tab_list_display_string post is {$_POST[$var_tab_list_display_string]} ";
				
				$var_tab_search_on = $var_id . "_tab_search_on";
				// // // // echo "<br><br>Field is $var_tab_search_on post is {$_POST[$var_tab_search_on]} ";
				If ($_POST[$var_tab_search_on] == "Y") {
					$data_rec['tab_search_on'] = "Y";
				} else {
					$data_rec['tab_search_on'] = "N";
				}
				$var_tab_add_on = $var_id . "_tab_add_on";
				// // // // echo "<br><br>Field is $var_tab_add_on post is {$_POST[$var_tab_add_on]} ";
				If ($_POST[$var_tab_add_on] == "Y") {
					$data_rec['tab_add_on'] = "Y";
				} else {
					$data_rec['tab_add_on'] = "N";
				}
				
				$this->db->where('id', $var_id);
				$this->db->update(ainf_xmodule2_tabs, $data_rec);
			}
		}
		
		//### VIP SET THE parent_has_children FLAG 
		
		$this->current_stock();
				
		If ($_POST['return_to_list'] == "yes") {
			$this->details(codes_manager);
		} else {
			$sql = "select * from ainf_xmodule2 where `system` = 'Churchofjesus' and parent_module = 0 ";
			$data['parent_modules'] = $this->db->query($sql)->result_array();
			$sql = "SELECT * FROM ainf_vps3_code_manager where code_group = 'sys_tab_keys' order by code_name";
			$data['key_codes'] = $this->db->query($sql)->result_array();
			if ($_POST['xmodules_id'] > 0 or $xmodules_id > 0) { // the id is always set from default meeting 
				if ($_POST['xmodules_id'] > 0) {$xmodules_id = $_POST['xmodules_id'];}
				$sql = "select * from $varmain_table where xmodules_id = $xmodules_id";
				$data['edit_module'] = $this->db->query($sql)->result_array();
				$_POST['xmodules_id'] = $xmodules_id;
				$sql = "select * from ainf_xmodule2_tabs where xmodules_id = $xmodules_id order by tab_label_order";
				$data['list_tabs'] = $this->db->query($sql)->result_array();
				$this->load->view('update_module', $data);
			} else {
				$_POST['id'] = 0;
				$this->load->view('update_module', $data);
			}
		}
	}
		
	public function details($pagename)
	{
	
		// #### Get the tips if they are present from the module record 
		$sql = "select * from ainf_xmodule2 where module_url = 'modules2/details' or module_url = 'Modules2/details' limit 0,1 "; 
		$data['tips_data'] = $this->db->query($sql)->result_array(); 
		// // var_dump($data['tips_data']); 

		if (isset($_SERVER['QUERY_STRING'])) { 
			$page_chk = explode('?',$pagename); 
			$pagename = $page_chk['0']; 
		} 
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = $_POST['sess_compid'];		
		$var_search = "";
		
		// Process the form filter 
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		$data['events'] = $this->db->query($sql)->result_array();
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$sql = "select * from ainf_xcloud_videos, mentor_series where video_series = mentor_series.id order by video_order";
		$data['messages'] = $this->db->query($sql)->result_array();
		// //// // var_dump($data['messages']);
		
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		// // // // // echo "<br>!!55 ";
		


		$var_search = "";
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_series'] = "";
		}
		if ($_POST['form_series'] != "") {
			$var_search .= " and video_series = '{$_POST['form_series']}' ";
		}
		
		if ($_POST['form_archive'] != "" and $_POST['form_archive'] != "all") {
			$var_search .= " and v.archive = '{$_POST['form_archive']}' ";
		}

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position"); 
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason 
		$data['eunit_checklist'] = $this->process_get_checklist(); // load the checklist items
		// //// // var_dump($data['eunit_checklist']);
		
		// // // // // echo "<br>!!66 ";
		
		// // echo "<br>!! 55"; 
		
		$var_mastercompid = 113;
		$sql = "select distinct code_group from ainf_vps3_code_manager where mastercompid = $var_mastercompid order by code_group";
		$data['code_group_list'] = $this->db->query($sql)->result_array();

		$var_mastercompid = 113;
		if ($_POST['form_code_group'] != "")
			{$var_sql = " and code_group = '{$_POST['form_code_group']}' ";}
		elseif ($_POST['code_group'] != "")
			{$var_sql = " and code_group = '{$_POST['code_group']}' ";
			$_POST['form_code_group'] = $_POST['code_group'];
			}
		else  
			{$var_sql = " ";}
		// // echo "<br>!! 55 B"; 
		
		$sql = "select * from ainf_xmodule2 where `system` = 'Churchofjesus' and active in ('Y','N') order by module_order_tot"; 
		$data['module_list'] = $this->db->query($sql)->result_array(); 
		// // echo "<br>!! 55 C"; 
		$sql = "select * from ainf_xmodule2 where `system` = 'Churchofjesus' and active = 'N' order by module_order_tot"; 
		$data['inactive_modules'] = $this->db->query($sql)->result_array(); 
		// // echo "<br>!! 55 D"; 
		$sql = "select * from ainf_xmodule2 where `system` = 'Churchofjesus' and active = 'D' order by module_order_tot"; 
		$data['dev_new_modules'] = $this->db->query($sql)->result_array(); 

		// // echo "<br>!! 66";

		// // echo "<br>!! 77";

		// very basic error handling 
		if (file_exists(base_url("views/$pagename_orig")))
		{ 
			$_POST['error'] = ""; 
			$this->load->view($pagename_orig, $data); 
		} else { 
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page."; 
			$this->load->view($pagename_orig, $data); 
			// $this->load->view('index', $data); 
		}
		
	}

}
	