<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Overshadow7 extends CI_Controller { 
	// Rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		error_reporting(0);
		parent::__construct();
					
		// // echo "<br>!! 11AA compid = $var_compid ";
		
		////error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_STRICT & ~E_USER_NOTICE & ~E_USER_DEPRECATED);
		
		$var_qr_public = $this->session->userdata('qr_public'); // #### with QR they are logged into the company USER not needed 
		
		// ################################################################
		// #### CORRECT SETTING TO SWITCH PUBLIC MODE - ONLY COMP IS SET 
		
		// var_dump($_POST);

		$var_userid = $this->session->userdata('userid');
		if ($var_userid != "" and $_POST['sess_userid'] == "") {
			$_POST['sess_userid'] = $var_userid;
		}

		$var_compid = $this->session->userdata('compid');
		if ($var_compid != "" and $_POST['sess_compid'] == "") {
			$_POST['sess_compid'] = $var_compid;
		}
				
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		$this->load->helper('text');
		
		// // echo "<br>!! 11gg compid = $var_compid ";
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function home()
	{
		$this->load->view('home');		
	}
	
	public function check_function()
	{
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // //// // // // // // // // // // echo   "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // //// // // // // // // // // // echo   "!! must write other functions code for funciton $callfunction";
		}
		// //// // // // // // var_dump($_POST);
	}

	public function focus($pagename)
	{
		$_POST['video_type'] = "tract"; 
		$this->details($pagename); 
	}

	public function details($pagename)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);

		if ($_POST['video_type'] == "") {$_POST['video_type'] = "regular";}
		//*** Get page name for the link 
		
		if ($pagename == "video-player-bsbc-qrcodes") {
			$_POST['qr_code_link'] = "yes";
			$pagename = "video-player-bsbc-base";
		} else {
			$_POST['qr_code_link'] = "no";
		}
				
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} 
		// index.php is multi-purpose but same core data - message list or service list 
		
		// // // echo "<br>!!33 pagename_orig $pagename_orig";
		
		$varcompid = 110; 
		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid > 0 order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book ";
		$data['messages'] = $this->db->query($sql)->result_array();
		
		// // // echo "<br>!!44";
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		$varcompid = $_POST['sess_compid'];
		$var_userid = $this->session->userdata('userid');
		$sql = "select * from ainf_vps3_users, ainf_xglobalclient where userid = profile_leader_userid and globcompid = $varcompid";
		$data['messages'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// ////// var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 
		// // // echo "<br>!!55";

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_xcloud_videos where id in (select profile_about_us_video from ainf_xglobalclient where globcompid = $varcompid)"; 
		$data['about_videos'] = $this->db->query($sql)->result_array(); 
		
		// // // echo "<br>!!66";
		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			// // // echo "<br>!!yy11 pagename_orig - $pagename_orig ";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	