<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Password_v2 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Load_sys_data'); //### FOR MENUS AND TABS 
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW START
		// ################################################################ 
		$this->load->model('Recheck_access6');
		$var_access_status = $this->Recheck_access6->reset_access6();
		if ($var_access_status == "expired/logout" and strpos($_SERVER['REQUEST_URI'], "bible") === false) {
			// #### The userid and/or compid expired or logged out - goto bible app 
			redirect('bible3/bible_display', 'refresh');
		}
		$this->load->model('System_modules');
		// ################################################################ 
		// #### NEW ACCES - HANDLES PUBLIC MODE NOW END 
		// ################################################################ 
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// // // // // // // echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // // // // // echo "!! must write other functions code for funciton $callfunction";
		}
		////// // var_dump($_POST);
	}	

	public function edit_pwd()
	{
		
		$varcompid = $_POST['sess_compid']; 
		$varmain_table = "aasys_passwd"; 
		if (isset($_POST['gen_title'])) {
			
			// ### IF INACTIVE THEN CAN DELETE - LEAVE A WHILE TO ENSURE NOT NEEDED 
			if ($_POST['delete_module'] == "Y") { 
				$data_rec = array(); 
				// ### Mark for the trash listing 
				$data_rec['pwd_trash_del'] = "Y"; 
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec); 
				redirect('Password_v2/list/manage_key_lists_4'); 
			} 

			$data_rec = array(); 
			$data_rec['pass_userid'] = $_POST['sess_userid']; $data_rec['pass_date_update'] = date('Y/m/d H:mm');
			$data_rec['pass_password_technote'] = $_POST['gen_pass_password_technote'];
			$data_rec['title'] = $_POST['gen_title'];
			$data_rec['pass_link'] = $_POST['gen_pass_link']; 
			
			$var_pass_link_short = str_replace('https://','', $data_rec['pass_link']); 
			$var_pass_link_short_array = explode('/',$var_pass_link_short); 
			$data_rec['pass_link_short'] = "https://" . $var_pass_link_short_array[0]; // ### Short is for list 

			$data_rec['pass_login'] = $_POST['gen_pass_login']; $data_rec['pass_password'] = $_POST['gen_pass_password']; 
			$data_rec['pass_notes_general'] = $_POST['gen_pass_notes_general']; $data_rec['pass_notes_support'] = $_POST['gen_pass_notes_support']; 
			$data_rec['pass_email'] = $_POST['gen_pass_email']; 

			if ($_POST['gen_pass_fav'] == "Y") {$data_rec['pass_fav'] = "Y";} else {$data_rec['pass_fav'] = "N";} 
			if ($_POST['gen_pass_draft'] == "Y") {$data_rec['pass_draft'] = "Y";} else {$data_rec['pass_draft'] = "N";} 
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
				$xmodules_id = $_POST['id'];
			} else {
				$data_rec['pass_date_create'] = date('d/m/Y H:mm');
				$this->db->insert($varmain_table, $data_rec);
				$_POST['id'] = $this->db->insert_id();
			}
		}
		
		//### VIP SET THE parent_has_children FLAG 
		If ($_POST['return_to_list'] == "yes") {
			redirect('Password_v2/list/manage_key_lists_4'); 
		} else {

			$length = 10;
			$_POST['pass_sample1'] = substr(str_shuffle("0123456789!@#$%^&*ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*"), 0, $length);
			$_POST['pass_sample2'] = substr(str_shuffle("ABCDEFGHIJKLMNOPQRSTUVWXYZ!@#$%^&*abcdefghijklmnopqrstuvwxyz0123456789!@#$%^&*"), 0, $length);
			$_POST['pass_sample3'] = substr(str_shuffle("ABCDEFGHIJKLMNOPQRSTUVWXYZ!@#$%^&*0123456789!@#$%^&*abcdefghijklmnopqrstuvwxyz"), 0, $length);
			$_POST['pass_sample4'] = substr(str_shuffle("ABCDEFGHIJKLMNOPQRSTUVWXYZ!@#$%^&*0123456789!@#$%^&*abcdefghijklmnopqrstuvwxyz"), 0, $length);
			
			$sql = "SELECT * FROM ainf_vps3_code_manager where code_group = 'sys_tab_keys' order by code_name";
			$data['key_codes'] = $this->db->query($sql)->result_array();
			if ($_POST['id'] > 0) { // the id is always set from default meeting 
				// echo "<br>!! 66 done ins";
				$sql = "select * from aasys_passwd where id = {$_POST['id']} ";
				$data['curr_pwd'] = $this->db->query($sql)->result_array();
				$this->load->view('update_password', $data);
			} else {
				$_POST['id'] = 0;
				// echo "<br>!! 77 done ins";
				$this->load->view('update_password', $data);
			}
		}
	}
	
	public function list($pagename)
	{
	
		// // echo "<br>!! 11 ";
		$data['sys_menu_tabs'] = $this->Load_sys_data->get_tabs();
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		
		$varcompid = $_POST['sess_compid'];		
		$var_search = "";

		$var_search = "";
		$var_mastercompid = 113;

		
		$sql = "select * from aasys_passwd where pass_fav in ('Y') and pass_draft in ('N') order by id"; 
		$data['main_list_array_tab1'] = $this->db->query($sql)->result_array(); 
		// var_dump($data['main_list_array_tab1']); 
		$sql = "select * from aasys_passwd where pass_fav not in ('Y') and pass_draft in ('N') order by pass_fav desc, id"; 
		$data['main_list_array_tab2'] = $this->db->query($sql)->result_array(); 

		$sql = "select * from aasys_passwd where pass_draft in ('Y') order by pass_fav desc, id"; 
		$data['main_list_array_tab3'] = $this->db->query($sql)->result_array(); 
		// var_dump($data['main_list_array_tab3']); 
		
		if (file_exists(base_url("views/$pagename_orig"))) 
		{ 
			$_POST['error'] = ""; 
			$this->load->view($pagename_orig, $data); 
		} else { 
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page."; 
			$this->load->view($pagename_orig, $data); 
			// $this->load->view('index', $data); 
		}
		
	}

}
	