<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Speakers6 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again.
			redirect('Ad_user_login_v4');
		}
		
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');	
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS 
		$this->load->model('System_modules'); $this->load->model('Recheck_access'); 
		$this->Recheck_access->reset_access(); 
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS 
		
		$var_compname = $this->session->userdata('compname'); 
		$var_first_name = $this->session->userdata('first_name'); 
		$var_last_name = $this->session->userdata('last_name'); 
		
	}

	public function foryou($hashnum)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);
		
		//#### From hashnum - extract videoid - then the companyid ####// 
		$var_vid_id_array = explode('4477',$hashnum); 
		$var_vid_id = $var_vid_id_array['1']; 
		// //var_dump($var_vid_id_array);
		
		// ### 956744773934477
		$subqry = ""; $var_search = ""; 
		$varoffset = 0; $recsperpage = 1; 
		
		$compid_string = " compid > 0 ";
		$sql = "select * from ainf_xcloud_videos where id = $var_vid_id"; 
		$data['messages'] = $this->db->query($sql)->result_array(); 
		foreach ($data['messages'] as $z) {
			$varcompid = $z['compid'];
			$compid_string = " compid = $varcompid ";
		}
		
		// //var_dump($data['messages']); 
				
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// ////var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where ($compid_string and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and $compid_string order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array();
		
		// very basic error handling
		
		$pagename_orig = "video-player-bsbc-base";
		$pagename_orig = "video-player-bsbc-foryou";
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function member_edit()
	{

		error_reporting(0);

		$var_userid = $this->session->userdata('userid');
		$varcompid = $_POST['sess_compid'];
		$varcompid2 = $varcompid;
		
		unset($_POST['add_vid_sent_id']);
		unset($_POST['add_vid_sent_notes']);
		
		// team_image_link
		$var_vid_teacher_image = "";
		if($_FILES['team_image_link']['name']) {
			$targetPath = "/home/bizadmin/churchofjesus.live/client_files/"; // correct path for infinity 
			$targetPath = "/home/bizadmin/churchofjesus.live/client_files/"; // correct path for infinity 
			$varurlpath = "https://churchofjesus.live/client_files/"; 
		
			$upload=$_FILES['team_image_link']['name'];
			$ext=end(explode('.',$upload));
			$config['allowed_types'] = array('png','jpg', 'jpeg', 'gif', 'tif');
			if(1==1 or in_array($ext,$config['allowed_types'])) {
			// echo"<br>XX22 vid 2 id {$_POST['id']}";
				$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
				$vardate = date("Y-m-d-H-m-s");
				$targetFile = $varcompid . "_vid_preacher_image_" . $vardate . "." . $ext;
				if (is_dir($targetPath)and is_writable($targetPath)) {
					if (move_uploaded_file($_FILES['team_image_link']['tmp_name'], $targetPath . $targetFile)) {
						$var_vid_teacher_image = $varurlpath . $targetFile;
					}
				} else {
					$err = "The path target or dir $targetPath or NOT WRITABLE";
				}
			} else {
				$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
			}
		}

		if ($_POST['first_name'] != "") {
			$dat_rec = array();
			if ($var_vid_teacher_image != "") {
				$dat_rec['team_image_link'] = $var_vid_teacher_image;
			}
			$dat_rec['first_name'] = $_POST['first_name']; $dat_rec['last_name'] = $_POST['last_name'];
			$dat_rec['start_date'] = $_POST['start_date']; $dat_rec['mobile'] = $_POST['mobile'];
			$dat_rec['team_regular_church'] = $_POST['team_regular_church']; $dat_rec['team_about'] = $_POST['team_about'];
			if ($_POST['is_speaker'] == "yes") {$dat_rec['is_speaker'] = "yes";} else {$dat_rec['is_speaker'] = "no";}
			$dat_rec['writeup'] = $_POST['writeup']; $dat_rec['sex'] = $_POST['sex'];
			$this->db->where('userid', $_POST['userid']);
			$this->db->update(ainf_vps3_users, $dat_rec);
		}
		
		//### Load the data for form edit 
		if ($_POST['id'] > 0) {
			$id = $_POST['id']; // value set from listing 
		} elseif ($_POST['add_record'] == "yes") {
			$dat_rec = array();
			$dat_rec['first_name'] = "New Speaker - Please Update";
			$dat_rec['compid'] = $varcompid; $dat_rec['is_speaker'] = "yes";
			$this->db->insert(ainf_vps3_users, $dat_rec);
			echo "";
			$_POST['id'] = $this->db->insert_id();
			$id = $_POST['id']; // value set from listing
			// $id = $_POST['userid']; // value set from listing 
		} elseif ($_POST['userid'] > 0) {
			$id = $_POST['userid']; // value set from listing 
		} else {
			$id = 0; // value set from listing 
		}
		$sql = "select code_name from ainf_vps3_code_manager where code_group = 'Sex' order by code_name";
		$data['sex_types'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where userid = $id";
		$data['edit_speaker'] = $this->db->query($sql)->result_array();
		// //var_dump($data['edit_teampro_groups']);
		
		If ($_POST['return_to_list'] == "yes") {
			redirect('/speakers6/speakers/manage_key_lists'); // back to listing 
		} else {
			$this->load->view('update_speaker', $data);
		}
	}

	public function speakers($pagename)
	{
	
		error_reporting(E_ALL);
		error_reporting(0);

		//*** Get page name for the link 
		
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} 
		// index.php is multi-purpose but same core data - message list or service list 
		
		$varcompid = 110; 
		$varcompid = $_POST['sess_compid'];
		$var_search = "";
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid and is_speaker = 'yes' order by first_name, last_name";
		$data['speaker_list'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid and is_speaker not in ('yes') order by first_name, last_name";
		$data['speaker_not_list'] = $this->db->query($sql)->result_array();
			
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}		
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid > 0 order by date_sort desc"; 
		$data['events'] = $this->db->query($sql)->result_array(); 
		
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$sql = "select id from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, book ";
		$data['messages'] = $this->db->query($sql)->result_array();
		
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		$var_userid = $this->session->userdata('userid'); 
		/// echo "!! mode is {$_POST['pagename_mode']} "; 
		if ($_POST['pagename_mode'] == "recommended_videos") {
			$ainf_fields = "audio_link, teacher_imagebg, book1, book1verse, book2, book2verse, book3, book3verse, book4, book4verse, book5, book5verse, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort ";
			$ainf_fields = "audio_link, teacher_imagebg, book1, book1verse, book2, book2verse, book3, book3verse, book4, book4verse, book5, book5verse, 
			point1for, point2for, point3for, point4for, point5for, point1itisnot, point2itisnot, point3itisnot, point4itisnot, point5itisnot, point1action, point2action, point3action, 
			point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, ainf_xcloud_videos.id, series, message, message_date_sort, vid_memberid_to, vid_sent_notes, vid_sent_date_sort ";
			// point4action, point5action, teacher_image, teacher_title, teacher, title, message_date, series, ainf_xcloud_videos.id, message, message_date_sort desc, vid_sent_notes, vid_sent_date_sort ";
	
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select * from ainf_xcloud_videos where id in (select vid_videoplay_id from ainf_xcloud_vid_sent where vid_memberid_to = $var_userid) order by message_date_sort desc, teacher limit $varoffset, $recsperpage";
			$sql = "select $ainf_fields from ainf_xcloud_videos, ainf_xcloud_vid_sent where ainf_xcloud_videos.id = vid_videoplay_id and vid_memberid_to = $var_userid order by vid_sent_date_sort desc, teacher ";
			$data['messages'] = $this->db->query($sql)->result_array(); 
			// echo "<br>!!! the new sql is $sql and dump is <br><br>"; 
			// //var_dump($data['messages']); 
		} else {
			$sql = "select * from ainf_xcloud_videos where compid > 0 $subqry $var_search order by message_date_sort desc, teacher limit $varoffset, $recsperpage"; 
			$data['messages'] = $this->db->query($sql)->result_array(); 
		}
				
		$sql = "select distinct teacher from ainf_xcloud_videos where compid > 0 $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid > 0 order by book"; 
		$data['books'] = $this->db->query($sql)->result_array(); 
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid > 0 order by code_id"; 
		$data['services'] = $this->db->query($sql)->result_array(); 
		// ////var_dump($data['services']); 

		$sql = "select * from cms_images where compid > 0 order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid > 0 order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 

		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and code_name not like '%Sun Service%' and code_name not like '%Sun Belvoir Kids%' and compid = $varcompid order by code_type"; $data['bible_study'] = $this->db->query($sql)->result_array();
		
		// very basic error handling
		
		$sql = "select * from speakers, ainf_vps3_users where speaker_userid = userid order by ainf_vps3_users.first_name, ainf_vps3_users.last_name ";
		$data['speakers'] = $this->db->query($sql)->result_array();
		// //var_dump($data['speakers']);
		
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}
	
	public function index()
	{
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // echo"!! must write other functions code for funciton $callfunction";
		}
	}

	public function video_edit()
	{

		// ### !!! The for post is getting totally cleared when the file field for VIDEO_LINK is being loaded.. 
		// ### The for post is getting totally cleared when the file field is being loaded.. 
		// //var_dump($_POST);
		error_reporting(0);
		
		$varcompid = $_POST['sess_compid'];
		// //echo "<br>!!11 vid id is {$_POST['id']} actual is 395";

		////echo "<br>!! vid 11 - this is post";
		// //var_dump($_POST);
		
		////echo "<br>!!aa OUT OF POST vid 11 - this is post";
		
		if ($_POST['title'] != "") {
			////echo "<br>!! vid 22";
			$var_video_link = "";
		//////echo "<br>!!22 vid id is {$_POST['id']} actual is 395";
			if ($_FILES['video_link']['name']) {

				$targetPath = "/home/bizadmin/churchofjesus.live/client_videos/"; // correct path for infinity
				$varurlpath = "https://churchofjesus.live/client_videos/";
				
				$upload=$_FILES['video_link']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('m4a','mp4', 'mov', 'mp3');
				if(1==1 or in_array($ext,$config['allowed_types'])) {
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = $varcompid . "_service_video_" . $vardate . "." . $ext;
					////echo "<br>!! vid aa";
					if (is_dir($targetPath)and is_writable($targetPath)) {
					////echo "<br>!! vid bb";
						if (move_uploaded_file($_FILES['video_link']['tmp_name'], $targetPath . $targetFile)) {
					////echo "<br>!! vid cc";
							$var_video_link = $varurlpath . $targetFile;
						}
					} else {
					////echo "<br>!! vid dd";
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}
				} else {
					////echo "<br>!! vid ee";
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
				}
		//////echo "<br>!!33 vid id is {$_POST['id']} actual is 395";
			} else {
		////echo "<br>!! vid 44";
			}

			$var_teacher_image = "";
			if($_FILES['user_image']['name']) {
				$targetPath = "/home/bizadmin/churchofjesus.live/client_files/"; // correct path for infinity 
				$targetPath = "/home/bizadmin/churchofjesus.live/client_files/"; // correct path for infinity 
				$varurlpath = "https://churchofjesus.live/client_files/"; 
			
				$upload=$_FILES['user_image']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('png','jpg', 'jpeg', 'gif', 'tif');
				if(1==1 or in_array($ext,$config['allowed_types'])) {
				// echo"<br>XX22 vid 2 id {$_POST['id']}";
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = $varcompid . "_preacher_image_" . $vardate . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						if (move_uploaded_file($_FILES['user_image']['tmp_name'], $targetPath . $targetFile)) {
							$var_teacher_image = $varurlpath . $targetFile;
							if ($_POST['teacher_image_all'] == "y" and $_POST['teacher'] != "") {
								$image_rec = array();
								$image_rec['teacher_image'] = $var_teacher_image; 
								$this->db->where('teacher', $_POST['teacher']);
								$this->db->where('compid', $varcompid);
								$this->db->update(ainf_xcloud_videos, $image_rec);
							}
						}
					} else {
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}
				} else {
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
				}
			}
			
		//////echo "<br>!!55 vid id is {$_POST['id']} actual is 395";
		
			$data_rec = array();
			$data_rec['teacher'] = $_POST['teacher']; $data_rec['title'] = $_POST['title'];
			$data_rec['book'] = $_POST['book']; 
			
			if (trim($_POST['series_add']) != "") {
				$data_rec['series'] = $_POST['series_add'];
			} else {
				$data_rec['series'] = $_POST['series'];
			}

			if(trim($_POST['video_link_youtube']) != "") {
				// ### GET LISTING TO RUN ON VIDEOS 
				// $data_rec['video_link'] = trim($_POST['video_link_youtube']); $data_rec['audio_link'] = trim($_POST['video_link_youtube']); 
			}
			if ($var_video_link != "") {
				$data_rec['video_link'] = $var_video_link; $data_rec['audio_link'] = $var_video_link;
			}
			if ($var_teacher_image != "") {
				$data_rec['teacher_image'] = $var_teacher_image; 
			} else {
				$data_rec['teacher_image'] = $_POST['teacher_image']; //## This is a hidden field and fine to use for copy or no changes made 
			}
			$data_rec['video_link_youtube'] = trim($_POST['video_link_youtube']); 
			$data_rec['message'] = $_POST['message']; 
			$data_rec['message_date'] = $_POST['message_date'];
			$date_time = explode(" ",$_POST['message_date']);
			$date_time_parts = explode("/",$date_time[0]);
			$data_rec['message_date_sort'] = $date_time_parts[2] . "/" . $date_time_parts[1] . "/" . $date_time_parts[0] . " " . $date_time[1];
			$data_rec['teacher_title'] = $_POST['teacher_title']; $data_rec['teacher'] = $_POST['teacher'];
			if ($_POST['active']=="Y") {$data_rec['active']="Y";} else {$data_rec['active']="N";}
			
			if ($_POST['id'] != 0 and $_POST['update_video'] == "y") {
				// echo"<br>!!x1 in update is {$_POST['id']}";
				$this->db->where('id', $_POST['id']);
				$this->db->update(ainf_xcloud_videos, $data_rec);
			} else {
				// echo"<br>!! y22 in update is {$_POST['id']}";
				if ($_POST['copy_video'] == "y") {
					$_POST['return_to_list'] = ""; //## COPY MAKE THEM CHECK THIS 
					$data_rec['title'] = "This is a copy - plese set now"; 
				}
				$data_rec['compid'] = $varcompid;
				$this->db->insert(ainf_xcloud_videos, $data_rec);
				$_POST['id'] = $this->db->insert_id();
			}
			
			if ($_POST['return_to_list'] == "y") {
				$this->video_views('manage_key_lists');
			} else {
				////////echo "<br>!!aa detail here";
				$this->video_views('update_video_detail');
			}
		} else {
				////////echo "<br>!!bb detail here";
			$this->video_views('update_video_detail');
		}
		
	}

	public function video_views($video_page)
	{
		
		//////echo "<br>!!AA IN video_views to load record vid id is {$_POST['id']} actual is 395";
		$varcompid = $_POST['sess_compid'];
		$var_action_copy = "copy_record_" . $_POST['id'];
		$var_action_edit = "mod_record_" . $_POST['id'];
		$var_copy_value = $_POST["$var_action_copy"];
		$var_edit_value = $_POST["$var_action_edit"];
		
		if ($var_copy_value == "yes") {
			//////echo "<br>!!BB IN copy video {$_POST['id']} actual is 395 ";
			$sql = "select * from ainf_xcloud_videos where id = {$_POST['id']} limit 0,1";
			$get_rec_forcopy = $this->db->query($sql)->result_array();
			$copy_rec = array();
			foreach ($get_rec_forcopy as $z) {

				$copy_rec['title'] = "Just Copied - Please Update";
				$copy_rec['teaser'] = "Just Copied - Please Update";
				$copy_rec['message'] = "Just Copied - Please Update";
				 	
				$copy_rec['video_type'] = $z['video_type'];
				$copy_rec['video_series'] = $z['video_series'];
				$copy_rec['video_writeup'] = $z['video_writeup'];
				$copy_rec['active'] = "Y";
				$copy_rec['video_order'] = $z['video_order'];
				$copy_rec['book'] = $z['book'];
				$copy_rec['compid'] = $z['compid'];
				$copy_rec['mastercompid'] = $z['mastercompid'];
				$copy_rec['public_viewing'] = $z['public_viewing'];
				$copy_rec['video_trainerid'] = $z['video_trainerid'];
				$copy_rec['pageid'] = $z['pageid'];
				$copy_rec['video_name'] = $z['video_name'];
				$copy_rec['ecourse_id'] = $z['ecourse_id'];
				$copy_rec['eunit_id'] = $z['eunit_id'];
				$copy_rec['date_create'] = date("Y/m/d H:i:s");
				
				$this->db->insert(ainf_xcloud_videos, $copy_rec); 
				$_POST['id'] = $this->db->insert_id(); 
			}
			
		}
		
		////////echo "<br>!! copy action POST value - $var_copy_value ";
		////////echo "<br>!! edit action POST value - $var_edit_value ";
		
		if ($video_page == "update_video_detail") {
			//////echo "<br>!!CC IN copy video {$_POST['id']} actual is 395 ";
			$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
			$data['vidbooks'] = $this->db->query($sql)->result_array();
			if ($_POST['id'] != "") {
				$sql = "select * from ainf_xcloud_videos where id = {$_POST['id']} limit 0,1";
				$data['videdit'] = $this->db->query($sql)->result_array();
			}
			$sql = "select distinct series from ainf_xcloud_videos where compid = $varcompid order by series "; 
			$data['vidseries'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from `ainf_vps3_code_manager` where code_group like 'preacher_title'";
			$data['titles'] = $this->db->query($sql)->result_array();
			$sql = "select title, full_name from speakers where compid = $varcompid";
			$data['speakers'] = $this->db->query($sql)->result_array();
			$sql = "select distinct teacher from ainf_xcloud_videos where compid = $varcompid order by teacher"; 
			$data['speakers'] = $this->db->query($sql)->result_array(); 
			
			$this->load->view($video_page, $data); 
			
		} elseif ($video_page == "manage_key_lists") {
			//////echo "<br>!!DD IN copy video {$_POST['id']} actual is 395 ";
			$sql = "select * from ainf_xcloud_videos order by message_date_sort desc "; 
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid order by message_date_sort desc "; 
			$data['vidlist'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid and active in ('Y') order by message_date_sort desc "; 
			$data['vidlist_active'] = $this->db->query($sql)->result_array(); 
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid  and active not in ('Y') order by message_date_sort desc "; 
			$data['vidlist_inactive'] = $this->db->query($sql)->result_array(); 
			
			$this->load->view($video_page, $data);
		}
	}

}
	
