<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Video_Trainer3 extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		if (strpos($_SERVER['REQUEST_URI'], 'display/trainer3_public') === false) {
			//### LOGIN CHECKS ARE AVOIDED FOR PUBLIC VIDEOS 
			$var_userid = $this->session->userdata('userid');
			if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
				redirect('Ad_user_login_v4');
				// break;
		
				//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
				$this->load->model('System_modules'); $this->load->model('Recheck_access');
				$this->Recheck_access->reset_access();
				//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
				
				$var_compname = $this->session->userdata('compname');
				$var_first_name = $this->session->userdata('first_name');
				$var_last_name = $this->session->userdata('last_name');
			}
		}
	}
	
	public function index()
	{
		$this->load->helper('url');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// echo "!! must write other functions code for funciton $callfunction";
		}
		////var_dump($_POST);
	}	

	function process_get_checklist()
	{
		// $compid = $this->session->userdata('compid');
		if (1==1) {
			// Add any new checklists 
			if (isset($_POST['checklist_item_add1']) and trim($_POST['checklist_item_add1']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add1']);
				$this->db->insert('edu_checklist', $inscheck);
			}
			if (isset($_POST['checklist_item_add2']) and trim($_POST['checklist_item_add2']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add2']);
				$this->db->insert('edu_checklist', $inscheck);
			}
		}

		$q = $this->db->query("select * FROM edu_checklist");		
		$data = $q->result_array();
		return($data);
	} 

	public function video_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_xcloud_videos";
		
		if (isset($_POST['teaser'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']); 
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";} else {$data_rec['archive'] = "no";}
			if ($_POST['introduction_video'] == "yes") {$data_rec['introduction_video'] = "yes";} else {$data_rec['introduction_video'] = "no";}
			if ($_POST['public_viewing'] == "yes") {$data_rec['public_viewing'] = "yes";} else {$data_rec['public_viewing'] = "no";}
			
			//var_dump($data_rec);
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}			
		}
		
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();
		////var_dump($data['list_series']);
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			$this->details(trainer3_manager);
		} elseif ($_POST['id'] > 0 or $id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $varmain_table where id = $id";
			$data['edit_videos'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_videos', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_videos', $data);
		}
	}
		
	public function series_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "mentor_series";
		
		if (isset($_POST['series_teaser'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['main_action']); unset($data_rec['MAX_FILE_SIZE']);
			unset($data_rec['userid']);
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
			
			// echo "<br>!! The value is {$_POST['video_id_group']}";
			$var_series_vids = explode(',',$_POST['video_id_group']);
			$var_vids_in_series = count($var_series_vids) - 1;
			// echo "<br>!! the num in the series is $var_vids_in_series";
			$var_series_vids_new = array();
			$var_series_vids_new_string = "";
			unset($data_rec['video_id_group']);
			
			// echo "";
			for ($i = 1; $i <= $var_vids_in_series; $i++) { // Only 1 cycle 
			
				foreach ($var_series_vids as $key => $value) {
					if (trim($value) != "") {
						// // echo "<br> The value is {$value} ";
						
						$var_vid_field = "video_order_" . $value;
						if ($i == $_POST[$var_vid_field]) { // begin to file the vid ids in the new order set 
							$var_series_vids_new_string .= "$value,";
						}
						unset($data_rec[$var_vid_field]);

						$var_this_value = $_POST[$var_vid_field];
						// $var_series_vids_new[$var_this_value] = $value;
					}
				}
			}

			$str_edit_length = strlen($var_series_vids_new_string) - 1;
			$var_series_vids_new_string2 = substr($var_series_vids_new_string, -$var_series_vids_new_string, $str_edit_length);
			$data_rec['series_video_order'] = $var_series_vids_new_string2;

			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";} else {$data_rec['archive'] = "no";}
			if ($_POST['public_viewing'] == "yes") {$data_rec['public_viewing'] = "yes";} else {$data_rec['public_viewing'] = "no";}
			
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where is_speaker = 'yes' and compid = $varcompid";
		$data['speaker_names'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		$sql = "select * from ainf_xcloud_videos where introduction_video = 'Yes' and compid = $varcompid";
		$data['intro_videos'] = $this->db->query($sql)->result_array();
		
		if ($_POST['id'] > 0) {$id = $_POST['id'];}
		if ($id == "") {$id = 0;}
		$sql = "select * from ainf_xcloud_videos where video_series = $id and compid = $varcompid";
		$data['series_videos'] = $this->db->query($sql)->result_array();
				
		If ($_POST['return_to_list'] == "yes") {
			$this->series(series_manager);
		} elseif ($_POST['id'] > 0 or $id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $varmain_table where id = $id";
			$data['edit_videos'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_series', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_series', $data);
		}
	}

	public function series($pagename)
	{
	
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // echo "!! email not sent ";
		}

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list
		
		$varcompid = $_POST['sess_compid'];		
		$var_search = "";
		
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		$data['events'] = $this->db->query($sql)->result_array();
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$sql = "select * from ainf_xcloud_videos, mentor_series where video_series = mentor_series.id order by video_order";
		$data['messages'] = $this->db->query($sql)->result_array();
		// //var_dump($data['messages']);
		
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		// !!! THIS IS THE NEW CODE TO BEGIN USING THE ainf_xcloud_videos TABLE AS IT HAS ALL THE DATA 
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$varfixed_comp = 114;
		$sql = "select * from ainf_xcloud_videos, speakers where  ainf_xcloud_videos.compid = $varfixed_comp and video_trainerid = speakers.id order by video_order";
										
		$var_search = "";
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_series'] = "";
		}
		if ($_POST['form_series'] != "") {
			$var_search .= " and video_series = '{$_POST['form_series']}' ";
		}
		
		if ($_POST['form_archive'] != "" and $_POST['form_archive'] != "all") {
			$var_search .= " and v.archive = '{$_POST['form_archive']}' ";
		}

		//### LEFT JOIN SQL
		$sql = "SELECT v.compid, v.id as id, v.archive as archive, video_name, v.video_link, teaser, video_writeup, series_title FROM ainf_xcloud_videos v LEFT JOIN mentor_series m ON v.video_series = m.id where v.compid = $varcompid $var_search";
		$data['messages'] = $this->db->query($sql)->result_array();

		if (!isset($_POST['form_archive']) or $_POST['form_archive'] == "") { // Starting value to all
			$_POST['form_archive'] = "all";
		}

		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'archive_values' order by code_id desc";
		$data['archive_list'] = $this->db->query($sql)->result_array();

		if ($_POST['form_series'] != "" and $_POST['form_series'] != 0) {
			$sql = "select * from mentor_series where id = {$_POST['form_series']}";
			$data['series_header'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select m.id, first_name, last_name, series_title, count(video_trainerid) as video_count from ainf_vps3_users u, mentor_series m left join ainf_xcloud_videos c on c.video_series = m.id where m.compid = $varcompid and m.series_speaker = u.userid order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array(); // Not getting videos with zero result for some reason
		
		$sql = "select * from mentor_series, ainf_vps3_users where series_speaker = userid and mentor_series.compid = $varcompid order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select id, video_series, compid from ainf_xcloud_videos where compid = $varcompid and video_series is not null order by video_series";
		$data['video_count'] = $this->db->query($sql)->result_array();
		// var_dump($data['video_count']);
		
		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

	public function display($pagename)
	{

		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}

		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);

		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'archive_values' order by code_id desc";
		$data['archive_list'] = $this->db->query($sql)->result_array();

		if ($_POST['form_series'] != "" and $_POST['form_series'] != 0) {
			$sql = "select * from mentor_series where id = {$_POST['form_series']}";
			$data['series_header'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select distinct teacher from ainf_xcloud_videos where $subqry order by teacher";
		// $data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' order by code_id";
		$data['services'] = $this->db->query($sql)->result_array();

		$sql = "select * from mentor_series where public_viewing = 'yes' order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array();
		
		//### list qrys
		$sql = "select distinct series_title, id from mentor_series where public_viewing = 'yes' and id  in (select video_series from ainf_xcloud_videos) order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();

		$varsql = "";
		if ($_POST['form_series'] != "" and $_POST['form_series'] != "0") {
		$varsql .= " and video_series = {$_POST['form_series']} ";
		}
		$sql = "select * from ainf_xcloud_videos where video_series in (select id from mentor_series where public_viewing = 'yes') $varsql order by video_series";
		$data['messages'] = $this->db->query($sql)->result_array();

		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
			
	}
		
	public function details($pagename)
	{
	
		$varcompid = $_POST['sess_compid'];
		echo "<br>!!11 - details $varcompid varcompid";
		
		if (isset($_POST['email'])) {
			$varemail = $_POST['email'];
			$to      = 'paul@lending.sydney'; 
			//$to      = 'max.emb@gmail.com'; 
			$subject = 'Web request to join the Belvoir Street Baptist Church Mailing List ';
			$message = "Hi Paul, " . "\r\n" . "\r\n" . "This person requested to join the emailing list with their email address of $varemail. Please check for duplicates and quality before adding them to the email list." . "\r\n" . "\r\n" . "Best Regards, Max Emberson" . "\r\n" . "BSBC Web Team.";
			$headers = 'From: max@peakwebsystems.com' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$_POST['emailsent'] = "<br>Thanks. You are now in our Newsletter Email";
		} else { 
			// // echo "!! email not sent ";
		}

		echo "<br>!!22 - details ";
		if (isset($_SERVER['QUERY_STRING'])) {
			$page_chk = explode('?',$pagename);
			$pagename = $page_chk['0'];
		}
		
		// Get page name for the link fr
		$pagename_orig = $pagename;
		$pagename_orig_php = $pagename . ".php";
		$pagename = str_replace('_',' ',$pagename);
		$ucpagename = ucfirst($pagename);
		if ($pagename_orig == "service_list" or $pagename_orig == "indexerror") {$pagename_orig = "index";} // index.php is multi-purpose but same core data - message list or service list 
		
		$var_search = "";
		
		echo "<br>!!33 - details ";
		// Process the form filter 		
		if (isset($_POST['form_reset'])) { // reset the form values 
			$_POST['form_book'] = ""; 
			$_POST['form_speaker'] = ""; 
			$_POST['form_keywords'] = ""; 
		}
		if ($_POST['form_book'] != "") { 
			$var_search .= " and book = '{$_POST['form_book']}' "; 
		}
		if ($_POST['form_speaker'] != "") { 
			$var_search .= " and teacher = '{$_POST['form_speaker']}' "; 
		}
				
		echo "<br>!!44 - details ";
		$sql = "select * from events where compid = $varcompid order by date_sort desc";
		
		echo "<br>!!44aa - sql - $sql";
		$data['events'] = $this->db->query($sql)->result_array();
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$sql = "select * from ainf_xcloud_videos, mentor_series where video_series = mentor_series.id order by video_order";
		echo "<br>!!44bb - sql - $sql ";
		$data['messages'] = $this->db->query($sql)->result_array();
		// //var_dump($data['messages']);
		
		echo "<br>!!55 - details ";
		$num_rows1 = count($data['messages']);
		$recsperpage = 4;
		$_POST['page_tot'] = ceil($num_rows1/$recsperpage);
		if ($_POST['page_tot'] < 1) { // reset the form values 
			$_POST['page_tot'] = 1;
		}
		if ($_POST['form_page'] > $_POST['page_tot']) { // reset the form values 
			$_POST['form_page'] = 1;
		}
		
		$_POST['page_curr'] = $_POST['form_page'];
				
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";} 
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {
			$varoffset = ($_POST['page_curr'] - 1) * $recsperpage;
		} else {
			$varoffset = 0; $_POST['page_curr'] = 1; $_POST['form_page'] = 1; 
		}
	
		echo "<br>!!66 - details ";
		// !!! THIS IS THE NEW CODE TO BEGIN USING THE ainf_xcloud_videos TABLE AS IT HAS ALL THE DATA 
		if ($pagename == "index" or $pagename == "indexerror") {$subqry = " and active = 'Y' ";} else {$subqry = "";}
		$varcompidsql = " and ainf_xcloud_videos.compid = $varcompid ";
		$varfixed_comp = 114;
		$sql = "select * from ainf_xcloud_videos, speakers where  ainf_xcloud_videos.compid = $varfixed_comp and video_trainerid = speakers.id order by video_order";
		
		// exit;
										
		$var_search = "";
		// Process the form filter
		if (isset($_POST['form_reset'])) { // reset the form values
			$_POST['form_series'] = "";
		}
		if ($_POST['form_series'] != "") {
			$var_search .= " and video_series = '{$_POST['form_series']}' ";
		}
		
		if ($_POST['form_archive'] != "" and $_POST['form_archive'] != "all") {
			$var_search .= " and v.archive = '{$_POST['form_archive']}' ";
		}

		//### LEFT JOIN SQL
		$sql = "SELECT v.compid, v.id as id, v.public_viewing, v.archive as archive, video_name, v.video_link, teaser, video_writeup, series_title FROM ainf_xcloud_videos v LEFT JOIN mentor_series m ON v.video_series = m.id where v.compid = $varcompid $var_search";
		$data['messages'] = $this->db->query($sql)->result_array();

		if (!isset($_POST['form_archive']) or $_POST['form_archive'] == "") { // Starting value to all
			$_POST['form_archive'] = "all";
		}

		$sql = "select code_name, code1 from ainf_vps3_code_manager where code_group = 'archive_values' order by code_id desc";
		$data['archive_list'] = $this->db->query($sql)->result_array();

		if ($_POST['form_series'] != "" and $_POST['form_series'] != 0) {
			$sql = "select * from mentor_series where id = {$_POST['form_series']}";
			$data['series_header'] = $this->db->query($sql)->result_array();
		}
		
		$sql = "select distinct teacher from ainf_xcloud_videos where compid = $varcompid $subqry order by teacher";
		$data['teachers'] = $this->db->query($sql)->result_array();
		
		$sql = "select distinct book from ainf_xcloud_videos where compid = $varcompid order by book";
		$data['books'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_code_manager where code_group = 'Service Times' and compid = $varcompid order by code_id";
		$data['services'] = $this->db->query($sql)->result_array();

		$sql = "select * from mentor_series where compid = $varcompid order by series_title";
		$data['series_list'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from cms_images where compid = $varcompid order by id desc"; 
		$data['cms_images'] = $this->db->query($sql)->result_array(); 

		$sql = "select distinct gallery_keyword from cms_images where compid = $varcompid order by gallery_keyword"; 
		$data['cms_images_keywords'] = $this->db->query($sql)->result_array(); 
				
		$q = $this->db->query("select id,page_name, page_title, menu_position, menu_owner_link FROM ainf_xcloud_sector_web_page where (compid = $varcompid and active_flag = 1 and menu_active = 1) order by menu_position");
		$data['page_list_menu'] = $q->result_array(); //!!! Cannot access $data['page_type_vals'] in view for some reason

		$data['eunit_checklist'] = $this->process_get_checklist(); // load the checklist items
		// //var_dump($data['eunit_checklist']);
		
		//### list qrys
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid and id  in (select video_series from ainf_xcloud_videos) order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();

		// very basic error handling
		if (file_exists(base_url("views/$pagename_orig")))
		{
			$_POST['error'] = "";
			$this->load->view($pagename_orig, $data);
		} else {
			// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
			$this->load->view($pagename_orig, $data);
			// $this->load->view('index', $data);
		}
		
	}

}
	