<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Videos extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
					
		error_reporting(0);
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		$this->load->model('Attendee_mods');
		$this->load->helper('text');
		$this->load->library('cart');
		$this->load->helper('url');			
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{		
		error_reporting(0);
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}	

	public function check_function()
	{		
		error_reporting(0);
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// // // echo"!! must write other functions code for funciton $callfunction";
		}
	}

	public function video_edit()
	{

		error_reporting(0);
		$varcompid = $_POST['sess_compid'];

		if ($_POST['teacher'] != "") {
			
			$var_video_link = "";
			if($_FILES['video_link']['name']) {

				$targetPath = "/home/ebooksonline/public_html/churchofjesus.live/client_videos/"; // correct path for infinity
				$varurlpath = "https://churchofjesus.live/client_videos/";
				
				$upload=$_FILES['video_link']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('m4a','mp4', 'mov', 'mp3', 'jpg');
				if(1==1 or in_array($ext,$config['allowed_types'])) {
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = $varcompid . "_service_video_" . $vardate . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						if (move_uploaded_file($_FILES['video_link']['tmp_name'], $targetPath . $targetFile)) {
							$var_video_link = $varurlpath . $targetFile;
						}
					} else {
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}
				} else {
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
				}
			}
			
			
			$var_teacher_image = "";
			if($_FILES['user_image']['name']) {
				$targetPath = "/home/ebooksonline/public_html/churchofjesus.live/client_files/"; // correct path for infinity 
				$varurlpath = "https://churchofjesus.live/client_files/"; 
			
				$upload=$_FILES['user_image']['name'];
				$ext=end(explode('.',$upload));
				$config['allowed_types'] = array('png','jpg', 'jpeg', 'gif', 'tif');
				if(1==1 or in_array($ext,$config['allowed_types'])) {
				// echo"<br>XX22 vid 2 id {$_POST['id']}";
					$upload=$config['upload_path'].$glob_id.'.'.$ext; // does nothing I think
					$vardate = date("Y-m-d-H-m-s");
					$targetFile = $varcompid . "_preacher_image_" . $vardate . "." . $ext;
					if (is_dir($targetPath)and is_writable($targetPath)) {
						if (move_uploaded_file($_FILES['user_image']['tmp_name'], $targetPath . $targetFile)) {
							$var_teacher_image = $varurlpath . $targetFile;
							// // echo"<br>XX44 vid 4 link is $var_video_link";
						}
					} else {
						$err = "The path target or dir $targetPath or NOT WRITABLE";
					}
				} else {
					$err = "The file must be gif','jpg', 'png' or 'jpeg' file types";
				}
			}
			
			$data_rec = array();
			$data_rec['teacher'] = $_POST['teacher']; $data_rec['title'] = $_POST['title'];
			$data_rec['book'] = $_POST['book']; $data_rec['series'] = $_POST['series'];
			if ($var_video_link != "") {
				$data_rec['video_link'] = $var_video_link; $data_rec['audio_link'] = $var_video_link;
			}
			if ($var_teacher_image != "") {
				$data_rec['teacher_image'] = $var_teacher_image; 
			}
			$data_rec['message'] = $_POST['message']; 
			$data_rec['message_date'] = $_POST['message_date'];
			$date_time = explode(" ",$_POST['message_date']);
			$date_time_parts = explode("/",$date_time[0]);
			$data_rec['message_date_sort'] = $date_time_parts[2] . "/" . $date_time_parts[1] . "/" . $date_time_parts[0] . " " . $date_time[1];
			$data_rec['teacher_title'] = $_POST['teacher_title']; $data_rec['teacher'] = $_POST['teacher'];
			if ($_POST['active']=="Y") {$data_rec['active']="Y";} else {$data_rec['active']="N";}
			
			if ($_POST['id'] != 0 and $_POST['update_video'] == "y") {
				// echo"<br>!!x1 in update is {$_POST['id']}";
				$this->db->where('id', $_POST['id']);
				$this->db->update(ainf_xcloud_videos, $data_rec);
			} else {
				// echo"<br>!! y22 in update is {$_POST['id']}";
				if ($_POST['copy_video'] == "y") {
					$_POST['return_to_list'] = ""; //## COPY MAKE THEM CHECK THIS 
					$data_rec['title'] = "This is a copy - plese set now"; 
				}
				$data_rec['compid'] = $varcompid;
				$this->db->insert(ainf_xcloud_videos, $data_rec);
				// echo"<br>!! y33 ";
				$_POST['id'] = $this->db->insert_id();
			}
			
			if ($_POST['return_to_list'] == "y") {
				$this->video_views('manage_key_lists');
			} else {
				$this->video_views('update_video_detail');
			}
		} else {
			$this->video_views('update_video_detail');
		}
		
	}

	public function video_views($video_page)
	{
		
		$varcompid = $_POST['sess_compid'];
		// $varcompid = 110;
		if ($video_page == "update_video_detail") {
			$sql = "select * from `ainf_vps3_code_manager` where code_group like '%book%'";
			$data['vidbooks'] = $this->db->query($sql)->result_array();
			$sql = "select * from ainf_xcloud_videos where id = {$_POST['id']} limit 0,1";
			$data['videdit'] = $this->db->query($sql)->result_array();
			$sql = "select * from `ainf_vps3_code_manager` where code_group like 'preacher_title'";
			$data['titles'] = $this->db->query($sql)->result_array();
			$sql = "select title, full_name from speakers where compid = $varcompid";
			$data['speakers'] = $this->db->query($sql)->result_array();
			
			$this->load->view($video_page, $data);
			
		} elseif ($video_page == "manage_key_lists") {
			$sql = "select * from ainf_xcloud_videos order by message_date_sort desc "; 
			$sql = "select * from ainf_xcloud_videos where compid = $varcompid order by message_date_sort desc "; 
			$data['vidlist'] = $this->db->query($sql)->result_array(); 
			
			$this->load->view($video_page, $data);
		}
	}

}
	
