<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');
  
class Admin_menus extends CI_Controller { 
	// !!!! rename this controller according to the most suitable settings to get started on 

	function __construct()
	{
		parent::__construct();
		
		$var_userid = $this->session->userdata('userid');
		if (trim($_POST['sess_userid']) == "" and $var_userid == "") { // if session and post are cleared login again. TWO sets to hold session 
			redirect('Ad_user_login_v4');
			// break;
		}
		
		$this->load->helper('html');
		//$this->load->model('mArticle');
		//$this->load->model('mArtist');
		$this->load->helper('text');
		$this->load->library('cart');
		
		//### CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		$this->load->model('System_modules'); $this->load->model('Recheck_access');
		$this->Recheck_access->reset_access();
		//### END - CHECKS AND SETS KEY POST AND KEY SESSION VARS LIKE ACCESS  
		
		$var_compname = $this->session->userdata('compname');
		$var_first_name = $this->session->userdata('first_name');
		$var_last_name = $this->session->userdata('last_name');
		
	}
	
	public function index()
	{
		$this->load->helper('url');
		// redirect('ministry/messages/sermons-list', 'refresh');
	}

	public function check_function()
	{		
		// This function allows the menu links to submit a form with sess_userid so cookies not needed 
		// The function to jump to is then what is passed over in $_POST['function_type']
		$this->load->helper('url');
		$callfunction = trim($_POST['function_type']);
		// echo "<br>!!! in check_function this is post callfunction is $callfunction!!!";
		if ($callfunction == "details") {
			$this->details('index');
		} else {
			// echo "!! must write other functions code for funciton $callfunction";
		}
		////var_dump($_POST);
	}	

	function process_get_checklist()
	{
		// $compid = $this->session->userdata('compid');
		if (1==1) {
			// Add any new checklists 
			if (isset($_POST['checklist_item_add1']) and trim($_POST['checklist_item_add1']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add1']);
				$this->db->insert('edu_checklist', $inscheck);
			}
			if (isset($_POST['checklist_item_add2']) and trim($_POST['checklist_item_add2']) != "") {
				$inscheck = array();
				$inscheck['compid'] = $compid;
				$inscheck['checklist_item'] = trim($_POST['checklist_item_add2']);
				$this->db->insert('edu_checklist', $inscheck);
			}
		}

		$q = $this->db->query("select * FROM edu_checklist");		
		$data = $q->result_array();
		return($data);
	} 

	public function video_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_xcloud_videos";
		
		if (isset($_POST['teaser'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']); 
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";	} else {$data_rec['archive'] = "no";}
			//var_dump($data_rec);
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}			
		}
		
		$sql = "select distinct series_title, id from mentor_series where compid = $varcompid order by series_title";
		$data['list_series'] = $this->db->query($sql)->result_array();
		////var_dump($data['list_series']);
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
		If ($_POST['return_to_list'] == "yes") {
			$this->details(trainer3_manager);
		} elseif ($_POST['id'] > 0 or $id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $varmain_table where id = $id";
			$data['edit_videos'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_videos', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_videos', $data);
		}
	}
		
	public function series_edit()
	{
		
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "mentor_series";
		
		if (isset($_POST['series_teaser'])) {
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']); 
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);
		
			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";	} else {$data_rec['archive'] = "no";}
			if ($_POST['id'] != 0) {
				$this->db->where('id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				$data_rec['compid'] = $varcompid;
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}
		}
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['trainer_names'] = $this->db->query($sql)->result_array();
		
		$sql = "select * from ainf_vps3_users where compid = $varcompid";
		$data['host_names'] = $this->db->query($sql)->result_array();
				
		If ($_POST['return_to_list'] == "yes") {
			$this->details(trainer3_manager);
		} elseif ($_POST['id'] > 0 or $id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $varmain_table where id = $id";
			$data['edit_videos'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_series', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_series', $data);
		}
	}
	
	
	public function menu_edit($pagename)
	{
		$varcompid = $_POST['sess_compid'];
		$varmain_table = "ainf_xmodules";
		
		if (isset($_POST['module_name'])) {
		
			
			$help="";
			if(isset($_FILES['help'])){
				if(trim($_FILES['help']['name'])!=""){
					$tmp = explode(".",$_FILES['help']['name']);
					$ext = $tmp[count($tmp)-1];
					$f_name = date("YmdHis")."_".rand(10000,99999).".".$ext;
					move_uploaded_file($_FILES['help']['tmp_name'],$_SERVER['DOCUMENT_ROOT']."/client_video/".$f_name);
					$help = $f_name;
				}
			}
			$data_rec = array();
			$data_rec = $_POST;
			unset($data_rec['userid']); 
			unset($data_rec['return_url']);
			unset($data_rec['id']); unset($data_rec['return_to_list']);
			unset($data_rec['sess_first_name']); unset($data_rec['sess_last_name']); unset($data_rec['sess_compid']); unset($data_rec['sess_globcompanyname']); unset($data_rec['sess_userid']);

			if ($_POST['delete_record'] == "yes") {$data_rec['delete_record'] = "yes";} else {$data_rec['delete_record'] = "no";}
			if ($_POST['archive'] == "yes") {$data_rec['archive'] = "yes";	} else {$data_rec['archive'] = "no";}
			//var_dump($data_rec);
			unset($data_rec['delete_record']);
			unset($data_rec['archive']);
			unset($data_rec['compid']);
			if($help!=""){
				$data_rec['help']=$help;
			}
			if ($_POST['id'] != 0) {
				$this->db->where('xmodules_id', $_POST['id']);
				$this->db->update($varmain_table, $data_rec);
			} else {
				// $data_rec['compid'] = $varcompid; - does not apply to ainf_xmodules
				$this->db->insert($varmain_table, $data_rec);
				$id = $this->db->insert_id();
			}			
		}
		
		$sql = "select xmodules_id, module_name, module_page from ainf_xmodules where parent_module = 0 and system = 'Church of Jesus' order by module_name";
		$sql = "select * from ainf_xmodules where parent_module = 0 and system = 'Church of Jesus' order by module_name";
		$data['parent_list'] = $this->db->query($sql)->result_array();
		//print_R($data['parent_list']);exit;
		// // echo "<br>!! id = {$_POST['id']} ";

		If ($_POST['return_to_list'] == "yes") {
			$this->details(menu_manager);
		} elseif ($_POST['id'] > 0 or $id > 0) { // the id is always set from default meeting 
			// back to updates 
			if ($_POST['id'] > 0) {$id = $_POST['id'];}
			$sql = "select * from $varmain_table where xmodules_id = $id";
			$data['edit_menus'] = $this->db->query($sql)->result_array();
			$_POST['id'] = $id;
			$this->load->view('update_menus', $data);
		} else {
			$_POST['id'] = 0;
			$this->load->view('update_menus', $data);
		}
	} 
		
	public function details($pagename)
	{
	
		$send = "yes"; $sent_num = 0;
		if ($send == "yes") {
			++$sent_num;
			$varemail = $_POST['email'];
			$to      = 'max.emberson@yahoo.com.au';
			//$to      = 'max.emb@gmail.com';
			$subject = 'Check our promotion through 2023 '; 
			$message = "Hi Friend, " . "\r\n" . "\r\n" . 
			"Do click for our latest range of eb at incredible promotional prices." . "\r\n" . "\r\n" . 
			"Best Regards, Shop ebooks" . "\r\n";
			$headers = 'From: sales@ebooksonline.live' . "\r\n" .
				'Reply-To: max.emb@gmail.com' . "\r\n" .
				'Cc: max.emb@gmail.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			mail($to, $subject, $message, $headers);
			$var_stats .= "<br>Sent to $to - sent_num = $sent_num";
		}

		// very basic error handling
		if (1==2) {
			if (file_exists(base_url("views/$pagename_orig")))
			{
				$_POST['error'] = "";
				$this->load->view($pagename_orig, $data);
			} else {
				// $_POST['error'] = "Sorry that web page was not found so you have been redirected to this page.";
				$this->load->view($pagename_orig, $data);
				// $this->load->view('index', $data);
			}
		}
		
	}

}
	
